      subroutine mcpyr6(from,to)  ! copy real 6x6 matrix
      real from(6,6),to(6,6)
      do i=1,6
         do j=1,6
            to(i,j)=from(i,j)
         end do
      end do
      return
      end

      subroutine mcpyi6(from,to)  ! copy integer 6x6 matrix
      integer from(6,6),to(6,6)
      do i=1,6
         do j=1,6
            to(i,j)=from(i,j)
         end do
      end do
      return
      end

      subroutine mcpyir6(from,to) ! copy integer 6x6 to real 6x6 matrix
      integer from(6,6)
      real to(6,6)
      do i=1,6
         do j=1,6
            to(i,j)=from(i,j)
         end do
      end do
      return
      end

      subroutine mtmplr(a,b,c,n)   ! multiply real nxn matrices
      real a(n,n),b(n,n),c(n,n)
      do i=1,n
         do j=1,n
            c(i,j)=0.
            do k=1,n
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmplri3(a,b,c)   ! multiply real and int nxn matrices
      real a(3,3),c(3,3)
      integer b(3,3)
      call mtmplri(a,b,c,3)
      return
      end

      subroutine mtmplri(a,b,c,n)   ! multiply real and int nxn matrices
      real a(n,n),c(n,n)
      integer b(n,n)
      do i=1,n
         do j=1,n
            c(i,j)=0.
            do k=1,n
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmplir3(a,b,c)   ! multiply int and real nxn matrices
      integer a(3,3)
      real b(3,3),c(3,3)
      call mtmplir(a,b,c,3)
      return
      end

      subroutine mtmplir(a,b,c,n)   ! multiply int and real nxn matrices
      integer a(n,n)
      real b(n,n),c(n,n)
      do i=1,n
         do j=1,n
            c(i,j)=0.
            do k=1,n
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmpli(a,b,c,n)   ! multiply real nxn matrices
      integer a(n,n),b(n,n),c(n,n)
      do i=1,n
         do j=1,n
            c(i,j)=0.
            do k=1,n
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmplr3(a,b,c)   ! multiply real 6x6 matrices
      real a(3,3),b(3,3),c(3,3)
      call mtmplr(a,b,c,3)
c      do i=1,3
c         do j=1,3
c            c(i,j)=0.
c            do k=1,3
c               c(i,j)=c(i,j)+a(i,k)*b(k,j)
c            end do
c         end do
c      end do
      return
      end

      subroutine mtmpli3(a,b,c)   ! multiply real 6x6 matrices
      integer a(3,3),b(3,3),c(3,3)
      call mtmpli(a,b,c,3)
c      do i=1,3
c         do j=1,3
c            c(i,j)=0.
c            do k=1,3
c               c(i,j)=c(i,j)+a(i,k)*b(k,j)
c            end do
c         end do
c      end do
      return
      end

      subroutine mtmplr6(a,b,c)   ! multiply real 6x6 matrices
      real a(6,6),b(6,6),c(6,6)
      call mtmplr(a,b,c,6)
c      do i=1,6
c         do j=1,6
c            c(i,j)=0.
c            do k=1,6
c               c(i,j)=c(i,j)+a(i,k)*b(k,j)
c            end do
c         end do
c      end do
      return
      end

      subroutine mtmpli6(a,b,c)   ! multiply integer 6x6 matrices
      integer a(6,6),b(6,6),c(6,6)
      call mtmpli(a,b,c,6)
c      do i=1,6
c         do j=1,6
c            c(i,j)=0.
c            do k=1,6
c               c(i,j)=c(i,j)+a(i,k)*b(k,j)
c            end do
c         end do
c      end do
      return
      end

      subroutine mtmplri6(a,b,c)   ! multiply real and integer 6x6 matrices
      real a(6,6),c(6,6)
      integer b(6,6)
      call mtmplri(a,b,c,6)
c      do i=1,6
c         do j=1,6
c            c(i,j)=0.
c            do k=1,6
c               c(i,j)=c(i,j)+a(i,k)*b(k,j)
c            end do
c         end do
c      end do
      return
      end

      subroutine mtmplir6(a,b,c)   ! multiply integer and real 6x6 matrices
      integer a(6,6)
      real b(6,6),c(6,6)
      call mtmplir(a,b,c,6)
c      do i=1,6
c         do j=1,6
c            c(i,j)=0.
c            do k=1,6
c               c(i,j)=c(i,j)+a(i,k)*b(k,j)
c            end do
c         end do
c      end do
      return
      end

      subroutine mtmplrmno(a,b,c,m,n,o) ! multiply real mxn and mxo matrices
      integer m,n,o
      real a(m,n),b(n,o),c(m,o)
      do i=1,m
         do j=1,o
            c(i,j)=0.
            do k=1,n
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmplimno(a,b,c,m,n,o) ! multiply integer mxn and mxo matrices
      integer m,n,o
      integer a(m,n),b(n,o),c(m,o)
      do i=1,m
         do j=1,o
            c(i,j)=0.
            do k=1,n
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmplirmno(a,b,c,m,n,o) ! multiply integer mxn and real nxo matrices
      integer m,n,o
      integer a(m,n)
      real b(n,o),c(m,o)
      do i=1,m
         do j=1,o
            c(i,j)=0.
            do k=1,n
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmplrimno(a,b,c,m,n,o) ! multiply real mxn and integer nxo matrices
      integer m,n,o
      real a(m,n),c(m,o)
      integer b(n,o)
      do i=1,m
         do k=1,o
            c(i,k)=0.
            do j=1,n
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine trnspr(sm,st,n)
      real sm(n,n),st(n,n)
      do i=1,n
         do j=1,n
            st(i,j)=sm(j,i)
         end do
      end do
      return
      end

      subroutine trnspi(sm,st,n)
      integer sm(n,n),st(n,n)
      do i=1,n
         do j=1,n
            st(i,j)=sm(j,i)
         end do
      end do
      return
      end

      subroutine trnspr3(sm)
      real smd(3,3),sm(3,3)
      call trnspr(sm,smd,3)
      call mcpyr(smd,sm,3)
      return
      end

      subroutine trnspi3(sm)
      integer smd(3,3),sm(3,3)
      call trnspi(sm,smd,3)
      call mcpyi(smd,sm,3)
      return
      end

      subroutine trnspr6(sm)
      real smd(6,6),sm(6,6)
      call trnspr(sm,smd,6)
      call mcpyr(smd,sm,6)
      return
      end

      subroutine trnspi6(sm)
      integer smd(6,6),sm(6,6)
      call trnspi(sm,smd,6)
      call mcpyi(smd,sm,6)
      return
      end

      subroutine qsort(x,st,ip,nx)
c     quick sort (ascending order of x)
c     nx: the number of data x
c     ip: the initial order
c     st: a work array
      real x(nx)
      integer r,s,st(nx,0:1),ip(nx)
      if(nx.eq.0) return
      do i=1,nx
         ip(i)=i
      end do
      s=1
      st(1,0)=1
      st(1,1)=nx
    1 l=st(s,0)
      r=st(s,1)
      s=s-1
    2 i=l
      j=r
      xt=x((l+r)/2)
    3 if(i.lt.nx) then
         if(x(i).lt.xt) then
            i=i+1
            go to 3
         endif
      endif
    4 if(j.gt.1) then
         if(xt.lt.x(j)) then
            j=j-1
            go to 4
         endif
      endif
      if(i.le.j) then
        temp=x(j)
        x(j)=x(i)
        x(i)=temp
        itemp=ip(j)
        ip(j)=ip(i)
        ip(i)=itemp
        if(i.le.nx.and.j.ge.1) then
           i=i+1
           j=j-1
           go to 3
        end if
      endif
      if(j-l.le.r-i) go to 5
      if(i.lt.r) then
         s=s+1
         st(s,0)=i
         st(s,1)=r
      endif
      r=j
      go to 6
    5 if(l.lt.j) then
         s=s+1
         st(s,0)=l
         st(s,1)=j
      endif
      l=i
    6 if(l.lt.r) go to 2
      if(s.ne.0) go to 1
      return
      end

      subroutine mcpyr(s1,s2,n)
      real s1(n,n),s2(n,n)
      do i=1,n
         do j=1,n
            s2(i,j)=s1(i,j)
         end do
      end do
      return
      end

      subroutine mcpyi(s1,s2,n)
      integer s1(n,n),s2(n,n)
      do i=1,n
         do j=1,n
            s2(i,j)=s1(i,j)
         end do
      end do
      return
      end

      subroutine mcpyr3(s1,s2)
      real s1(3,3),s2(3,3)
      do i=1,3
         do j=1,3
            s2(i,j)=s1(i,j)
         end do
      end do
      return
      end

      subroutine mcpyi3(s1,s2)
      integer s1(3,3)
      integer s2(3,3)
      do i=1,3
         do j=1,3
            s2(i,j)=s1(i,j)
         end do
      end do
      return
      end

      subroutine zerov(v1,n)  ! zero vectors
      real v1(*)
      do j=1,n
         v1(j)=0
      end do
      return
      end

      subroutine zerovr(v1,n)  ! zero vectors
      real v1(*)
      do j=1,n
         v1(j)=0
      end do
      return
      end

      subroutine zerovc(v1,n)  ! complex zero vectors
      complex v1(*)
      do j=1,n
         v1(j)=0
      end do
      return
      end

      subroutine zerovi(v1,n)  ! zero integer vectors
      integer v1(*)
      do j=1,n
         v1(j)=0
      end do
      return
      end

      integer function ifzerovr(v1,n)  ! zero vectors
      real v1(*)
      do j=1,n
         if(v1(j).ne.0) then
            ifzerovr=0
            return
         end if
      end do
      ifzerovr=1
      return
      end

      integer function ifzerovi(v1,n)  ! zero vectors
      integer v1(*)
      do j=1,n
         if(v1(j).ne.0) then
            ifzerovi=0
            return
         end if
      end do
      ifzerovi=1
      return
      end

      subroutine vfact(v1,fact,n)  ! multiplied by fact
      real v1(*)
      do j=1,n
         v1(j)=v1(j)*fact
      end do
      return
      end

      subroutine vmult(v1,v2,v3,n)
      real v1(*),v2(*),v3(*)
      do j=1,n
         v3(j)=v1(j)*v2(j)
      end do
      return
      end

      subroutine vcpyr(dd,de,n)
      real dd(*),de(*)
      do j=1,n
         de(j)=dd(j)
      end do
      return
      end

      subroutine negater(v1,n)
      real v1(*)
      do j=1,n
         v1(j)=-v1(j)
      end do
      return
      end

      subroutine negatei(v1,n)
      integer v1(*)
      do j=1,n
         v1(j)=-v1(j)
      end do
      return
      end

      subroutine vcpyir(dd,de,n) ! copy integer vector to real vector
      integer dd(*)
      real de(*)
      do j=1,n
         de(j)=dd(j)
      end do
      return
      end

      subroutine vcpyi(dd,de,n)
      integer dd(*),de(*)
      do 10 j=1,n
      de(j)=dd(j)
 10   continue
      return
      end

      subroutine vsumr(x1,x2,x3,n)
      real x1(*),x2(*),x3(*)
      do j=1,n
         x3(j)=x1(j)+x2(j)
      end do
      return
      end

      subroutine vsumi(x1,x2,x3,n)
      integer x1(*),x2(*),x3(*)
      do j=1,n
         x3(j)=x1(j)+x2(j)
      end do
      return
      end

      subroutine vsumir(x1,x2,x3,n)
      integer x1(*)
      real x2(*),x3(*)
      do j=1,n
         x3(j)=x1(j)+x2(j)
      end do
      return
      end

      subroutine vsubr(x1,x2,x3,n)
      real x1(*),x2(*),x3(*)
      do j=1,n
         x3(j)=x1(j)-x2(j)
      end do
      return
      end

      subroutine vsubi(x1,x2,x3,n)
      integer x1(*),x2(*),x3(*)
      do j=1,n
         x3(j)=x1(j)-x2(j)
      end do
      return
      end

      subroutine vprd(q1,q2,q3)
      call vprdr(q1,q2,q3)
      return
      end

      subroutine vprdr(q1,q2,q3)     ! vector product of 3d vectors
      real q1(*),q2(*),q3(*)
      q3(1)=q1(2)*q2(3)-q1(3)*q2(2)
      q3(2)=q1(3)*q2(1)-q1(1)*q2(3)
      q3(3)=q1(1)*q2(2)-q1(2)*q2(1)
      return 
      end

      subroutine chsgn(q)
      real q(*)
      do i=1,6
         q(i)=-q(i)
      end do
      return
      end

      function vinpr(x,y,n)
c*****inner product of n-dimensional vactors, x,y
      real x(*),y(*)
      vinpr=0
      do i=1,n
         vinpr=vinpr+x(i)*y(i)
      end do
      return
      end

      integer function vinpi(x,y,n)
c*****inner product of n-dimensional vactors, x,y
      integer x(*),y(*)
      vinpi=0
      do i=1,n
         vinpi=vinpi+x(i)*y(i)
      end do
      return
      end

      integer function vinpir(x,y,n)
c*****inner product of n-dimensional vactors, x,y
      integer x(*)
      real y(*)
      vinpir=0
      do i=1,n
         vinpir=vinpir+x(i)*y(i)
      end do
      return
      end

      function vinpri(h,x,n)
c*****inner product of n-dimensional integral and real vectors
      integer h(*)
      real x(*)
      vinpri=0
      do i=1,n
         vinpri=vinpri+h(i)*x(i)
      end do
      return
      end

      function vabs(x,n)
c*****absolute value of n-dimensional vector x
      real x(*)
      vabs=0
      do i=1,n
         vabs=vabs+x(i)**2
      end do
      vabs=sqrt(vabs)
      return
      end

      subroutine zeromtrxr(m,n)  ! zero matrix
      real m(n,n)
      do i=1,n
         do j=1,n
            m(i,j)=0
         end do
      end do
      return
      end

      subroutine zeromtrxi(m,n)  ! zero matrix
      integer m(n,n)
      do i=1,n
         do j=1,n
            m(i,j)=0
         end do
      end do
      return
      end

      subroutine unitmtrxi(a,n)
      integer a(n,n)
      do i=1,n
         do j=1,n
            a(i,j)=0
            a(i,i)=1
         end do
      end do
      return
      end

      subroutine unitmtrxr(a,n)
      real a(n,n)
      do i=1,n
         do j=1,n
            a(i,j)=0.
            a(i,i)=1.
         end do
      end do
      return
      end

      subroutine norml(x,n)
      real x(*)
      data eps /0.000001/
c     normalization of x
      absh=vabs(x,n)
      if(absh.gt.eps) then
         do i=1,n
            x(i)=x(i)/absh
         end do
      end if
      return
      end

      subroutine wtvctrr(str,v,n)
      character(*) str
      real v(*)
      write(6,'(a,$)') str
      write(6,*) (v(j),j=1,n)
      return
      end

      subroutine wtvctri(str,v,n)
      character(*) str
      integer v(*)
      write(6,'(a,$)') str
      write(6,*) (v(j),j=1,n)
      return
      end

      subroutine wtvctrrf(str,v,n,frmt)
      character(*) str,frmt
      real v(*)
      write(6,'(a,$)') str
      write(6,frmt) (v(j),j=1,n)
      return
      end

      subroutine wtvctrif(str,v,n,frmt)
      character(*) str,frmt
      integer v(*)
      write(6,'(a,$)') str
      write(6,frmt) (v(j),j=1,n)
      return
      end

      subroutine wtmtrxi(str,mtrx,n)
      character(*) str
      integer mtrx(n,n)
      write(6,'(a)') str
      do i=1,n
         write(6,*) (mtrx(i,j),j=1,n)
      end do
      return
      end

      subroutine wtmtrxr(str,mtrx,n)
      character(*) str
      real mtrx(n,n)
      write(6,'(a)') str
      do i=1,n
         write(6,*) (mtrx(i,j),j=1,n)
      end do
      return
      end

      subroutine wtmtrxif(str,mtrx,n,frmt)
      character(*) str,frmt
      integer mtrx(n,n)
      write(6,'(a)') str
      do i=1,n
         write(6,frmt) (mtrx(i,j),j=1,n)
      end do
      return
      end

      subroutine wtmtrxrf(str,mtrx,n,frmt)
      character(*) str,frmt
      real mtrx(n,n)
      write(6,'(a)') str
      do i=1,n
         write(6,frmt) (mtrx(i,j),j=1,n)
      end do
      return
      end

      subroutine matinv3(a,b,m,det)
      real a(3,3),b(3)
      real pivot(3)
      integer ipivot(3),index(3,2)
      call matinv(a,3,3,b,m,det,ipivot,index,pivot)
      return
      end

      subroutine matinv6(a,b,m,det)
      real a(6,6),b(6)
      real pivot(6)
      integer ipivot(6),index(6,2)
      call matinv(a,6,6,b,m,det,ipivot,index,pivot)
      return
      end

      subroutine matinv(a,nm,n,b,m,determ,ipivot,index,pivot)
c
c    n*n matrix a is replaced by its inverse matrix a**-1
c    if m is nonzero vector b is replaced by a**-1*b
c
c      dimension a(nm,nm),b(nm),ipivot(nm),index(nm,2),pivot(nm)
      real a(nm,nm),b(nm),pivot(nm)
      integer ipivot(nm),index(nm,2)
      equivalence (irow,jrow),(icolum,jcolum),(amax,t,swap)
      determ=1.0
      do j=1,n
         ipivot(j)=0
      end do
      do i=1,n
         amax=0.0
         do j=1,n
            if(ipivot(j).eq.1) go to 105
            do k=1,n
c               if(ipivot(k)-1) 80,100,740
               if(ipivot(k)-1.lt.0) then
                  if(abs(amax).ge.abs(a(j,k))) go to 100
                  irow=j
                  icolum=k
                  amax=a(j,k)
               else if(ipivot(k)-1.gt.0) then
                  go to 740
               end if
 100           continue
            end do
 105        continue
         end do
         ipivot(icolum)=ipivot(icolum)+1
         if(irow.eq.icolum) go to 260
         determ=-determ
         do l=1,n
            swap=a(irow,l)
            a(irow,l)=a(icolum,l)
            a(icolum,l)=swap
         end do
         if(m.eq.0) go to 260
         swap=b(irow)
         b(irow)=b(icolum)
         b(icolum)=swap
 260     index(i,1)=irow
         index(i,2)=icolum
         pivot(i)=a(icolum,icolum)
         determ=determ*pivot(i)
         a(icolum,icolum)=1.0
         do l=1,n
            a(icolum,l)=a(icolum,l)/pivot(i)
         end do
         if(m.eq.0) go to 380
         b(icolum)=b(icolum)/pivot(i)
 380     continue
         do l1=1,n
            if(l1.eq.icolum) go to 550
            t=a(l1,icolum)
            a(l1,icolum)=0.0
            do l=1,n
               a(l1,l)=a(l1,l)-a(icolum,l)*t
            end do
            if(m.eq.0) go to 550
            b(l1)=b(l1)-b(icolum)*t
 550        continue
         end do
      end do
      do i=1,n
         l=n+1-i
         if(index(l,1).eq.index(l,2)) go to 710
         jrow=index(l,1)
         jcolum=index(l,2)
         do k=1,n
            swap=a(k,jrow)
            a(k,jrow)=a(k,jcolum)
            a(k,jcolum)=swap
         end do
 710  continue
      end do
 740  continue
      return
      end

      subroutine wtrvct6(str,ej1)
      character(*) str
      real ej1(6)
      write(6,'(a,6f10.5)') str,(ej1(j),j=1,6)
      return
      end

      subroutine wtrmtrx6(str,rmtrx)
      character(*) str
      real rmtrx(6,6)
      write(6,*) str
      do i=1,6
         write(6,'(6f10.5)') (rmtrx(i,j),j=1,6)
      end do
      return
      end

      subroutine wtrmtrx3(str,rmtrx)
      character(*) str
      real rmtrx(3,3)
      write(6,*) str
      do i=1,3
         write(6,'(3f10.5)') (rmtrx(i,j),j=1,3)
      end do
      return
      end

      subroutine atanf(x,t)
      dimension x(2)
c******************************************************
c          angle calculation
c******************************************************
c     x: 2-dimensional vector (x,y in plotter system)
c     t: angle in rad/6.28318   (0<=t<=1)
      if(x(1).eq.0) go to 10
      td=atan(x(2)/x(1))/6.28318
      if(x(1).gt.0.and.x(2).ge.0) t=td
      if(x(1).lt.0.and.x(2).ge.0) t=td+0.5
      if(x(1).lt.0.and.x(2).le.0) t=td+0.5
      if(x(1).gt.0.and.x(2).le.0) t=td+1.0
      return
 10   if(x(2).gt.0) t=0.25
      if(x(2).lt.0) t=0.75
      return
      end
