      subroutine getindex(index,nind)
c     get index of independent reflections
      integer index(*)
      include 'nhmax.inc'
      integer hkl(6,nhmax)
      integer ng(6)
      integer getnt
      call getng(ng)
      nt=getnt()
      write(6,*) 'nt=',nt
      call getallhkl(ng,hkl,nt)
      call gethkllen(hkl,t,nt)
      call qsort(t,ks,kp,nt)  ! for indref
      call indref(t,kp,hkl,nt,ks,nind,index) ! for MemLde
      return
      end

      subroutine setfoi(ar,ai,br,bi,nt,index,hkli,foi,iphas,nind)
      real ar(0:*),ai(0:*),br(0:*),bi(0:*)
      integer index(*)
      integer hkli(6,*)
      real foi(*)
      integer iphas(*)
      integer getcphase,gethkltoj
      call getidm(idm)
      do id=1,nind
         i=index(id)            ! i runs from 0
         call getitohkl(i,hkli(1,id)) ! get hkl for independent reflections
c     write(6,*) 'index=',i
c     j=gethkltoj(hkli(1,id))
c     if(i.ne.j) then
c     write(6,*) 'i,j=',i,j
c     end if
         if(ar(i).ne.0.or.ai(i).ne.0) then
            foi(id)=sqrt(ar(i)**2+ai(i)**2)
         else
            foi(id)=sqrt(br(i)**2+bi(i)**2)
         end if
         iphas(id)=getcphase(cmplx(br(i),bi(i)))
c         write(6,*) 'foi=',foi(id)
c         call wtvctri('hkli=',hkli(1,id),idm)
c         write(6,*) 'iphas=',iphas(id)
      end do
      return
      end

      subroutine getallhkl(ng,hkl,nt)
      integer ng(*),hkl(6,*)
      do i=0,nt-1
         call getitohkl(i,hkl(1,i+1)) ! offset = 0
      end do
      return
      end

      subroutine indref(qe,ns,h,nref,iflg,nind,index)  ! for MemLde
c     set iflg=1 for independent reflections and count
c     number of independent reflections
c     store original index for i-th independent reflection into index(i)

      real qe(*)              
c     qe: length of diffraction vector in external space after sort
      integer ns(*)             ! index before sort
      integer h(6,*)
      integer nref              ! number of total reflections
      integer iflg(*)           ! flag for independent reflections
      integer index(*)          ! index for independent reflections

c     **** note that this assumes less than 5 non-equivalent reflections
c     with same qe (ndqe=5)
      data eps /0.001/
      data nsqe /5/

      call zerovi(iflg,nref)
c      write(6,*) 'nref=',nref
c      write(6,'(a,10i8/(3x,10i8))') 'ns=',(ns(j),j=1,min(100,nref))
c      write(6,'(a,5f10.5/(4x,5f10.5))') 'qe=',(qe(j),j=1,min(100,nref))
      nind=0                    ! number of independent reflections
      do id=1,nref
         ii=ns(id)              ! index before sort
         do jd=max(1,nind-nsqe),nind
                                ! check equivalent to last 5 independent refl.
            jj=index(jd)+1      ! original index for last independent refl.
            ieq=iequiv1(h(1,ii),h(1,jj))
            if(ieq.ne.0) then  ! equivalent to some independent reflection
               go to 200
            end if
         end do
 100     continue
c     new independent reflection
         if(iskip(h(1,ii)).eq.0) then
            iflg(ii)=1
            nind=nind+1
            index(nind)=ii-1    ! index for independent reflection
         end if
 200     continue
      end do
      write(6,*) ' number of total rfeflections       =',nref
      write(6,*) ' number of independent rfeflections =',nind
c      do i=1,100
c         ii=index(i)
c         call wtvctri('h=',h(1,ii+1),6)
c      end do
      return
      end

