      function asf(yb,jk)
      include 'qcdiff.inc'
      parameter (nemx=nemax*3)
      common /asft/ ne,ascf(35,nemx),df1(nemx),df2(nemx),iand,
     *              iel(3,nemx)
      i=yb/0.05+1.0
      if(i.ge.29) i=(yb-1.4)/0.1+29.0
      if(i.ge.35) go to 20
      j=i+1
      if(i.ge.29) go to 21
      ai=float(i-1)*0.05
      asf=ascf(i,jk)+(ascf(j,jk)-ascf(i,jk))*(yb-ai)/0.05+df1(jk)
      return
 21   ai=float(i-29)*0.1+1.4
      asf=ascf(i,jk)+(ascf(j,jk)-ascf(i,jk))*(yb-ai)/0.1+df1(jk)
      return
 20   continue
      asf=0.0
      return
      end

      function f1p(jk)
      include 'qcdiff.inc'
      parameter (nemx=nemax*3)
      common /asft/ ne,ascf(35,nemx),df1(nemx),df2(nemx),iand,
     *              iel(3,nemx)
      f1p=df1(jk)
      return
      end

      function f2p(jk)
      include 'qcdiff.inc'
      parameter (nemx=nemax*3)
      common /asft/ ne,ascf(35,nemx),df1(nemx),df2(nemx),iand,
     *              iel(3,nemx)
      f2p=df2(jk)
      return
      end

      subroutine getnel(nelem)
      include 'qcdiff.inc'
      parameter (nemx=nemax*3)
      common /asft/ ne,ascf(35,nemx),df1(nemx),df2(nemx),iand,
     *              iel(3,nemx)
      nelem=ne
      return
      end


      subroutine setiwflag(iwf)
      common /cwflag/ iwflag(6)
      iwflag(3)=iwf
      return
      end

      subroutine savex(rx,rxs)
      real rx(*),rxs(*)
      common /cdim/ idm,nde
      do i=1,idm
         rxs(i)=rx(i)
      end do
      return
      end

      subroutine getrx0(x,rx,r,t,ns,ic)
      real x(*),rx(*),t(6,*)
      integer r(6,6,*)
      call getsys(isys)
      if(isys.le.2) then
         do i=1,6
            rx(i)=0.
            do j=1,6
               rx(i)=rx(i)+r(i,j,ns)*x(j)
            end do
            rx(i)=rx(i)+t(i,ns)
            if(ic.eq.1) then
               rx(i)=-rx(i)
            end if
         end do
      else
*************************************
         do i=1,6
            rx(i)=0.
            do j=1,6
               rx(i)=rx(i)+r(i,j,ns)*x(j)
            end do
            if(i.le.5) then
               rx(i)=rx(i)+t(i,ns)
               if(ic.eq.1.or.ic.eq.-1) then
                  rx(i)=-rx(i)
               end if
            else if(i.eq.6) then
               if(ic.eq.-1) then
                  rx(i)=-rx(i)
               end if
            end if
         end do
*************************************
      end if
      return
      end

      subroutine rdhkl(hk,mpl,q,fcal,nh)
      integer hk(6,*),mpl(*)
      real q(*),fcal(*)
      nh=0
 100  continue
      nh=nh+1
      read(1,'(6i2,i5,f12.6)',end=200)
     *                 (hk(i,nh),i=1,6),mpl(nh),q(nh)
           go to 100
 200  continue
      nh=nh-1
      return
      end

c      subroutine getsys(isysd)
c      common /cisys/ isys
c      isysd=isys
c      return
c      end            

c      subroutine setsys(isysd)
c      common /cisys/ isys
c      isys=isysd
c      return
c      end            

      subroutine geta(ae,ai)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *          al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      ae=al
      ai=am
      return
      end

      subroutine getc(c)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *          al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      c=cl
      return
      end

      subroutine seta(ae,ai)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *          al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      al=ae
      am=ai
      return
      end

      subroutine setc(c)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *          al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      cl=c
      return
      end


      subroutine setbrv(brv)
      character brv,brvs
      common /cbrv/ brvs
      brvs=brv
      return
      end

      subroutine getbrv(brv)
      character brv,brvs
      common /cbrv/ brvs
      brv=brvs
      return
      end
