      subroutine setprjm00()    ! set unit matrix for prj
      common /cprjm/ prj(3,3)
      call unitmtrxr(prj,3)
      return
      end

      subroutine getprjm(prjm)    ! set unit matrix for prj
      real prjm(3,3)
      common /cprjm/ prj(3,3)
      call mcpyr3(prj,prjm)
      call wtmtrxrf('projection matrix',prjm,3,'(3f10.5)')
      return
      end

      subroutine setprjm1(c0m)
      common /cprjm/ prj(3,3)
      real c0m(3,3),om1(3,3)
      call getprjm0(prj)
c     call wtmtrxrf('projection matrix',prj,3,'(3f10.5)')
      call mtmplr(c0m,prj,om1,3)
      call mcpyr3(om1,prj)
c     call wtmtrxrf('new projection matrix',prj,3,'(3f10.5)')
      return
      end

      subroutine setprjm2(ix,ph)
      common /cprjm/ prj(3,3)
c     write(6,*) 'enter setprjm2'
      call prmtrx(ix,ph,prj)
c     call wtmtrxrf('new projection matrix',prj,3,'(3f10.5)')
      return
      end

      subroutine viewtrns(xy1,rx1)
      real xy1(3),rx1(3)
      common /cprjm/ prj(3,3)
      call mtmplmnor(prj,xy1,rx1,3,3,1)
      return
      end

      block data
      common /format/ c001,c002,c003,c004,c005,c006,c007,c008,c009,
     *                c010,c011,c012,c013
      character(53) c001,c002,c003,c004,c005,c006,c007,c008,c009,c010
      character(53) c011,c012,c013*1
      data c001/'('' crystal in initial orientation'')'/
      data c002/'('' rotated about '',a1,''-axis '',f7.2,'' degree'')'/
      data c003/'('' crazy requirement'')'/
      data c004/'(7x,3i4,17x,''does not cut the crystal'')'/
      data c005/'(14h0list of faces/1h0,5x,9hh   k   l,9x,1hd/1h )'/
      data c006/'(14h0list of edges/1h0,13x,6hbgnpnt,16x,6hendpnt,'/
      data c007/'14x,6hvb,nvb/12x,1hx,7x,1hy,13x,1hx,7x,1hy/1h )'/
      data c008/'('' * back side (y,n)? *'')'/
      data c009/'('' * scale factor? *'')'/
      data c010/'('' * output into graphic data file (y,n)? *'')'/
      data c011/'('' * member name? *'')'/
      data c012/'('' * output on plotter (y,n)? *'')'/
      data c013/'y'/
      end

      subroutine prmtrx(ix,pph,prj)  ! projection matrix
      include 'impr8.inc'
      real pph,prj(3,3)
      character(53) c001,c002,c003,c004,c005,c006,c007,c008,c009,c010
      character(53) c011,c012,c013*1
      common /format/ c001,c002,c003,c004,c005,c006,c007,c008,c009,
     *                c010,c011,c012,c013

      character achse(3)
      logical l1
      real a(3,3),b(3,3),ph
      real sinph,cosph,sinph0,cosph0
      data achse/'x','y','z'/

      ph=pph*0.01745329
      cosph=cos(ph)
      sinph=sin(ph)

      l1=.true.

      go to 5
      entry prmx(ix,cosph0,sinph0)
      cosph=cosph0
      sinph=sinph0
      l1=.false.
 5    continue
      if(ix.gt.3) return

c     if(ix.lt.0) then
      if(ix.eq.1) then
         a(1,1)=1.0
         a(1,2)=0.0
         a(1,3)=0.0
         a(2,1)=0.0
         a(2,2)=cosph
         a(2,3)=-sinph
         a(3,1)=0.0
         a(3,2)=sinph
         a(3,3)=cosph
c     else if(ix.eq.0) then
      else if(ix.eq.2) then
         a(1,1)=cosph
         a(1,2)=0.0
         a(1,3)=sinph
         a(2,1)=0.0
         a(2,2)=1.0
         a(2,3)=0.0
         a(3,1)=-sinph
         a(3,2)=0.0
         a(3,3)=cosph
c     else
      else if(ix.eq.3) then
         a(1,1)=cosph
         a(1,2)=-sinph
         a(1,3)=0.0
         a(2,1)=sinph
         a(2,2)=cosph
         a(2,3)=0.0
         a(3,1)=0.0
         a(3,2)=0.0
         a(3,3)=1.0
      else
         call quit('invalid ix in prmtrx, ix=1,2 or 3 ?')
      end if
      call mtmplr3(a,prj,b)
      call mcpyr3(b,prj)
      if(l1) write(6,fmt=c002) achse(ix),pph
      return
      end

