      subroutine zeromtrxr(mtrx,n)
      real mtrx(n,n)
      do i=1,n
         do j=1,n
            mtrx(i,j)=0
         end do
      end do
      return
      end

      subroutine zeromtrxi(mtrx,n)
      integer mtrx(n,n)
      do i=1,n
         do j=1,n
            mtrx(i,j)=0
         end do
      end do
      return
      end

      subroutine mcpy3(s1,s2)
      real s1(3,3)
      real s2(3,3)
      do i=1,3
         do j=1,3
            s2(i,j)=s1(i,j)
         end do
      end do
      return
      end

      subroutine mtmul(r1,r2,r3)
      integer r1(6,6),r2(6,6),r3(6,6)
      call mtmpli6(r1,r2,r3)
c      do i=1,6
c         do j=1,6
c            r3(i,j)=0
c            do k=1,6
c               r3(i,j)=r3(i,j)+r1(i,k)*r2(k,j)
c            end do
c         end do
c      end do
      return
      end

      subroutine micpy(from,to)
      integer from(6,6),to(6,6)
      call mcpyi6(from,to)
c      do i=1,6
c         do j=1,6
c            to(i,j)=from(i,j)
c         end do
c      end do
      return
      end

      subroutine mcpyr6(from,to)  ! copy real 6x6 matrix
      real from(6,6),to(6,6)
      do i=1,6
         do j=1,6
            to(i,j)=from(i,j)
         end do
      end do
      return
      end

      subroutine mcpyi6(from,to)  ! copy integer 6x6 matrix
      integer from(6,6),to(6,6)
      do i=1,6
         do j=1,6
            to(i,j)=from(i,j)
         end do
      end do
      return
      end

      subroutine mcpyir6(from,to) ! copy integer 6x6 to real 6x6 matrix
      integer from(6,6)
      real to(6,6)
      do i=1,6
         do j=1,6
            to(i,j)=from(i,j)
         end do
      end do
      return
      end

      subroutine mtmplr6(a,b,c)   ! multiply real 6x6 matrices
      real a(6,6),b(6,6),c(6,6)
      do i=1,6
         do j=1,6
            c(i,j)=0.
            do k=1,6
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmpli6(a,b,c)   ! multiply integer 6x6 matrices
      integer a(6,6),b(6,6),c(6,6)
      do i=1,6
         do j=1,6
            c(i,j)=0.
            do k=1,6
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmplri6(a,b,c)   ! multiply real and integer 6x6 matrices
      real a(6,6),c(6,6)
      integer b(6,6)
      do i=1,6
         do j=1,6
            c(i,j)=0.
            do k=1,6
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmplir6(a,b,c)   ! multiply integer and real 6x6 matrices
      integer a(6,6)
      real b(6,6),c(6,6)
      do i=1,6
         do j=1,6
            c(i,j)=0.
            do k=1,6
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine xmpy(a,b,c,lm,ln,lp)
      real a(3,*),b(3,*),c(3,*)
      call mtmplrmno(a,b,c,lm,ln,lp)
      return
      end

      subroutine mtmplrmno(a,b,c,m,n,o) ! multiply real mxn and mxo matrices
      integer m,n,o
      real a(m,n),b(n,o),c(m,o)
      do i=1,m
         do j=1,o
            c(i,j)=0.
            do k=1,n
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmplimno(a,b,c,m,n,o) ! multiply integer mxn and mxo matrices
      integer m,n,o
      integer a(m,n),b(n,o),c(m,o)
      do i=1,m
         do j=1,o
            c(i,j)=0.
            do k=1,n
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmplirmno(a,b,c,m,n,o) ! multiply integer mxn and real nxo matrices
      integer m,n,o
      integer a(m,n)
      real b(n,o),c(m,o)
      do i=1,m
         do j=1,o
            c(i,j)=0.
            do k=1,n
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmplrimno(a,b,c,m,n,o) ! multiply real mxn and integer nxo matrices
      integer m,n,o
      real a(m,n),c(m,o)
      integer b(n,o)
      do i=1,m
         do j=1,o
            c(i,j)=0.
            do k=1,n
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine trnspr6(sm)  ! for backward compatibility
      real smd(6,6),sm(6,6)
      do i=1,6
         do j=1,6
            smd(i,j)=sm(j,i)
         end do
      end do
      do i=1,6
         do j=1,6
            sm(i,j)=smd(i,j)
         end do
      end do
      return
      end

      subroutine trnspi6(sm)  ! for backward compatibility
      integer smd(6,6),sm(6,6)
      do i=1,6
         do j=1,6
            smd(i,j)=sm(j,i)
         end do
      end do
      do i=1,6
         do j=1,6
            sm(i,j)=smd(i,j)
         end do
      end do
      return
      end

      subroutine mtrnspr3(sm)
      real smd(3,3),sm(3,3)
      do i=1,3
         do j=1,3
            smd(i,j)=sm(j,i)
         end do
      end do
      do i=1,3
         do j=1,3
            sm(i,j)=smd(i,j)
         end do
      end do
      return
      end

      subroutine mtrnspi3(sm)
      integer smd(3,3),sm(3,3)
      do i=1,3
         do j=1,3
            smd(i,j)=sm(j,i)
         end do
      end do
      do i=1,3
         do j=1,3
            sm(i,j)=smd(i,j)
         end do
      end do
      return
      end

      subroutine mtrnspr6(sm)
      real smd(6,6),sm(6,6)
      do i=1,6
         do j=1,6
            smd(i,j)=sm(j,i)
         end do
      end do
      do i=1,6
         do j=1,6
            sm(i,j)=smd(i,j)
         end do
      end do
      return
      end

      subroutine mtrnspi6(sm)
      integer smd(6,6),sm(6,6)
      do i=1,6
         do j=1,6
            smd(i,j)=sm(j,i)
         end do
      end do
      do i=1,6
         do j=1,6
            sm(i,j)=smd(i,j)
         end do
      end do
      return
      end

      subroutine qsort(x,st,ip,nx)
c     quick sort (ascending order of x)
c     nx: the number of data x
c     ip: the initial order
c     st: a work array
      real x(nx)
      integer r,s,st(nx,0:1),ip(nx)
      if(nx.eq.0) return
      do i=1,nx
         ip(i)=i
      end do
      s=1
      st(1,0)=1
      st(1,1)=nx
    1 l=st(s,0)
      r=st(s,1)
      s=s-1
    2 i=l
      j=r
      xt=x((l+r)/2)
    3 if(i.lt.nx) then
         if(x(i).lt.xt) then
            i=i+1
            go to 3
         endif
      endif
    4 if(j.gt.1) then
         if(xt.lt.x(j)) then
            j=j-1
            go to 4
         endif
      endif
      if(i.le.j) then
        temp=x(j)
        x(j)=x(i)
        x(i)=temp
        itemp=ip(j)
        ip(j)=ip(i)
        ip(i)=itemp
        if(i.le.nx.and.j.ge.1) then
           i=i+1
           j=j-1
           go to 3
        end if
      endif
      if(j-l.le.r-i) go to 5
      if(i.lt.r) then
         s=s+1
         st(s,0)=i
         st(s,1)=r
      endif
      r=j
      go to 6
    5 if(l.lt.j) then
         s=s+1
         st(s,0)=l
         st(s,1)=j
      endif
      l=i
    6 if(l.lt.r) go to 2
      if(s.ne.0) go to 1
      return
      end

      subroutine mcpyr(s1,s2,n)
      real s1(n,n)
      real s2(n,n)
      do i=1,n
         do j=1,n
            s2(i,j)=s1(i,j)
         end do
      end do
      return
      end

      subroutine mcpyi(s1,s2,n)
      integer s1(n,n)
      integer s2(n,n)
      do i=1,n
         do j=1,n
            s2(i,j)=s1(i,j)
         end do
      end do
      return
      end

      subroutine mcpyr3(s1,s2)
      real s1(3,3)
      real s2(3,3)
      do i=1,3
         do j=1,3
            s2(i,j)=s1(i,j)
         end do
      end do
      return
      end

      subroutine mcpyi3(s1,s2)
      integer s1(3,3)
      integer s2(3,3)
      do i=1,3
         do j=1,3
            s2(i,j)=s1(i,j)
         end do
      end do
      return
      end

      subroutine mcpymn(x,y,m,n)
      real x(m,n), y(m,n)
      do i=1,m
         do j=1,n
            y(i,j)=x(i,j)
         end do
      end do
      return
      end

      subroutine zerov(v1,n)  ! zero vectors
      real v1(*)
      call zerovr(v1,n)
      return
      end

      subroutine zerovr(v1,n)  ! zero vectors
      real v1(*)
      do j=1,n
         v1(j)=0
      end do
      return
      end

      subroutine zerovc(v1,n)  ! complex zero vectors
      complex v1(*)
      do j=1,n
         v1(j)=0
      end do
      return
      end

      subroutine zerovi(v1,n)  ! zero integer vectors
      integer v1(*)
      do j=1,n
         v1(j)=0
      end do
      return
      end

      integer function ifzerovr(v1,n)  ! zero vectors
      real v1(*)
      do j=1,n
         if(v1(j).ne.0) then
            ifzerovr=0
            return
         end if
      end do
      ifzerovr=1
      return
      end


      function vinpr(x,y,n) ! inner product of vactors  x and y
      real x(*),y(*)
      vinpr=0
      do i=1,n
         vinpr=vinpr+x(i)*y(i)
      end do
      return
      end

      integer function vinpi(x,y,n) ! inner product of vactors  x and y
      integer x(*),y(*)
      vinpi=0
      do i=1,n
         vinpi=vinpi+x(i)*y(i)
      end do
      return
      end

      function vinpir(h,x,n) ! inner product of vactors  x and y
      integer h(*)
      real x(*)
      vinpir=0
      do i=1,n
         vinpir=vinpir+h(i)*x(i)
      end do
      return
      end

      function vinpri(x,h,n) ! inner product of vactors  x and y
      integer h(*)
      real x(*)
      vinpri=0
      do i=1,n
         vinpri=vinpri+h(i)*x(i)
      end do
      return
      end

      function vabs(x,n) ! absolute value of vector x
      real x(*)
      vabs=0
      do i=1,n
         vabs=vabs+x(i)**2
      end do
      vabs=sqrt(vabs)
      return
      end

      subroutine mtmpli(a,b,c)     ! mutrix multiplication (6D only)
      integer a(6,6),b(6,6),c(6,6)
      do i=1,6
         do j=1,6
            c(i,j)=0.
            do k=1,6
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine norml(x,n)
      real x(*)
      data eps /0.000001/
c     normalization of x
      absh=vabs(x,n)
      if(absh.gt.eps) then
         do i=1,n
            x(i)=x(i)/absh
         end do
      end if
      return
      end

      subroutine wtvctrr(str,v,n)
      character*(*) str
      real v(*)
      write(6,'(a,$)') str
      write(6,*) (v(j),j=1,n)
      return
      end

      subroutine wtvctri(str,v,n)
      character*(*) str
      integer v(*)
      write(6,'(a,$)') str
      write(6,*) (v(j),j=1,n)
      return
      end

      subroutine wtvctrrf(str,v,n,frmt)
      character*(*) str,frmt
      real v(*)
      write(6,'(a,$)') str
      write(6,frmt) (v(j),j=1,n)
      return
      end

      subroutine wtvctrif(str,v,n,frmt)
      character*(*) str,frmt
      integer v(*)
      write(6,'(a,$)') str
      write(6,frmt) (v(j),j=1,n)
      return
      end

      real function mtrxrdiag(m,n)
                           ! get diagonal term of trianguler matrix
      real m(*)            ! trianguler matrix
      mtrxrdiag=m(n*(n+1)/2) ! n-th diagonal term 
      return
      end

      subroutine wttangmtrxr(str,m,n)  ! write trianguler matrix
      character*(*) str
      real m(*)
      write(6,'(a)') str
      do i=1,n
         write(6,*) (m(j+(i-1)*i/2),j=1,i)
      end do
      return
      end

      subroutine wttangmtrxr_f(str,m,n,frmt)
                                ! write trianguler matrix with format
      character*(*) str
      real m(*)
      write(6,'(a)') str
      do i=1,n
         write(6,*) (m(j+(i-1)*i/2),j=1,i)
      end do
      return
      end

      subroutine wttangdiagr(str,m,n)  ! write trianguler matrix diagonal term
      character*(*) str
      real m(*)
      write(6,'(a,$)') str
      write(6,*) (m(i+(i-1)*i/2),i=1,n)
      return
      end

      subroutine wtmtrxr(str,m,n)
      character*(*) str
      real m(n,*)
      write(6,'(a,$)') str
      do i=1,n
         write(6,*) (m(i,j),j=1,n)
      end do
      return
      end

      subroutine wtmtrxi(str,m,n)
      character*(*) str
      integer m(n,*)
      write(6,'(a,$)') str
      do i=1,n
         write(6,*) (m(i,j),j=1,n)
      end do
      return
      end

      subroutine wtmtrxif(str,mtrx,n,frmt)
      character*(*) str,frmt
      integer mtrx(n,n)
      write(6,'(a)') str
      do i=1,n
         write(6,frmt) (mtrx(i,j),j=1,n)
      end do
      return
      end

      subroutine wtmtrxrf(str,mtrx,n,frmt)
      character*(*) str,frmt
      real mtrx(n,n)
      write(6,'(a)') str
      do i=1,n
         write(6,frmt) (mtrx(i,j),j=1,n)
      end do
      return
      end

      subroutine matinv(a,nm,n,b,m,determ,ipivot,index,pivot)
c
c    n*n matrix a is replaced by its inverse matrix a**-1
c    if m is nonzero vector b is replaced by a**-1*b
c
c      dimension a(nm,nm),b(nm),ipivot(nm),index(nm,2),pivot(nm)
      real a(nm,nm),b(nm),pivot(nm)
      integer ipivot(nm),index(nm,2)
      equivalence (irow,jrow),(icolum,jcolum),(amax,t,swap)
      determ=1.0
      do j=1,n
         ipivot(j)=0
      end do
      do i=1,n
         amax=0.0
         do j=1,n
            if(ipivot(j).eq.1) go to 105
            do k=1,n
c               if(ipivot(k)-1) 80,100,740
               if(ipivot(k)-1.lt.0) then
 80               if(abs(amax).ge.abs(a(j,k))) go to 100
                  irow=j
                  icolum=k
                  amax=a(j,k)
               else if(ipivot(k)-1.gt.0) then
                  go to 740
               end if
 100           continue
            end do
 105        continue
         end do
         ipivot(icolum)=ipivot(icolum)+1
         if(irow.eq.icolum) go to 260
         determ=-determ
         do l=1,n
            swap=a(irow,l)
            a(irow,l)=a(icolum,l)
            a(icolum,l)=swap
         end do
         if(m.eq.0) go to 260
         swap=b(irow)
         b(irow)=b(icolum)
         b(icolum)=swap
 260     index(i,1)=irow
         index(i,2)=icolum
         pivot(i)=a(icolum,icolum)
         determ=determ*pivot(i)
         a(icolum,icolum)=1.0
         do l=1,n
            a(icolum,l)=a(icolum,l)/pivot(i)
         end do
         if(m.eq.0) go to 380
         b(icolum)=b(icolum)/pivot(i)
 380     continue
         do l1=1,n
            if(l1.eq.icolum) go to 550
            t=a(l1,icolum)
            a(l1,icolum)=0.0
            do l=1,n
               a(l1,l)=a(l1,l)-a(icolum,l)*t
            end do
            if(m.eq.0) go to 550
            b(l1)=b(l1)-b(icolum)*t
 550        continue
         end do
      end do
      do i=1,n
         l=n+1-i
         if(index(l,1).eq.index(l,2)) go to 710
         jrow=index(l,1)
         jcolum=index(l,2)
         do k=1,n
            swap=a(k,jrow)
            a(k,jrow)=a(k,jcolum)
            a(k,jcolum)=swap
         end do
 710  continue
      end do
 740  continue
      return
      end

      subroutine chlsk(m,b,x,n,mi,isng,iret,dmp,sqrtm)
c     solve the normal equation mx=b  where m is n*n real positive
c                  matrix
c     choleskis decomposition of matrix m to l*lt where l is lower
c     triangular matrix and lt is its transpose matrix
c     m is replaced by l
c     if mi=0,1   x is calculated
c     if mi=1,2   m is replaced by its inversion
      real m(*),b(*),x(*),sqrtm(*)
c     normalization
      isng=0
      ii=0
      ij=0
      do i=1,n
         ii=ii+i
         if(m(ii).eq.0) then
            isng=1
            write(6,*) 'matrix is singular'
            iret=i
            return
         end if
         sqrtm(i)=sqrt(m(ii))
         if(mi.ne.2) x(i)=b(i)/sqrtm(i)
         do j=1,i
            ij=ij+1
            m(ij)=m(ij)/(sqrtm(i)*sqrtm(j))
            if(i .eq. j) m(ij)=m(ij)+dmp
         end do
      end do
c     choleskis decomposition
      i0=0
      do i=1,n
         i0=i0+i-1
         j0=i0-i+1
         do j=i,n
            j0=j0+j-1
            am=0.0
            do k=1,i
               jk=j0+k
               ik=i0+k
               if(k.ne.i) am=am-m(jk)*m(ik)
               if(k .eq. i) am=am+m(jk)
            end do
            if(j .eq. i.and.am .le.0.0) then
               isng=1
               write(6,*) 'matrix is singular or nonpositive'
               iret=i
               return
            end if
            if(j .eq. i) m(jk)=sqrt(am)
            if(j.ne.i) m(jk)=am/m(ik)
         end do
      end do

c     solution of normal equation
      if(mi .eq. 2) go to 25
      ij=0
      do i=1,n
         am=x(i)
         do j=1,i
            ij=ij+1
            if(j.ne.i) am=am-m(ij)*x(j)
            if(j .eq. i) x(i)=am/m(ij)
         end do
      end do
      nn=n*(n+1)/2
      do j=1,n
         i=n+1-j
         ki=nn+i
         am=x(i)
         do kd=i,n
            k=n+i-kd
            ki=ki-k
            if(k.ne.i) am=am-m(ki)*x(k)
            if(k .eq. i) x(i)=am/m(ki)
         end do
      end do
      do i=1,n
         x(i)=x(i)/sqrtm(i)
      end do
      if(mi .eq. 0) return
c     matrix inversion of matrix l

 25   i0=0
      do i=1,n
         i0=i0+i-1
         j0=i0-i+1
         do j=i,n
            am=0.0
            if(j .eq. i) am=1.0
            j0=j0+j-1
            ki=i0+1
            do k=i,j
               jk=j0+k
               ki=ki+k-1
               if(k.ne.j) am=am-m(jk)*m(ki)
               if(k .eq. j) m(ki)=am/m(jk)
            end do
         end do
      end do
c     matrix inversion of matrix m
      ij=0
      i0=0
      do i=1,n
         i0=i0+i-1
         do j=1,i
            am=0.0
            k0=i0-i+1
            do k=i,n
               k0=k0+k-1
               ki=k0+i
               kj=k0+j
               am=am+m(ki)*m(kj)
            end do
            ij=ij+1
            m(ij)=am/(sqrtm(i)*sqrtm(j))
         end do
      end do
      return
      end

      subroutine vprdr(v1,v2,v3) ! vector product of v1 and v2 is v3
      real v1(3),v2(3),v3(3)
      v3(1)=v1(2)*v2(3)-v1(3)*v2(2)
      v3(2)=v1(3)*v2(1)-v1(1)*v2(3)
      v3(3)=v1(1)*v2(2)-v1(2)*v2(1)
      return
      end

      function determ3(u1,u2,u3)
      real u1(3),u2(3),u3(3)
      determ3=u1(1)*(u2(2)*u3(3)-u2(3)*u3(2))+
     *        u1(2)*(u2(3)*u3(1)-u2(1)*u3(3))+
     *        u1(3)*(u2(1)*u3(2)-u2(2)*u3(1))
      return
      end

      subroutine wtrvct6(str,ej1)
      character*(*) str
      real ej1(6)
      write(6,'(a,6f10.5)') str,(ej1(j),j=1,6)
      return
      end

      subroutine wtrmtrx6(str,rmtrx)
      character*(*) str
      real rmtrx(6,6)
      write(6,*) str
      do i=1,6
         write(6,'(6f10.5)') (rmtrx(i,j),j=1,6)
      end do
      return
      end

      subroutine mtmpl(a,b,c)
      real a(6,6),b(6,6),c(6,6)
      do i=1,6
         do j=1,6
            c(i,j)=0.
            do k=1,6
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine trnsp(sm)
      real smd(6,6),sm(6,6)
      do i=1,6
         do j=1,6
            smd(i,j)=sm(j,i)
         end do
      end do
      do i=1,6
         do j=1,6
            sm(i,j)=smd(i,j)
         end do
      end do
      return
      end

      subroutine mtmlt(x,y,z,n)
      real x(n,n), y(n,n), z(n,n)
      do i=1,n
         do j=1,n
            z(i,j)=0
            do k=1,n
               z(i,j)=z(i,j)+x(i,k)*y(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmltir(x,y,z,n)
      integer x(n,n)
      real y(n,n), z(n,n)
      do i=1,n
         do j=1,n
            z(i,j)=0
            do k=1,n
               z(i,j)=z(i,j)+x(i,k)*y(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmltri(x,y,z,n)
      real x(n,n)
      integer y(n,n)
      real z(n,n)
      do i=1,n
         do j=1,n
            z(i,j)=0
            do k=1,n
               z(i,j)=z(i,j)+x(i,k)*y(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmltijk(x,y,z,i,j,k)
      real x(i,j), y(j,k), z(i,k)
      do id=1,i
         do kd=1,k
            z(id,kd)=0
            do jd=1,j
               z(id,kd)=z(id,kd)+x(id,jd)*y(jd,kd)
            end do
         end do
      end do
      return
      end

      function atan3(y,x)
      real x,y
      data pi /3.1415926536/
      data eps /0.00001/
      if(abs(x) .lt.eps) then
         if(y .gt. eps) then
            atan3=pi/2
         else
            atan3=-pi/2
         end if
      else
         atan3=atan2(y,x)    ! -pi .lt. atan3 .le. pi
      end if
      return
      end

      subroutine vmult(v1,v2,v3,n) ! v3(i)=v1(i)*v2(i)
      real v1(*),v2(*),v3(*)
      do j=1,n
         v3(j)=v1(j)*v2(j)
      end do
      return
      end

      subroutine vaddr(v1,v2,v3,n) ! v3=v1+v2  vector addition
      real v1(*),v2(*),v3(*)
      do j=1,n
         v3(j)=v1(j)+v2(j)
      end do
      return
      end

      subroutine vsubr(v1,v2,v3,n) ! v3=v1-v2  vector subtruction
      real v1(*),v2(*),v3(*)
      do j=1,n
         v3(j)=v1(j)-v2(j)
      end do
      return
      end

      subroutine vcpyr(dd,de,n)  ! copy real vector
      real dd(*),de(*)
      do j=1,n
         de(j)=dd(j)
      end do
      return
      end

      subroutine vcpyir(dd,de,n)  ! copy integer vector to real vector
      integer dd(*)
      real de(*)
      do j=1,n
         de(j)=dd(j)
      end do
      return
      end

      subroutine vcpyi(dd,de,n) ! copy integer vector
      integer dd(*),de(*)
      do 10 j=1,n
      de(j)=dd(j)
 10   continue
      return
      end

      subroutine vsum(x1,x2,x3,n)
      real x1(*),x2(*),x3(*)
      do j=1,n
         x3(j)=x1(j)+x2(j)
      end do
      return
      end

      subroutine vsub(x1,x2,x3,n)
      real x1(*),x2(*),x3(*)
      do j=1,n
         x3(j)=x1(j)-x2(j)
      end do
      return
      end
