      subroutine getiaslct0(iaslct,n)
      integer iaslct(*)
      include 'qcdiff.inc'
      common /cislct0/ iaslct0(120,namax)
      call vcpyi(iaslct0(1,n),iaslct,120)
      return
      end

      subroutine rdpod(npod)
      include 'qcdiff.inc'
      common /cwflag/ iwflag(6)
      common /copd1/ ramin00(namax),ramax00(namax)
      common /copd2/ ej0(7,nemax,namax),nej0(namax),nth0(namax),
     *     mej0(3,nemax,namax)
      common /cislct0/ iaslct0(120,namax)
      character(40) str
      common /ctype/ ityp(-2:namax)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      real fj(7,nemax)
      call getsys(isys)
      call getinp(inpu)
      call getout(iout)
      iwflag(3)=1
      if(isys.ne.5) then
         nd=6
      else
         nd=7
      end if
      do i=1,npod
         read(inpu,*) n,nej0(i),ityp(i),str
         do j=1,nej0(i)
            call freadra('ej=',nd,ej0(1,j,i),1)
         end do
         if(iwflag(3).eq.1) then
            write(iout,302) n, nej0(i), str
         end if
         do j=1,nej0(i)
            write(iout,303) 'ej=', (ej0(k,j,i),k=1,nd)
         end do
         call freadis('nth=',1,nth0(i),1)
         write(6,*) 'nth0=',nth0(i)
         if(nth0(i).gt.nemax) call quit('nth > nemax')
         do j=1,nth0(i)
            if(isys.le.2) then
               call freadia(' ',3,mej0(1,j,i),0)
            else
               call freadia(' ',2,mej0(1,j,i),0)
            end if
         end do
         call wtmej0(mej0(1,1,i),nth0(i))
         read(inpu,'(60i1)') (iaslct0(j,i),j=1,nsymo*(icent+1))
         write(iout,'(60i1)') (iaslct0(j,i),j=1,nsymo*(icent+1))
      end do
 300  format(' ')
 301  format(' ','na=',i3)
 302  format(' ',2i4,a)
 303  format(' ',a,7(f8.5,1x),1x,a,f8.5)
      return
      end

      subroutine wtmej0(mej0,nth0)
      include 'qcdiff.inc'
      integer mej0(3,*)                
      call getsys(isys)
      call getout(iout)
      if(isys.le.2) then
         write(iout,304) ('(',(mej0(k,j),k=1,3),j=1,nth0)
      else
         write(iout,305) ('(',(mej0(k,j),k=1,2),j=1,nth0)
      end if
      return
 304  format(1h ,'(e1,e2,e3)=',8(a,i2,',',i2,',',i2,')')/
     *                (1h ,11x,8(a,i2,',',i2,',',i2,')')))
 305  format(1h ,'(e1,e2)=',10(a,i2,',',i2,')')/
     *              (1h ,8x,10(a,i2,',',i2,')')))
      end

      subroutine setnpod(npo)
      common /copd3/ npod
      npod=npo
      return
      end

      subroutine getnpod(npodd)
      common /copd3/ npod
      npodd=npod
      return
      end

      function getfacti(brv)
      character brv
      integer getisys
      isys=getisys()
      if(brv.eq.'p') then
         fact=1
      else if(isys.le.2.and.(brv.eq.'f'.or.brv.eq.'s')) then
         fact=32
      else if(brv.eq.'i') then
         fact=2
      else if(brv.eq.'g') then
         fact=1
      else
         call quit('invalid brv in vivoli')
      end if
      getfacti=fact
      return
      end

      function getfactd(brv)
      character brv
      integer getisys
      isys=getisys()
      if(brv.eq.'p'.or.brv.eq.'s') then
         fact=1
      else if(brv.eq.'i') then
         fact=2
      else if(brv.eq.'c') then
         fact=2
      else
         call quit('invalid brv in vivold')
      end if
      getfactd=fact
      return
      end

      subroutine vivoli(na,mpl,isk,irs)
c      volume of each occupation domainnd
      integer isk(0:120,*), irs(0:120,*)
      real mpl(*)
      include 'qcdiff.inc'
      parameter (nemx=nemax*3)
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      common /cstrc7/ p(namax),s(2,namax),ramin(namax),ramax(namax)
      common /cpnf1/ atp(3),atp0(3),datpdp(3,3,namax)
      real vn(namax)
      real vi(nemax)
      real e1e2(6)
      character brv
      integer r
      integer getien,getish
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      integer hr(6)
      integer getiel
c      data pi2/6.28318/, eps/0.001/, ras/1.4325/
      data pi2/6.28318/, eps/0.001/, ras/1./
      data hr/0,0,0,0,0,0/

c     write(6,*) '*****icent in vivoli****',icent
      call getsys(isys)
      pi4=2*pi2
      call getbrv(brv)
****************
      atp(1)=0
      atp(2)=0
      atp(3)=0
      call geta(al)
      call getam(am)

      do n=1,na
c  ****** vi: volume of rhombohedron with edge vecotrs e1,e2,e3
         ishn=getish(n)
         if(ishn.ge.0) then
c           tetrahedron
            vn(n)=0
            call getvii(n,vi)
            call setvi(n,vi)
            do j=1,nth(n)
               vn(n)=vn(n)+
     *              vi(j)*mpl(n)*isk(0,n)*irs(0,n)*
     *              (ramax(n)**3-ramin(n)**3)/6
            end do
         else if(ishn.eq.-1) then
c           ellipsoid
            r1=vabs(ej(4,1,n),3)
            r2=vabs(ej(4,2,n),3)
            r3=vabs(ej(4,3,n),3)
            vn(n)=pi4*r1*r2*r3*mpl(n)*isk(0,n)*
     *           (ramax(n)**3-ramin(n)**3)*am**3/3
         else if(ishn.eq.-2) then
c           sphare
            v=pi4*ras**3*am**3/3
            vn(n)=v*mpl(n)*isk(0,n)*(ramax(n)**3-ramin(n)**3)
         else 
            call quit('invalid ish')
         end if
         ie=getien(n)
         i1=getiel(1,ie)
         i2=getiel(2,ie)
         i3=getiel(3,ie)
         if(i1.gt.3.or.i2.gt.3.or.i3.gt.3) then
            write(6,*) 'ie=',ie,' iel=',i1,i2,i3
            call quit('iel invalid')
         end if
         if(i1.lt.1.or.i2.lt.1.or.i3.lt.1) then
            write(6,*) 'ie=',ie,' iel=',i1,i2,i3
            call quit('iel invalid')
         end if
         atp(i1)=atp(i1)+vn(n)*(1-s(1,n)-s(2,n))*p(n)/am**3
         atp(i2)=atp(i2)+vn(n)*(s(1,n))*p(n)/am**3
         atp(i3)=atp(i3)+vn(n)*(s(2,n))*p(n)/am**3
         datpdp(i1,1,n)=vn(n)*(1-s(1,n)-s(2,n))/am**3
         datpdp(i1,2,n)=vn(n)*(-p(n))/am**3
         datpdp(i1,3,n)=vn(n)*(-p(n))/am**3
         datpdp(i2,1,n)=vn(n)*(s(1,n))/am**3
         datpdp(i2,2,n)=vn(n)*p(n)/am**3
         datpdp(i2,3,n)=0
         datpdp(i3,1,n)=vn(n)*(s(2,n))/am**3
         datpdp(i3,2,n)=0
         datpdp(i3,3,n)=vn(n)*p(n)/am**3

************************
         vn(n)=vn(n)/am**3  ! independent of am
************************
      end do
      if(icent.eq.1) then
          do n=1,na
             vn(n)=vn(n)*2
          end do
          atp(1)=atp(1)*2
          atp(2)=atp(2)*2
          atp(3)=atp(3)*2
      else
         do n=1,na
            vn(n)=vn(n)
         end do
         atp(1)=atp(1)
         atp(2)=atp(2)
         atp(3)=atp(3)
      end if
      vt=0
      do n=1,na
         vt=vt+vn(n)*p(n)
      end do
      fact=getfacti(brv)
      write(6,*) 'volume of the occupation domain',vt,'(a**3)'
      write(6,'(4(a,i3,f12.6))') (' atom',n,vn(n)*p(n),n=1,na)
      tatp=atp(1)+atp(2)+atp(3)
      f000=atp(1)*asf(0.,1)+atp(2)*asf(0.,2)+atp(3)*asf(0.,3)
      atp(1)=atp(1)/tatp
      atp(2)=atp(2)/tatp
      atp(3)=atp(3)/tatp
      do n=1,na
         do i=1,3
            do j=1,3
               datpdp(i,j,n)=datpdp(i,j,n)/tatp
            end do
         end do
      end do
      call getdet(det)  ! volume of unit cell in reciprocal space (a**-6)
      write(6,'(a,3f12.6,a,f12.6,a,a,f12.6,a)')
     *     ' chemical composition', atp(1),atp(2),atp(3),
     *     '  point density=', vt*abs(det)*fact, '(a**-3)',
     *     ' = ',vt*abs(det)*fact/al**3,'(A**-3)'
      write(6,*) 'f000=',f000
      return
      end

      subroutine vivold(na,mpl,isk,irs)
      integer isk(0:120,*),irs(0:120,*)
      real mpl(*)
      include 'qcdiff.inc'
      parameter (nemx=nemax*3)
c      common /asft/ ne,ascf(35,nemx),df1(nemx),df2(nemx),iel(3,nemx)
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      common /cstrc7/ p(namax),s(2,namax),ramin(namax),ramax(namax)
      common /cpnf1/ atp(3),atp0(3),datpdp(3,3,namax)
      real vn(namax)
      real vi(nemax)
      character brv
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      integer getien,getish,getiel
c      data pi/3.141592/, eps/0.0001/, ras/0.8700/, sqrt5/2.23606/
      data pi/3.141592/, eps/0.0001/, ras/1./, sqrt5/2.23606/

****************
      call getbrv(brv)
      atp(1)=0
      atp(2)=0
      atp(3)=0
      call geta(al)
      call getam(am)
      call getc(cl)
      do n=1,na
c*****     ej: edge vectors of triangle in vi
c          vi: area of the triangle with edges ej
c*****     ish(n)      : 0: triangle 1: ellips 2: circle
         ishn=getish(n)
         if(ishn.ge.0) then
c           triangle
            vn(n)=0
            do j=1,nth(n)
               k1=mej(1,j,n)
               k2=mej(2,j,n)
               call getvid(n,vi)
               call setvi(n,vi)
               vn(n)=vn(n)+
     *              vi(j)*mpl(n)*isk(0,n)*irs(0,n)*
     *              (ramax(n)**2-ramin(n)**2)/2
            end do
      else if(ishn.eq.-1) then
c     ellips
         r1=vabs(ej(4,1,n),2)
         r2=vabs(ej(4,2,n),2)
c     si=pi*r1*r2*(2/sqrt5)**2*am**2
         si=pi*r1*r2*am**2
         vn(n)=si*mpl(n)*isk(0,n)*(ramax(n)**2-ramin(n)**2)*am**2
      else if(ishn.eq.-2) then
c          circle
c           si=pi*(2/sqrt5)**2*ras**2*am**2
           si=pi*ras**2*am**2
           vn(n)=si*mpl(n)*isk(0,n)*(ramax(n)**2-ramin(n)**2)
      end if
      ie=getien(n)
      i1=getiel(1,ie)
      i2=getiel(2,ie)
      i3=getiel(3,ie)
      if(i1.gt.3.or.i2.gt.3.or.i3.gt.3) then
         write(6,*) 'ie=',ie,' iel=',i1,i2,i3
         call quit('iel invalid')
      end if
      if(i1.lt.1.or.i2.lt.1.or.i3.lt.1) then
         write(6,*) 'ie=',ie,' iel=',i1,i2,i3
         call quit('iel invalid')
      end if
      atp(i1)=atp(i1)+vn(n)*(1-s(1,n)-s(2,n))*p(n)/am**2
      atp(i2)=atp(i2)+vn(n)*(s(1,n))*p(n)/am**2
      atp(i3)=atp(i3)+vn(n)*(s(2,n))*p(n)/am**2
      datpdp(i1,1,n)=vn(n)*(1-s(1,n)-s(2,n))/am**2
      datpdp(i1,2,n)=vn(n)*(-p(n))/am**2
      datpdp(i1,3,n)=vn(n)*(-p(n))/am**2
      datpdp(i2,1,n)=vn(n)*(s(1,n))/am**2
      datpdp(i2,2,n)=vn(n)*p(n)/am**2
      datpdp(i2,3,n)=0
      datpdp(i3,1,n)=vn(n)*(s(2,n))/am**2
      datpdp(i3,2,n)=0
      datpdp(i3,3,n)=vn(n)*p(n)/am**2
******************
      vn(n)=vn(n)/am**2
******************
      end do
      if(icent.eq.1) then
          do n=1,na
             vn(n)=vn(n)*2
          end do
          atp(1)=atp(1)*2
          atp(2)=atp(2)*2
          atp(3)=atp(3)*2
      else
          do n=1,na
             vn(n)=vn(n)
          end do
          atp(1)=atp(1)
          atp(2)=atp(2)
          atp(3)=atp(3)
      end if
      vt=0
      do n=1,na
c        vt=vt+vn(n)*sign(1.,p(n))
         vt=vt+vn(n)*p(n)
      end do
      fact=getfactd(brv)

      write(6,*) 'volume of the occupation domain',vt*fact,'(a**2)'
      write(6,'(4(a,i3,f12.6))') (' atom',n,vn(n)*p(n)*fact,n=1,na)
      tatp=atp(1)+atp(2)+atp(3)
      f000=atp(1)*asf(0.,1)+atp(2)*asf(0.,2)+atp(3)*asf(0.,3)
      atp(1)=atp(1)/tatp
      atp(2)=atp(2)/tatp
      atp(3)=atp(3)/tatp
      do n=1,na
         do i=1,3
            do j=1,3
               datpdp(i,j,n)=datpdp(i,j,n)/tatp
            end do
         end do
      end do
      call getdet(det)  ! volume of the unit cell in reciprocal space (a**-4)
      write(6,'(a,3f12.6,a,f12.6,a,a,f12.6,a)')
     *     ' chemical composition',atp(1),
     *     atp(2),atp(3),'  point density=', vt*abs(det)*fact,
     *     '(a**-2*cl**-1)',' = ',vt*abs(det)*fact/(al**2*cl),'(A**-3)'
      write(6,*) 'f000=',f000
      return
      end

      subroutine setvi(n,vid)
      real vid(*)
      include 'qcdiff.inc'
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      common /cvi/ vi(nemax,namax)
      call vcpyr(vid,vi(1,n),nth(n))
      return
      end

      subroutine getvi(n,vid)
      real vid(*)
      include 'qcdiff.inc'
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      common /cvi/ vi(nemax,namax)
      call vcpyr(vi(1,n),vid,nth(n))
      return
      end

      subroutine getvii(n,vi) ! occupation domain volume for icosahedral
      real vi(*)
      include 'qcdiff.inc'
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      real e1e2(6)
      do j=1,nth(n)
         k1=mej(1,j,n)
         k2=mej(2,j,n)
         k3=mej(3,j,n)
         e1e2(4)=ej(5,k1,n)*ej(6,k2,n)-ej(6,k1,n)*ej(5,k2,n)
         e1e2(5)=ej(6,k1,n)*ej(4,k2,n)-ej(4,k1,n)*ej(6,k2,n)
         e1e2(6)=ej(4,k1,n)*ej(5,k2,n)-ej(5,k1,n)*ej(4,k2,n)
         vi(j)=abs(vinpr(e1e2(4),ej(4,k3,n),3))
      end do
      return
      end

      subroutine getvid(n,vi) ! occupation domain volume for dihedral
      real vi(*)
      include 'qcdiff.inc'
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      do j=1,nth(n)
         k1=mej(1,j,n)
         k2=mej(2,j,n)
         vi(j)=abs(ej(4,k1,n)*ej(5,k2,n)-ej(5,k1,n)*ej(4,k2,n))
      end do
      return
      end


      subroutine setvi0(n,vid)
      real vid(*)
      include 'qcdiff.inc'
      common /copd2/ ej0(7,nemax,namax),nej0(namax),nth0(namax),
     *     mej0(3,nemax,namax)
      common /cvi/ vi(nemax,namax)
      call vcpyr(vid,vi(1,n),nth0(n))
      return
      end

      subroutine getvi0(n,vid)
      real vid(*)
      include 'qcdiff.inc'
      common /copd2/ ej0(7,nemax,namax),nej0(namax),nth0(namax),
     *     mej0(3,nemax,namax)
      common /cvi/ vi(nemax,namax)
      call vcpyr(vi(1,n),vid,nth0(n))
      return
      end

      subroutine getvii0(n,vi) ! occupation domain volume for icosahedral
      real vi(*)
      include 'qcdiff.inc'
      common /copd2/ ej0(7,nemax,namax),nej0(namax),nth0(namax),
     *     mej0(3,nemax,namax)
      real e1e2(6)
      do j=1,nth0(n)
         k1=mej0(1,j,n)
         k2=mej0(2,j,n)
         k3=mej0(3,j,n)
         e1e2(4)=ej0(5,k1,n)*ej0(6,k2,n)-ej0(6,k1,n)*ej0(5,k2,n)
         e1e2(5)=ej0(6,k1,n)*ej0(4,k2,n)-ej0(4,k1,n)*ej0(6,k2,n)
         e1e2(6)=ej0(4,k1,n)*ej0(5,k2,n)-ej0(5,k1,n)*ej0(4,k2,n)
         vi(j)=abs(vinpr(e1e2(4),ej0(4,k3,n),3))
      end do
      return
      end

      subroutine getvid0(n,vi) ! occupation domain volume for dihedral
      real vi(*)
      include 'qcdiff.inc'
      common /copd2/ ej0(7,nemax,namax),nej0(namax),nth0(namax),
     *     mej0(3,nemax,namax)
      do j=1,nth0(n)
         k1=mej0(1,j,n)
         k2=mej0(2,j,n)
         vi(j)=abs(ej0(4,k1,n)*ej0(5,k2,n)-ej0(5,k1,n)*ej0(4,k2,n))
      end do
      return
      end

      complex function f0(n,irs,isymo,h,df0dr1,df0dr2)
c     Fourier integral of the occupation domain
      include 'qcdiff.inc'
      integer irs(0:120,*),isymo(0:*),h(*)
      complex df0dr1,df0dr2
      complex f0i,f0d,f0i0,f0d0
      call getsys(isys)
      if(isys.le.2) then
         f0=f0i(n,irs,isymo,h,df0dr1,df0dr2)
c         f0=f0i0(n,irs,isymo,h,df0dr1,df0dr2)
      else
         f0=f0d(n,irs,isymo,h,df0dr1,df0dr2)
c         f0=f0d0(n,irs,isymo,h,df0dr1,df0dr2)
      end if
c     write(6,*) 'isys,f0=',isys,f0
      return
      end

      complex function f0i(n,irs,isymo,h,df0dr1,df0dr2)
c     Fourier integral of the occupation domain
c     for icosahedral cases
      include 'qcdiff.inc'
      real vi(nemax)
      integer irs(0:120,*),isymo(0:*),h(*)
      complex df0dr1,df0dr2

      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *     mej(3,nemax,namax)
      common /cstrc7/ p(namax),s(2,namax),ramin(namax),ramax(namax)
      complex fq0i,phs
      complex dfqdr1,dfqdr2
      integer hr(6),hs(6)
      real e1(6),e2(6),e3(6)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      integer getish,getisyd
      data  eps/0.0001/
      isyd=getisyd(n)
      f0i=(0.,0.)
      df0dr1=(0.,0.)
      df0dr2=(0.,0.)
      if(isyd.gt.nsymo) then
         isd=isyd-nsymo
         icd=1
      else
         isd=isyd
         icd=0
      end if
c      jsd=isymo(isd)            ! inverse operator of isd
      ishn=getish(n)
      if(ishn.ge.0) then
         phs=(0.,0.)
         do nsd=1,irs(0,n)       ! site symmetry operator
            ns=irs(nsd,n)        ! site symmetry operator
            if(ns.gt.nsymo) then
               ns=ns-nsymo
               icnt=1
            else
               icnt=0
            end if
c            nsi=isymo(ns)       ! inverse operator of ns
c           ns: sitesymmetry operator
            call gethr0(h,hs,isd,icd)
            call gethr0(hs,hr,ns,icnt)
c*****     e1,e2,e3 : edge vectors of tetrahedron or rhombohedron in vi
c          vi: volume of the rhombohedron with edges e1,e2,e3
c*****     ishn      : >=0: tetrahedron, -1: ellipsoid -2: shpere
            call getvi(n,vi)
            do j=1,nth(n)
               call gete123(j,n,e1,e2,e3)
               phs=phs+fq0i(hr,e1,e2,e3,vi(j),ramax(n),dfqdr2)
c              write(6,*) 'df0dr2,dfqdr2=',df0dr2,dfqdr2
               df0dr2=df0dr2+dfqdr2
               if(ramin(n).gt.eps) then
                  phs=phs-fq0i(hr,e1,e2,e3,vi(j),ramin(n),dfqdr1)
                  df0dr1=df0dr1-dfqdr1
               end if
            end do
         end do
      else if(ishn.eq.-1) then
         phs=fq1i(h,ej(1,1,n),ramax(n),dfqdr2)
         df0dr2=df0dr2+dfqdr2
         if(ramin(n).gt.eps) then
            phs=phs-fq1i(h,ej(1,1,n),ramin(n),dfqdr1)
            df0dr1=df0dr1-dfqdr1
         end if
      else if(ishn.eq.-2) then
         phs=fq2i(h,ramax(n),dfqdr2)
         df0dr2=df0dr2+dfqdr2
         if(ramin(n).gt.eps) then
            phs=phs-fq2i(h,ramin(n),dfqdr1)
            df0dr1=df0dr1-dfqdr1
         end if
      end if
      f0i=f0i+phs
      return
      end

      complex function f0i0(n,irs,isymo,h,df0dr1,df0dr2)
c      Fourier integral of the occupation domain
c      for icosahedral cases
      integer h(*),irs(0:120,*),isymo(0:*)
      integer hr(6),hs(6)
      include 'qcdiff.inc'
      real vi(nemax),e1(6),e2(6),e3(6)
      complex df0dr1,df0dr2,dfqdr1,dfqdr2
      common /cstrc7/ p(namax),s(2,namax),ramin(namax),ramax(namax)
      common /copd2/ ej0(7,nemax,namax),nej0(namax),nth0(namax),
     *     mej0(3,nemax,namax)

      complex fq0i,phs
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      integer getish,getisyd
      data  eps/0.0001/
      f0i0=(0.,0.)
      df0dr1=(0.,0.)
      df0dr2=(0.,0.)
      isydn=getisyd(n)
      if(isydn.gt.nsymo) then
         isd=isydn-nsymo
         icd=1
      else
         isd=isydn
         icd=0
      end if
c      jsd=isymo(isd)            ! inverse operator of isd
      ishn=getish(n)
      if(ishn.ge.0) then
         phs=(0.,0.)
         do nsd=1,irs(0,n)
            ns=irs(nsd,n)
            if(ns.gt.nsymo) then
               ns=ns-nsymo
               icnt=1
            else
               icnt=0
            end if
c            nsi=isymo(ns)       ! inverse operator of ns
c           ns: sitesymmetry operator
            call gethr0(h,hs,ns,icnt)
            call gethr0(hs,hr,isd,icd)
c*****     e1,e2,e3 : edge vectors of tetrahedron or rhombohedron in vi
c          vi: volume of the rhombohedron with edges e1,e2,e3
c*****     ishn      : >=0: tetrahedron, -1: ellipsoid -2: shpere
            call getvi0(n,vi)
            do j=1,nth0(n)
               call gete1230(j,n,e1,e2,e3)
               phs=phs+fq0i(hr,e1,e2,e3,vi(j),ramax(n),dfqdr2)
               df0dr2=df0dr2+dfqdr2
               if(ramin(n).gt.eps) then
                  phs=phs-fq0i(hr,e1,e2,e3,vi(j),ramin(n),dfqdr1)
                  df0dr1=df0dr1-dfqdr1
               end if
            end do
         end do
      else if(ishn.eq.-1) then
         phs=fq1i(h,ej0(1,1,n),ramax(n),dfqdr2)
         df0dr2=df0dr2+dfqdr2
         if(ramin(n).gt.eps) then
            phs=phs-fq1i(h,ej0(1,1,n),ramin(n),dfqdr1)
            df0dr1=df0dr1-dfqdr1
         end if
      else if(ishn.eq.-2) then
         phs=fq2i(h,ramax(n),dfqdr2)
         df0dr2=df0dr2+dfqdr2
         if(ramin(n).gt.eps) then
            phs=phs-fq2i(h,ramin(n),dfqdr1)
            df0dr1=df0dr1-dfqdr1
         end if
      end if
      f0i0=f0i0+phs
      return
      end
c
      complex function fq0i(hr,e1,e2,e3,v,rmax,dfqdr)
c     fourier integral of the tetrahedron defined by ej
      integer hr(*)
      real e1(*),e2(*),e3(*)
      real q1,q2,q3,q4,q5,q6,q(6)
      complex dfqdr
      complex cexp1,cexp2,cexp3,cexp4,cexp5,cexp6,i,cexpf
****  added Oct. 23, 1992
      complex dedr1,dedr2,dedr3,dedr4,dedr5,dedr6
****
c      data eps/0.1/, i/(0.0,1.0)/
      data eps/0.01/, i/(0.0,1.0)/
      data pi2/6.28318/
c
      vr=v*rmax**3
c     call getqi0(hr,q)
      call getqi(hr,q)
      dq1dr=vinpr(q(4),e1(4),3)*pi2
      dq2dr=vinpr(q(4),e2(4),3)*pi2
      dq3dr=vinpr(q(4),e3(4),3)*pi2
      q1=dq1dr*rmax
      q2=dq2dr*rmax
      q3=dq3dr*rmax
      q4=(q2-q3)
      q5=(q3-q1)
      q6=(q1-q2)
      dq4dr=dq2dr-dq3dr
      dq5dr=dq3dr-dq1dr
      dq6dr=dq1dr-dq2dr
      cexp1=cexpf(i*q1)-1-i*q1+q1**2/2
      cexp2=cexpf(i*q2)-1-i*q2+q2**2/2
      cexp3=cexpf(i*q3)-1-i*q3+q3**2/2
      cexp4=cexpf(i*q4)-1-i*q4+q4**2/2
      cexp5=cexpf(i*q5)-1-i*q5+q5**2/2
      cexp6=cexpf(i*q6)-1-i*q6+q6**2/2
      dedr1=(i*cexpf(i*q1)-i+q1)*dq1dr
      dedr2=(i*cexpf(i*q2)-i+q2)*dq2dr
      dedr3=(i*cexpf(i*q3)-i+q3)*dq3dr
      dedr4=(i*cexpf(i*q4)-i+q4)*dq4dr
      dedr5=(i*cexpf(i*q5)-i+q5)*dq5dr
      dedr6=(i*cexpf(i*q6)-i+q6)*dq6dr
      dfqdr=(0.,0.)  ! insert Jan. 27, 2003
      if(abs(q1).lt.eps.and.abs(q2).lt.eps.and.abs(q3).lt.eps) then
c*****  wave vector zero
           fq0i=vr/6
           dfqdr=v*rmax**2/2
c*****  wave vector normal to two edges
      else if(abs(q1).lt.eps.and.abs(q2).lt.eps) then
           fq0i=i*vr*cexp3/q3**3
           dfqdr=i*vr*dedr3/q3**3
      else if(abs(q2).lt.eps.and.abs(q3).lt.eps) then
           fq0i=i*vr*cexp1/q1**3
           dfqdr=i*vr*dedr1/q1**3
      else if(abs(q3).lt.eps.and.abs(q1).lt.eps) then
           fq0i=i*vr*cexp2/q2**3
           dfqdr=i*vr*dedr2/q2**3
      else if(abs(q4).lt.eps.and.abs(q5).lt.eps) then
c          q1=q2=q3
           fq0i=-i*vr*cexpf(i*q3)*conjg(cexp3)/q3**3
           dfqdr=-i*vr*(i*cexpf(i*q3)*dq3dr*conjg(cexp3)+
     *           cexpf(i*q3)*conjg(dedr3))/q3**3
      else if(abs(q1).lt.eps.and.abs(q4).lt.eps) then
           fq0i=-i*vr*(-i*q3*(cexp3-q3**2/2)+2*cexp3)/q3**3
           dfqdr=-i*vr*(-i*dq3dr*(cexp3-q3**2/2)-
     *         i*q3*(dedr3-q3*dq3dr)+2*dedr3)/q3**3
      else if(abs(q2).lt.eps.and.abs(q5).lt.eps) then
           fq0i=-i*vr*(-i*q1*(cexp1-q1**2/2)+2*cexp1)/q1**3
           dfqdr=-i*vr*(-i*dq1dr*(cexp1-q1**2/2)-
     *         i*q1*(dedr1-q1*dq1dr)+2*dedr1)/q1**3
      else if(abs(q3).lt.eps.and.abs(q6).lt.eps) then
           fq0i=-i*vr*(-i*q2*(cexp2-q2**2/2)+2*cexp2)/q2**3
           dfqdr=-i*vr*(-i*dq2dr*(cexp2-q2**2/2)-
     *         i*q2*(dedr2-q2*dq2dr)+2*dedr2)/q2**3
c**** wave vector normal to one edge
      else if(abs(q1).lt.eps) then
           fq0i=-i*vr*(-cexp2/(q2**2*q4)+cexp3/(q3**2*q4))
           dfqfr=-i*vr*(-dedr2/(q2**2*q4)+dedr3/(q3**2*q4))
      else if(abs(q2).lt.eps) then
           fq0i=-i*vr*(-cexp3/(q3**2*q5)+cexp1/(q1**2*q5))
           dfdqr=-i*vr*(-dedr3/(q3**2*q5)+dedr1/(q1**2*q5))
      else if(abs(q3).lt.eps) then
           fq0i=-i*vr*(-cexp1/(q1**2*q6)+cexp2/(q2**2*q6))
           dfqfr=-i*vr*(-dedr1/(q1**2*q6)+dedr2/(q2**2*q6))
      else if(abs(q4).lt.eps) then
           fq0i=-i*vr*cexpf(i*q2)*(-conjg(cexp5)/(q5**2*q1)
     *                           +conjg(cexp2)/(q2**2*q1))
           dfqdr=i*dq2dr*fq0i-i*vr*cexpf(i*q2)*(-conjg(dedr5)/
     *            (q5**2*q1)+conjg(dedr2)/(q2**2*q1))
      else if(abs(q5).lt.eps) then
           fq0i=-i*vr*cexpf(i*q3)*(-conjg(cexp6)/(q6**2*q2)
     *                           +conjg(cexp3)/(q3**2*q2))
           dfqdr=i*dq3dr*fq0i-i*vr*cexpf(i*q3)*(-conjg(dedr6)/
     *            (q6**2*q2)+conjg(dedr3)/(q3**2*q2))
      else if(abs(q6).lt.eps) then
           fq0i=-i*vr*cexpf(i*q1)*(-conjg(cexp4)/(q4**2*q3)
     *                           +conjg(cexp1)/(q1**2*q3))
           dfqdr=i*dq1dr*fq0i-i*vr*cexpf(i*q1)*(-conjg(dedr4)/
     *            (q4**2*q3)+conjg(dedr1)/(q1**2*q3))
      else
c****  wave vector at a general direction
           fq0i=-i*vr*(cexp1/(q1*q5*q6)+cexp2/(q2*q4*q6)
     *                     +cexp3/(q3*q4*q5))
           dfqdr=-i*vr*(dedr1/(q1*q5*q6)+dedr2/(q2*q4*q6)
     *                     +dedr3/(q3*q4*q5))
      end if
      return
      end

      complex function f0d(n,irs,isymo,h,df0dr1,df0dr2)
c      Fourier integral of the occupation domain
c      for dihedral cases
      include 'qcdiff.inc'
      real vi(nemax)
      integer irs(0:120,*),isymo(0:*),h(*)
      integer hr(6),hs(6)
      complex df0dr1,df0dr2

      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      common /cstrc7/ p(namax),s(2,namax),ramin(namax),ramax(namax)
      complex dfqdr1,dfqdr2
      complex fq0d,phs
      real e1(6),e2(6)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      integer getish,getisyd
      data eps/0.001/

      f0d=(0.,0.)
      df0dr1=(0.,0.)
      df0dr2=(0.,0.)
      ishn=getish(n)
      isydn=getisyd(n)
      if(ishn.ge.0) then
         phs=(0.,0.)
         if(isydn.gt.nsymo) then
            isd=isydn-nsymo
            icd=1
         else
            isd=isydn
            icd=0
         end if
c         jsd=isymo(isd)         ! inverse operator of isd
c         write(6,*) 'n,isd,icd,jsd=',n,isd,icd,jsd
         do nsd=1,irs(0,n)
            ns=irs(nsd,n)
            if(ns.gt.nsymo) then
               ns=ns-nsymo
               icnt=1
            else
               icnt=0
            end if
c            nsi=isymo(ns)       ! inverse operator of ns
c           ns: sitesymmetry operation
            call gethr0(h,hs,isd,icd)
            call gethr0(hs,hr,ns,icnt)
c            call gethr0(h,hs,ns,icnt)
c            call gethr0(hs,hr,isd,icd)
c            call gethr0(h,hs,nsi,icnt)
c            call gethr0(hs,hr,jsd,icd)
c*****     ej: edge vectors of triangle in vi
c          vi: volume of the triangle with edges ej
c*****     ishn  = 0: triangle =-1: ellips =-2: circle
            call getvi(n,vi)
            do j=1,nth(n)
               call gete12(j,n,e1,e2)               
               phs=phs+fq0d(hr,e1,e2,vi(j),ramax(n),dfqdr2)
               df0dr2=df0dr2+dfqdr2
               if(ramin(n).gt.eps) then
                  phs=phs-fq0d(hr,e1,e2,vi(j),ramin(n),dfqdr1)
                  df0dr1=df0dr1-dfqdr1
               end if
            end do
         end do
      else if(ishn.eq.-1) then
c        phs=fq1d(hr,ramax(n),dfqdr2)
         phs=fq1d(h,ej(1,1,n),ramax(n),dfqdr2)
         df0dr2=df0dr2+dfqdr2
         if(ramin(n).gt.eps) then
            phs=phs-fq1d(h,ej(1,1,n),ramin(n),dfqdr1)
            df0dr1=df0dr1-dfqdr1
         end if
      else if(ishn.eq.-2) then
         phs=fq2d(h,ramax(n),dfqdr2)
         df0dr2=df0dr2+dfqdr2
         if(ramin(n).gt.eps) then
            phs=phs-fq2d(h,ramin(n),dfqdr1)
            df0dr1=df0dr1-dfqdr1
         end if
      else
         call quit('invalid ish')
      end if
      f0d=f0d+phs
      return
      end

      complex function f0d0(n,irs,isymo,h,df0dr1,df0dr2)
c      Fourier integral of the occupation domain
c      for dihedral cases
      integer h(*),irs(0:120,*),isymo(0:*)
      integer hr(6),hs(6)
      include 'qcdiff.inc'
      real vi(nemax),e1(6),e2(6)
      complex df0dr1,df0dr2,dfqdr1,dfqdr2
      common /cstrc7/ p(namax),s(2,namax),ramin(namax),ramax(namax)
      common /copd2/ ej0(7,nemax,namax),nej0(namax),nth0(namax),
     *     mej0(3,nemax,namax)

      complex fq0d,phs
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      integer getish,getisyd
      data eps/0.001/
      f0d0=(0.,0.)
      df0dr1=(0.,0.)
      df0dr2=(0.,0.)
      ishn=getish(n)
      isydn=getisyd(n)
      if(ishn.ge.0) then
         phs=(0.,0.)
         if(isydn.gt.nsymo) then
            isd=isydn-nsymo
            icd=1
         else
            isd=isydn
            icd=0
         end if
c         jsd=isymo(isd)         ! inverse operator of isd
c         write(6,*) 'n,isd,icd,jsd=',n,isd,icd,jsd
         do nsd=1,irs(0,n)       ! site symmetry
            ns=irs(nsd,n)
            if(ns.gt.nsymo) then
               ns=ns-nsymo
               icnt=1
            else
               icnt=0
            end if
c            nsi=isymo(ns)       ! inverse operator of ns
c           ns: sitesymmetry operation
            call gethr0(h,hs,ns,icnt)
            call gethr0(hs,hr,isd,icd)
c            call gethr0(h,hs,nsi,icnt)
c            call gethr0(hs,hr,jsd,icd)
c*****     ej0: edge vectors of triangle in vi
c          vi: volume of the triangle with edges ej0
c*****     ishn  = 0: triangle =-1: ellips =-2: circle
            call getvi0(n,vi)
            do j=1,nth0(n)
               call gete120(j,n,e1,e2)                              
               phs=phs+fq0d(hr,e1,e2,vi(j),ramax(n),dfqdr2)
               df0dr2=df0dr2+dfqdr2
               if(ramin(n).gt.eps) then
                  phs=phs-fq0d(hr,e1,e2,vi(j),ramin(n),dfqdr1)
                  df0dr1=df0dr1-dfqdr1
               end if
            end do
         end do
      else if(ishn.eq.-1) then
c        phs=fq1d(hr,ramax(n),dfqdr2)
         phs=fq1d(h,ej0(1,1,n),ramax(n),dfqdr2)
         df0dr2=df0dr2+dfqdr2
         if(ramin(n).gt.eps) then
            phs=phs-fq1d(h,ej0(1,1,n),ramin(n),dfqdr1)
            df0dr1=df0dr1-dfqdr1
         end if
      else if(ishn.eq.-2) then
         phs=fq2d(h,ramax(n),dfqdr2)
         df0dr2=df0dr2+dfqdr2
         if(ramin(n).gt.eps) then
            phs=phs-fq2d(h,ramin(n),dfqdr1)
            df0dr1=df0dr1-dfqdr1
         end if
      else
         call quit('invalid ish')
      end if
      f0d0=f0d0+phs
      return
      end

c
      complex function fq0d(hr,e1,e2,v,rmax,dfqdr)
c      Fourier integral of a triangle
      integer hr(*)
      real e1(*),e2(*)
      real q1,q2,q3,q(6)
      complex cexp1,cexp2,i,cexpf,dcq1dq,dcq2dq,dfqdr,cexp01,cexp02
c      data eps/0.01/, i/(0.0,1.0)/
      data eps/0.001/, i/(0.0,1.0)/
      data pi2/6.283184/
c     fourier integral of the triangle given by e1 and e2
      vr=v*rmax**2
c      call getqi0(hr,q)
      call getqi(hr,q)
      q1=vinpr(q(4),e1(4),2)*pi2*rmax
      q2=vinpr(q(4),e2(4),2)*pi2*rmax
      q3=(q1-q2)
      dq1dr=q1/rmax            ! derivative of q1 by rmax
      dq2dr=q2/rmax            ! derivative of q2 by rmax
      dq3dr=q3/rmax            ! derivative of q3 by rmax
      cexp01=cexpf(i*q1)-1 ! -> -q1**2/2  when q1 ->0
      cexp02=cexpf(i*q2)-1 ! -> -q2**2/2  when q2 ->0
      cexp1=cexpf(i*q1)-1-i*q1 ! -> -q1**2/2  when q1 ->0
      cexp2=cexpf(i*q2)-1-i*q2 ! -> -q2**2/2  when q2 ->0
      dcq1dq=i*cexpf(i*q1)-i   ! derivative of cexp1 by q1  -> -q1
      dcq2dq=i*cexpf(i*q2)-i   ! derivative of cexp2 by q2  -> -q2
      dfqdr=(0.,0.)  ! insert Jan. 27, 2003c
************vr/q2**2 etc are independent of rmax************
      if(abs(q1).lt.eps.and.abs(q2).lt.eps) then
           fq0d=vr/2
           dfqdr=v*rmax
      else if(abs(q1).lt.eps) then
c          q3=-q2
           fq0d=-vr*cexp2/q2**2                         ! -> vr/2
           dfqdr=-vr*dcq2dq*dq2dr/q2**2                 ! -> v*rmax
      else if(abs(q2).lt.eps) then
c          q3=q1
           fq0d=-vr*cexp1/q1**2                         ! -> vr/2
           dfqdr=-vr*dcq1dq*dq1dr/q1**2                 ! -> v*rmax
      else if(abs(q3).lt.eps) then
c           q1=q2
c           q2=q1-q3  cexp2=cexp1-dcq1dq*q3
c           q1*cexp1-dcq1dq*q1*q3-q1*cexp1+q3*cexp1
            fq0d=vr*(cexp1/q1**2-dcq1dq/q1)             ! -> vr/2
            dfqdr=vr*dcq1dq*dq1dr/q1**2                 ! -> -v*rmax
     *      -(v*rmax/q1)*dcq1dq-(vr/q1)*(-cexpf(i*q1))*dq1dr ! -> 2*v*rmax
      else
           fq0d=vr*(q1*cexp02-q2*cexp01)/(q1*q2*q3)
c               -> -vr*(q1*q2**2-q2*q1**2)/(q1*q2*q3)/2
c               -> vr*q1*q2*q3/(q1*q2*q3)/2=vr/2
           dfqdr=vr*(q1*dcq2dq*dq2dr-q2*dcq1dq*dq1dr)/(q1*q2*q3)
c               -> -vr*(q1*q2**2-q2*q1**2)/(q1*q2*q3)/rmax
c               -> vr*q1*q2*q3/(q1*q2*q3)/rmax=vr/rmax=v*rmax
      end if
      return
      end

      subroutine gete120(j,n,e1,e2)
      real e1(*),e2(*)
      include 'qcdiff.inc'
      common /copd2/ ej0(7,nemax,namax),nej0(namax),nth0(namax),
     *     mej0(3,nemax,namax)
      k1=mej0(1,j,n)
      k2=mej0(2,j,n)
      call vcpyr(ej0(1,k1,n),e1,6)
      call vcpyr(ej0(1,k2,n),e2,6)
      return
      end

      subroutine gete12(j,n,e1,e2)
      real e1(*),e2(*)
      include 'qcdiff.inc'
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      k1=mej(1,j,n)
      k2=mej(2,j,n)
      call vcpyr(ej(1,k1,n),e1,6)
      call vcpyr(ej(1,k2,n),e2,6)
      return
      end

      subroutine gete1230(j,n,e1,e2,e3)
      real e1(*),e2(*),e3(*)
      include 'qcdiff.inc'
      common /copd2/ ej0(7,nemax,namax),nej0(namax),nth0(namax),
     *     mej0(3,nemax,namax)
      k1=mej0(1,j,n)
      k2=mej0(2,j,n)
      k3=mej0(3,j,n)
      call vcpyr(ej0(1,k1,n),e1,6)
      call vcpyr(ej0(1,k2,n),e2,6)
      call vcpyr(ej0(1,k3,n),e3,6)
      return
      end

      subroutine gete123(j,n,e1,e2,e3)
      real e1(*),e2(*),e3(*)
      include 'qcdiff.inc'
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *     mej(3,nemax,namax)
      k1=mej(1,j,n)
      k2=mej(2,j,n)
      k3=mej(3,j,n)
      call vcpyr(ej(1,k1,n),e1,6)
      call vcpyr(ej(1,k2,n),e2,6)
      call vcpyr(ej(1,k3,n),e3,6)
      return
      end
