      subroutine rdhkl(hk,mpl,q,fcal,nh)
      integer hk(6,*),mpl(*)
      real q(*),fcal(*)
      nh=0
 100  continue
      nh=nh+1
      read(1,'(1h ,6i2,i5,f12.6)',end=200)
     *                 (hk(i,nh),i=1,6),mpl(nh),q(nh)
           go to 100
 200  continue
      nh=nh-1
      return
      end

      subroutine rdhkl0(nfcal,nref0)
c     rdhkl for powder data
      include 'qcdiff.inc'
      parameter (ngmax=120)
      complex fc
      real qk
      integer hklm,fmpl
      common /chklfm/ hklm(6,nhkl),qk(nhkl),fmpl(nhkl),fc(nhkl),
     *   fo(nhkl),theta0(nhkl),ext(nhkl),wg(nhkl)
      common /cqks/ qs(6,mhkl),qks(mhkl),fcs(mhkl),mks(mhkl),ihkl(mhkl),
     *   nref,iqs(mhkl),qs0(6,mhkl)
      integer ns,st
      common /cqsort/ ns(mhkl),st(mhkl,2)
      real icmax
      common /ctorms2/ theta(mhkl),qe(3,mhkl),thbm,awl,fi,icmax
      real mpl
      common /toqcd2/na,mpl(namax),isk(0:120,namax),irs(0:120,namax),
     *     isymo(0:120)
      common /ctorms0/ job,ids,mthd(idsmax)
      common /criccut/ riccut
      real iccut,icalc
      common /csimul/ dfdx(nxprm,nhkl),nxx
c      common /cdim/ idm,nde
      integer hs(6,ngmax),h(6)
      real qgs(ngmax),qkd(mhkl),q0(6),qsd(6,ngmax)
      integer mk(ngmax)
      data pi/3.141592/, eps/0.00001/

      fact=pi/180
      call getsys(isys)
      id=1
      call getilp(ilp,id)
c     calculate qe,theta
      if(nfcal.gt.nhkl) call quit('number of reflections > nhkl')
c     find maximum intensity icmax
      do i=1,nfcal
          absfc=abs(fc(i))
          if(ilp.eq.0) then
             icalc=absfc**2
          else
             icalc=absfc**2*fmpl(i)
          end if
          if(i.eq.1) then
               icmax=icalc
          else if(icalc.gt.icmax) then
               icmax=icalc
          end if
       end do
c     remove weak reflections from powder pattern calculation
      iccut=icmax*riccut
      j=0
      do i=1,nfcal
         absfc=abs(fc(i))
         if(ilp.eq.0) then
            icalc=absfc**2
         else
            icalc=absfc**2*fmpl(i)
         end if
c     write(6,*) 'icalc, iccut=',icalc, iccut
         if(icalc.gt.iccut) then
            j=j+1
            fmpl(j)=fmpl(i)
            call vcpyi(hklm(1,i),hklm(1,j),6)
            qk(j)=qk(i)
            qkd(j)=qk(j)
            do  k=1,3
               qe(k,j)=qe(k,i)
            end do
c     theta0(j)=theta0(i)
            fc(j)=fc(i)
            xx=qk(j)*awl/2
            if(xx.le.0.999) then
               th=asin(xx)
               th2=2*th
               theta0(j)=th2/fact
            else
               theta0(j)=180.
            end if
            do k=1,nxx
               dfdx(k,j)=dfdx(k,i)
            end do
         end if
      end do
      nref0=j
c           calculation of fc under the phason strain
c     generate equivalent reflections by symmetry operators in icosahedral
c     group and classify into nonequivalent groups by the difference in qk
c     because nonequivalent reflections should have different qk
      l=0
      ih=0
      do j=1,nref0
         call vcpyi(hklm(1,j),h,6)
         mult=ngrp(h,hs,mk,qsd,qgs,fmpl(j))
c     hs  : inequivalent reflections under the phason strain
c     mult: number of such reflections
c     mk  : multiplicity of inequivalent reflection
c     qgs : |q| in the external space
         ngroup=mult
         do i=1,ngroup
            ih=ih+1
            if(ih.gt.mhkl) call quit('ih > mhkl')
            call vcpyr(qsd(1,i),qs(1,ih),6)
            qks(ih)=qgs(i)
            fcs(ih)=abs(fc(j))
            mks(ih)=mk(i)
            ihkl(ih)=j
            iqs(ih)=j
            call vcpyr(qsd(1,i),qe(1,ih),3)
c     call getqi0(hs(1,i),q0)
            call getqi(hs(1,i),q0)
c     call mcpy(q0,qs0(1,ih))
            call vcpyr(q0,qs0(1,ih),6)
            qkd(ih)=qgs(i)
            qd=qgs(i)
            xx=qd*awl/2
            if(xx.le.0.999) then
               th=asin(xx)
               th2=2*th
               theta(ih)=th2/fact
            else
               theta(ih)=180.
            end if
         end do
c     write(6,'(a,6i3,a,i3)') 'hklm=',(hklm(i,j),i=1,6),
c     *           ' fmpl=',fmpl(j)
c     do 999 i=1,ngroup
c     write(6,'(a,i3,a,i3,f8.5,1x,4(6i2,1x)/6(6i2,1x))') 'group=',i,
c     *     ' multp=',mk(i),qgs(i),(hs(jl,i),jl=1,6)
 999     continue
      end do
      nref=ih
      call qsort(qkd,st,ns,nref)
      write(6,200) nfcal,nref0,nref
 200  format(1h ,'number of total reflections',i5,5x,
     *     ' reflections used',i5,5x,' under phason strain',i5)
      return
      end

      subroutine rdhkl1(hs,nfcal)
c     rd hkl and fo for single crystal
      integer hs(6,*)
      include 'qcdiff.inc'
      complex fc
      real qk
      integer hklm,fmpl
      common /chklfm/ hklm(6,nhkl),qk(nhkl),fmpl(nhkl),fc(nhkl),
     *   fo(nhkl),theta0(nhkl),ext(nhkl),wg(nhkl)
      data pi/3.141592/, eps/0.00001/
      rewind 91
      do ih=1,nfcal
         read(91,'(6i3,2e13.6)') (hklm(j,ih),j=1,6),fo(ih),wg(ih)
         do j=1,6
            hs(j,ih)=hklm(j,ih)
         end do
      end do
      return
      end
