      subroutine getatmi0_old(ipsig,no,jobd)
      include 'qcstrc.inc'
      common /cnatm/ natom(namax)
      character brv
      integer isk(0:120)
      real shifto(6)
      common /cplt/ job,icase,ihmax,iatom,iwxy,ldev,amag,shftx,shfty
      common /clmt1/ ram,rbm,dx,dy,n1(6),n2(6),n3(6),n3x
      parameter (mmax=100000)
      parameter (nl2=1000)
      parameter (imax=30)       !  parameter (imax=15)
      common /ccolor/ icolor(namax),raplt(nemax)
      common /cislct/ iaslct(120,namax),jaslct(namax)
      common /cgetat/ isl2(imax+1,imax+1,nl2),nsl2(imax+1,imax+1)
      real ra(namax),rb(namax)
      character star(mmax)
      real q(6),qd(6)
      real hr(6),rx(6),ry(6),rz(6),rx0(6)
      real h(6),hd(6)
      real x(6),x0(6),x1(6),x2(6),xd(6)
      real xy(3)   ! coordinates in cubic coordinate sys. with a=1
      real uixy(6) ! anisotropic temperature factor in cubic coordinate sys.
      common /cpcol/ pcol
      common /ceps/ epsd
      real ht(6)
      integer natm(namax),iski(0:120)
      integer pcol
      real td(6)
      common /ctrc/ trc(6,32),trcd(6,32), ntrc
      integer rh(6,6,60)
      real th(6,60)
      real rq(6),shtq(6),trq(6),hrq(6)
      integer ityp(namax)
      integer ii(6)
      integer hmax(6),mm(7)
      integer select
      integer getndm,geticnt,getish,getien,getna,getcol
      integer getihdmi,getntrc,getisim
c     include 'nhkl.inc'
      data eps/0.00001/
c     data td/6*0./
c     data ht/1.0,0.5,0.5,0.5,0.5,0.5/
      data ht/0.5,0.,0.,0.,0.,0./
c********initialize
      call getityp(ityp)
      call getiski(iski)
      call getbrv(brv)
      call geta(al,am)
      na=getna()
      do i=1,na
         ra(i)=getramin(i)
         rb(i)=getramax(i)
      end do
      ihdm=getihdmi()
      call gethul(rh,th,ig)
c     write(6,*) 'ihmax=',ihmax
      call gethmaxi(hmax,ihmax)
c     call wrthkl(hmax)
      call getmm(hmax,mm,nt)
      call getshfto(shifto)
      isim=getisim()
      no=0
      do nd=1,nt   ! lattice vector loop
         call gethkl(nd,hmax,ii,mm)  ! get lattice vector ii
c        call wtvctri('ii=',ii,6)
         call vcpyir(ii,hd,6)        ! copy integer vector to real vector
         if(brv.eq.'f'.or.brv.eq.'s'.or.brv.eq.'p') then
            if(iprty(ii,2).eq.1) go to 106  ! skip odd parity sublattice
c           even parity sublattice
         end if
         
         do ihd=0,ihdm            ! 0 even parity sublattice 1 odd parity one
            call smtrx(hd,h,isim) ! similarity transformation for f-lattice
            do i=1,6
               h(i)=h(i)/2        ! include centering translations
            end do
c           write(6,'(a,i2,12f6.2)') 'iprty,hd,h=',iprty(ii,2),hd,h
            if(brv.eq.'p') then
c              add odd parity sublattice for brv='p'
               do i=1,6
                  h(i)=h(i)+ht(i)*ihd ! ihd=0 even ihd=1 odd sublattice
                  h(i)=h(i)*2   ! only for primitive lattice
               end do
            end if
c           call vsub(h,shifto,hr,6)  ! hr : lattice vector from selected org.
            call vcpyr(h,hr,6)        ! hr : lattice vector
            call seths(h)              ! for inter atomic dist.
c     *********  atom loop
            do n=1,na
               if(jaslct(n).eq.0) go to 201
               if(ipsig.eq. 1.and.getp0(n).lt.0) go to 201
               if(ipsig.eq.-1.and.getp0(n).gt.0) go to 201
               icol=getcol(n)
c               call getx(n,x)           ! get coordinate of OD (in 6D space)
c               call vsub(x,shifto,x1,6) ! x1: coordinate from shifto

c               call getx0(n,x0) ! get coordinate of Large OD (in 6D space)
c               call vsub(x,x0,x1,6) ! x-x0

               call geticistp(n,icentd,istep)
               if(brv.eq.'g') then
                  itce=ig
               else
                  itce=1
               end if
               call getisk(n,isk)
               do itc=1,itce             ! hull elements for the groupoid
                  do icnt=0,icentd,istep !  symmetry operator loop
                     do nsd=1,isk(0)     ! equivalent site
                        nsy=isk(nsd)     ! symmetry operator generating eq.atm
                        call setnsic(nsy,icnt)    ! set current symo.

c                       ! ***** test when nsy is included in the site sym. grp. for x0c 
c                       call getrx(x1,x2,nsy,icnt) ! site equivalent to x
c                       call vsumr(x2,x0,ry,6)     ! add x0
c                       ! ***************
c                        call getrx2(x1,ry,nsy,icnt)
c                       ! site equivalent to x (rotation around shifto)

                        call getrx(x,ry,nsy,icnt) ! site equivalent to x
                        call getrx00d(n,nsy,icnt,rx) ! rotated position x under phason
c                       call wtvctrrf('rq=',rq,6,'(6f10.5)')
                        call vsub(rx,shifto,ry,6)
                        call reduc(ry) ! reduced coordinates
                        call addhrryi(hr,ry,rx,itc) ! rx=hr+ry+trc(itc)
                        call getqed(rx,qd) ! qd distorted for polyhd
                        call vcpyr(qd,q,6)
                        call vsumr(qd,rq,qd,6)
                        call trcs(qd,xy)          ! plotter system coord. xy
                        if(iflimit(xy).eq.1) go to 204
                        ito204=ifatmi(qd,n)  ! -qd in n-th OD 0 else 1
                        if(ito204.eq.1) go to 204
                        call setifatm(ito204)
c                       write(6,*) 'before setodn, n=',n
                        call setodn(n)       ! set OD number, n, for select
                        islct=select(no,xy,h,icol,3,isl2,
     *                       nsl2,imax,nl2)
                        if(no.ge.mmax) then
                           write(6,'(a)') '*** no >= mmax **'
                           go to 108
                        end if
 204                    continue
                     end do
                  end do
               end do
 201           continue
            end do
         end do
 106     continue
      end do
 108  continue
********end of atom loop********
      return
      end
