      subroutine getocc(na)
      real pocc(3)
      write(6,'(a)') ' partial occupancies of each site'
      write(6,'(a)') 'atom  p(1)    p(2)    p(3)'
      do n=1,na
         call getoccn(n,pocc)
         write(6,'(i3,3f8.4)') n, (pocc(j),j=1,3)
      end do
      return
      end

      subroutine getoccn(n,pocc)
c     n: occupation domain number
c     pocc: return occupation probability for three element
c     in this occupation domain
      real pocc(*)
      include 'qcstrc.inc'
      common /cwflag/ iwflag(6)
      common /cstrc7/ p(namax),s(2,namax),ramin(namax),ramax(namax)
      common /cpnf1/ ne,atp(3),atp0(3),iel(3,nemax)
      integer getien
c     n : occupation domain number (independent atom number)
      ie=getien(n)  ! structure factor table number
      i1=iel(1,ie)
      i2=iel(2,ie)
      i3=iel(3,ie)
      if(i1.gt.3.or.i2.gt.3.or.i3.gt.3) then
         write(6,*) 'n=',n,' ie=',ie,' iel=',i1,i2,i3
         call quit('iel invalid in getoccn')
      end if
      if(i1.lt.1.or.i2.lt.1.or.i3.lt.1) then
         write(6,*) 'n=',n,' ie=',ie,' iel=',i1,i2,i3
         call quit('iel invalid in getoccn')
      end if
      pocc(i1)=(1-s(1,n)-s(2,n))*p(n)
      pocc(i2)=(s(1,n))*p(n)
      pocc(i3)=(s(2,n))*p(n)
      return
      end
