c
c     get RGB values from color number, icol, in calcomp
c
      subroutine icol2rgb(icol,r,g,b)
      real r,g,b
      real h,s,v
      call icol2hsb(icol,h,s,v)
      call initcol()
      call HSVtoRGB(h,s,v,r,g,b)  ! HSV=HSB
      return
      end

      subroutine icol2hsb(icol,h,s,b)
      integer icol
      real h,s,b
      s=1
      ic=icol/10    ! color number
      b0=icol-ic*10
      if(icol.lt.10) then  ! B&W
         h=0
         s=0
         b=b0/10
         return
      else if(icol.eq.10) then  ! white
         h=0
         s=0
         b=1
         return
      else
         if(h.le.6) then
            h=float(icol/10)/18
c     h=1/18 means blue  => 12/18
            h=mod(h+float(11)/18,1.)
         else
            h=float(icol/10)/18
c     h=7/18 means red
            h=h-float(7)/18
         end if
         b=float(mod(icol,10))/10
         if(b.gt.0.5) then
            s=(1-b)*2
         else
            s=1.0
         end if
         b=min(b*2,1.)
      end if
      h=h*360   ! for 0 < h < 360
c     if(icol.lt.80) then  ! 1<=ic<=6
c     h=220+20*ic
c     else
c     h=20*(ic-7)
c     end if
      return
      end
