c
c     strcture information class
c
      integer function getna()
      common /strinf2/ nas
      getna=nas
      return
      end

      integer function getiel(i)
c     if p123(1),p123(2) or p123(3) is maximum return 1 2 or 3
      include "cluster.inc"
      real xa(3,namax),mpl(namax),uixy(6,namax),p123(3,namax)
      integer isft(namax)
      common /strinf1/ xa,mpl,isft,uixy,p123
      common /strinf2/ nas
      getiel=1
      pmax=p123(1,i)
      if(p123(2,i).gt.pmax) then
         pmax=p123(2,i)
         getiel=2
      end if
      if(p123(3,i).gt.pmax) then
         pmax=p123(3,i)
         getiel=3
      end if
      return
      end

      integer function getodno(i)
c     return OD number for quasicrystals
      include "cluster.inc"
      integer atom
      character(8) atomsymb
      common /cltc/ atom(namax), atomsymb(namax)
      getodno=atom(i)
      return
      end

      subroutine rdap(na,ip,iat,icase,itempf)
      include "cluster.inc"
      real xa(3,namax),mpl(namax),uixy(6,namax),p123(3,namax)
      integer isft(namax)
      common /strinf1/ xa,mpl,isft,uixy,p123
      common /strinf2/ nas
      character(50) dummy
      integer atom
      character(8) atomsymb
      common /cltc/ atom(namax), atomsymb(namax)

      nas=na
      if(na.gt.namax) then
         call quit('na > namax')
      end if
c      if(iat.eq.1.and.icase.eq.0) then
c         call quit('iat should be 0 for icase=0')
c      end if
      if(iat.eq.0) then
         if(itempf.eq.0) then
            write(6,201)
         else
            write(6,301)
         end if
      else
         if(itempf.eq.0) then
            write(6,200)         
         else
            write(6,300)         
         end if
      end if
      if(ip.eq.0) then
         inp=5
      else
         inp=50
      end if
      call setinp(inp)
c     call freadc('basic structure',0,dummy,1)
      npod=0
      do i=1,na
         if(icase.eq.0) then 
            if(iat.eq.0) then   ! quasicrystals
               if(itempf.eq.1) then  ! atom : od number for quasicrystal
                  read(inp,*) ik,atom(i),isft(i),(xa(j,i),j=1,3),
     *                 (uixy(j,i),j=1,6),
     *                 (p123(j,i),j=1,3)
c     isft(i)=1
               else ! atom : od number for quasicrystal
                  read(inp,*) ik,atom(i),isft(i),(xa(j,i),j=1,3),
     *                 (p123(j,i),j=1,3)
c                 call zerovr(uixy(1,i),6)
               end if
c     isft(i)=1
               npod=max(npod,atom(i))
            else                ! crystals
               if(itempf.eq.1) then
                  read(inp,*) ik,atomsymb(i),isft(i),(xa(j,i),j=1,3),
     *                 (uixy(j,i),j=1,6)
c     isft(i)=1
               else
                  read(inp,*) ik,atomsymb(i),isft(i),(xa(j,i),j=1,3)
                  call zerovr(uixy(1,i),6)
               end if
c     isft(i)=1
               npod=max(npod,atom(i))
            end if
         else if(icase.eq.1.and.itempf.eq.0) then   ! use symmetry operators
            if(iat.eq.0) then
               read(inp,*) ik,atom(i),isft(i),(xa(j,i),j=1,3)
               npod=max(npod,atom(i))
               call zerovr(uixy(1,i),6)
            else
               read(inp,*) ik,atomsymb(i),isft(i),(xa(j,i),j=1,3)
               call zerovr(uixy(1,i),6)
            end if
            call zerovr(uixy(1,i),6)
         else if(icase.eq.1.and.itempf.eq.1) then
            if(iat.eq.0) then
               read(inp,*) ik,atom(i),isft(i),(xa(j,i),j=1,3),
     *              (uixy(j,i),j=1,6)
               npod=max(npod,atom(i))
            else
               read(inp,*) ik,atomsymb(i),isft(i),(xa(j,i),j=1,3),
     *              (uixy(j,i),j=1,6)
            end if
         else
            call quit('icase should be 0,1 or 2')
         end if
         call writeatm(i,ik,iat,itempf)
      end do
      if(ip.eq.1) then
         close(unit=50)
      end if
      call setinp(5)
      call setnpod(npod)
      return
 201  format('number',2x,'ocd no.',2x,'element  ',4x
     1,'x, y, z')
 200  format('number',2x,'atom symb',2x,'table NO. ',4x
     1,'x, y, z')
 301  format('number',2x,'ocd no.',2x,'element  ',4x
     1,'x, y, z u11, u22, u33, u23, u31, u12')
 300  format('number',2x,'atom symb',2x,'table NO. ',4x
     1,'x, y, z u11, u22, u33, u23, u31, u12')
      end

      subroutine writeatm(i,ik,iat,itempf)
      include "cluster.inc"
      real xa(3,namax),mpl(namax),uixy(6,namax),p123(3,namax)
      integer isft(namax)
      common /strinf1/ xa,mpl,isft,uixy,p123
      common /strinf2/ nas
      character(50) dummy
      integer atom
      character(8) atomsymb
      common /cltc/ atom(namax), atomsymb(namax)
      iln=istrln(atomsymb(i))
      if(iat.eq.0) then
         write(6,'(i5,i5,$)') ik,atom(i)
      else
         write(6,'(i5,3a,$)') ik,' ''',atomsymb(i)(1:iln),''''
      end if
      if(itempf.eq.0) then
         write(6,'(i2,6x,3f9.4,6f10.5)') isft(i),(xa(j,i),j=1,3)
      else
         write(6,'(i2,6x,3f9.4,6f10.5)') isft(i),(xa(j,i),j=1,3),
     *     (uixy(j,i),j=1,6)
      end if
      return
      end

      integer function getatomno(str)  ! return atom No in periodic table
      character(2) str
      character(2) element(106)
      data element/
     *     'H ','He',
     *     'Li','Be','B ','C ','N ','O ','F ','Ne',
     *     'Na','Mg','Al','Se','P ','S ','Cl','Al',
     *     'K ','Ca',
     *     'Sr','Ti','V ','Cr','Mn','Fe','Co','Ni','Cu','Zn',
     *     'Ga','Ge','As','Se','Br','Kr',
     *     'Rb','Sr',
     *     'Y ','Zr','Nb','Mo','Tc','Ru','Rh','Pd','Ag','Cd',
     *     'In','Sn','Sb','Te','I ','Xe',
     *     'Cs','Ba',
     *     'La','Ce','Pr','Nd','Pm','Sm','Eu','Gd','Tb','Dy',
     *     'Ho','Er','Tm','Yb','Lu',
     *     'Hf','Ta','W ','Re','Os','Ir','Pt','Au','Hg',
     *     'Tl','Pb','Bi','Po','At','Rn',
     *     'Fr','Ra',
     *     'Ac','Th','Pa','U ','Np','Pu','Am','Cm','Bk','Cf',
     *     'Es','Fm','Md','No','Lr','Uq','Up','Uh'/
      iln=istrln(str)  ! number of non-blank characters
      getatomno=0
      do i=1,106
         ilni=istrln(element(i))
         do j=1,iln
            if(iln.ne.ilni) then
               go to 80
            end if
            if(str(j:j).ne.element(i)(j:j)) then
               go to 80
            end if
         end do
         getatomno=i
         return
 80      continue
      end do
      write(6,*) 'given symbol is ',str
      write(6,*) 'no atomno is found'
c     call quit('no atomno is found')
      return
      end

