      subroutine getrx0(x,rx,r,t,ns,ic)
      real x(*),rx(*),t(3,*)
      integer r(3,3,*)
      common /cdim/ idm,nde
      call mtmplirmno(r(1,1,ns),x,rx,3,3,1)
      call vsumr(rx,t(1,ns),rx,3)
      if(ic.eq.1) then
         call negater(rx,3)
      end if
      return
      end

      integer function extnsic(ns,ic)
      integer rr
      common /sym/ rr(3,3,48),tt(3,48),nsymo,icent
      if(ic.eq.0) then
         extnsic=ns
      else
         extnsic=ns+nsymo
      end if
      return
      end

      subroutine rednsic(ns1,ns,ic)
c     decompose symmetry operator number into ns < nsymo and ic =0 or 1
      integer rr
      common /sym/ rr(3,3,48),tt(3,48),nsymo,icent
      if(ns1.gt.nsymo) then
         ns=ns1-nsymo
         ic=1
      else
         ns=ns1
         ic=0
      end if
      return
      end

      subroutine getrx(x,rx,ns,ic)
      real x(*),rx(*)
      integer rr
      common /sym/ rr(3,3,48),tt(3,48),nsymo,icent
      common /cdim/ idm,nde
      call mtmplirmno(rr(1,1,ns),x,rx,3,3,1)
      call vsumr(rx,tt(1,ns),rx,3)
      if(ic.eq.1) then
         call negater(rx,3)
      end if
      return
      end

      integer function getltype()
      common /cskip/ iskip,ltype
      getltype=ltype
      return
      end

      integer function getlt(brv)
      character brv
      character brvs(0:7)
      data brvs/' ','p','a','b','c','i','f','r'/
      do i=0,7
         if(brv.eq.brvs(i)) then
            getlt=i
            return
         end if
      end do
      call quit('invalid getlt')
      return
      end

      integer function getnct()
      common /cnct/ nct,trc(3,4)
      getnct=nct
      return
      end

      subroutine gettrc(trcd)
      real trcd(3,*)
      common /cnct/ nct,trc(3,4)
      integer ncts(0:7)
      data ncts/1,1,2,2,2,2,4,3/
      imax=max(nct,1)
      do i=1,imax
         do j=1,3
            trcd(j,i)=trc(j,i)
         end do
      end do
      return
      end

      subroutine settrc(lt)   ! set trc and nct
      common /cnct/ nct,trc(3,4)
      real trcd(3,4,0:7)
      integer ncts(0:7)
      data ncts/1,1,2,2,2,2,4,3/
      data (trcd(i,1,0),i=1,3) /0.0,0.0,0.0/
      data (trcd(i,1,1),i=1,3) /0.0,0.0,0.0/
      data ((trcd(i,j,2),i=1,3),j=1,2) /0.0,0.0,0.0,0.0,0.5,0.5/
      data ((trcd(i,j,3),i=1,3),j=1,2) /0.0,0.0,0.0,0.5,0.0,0.5/
      data ((trcd(i,j,4),i=1,3),j=1,2) /0.0,0.0,0.0,0.5,0.5,0.0/
      data ((trcd(i,j,5),i=1,3),j=1,2) /0.0,0.0,0.0,0.5,0.5,0.5/
      data ((trcd(i,j,6),i=1,3),j=1,4) /0.0,0.0,0.0,0.5,0.5,0.0,
     *                                 0.5,0.0,0.5,0.0,0.5,0.5/
      data ((trcd(i,j,7),i=1,3),j=1,3) /0.0,0.0,0.0,0.666666,
     *            0.333333,0.333333,0.333333,0.666666,0.666666/
      nct=ncts(lt)
      imax=max(nct,1)
      do i=1,imax
         call vcpyr(trcd(1,i,lt),trc(1,i),3)
         call wtvctrr('trc=',trc(1,i),3)
      end do
      return
      end

      subroutine rdsym(icase)
      integer rr
      common /sym/ rr(3,3,48),tt(3,48),nsymo,icent
      common /cdim/ idm,nde
      common /cwflg0/ iwflag(6)
      common /cskip/ iskip,ltype
      integer rg(3,3,5),imps(60)
      real tg(3,5)
      character(30) coord
      character brv
      integer getlt
      call getinp(inpu)
      call getout(iout)
      idm=3
      nde=0
      iwflag(3)=1
c     read(inpu,*) 'symmetry operator'
      if(icase.eq.0) then
         nsymo=1
         ige=0
         icent=0
         brv=' '
         coord='x,y,z'
         call decode(coord,rr,tt,1)
      else
         call freadi('ns=',1,nsymo,1)
         call freadi('ig=',1,ige,0)
         call freadi('ic=',1,icent,0)
         call freadc('brv=',1,brv,0)
         call freadr('symmetry operator',0,dummy,1)
         do k=1,nsymo
            read(inpu,'(a)') coord
            call decode(coord,rr,tt,k)
         end do
      end if
      ltype=getlt(brv)  ! get lt
      write(6,*) 'ltype=',ltype
      call settrc(ltype)

      if(icent.eq.1) then
            write(iout,2022)
      else
            write(iout,2021)
      end if

      if(ige.eq.1) then
           write(iout,201) 'generating elements'
      end if
      write(iout,*)
      nn=nde+1
      call wtsymo(rr,tt,nsymo,idm)
      if(ige.eq.1) then
         call ordr(rr,imps,nsymo,idm)
         do i=1,nsymo
            do j=1,idm
               tg(j,i)=tt(j,i)
               do k=1,idm
                  rg(j,k,i)=rr(j,k,i)
               end do
            end do
         end do

         impt=1
         call zerovr(tt(1,1),3)
         call unitmtrxi(rr(1,1,1),3)
         do ns=1,nsymo
            imp=imps(ns)
            do i=2,imp
               do j=1,impt
                  mp1=j+(i-2)*impt
                  mp2=j+(i-1)*impt
                  call mpso(rg,tg,ns,rr,tt,mp1,mp2)
               end do
            end do
            impt=impt*imp
         end do
         nsymo=impt
         if(iwflag(3).eq.1) then
            write(iout,207)
            write(iout,*)
            call wtsymo(rr,tt,nsymo,idm)
         end if
      end if
      return
 201  format(' ',a)
 2021 format(' ','symmetry operation',10x,'noncentrosymmetric')
 2022 format(' ','symmetry operation',10x,'centrosymmetric')
 207  format(' ','symmetry operators generated by generating elements')
      end

c
      subroutine mpso(r1,t1,m1,r2,t2,m2,m3)
      integer r1(3,3,*),r2(3,3,*)
      real t1(3,*),t2(3,*)
      do i=1,3
         t2(i,m3)=0.0
         do j=1,3
            t2(i,m3)=t2(i,m3)+r1(i,j,m1)*t2(j,m2)
         end do
         t2(i,m3)=t2(i,m3)+t1(i,m1)
         do j=1,3
            r2(i,j,m3)=0.0
            do k=1,3
               r2(i,j,m3)=r2(i,j,m3)+r1(i,k,m1)*r2(k,j,m2)
            end do
         end do
      end do
      return
      end

      subroutine getwtt(tt,wtt,nsymo,idm)
      real tt(3,*)
      character(3) wtt(3,*)
      real rt(8)
      character(3) wt(8)
      data rt/0.,0.5,0.333333,0.666666,0.25,0.75,0.166666,0.833333/
      data wt/'0','1/2','1/3','2/3','1/4','3/4','1/6','5/6'/
      data eps/0.00001/
      call getinp(inpu)
      call getout(iout)
      do i=1,nsymo
         do j=1,idm
            td=tt(j,i)
            td=mod(td,1.)
            if(td.lt.-eps) then
               td=td+1
            else if(td.gt.1-eps) then
               td=td-1
            end if
            do k=1,8
               if(abs(td-rt(k)).lt.eps) then
                  wtt(j,i)=wt(k)
                  go to 110
               end if
            end do
 110        continue
         end do
      end do
      return
      end

      subroutine wtsmop(r1,t1,nsymo,d1,d2)
c*******************************************************************
c         representation of symmetry operators in the i.t. format
c*******************************************************************
      implicit integer (a-z)
      integer r1(3,3,*)
      integer r(3,3),lenc(48),ip(16)
      real t1(3,*),t(3),eps,cnt2(27,6),rtr(7)
      character xyz(6)
c        for (d2+d1) dimensional case
      character(31) z1(48),bl
      character(3) ntr(7)
      data xyz/'x','y','z','t','u','v'/
      data ntr/'1/2','1/3','2/3','1/4','3/4','1/6','5/6'/
      data rtr/0.5,0.333333,0.666666,0.25,0.75,0.166666,0.833333/
      data bl/'                            '/
      call getinp(inpu)
      call getout(iout)
      eps=0.00001
      d3=d1+d2
c******** write symmetry operators *******
      do ii=1,nsymo
         cp=1
         call vcpyr(t1(1,ii),t,3)
         call mcpyi(r1(1,1,ii),r,3)
         do i=1,d3
            t(i)=mod(t(i),1.0)
            if(t(i).lt.eps) then
               t(i)=t(i)+1
            else if(t(i).gt.1.0-eps) then
               t(i)=t(i)-1
            end if
         end do
         do i=1,22
            z1(ii)=bl
         end do
         do 13 i=1,d3
            do j=1,7
               if(abs(t(i)-rtr(j)).le.eps) then
                  z1(ii)(cp:cp+2)=ntr(j)
                  cp=cp+3
                  go to 132
               end if
            end do
 132        continue
            do j=1,d3
               if(j.le.d2) then
                  k=j
               else if(j.gt.d2) then
                  k=j+(3-d2)
               end if
               if(r(i,j).eq.1) then
                  if(cp.eq.1) then
                     z1(ii)(cp:cp)=xyz(k)
                     cp=cp+1
                  else if(z1(ii)(cp-1:cp-1).eq.',') then
                     z1(ii)(cp:cp)=xyz(k)
                     cp=cp+1
                  else
                     z1(ii)(cp:cp+1)='+'//xyz(k)
                     cp=cp+2
                  end if
               else if(r(i,j).eq.-1) then
                  z1(ii)(cp:cp+1)='-'//xyz(k)
                  cp=cp+2
               end if
               if(j.eq.d3.and.i.ne.d3) then
                  z1(ii)(cp:cp)=','
                  cp=cp+1
               else if(j.eq.d3.and.i.eq.d3) then
                  z1(ii)(cp:cp)=';'
                  cp=cp+1
               end if
            end do
 13      continue
         lenc(ii)=istrln(z1(ii))
      end do
      write(iout,'(6(a,1x))') (z1(ii)(1:lenc(ii)),ii=1,nsymo)
      return
      end

      subroutine decode(coord,r,t,n)
c     symmetry operation in I.T into matrix representation
      character coord*30
      integer r(3,3,*)
      real t(3,*)
      common /cdim/ idm,nde
      character sym(6)*20,xyz(6)
      data xyz/'x','y','z','t','u','v'/
      call getinp(inpu)
      call getout(iout)
c     position of ',' 
      i=1
      do k=1,idm-1
         m=index(coord(i:30),',')
         if(m.eq.0) call quit(' incorrect symmetry operation')
         sym(k)=coord(i:i+m-2)
         i=i+m
      end do
      sym(idm)=coord(i:30)
c
      call zerovr(t(1,n),3)
      call zeromtrxi(r(1,1,n),3)
      do j=1,idm
c        rotation matrix
         do k=1,idm
            i=index(sym(j),xyz(k))
            if(i.gt.0) then
               if(i.eq.1) then
                  r(j,k,n)=1
               else
                  if(sym(j)(i-1:i-1).eq.'+') then
                     r(j,k,n)=1
                  else
                     r(j,k,n)=-1
                  endif
               endif
            endif
         end do
c
c        translation vector
         i=index(sym(j),'/')
         if(i.gt.0) then
            read(sym(j)(i-1:i-1),'(i1)') n1
            read(sym(j)(i+1:i+1),'(i1)') n2
            t(j,n)=float(n1)/float(n2)
            if(i.ne.2.and.sym(j)(i-2:i-2).eq.'-') t(j,n)=-t(j,n)
         endif
      end do
      end

      subroutine ordr(re,imps,nsymo,idm)
c      integer re(3,3,*),imps(*)
      integer re(3,3,*),imps(*)
      integer r(3,3),a(3,3),b(3,3)
      data eps/0.001/
      call getinp(inpu)
      call getout(iout)
      do 10 i=1,nsymo
         call mcpyi(re(1,1,i),r,3)
         call mcpyi(r,b,3)
         do j=1,7
c     check whether r is identity operator or not
            do k=1,idm
               if(r(k,k).ne.1) go to 15
               do l=1,idm
                  if(k.ne.l.and.r(k,l).ne.0) go to 15
                  continue
               end do
            end do
            imps(i)=j
            go to 10
 15         continue
            call mcpyi(r,a,3)
            call mtmpli(a,b,r,3)
         end do
 10   continue
      do 20 i=1,nsymo
         if(imps(i).ge.7) then
            ierror=1
            go to 21
         else
            ierror=0
         end if
 20   continue
 21   continue
      if(ierror.eq.1) then
         write(iout,'(''error in symmetry operator ?'',a,24i3)')
     *        '  order: ',(imps(i),i=1,nsymo)
      end if
      return
      end

      subroutine wtsymo(rr,tt,nsymo,idm)
      integer rr(3,3,*)
      real tt(3,*)
      character(3) wtt(3,48)
      integer wd,w
      data wd/8/,eps/0.001/
      call getinp(inpu)
      call getout(iout)
      w=wd
      ll=(nsymo-1)/w+1
      le=nsymo-(ll-1)*w
      call wtsmop(rr,tt,nsymo,idm-3,3)
      write(iout,*)
      call getwtt(tt,wtt,nsymo,idm)
      do ii=1,ll
         lbgn=(ii-1)*w+1
         if(ii.ne.ll) lend=lbgn+w-1
         if(ii.eq.ll) lend=lbgn+le-1
         do i=1,idm
            write(iout,204) ((rr(i,j,k),j=1,idm),wtt(i,k),
     *           k=lbgn,lend)
         end do
         write(iout,*)
      end do
      return
 204  format(' ',8(3i2,1x,a,2x))
      end

      subroutine getisk(iskd)
      integer iskd(0:48,*)
      include "cluster.inc"
      integer isk(0:48,namax),irs(0:48,namax)
      common /symmetry1/ isk,irs
      integer getna
      do i=1,getna()
         call vcpyi(isk(0,i),iskd(0,i),namax)
      end do
      return
      end

      subroutine getirs(irsd)
      integer irsd(0:48,*)
      include "cluster.inc"
      integer isk(0:48,namax),irs(0:48,namax)
      common /symmetry1/ isk,irs
      integer getna
      do i=1,getna()
         call vcpyi(irs(0,i),irsd(0,i),namax)
      end do
      return
      end

      subroutine sitesy(na) 
      include "cluster.inc"
      integer isk(0:48,namax),irs(0:48,namax)
      common /symmetry1/ isk,irs

      real xa(3,namax),mpl(namax)
      integer isft(namax)
      common /strinf1/ xa,mpl,isft

      integer rr
      common /sym/ rr(3,3,48),tt(3,48),nsymo,icent
      common /cdim/ idm,nde
      real rx(3)
      real rxs(3,48)
      integer rcomp,extnsic
      write(6,*) 'nsymo,icent=',nsymo,icent
      do i=1,na
         nsym=0
         nrx=1
         isk(nrx,i)=1
         call savex(xa(1,i),rxs(1,nrx))
         do ic=0,icent
            do ns=1,nsymo
               call getrx(xa(1,i),rx,ns,ic)
               do irx=1,nrx
                  if(rcomp(rx,rxs(1,irx)).eq.1) go to 120
               end do
               nrx=nrx+1
               call savex(rx,rxs(1,nrx))
               isk(nrx,i)=extnsic(ns,ic)
 120           continue
               if(rcomp(rx,xa(1,i)).eq.1) then
                  nsym=nsym+1
                  irs(nsym,i)=extnsic(ns,ic)
               end if
            end do
         end do
         isk(0,i)=nrx
         irs(0,i)=nsym
         mpl(i)=1
      end do

      write(6,*) 'site symmetry group'
      do i=1,na
         write(6,'(a,i3,a,20i3/(8x,20i3))')
     *        'atom',i,'  ',(irs(j,i),j=1,irs(0,i))
      end do

      write(6,*) 'multiplicity and equivalent position'
      do i=1,na
         write(6,'(a,i5,f9.4,2x,20i3/(18x,20i3))')
     *        'atom',i, mpl(i),(isk(j,i),j=1,isk(0,i))
      end do
      return
      end

      integer function rcomp(x,rx)
      real x(*),rx(*)
      common /cdim/ idm,nde
      common /cskip/ iskip,ltype
      common /cnct/ nct,trc(3,4)
      data eps/0.00001/
      rcomp=0
      do j=1,nct
           do i=1,3
           xx=abs(x(i)-rx(i)-trc(i,j))+eps/2
           xx=mod(xx,1.)
           if(xx.gt.eps) go to 110
        end do
      rcomp=1
      return
 110  continue
      end do
      return
      end

      subroutine getruirt(uixy,ui,ns,ic)  ! aniso tempf for rotated atoms
      real uixy(*)  ! ui in the common orthogonal system (q system)
      real ui(*)    ! rotated uixy
c     rotation of anisotropic temp. fact. uij in physical space
c     symmetric tensor does not depend on inversion
c     rotation matrix depends on OD in this case
      integer rr
      common /sym/ rr(3,3,48),tt(3,48),nsymo,icent
c     common /symext1/ re(3,3,60),te(3,60)
c     Sakurai P 241, eq (5.5-7)
      real uij(3,3) 
      real m1(3,3)
      integer ret(3,3)
      call mcpyi(rr(1,1,ns),ret,3) ! copy rotation matrix into ret for transpose
      call trnspi3(ret)            ! take transposed matrix
      call getuitouij(uixy,uij)    ! get uij from ui
c     uij times ret
      call mtmplri3(uij,ret,m1)
c     uij= ret*uij*re 
      call mtmplir3(rr(1,1,ns),m1,uij)
      call getuijtoui(uij,ui)   ! get ui from uij
      return
      end

