
c     complex fft written by t. yamaguchi
      subroutine fft2(a,b,t,list,n2,ind,key,lp)
      implicit complex*16(a-c,e-h,o-z)
      real*8 div
      dimension a(n2*2),b(n2*2),t(n2*lp,2),list(n2*lp)
c     if(ind.eq.1) then set tables and list
      if(ind.eq.1) then
         call settbl(n2,t,b,lp)
         call setlst(list,n2,lp)
         ind=0
      end if
      k=1
      l=n2
      do 10 i=1,lp
         m=(m-1)*n2+1
         if(k.eq.1) then
            call fftsub(a,b,t(m,key),list(m),l,n2)
         else
            call fftsub(b,a,t(m,key),list(m),l,n2)
         end if
         k=k*(-1)
         l=l/2
 10   continue
c  if (key.eq.2) then inverse transformation else normal transformation
      if(key.eq.2) then
         div=1.d0/(n2*2)
         if(k.eq.1) then
            do 20 i=1,n2*2
 20         b(i)=a(i)*div
         else
            do 30 i=1,n2*2
 30         b(i)=b(i)*div
         end if
      else if(k.eq.1) then
         do 40 i=1,n2*2
 40      b(i)=a(i)
      end if
      return
      end

c     transformation for fft written by y. yamaguchi
      subroutine fftsub(a,b,t,list,l,n2)
      implicit complex*16(a-h,o-z)
      dimension a(n2*2),b(n2,2),t(n2),list(n2)
      do 10 i=1,n2
         b(i,1)=a(list(i))+a(list(i)+l)*t(i)
         b(i,2)=a(list(i))-a(list(i)+l)*t(i)
 10   continue
      return
      end

c  table setting for fft written by t. yamaguchi
      subroutine settbl(n2,t,b,lp)
      complex*16 t,b
      real*8 tr,ti,pai
      dimension t(n2,lp,2),b(n2,2)
      pai=datan(1.d0)*4.d0
      do 10 i=1,n2
         tr=dcos(2.d0*pai*(i-1)/(n2*2))
         ti=dsin(2.d0*pai*(i-1)/(n2*2))
         b(i,1)=dcmplx(tr,-ti)
         b(i,2)=dcmplx(tr,ti)
 10   continue
      k=1
      nn=n2
      do 40 l=1,lp
         do 30 j=0,k-1
            do 20 i=1,nn
               t(i+j*nn,l,1)=b(1+nn*j,1)
               t(i+j*nn,l,2)=b(1+nn*j,2)
 20         continue
 30      continue
         k=k*2
         nn=nn/2
 40   continue
      return
      end

c  list setting for fft written by t. yamaguchi
      subroutine setlst(list,n2,lp)
      dimension list(n2,lp)
      n1=n2
      nn=1
      do 30 k=1,lp
         m=0
         do 20 j=1,nn
            do 10 i=1,n1
               m=m+1
               list(m,k)=i+(j-1)*2*n1
 10         continue
 20      continue
         n1=n1/2
         nn=nn*2
 30   continue
      return
      end
