      subroutine freadi(prfx,n,var,nl)  ! for n=1
      character(*) prfx
      integer var
      integer var0(1)
      call freadiv(prfx,n,var0,nl)
      var=var0(1)
      return
      end

      subroutine freadiv(prfx,n,var,nl) ! vector version
      character(*) prfx
      integer var(*)

      integer ip,ep
      character(256) buf
      common /cbuf/ buf,ip

      call getinp(inpu)
      call getout(iout)
      call getskp(iskp)
 100  continue
      if(nl.eq.1) then
         read(inpu,'(a)',end=200) buf
         ip=1
      end if
      if(prfx.eq.' ') then
         ipd=1
      else
         ipd=index(buf(ip:256),prfx)
      end if
c     ip beginning of the prfx
      ip=ipd+ip-1
      if(ipd.eq.0) then
         if(iskp.eq.0) then
            write(iout,'(2a)') prfx,' not found'
            call quit(' ')
         else
            go to 100
         end if
      end if
      ep=len(prfx)+ip-1
c     ep: end of the prefix
      if(n.eq.0) return
c     skip blanks between prefix and value or value and value
      if(prfx.ne.' ') then
         jp=ep+1
      else
         jp=ep
      end if
      do 150 i=1,n
         do j=jp,256
            if(buf(j:j).ne.' ') go to 20
         end do
 20      continue
         jp=j
c     jp: beginning of i-th value
         ipd1=index(buf(jp:256),' ')
         ipd2=index(buf(jp:256),',')
         if(ipd1.gt.0.and.ipd2.gt.0) then
            jp=min(ipd1,ipd2)+jp
         else if(ipd1.gt.0) then
            jp=ipd1+jp
         else if(ipd2.gt.0) then
            jp=ipd2+jp
         else
            jp=256
         end if
c     jp: beginning of next prefix or value
 150  continue
      if(jp.eq.256) then
         write(iout,'(3a)') 'value of ',prfx,' not fund'
         call quit(' ')
      end if
      if(prfx.ne.' ') then
         read(buf(ep+1:jp-1),*) (var(i),i=1,n)
         ip=jp
      else
         read(buf(ep:jp-1),*) (var(i),i=1,n)
         ip=jp-1
      end if
      return
 200  continue
      write(iout,'(2a)') prfx,' not found'
      call quit(' ')
      return
      end

      subroutine freadr(prfx,n,var,nl) ! for n=1
      character(*) prfx
      real var
      real var0(1)
      call freadrv(prfx,n,var0,nl)
      var=var0(1)
      return
      end

      subroutine freadrv(prfx,n,var,nl) ! vector version
      character(*) prfx
      real var(*)

      integer ip,ep
      character(256) buf
      common /cbuf/ buf,ip

      call getinp(inpu)
      call getout(iout)
      call getskp(iskp)
 100  continue
      if(nl.eq.1) then
         read(inpu,'(a)',end=200) buf
         ip=1
      end if
      if(prfx.eq.' ') then
         ipd=1
      else
         ipd=index(buf(ip:256),prfx)
      end if
      ip=ipd+ip-1
      if(ipd.eq.0) then
         if(iskp.eq.0) then
            write(iout,'(2a)') prfx,' not found'
            call quit(' ')
         else
            go to 100
         end if
      end if
      ep=len(prfx)+ip-1
c     ep: end of the prefix
      if(n.eq.0) return
c     skip blanks between prefix and value or value and value
      if(prfx.ne.' ') then
         jp=ep+1
      else
         jp=ep
      end if
      do 150 i=1,n
         do 10 j=jp,256
            if(buf(j:j).ne.' ') go to 20
 10      continue
 20      continue
         jp=j
c     jp: beginning of i-th value
         ipd1=index(buf(jp:256),' ')
         ipd2=index(buf(jp:256),',')
         if(ipd1.gt.0.and.ipd2.gt.0) then
            jp=min(ipd1,ipd2)+jp
         else if(ipd1.gt.0) then
            jp=ipd1+jp
         else if(ipd2.gt.0) then
            jp=ipd2+jp
         else
            jp=256
         end if
c     jp: beginning of next prefix or value
 150  continue
      if(jp.eq.256) then
         write(iout,'(3a)') 'value of ',prfx,' not fund'
         call quit(' ')
      end if
      if(prfx.ne.' ') then
         read(buf(ep+1:jp-1),*) (var(i),i=1,n)
         ip=jp
      else
         read(buf(ep:jp-1),*) (var(i),i=1,n)
         ip=jp-1
      end if
      return
 200  continue
      write(iout,'(2a)') prfx,' not found'
      call quit(' ')
      return
      end

      subroutine freadc(prfx,n,var,nl) ! for n=1
      character(*) prfx
      character(*) var
      character(80) var0(1)
      call freadcv(prfx,n,var0,nl)
      var=var0(1)
      return
      end

      subroutine freadcv(prfx,n,var,nl) ! vector version
      character(*) prfx
      character(*) var(*)

      integer ip,ep
      character(256) buf
      common /cbuf/ buf,ip

      call getinp(inpu)
      call getout(iout)
      call getskp(iskp)
 100  continue
      lval=len(var(1))
      if(nl.eq.1) then
c           read(inpu,'(a)') buf
           read(inpu,'(a)',end=200) buf
           ip=1
      end if
      if(prfx.eq.' ') then
          ipd=1
      else
          ipd=index(buf(ip:256),prfx)
      end if
      ip=ipd+ip-1
      if(ipd.eq.0) then
           if(iskp.eq.0) then
               write(iout,'(2a)') prfx,' not found'
               call quit(' ')
           else
               go to 100
           end if
      end if
      if(ipd.eq.0) then
           write(iout,'(2a)') prfx,' not found'
           call quit(' ')
      end if
      ep=len(prfx)+ip-1
c     ep: end of the prefix
      if(n.eq.0) return
c       skip blanks between prefix and value or value and value
      if(prfx.ne.' ') then
          jp=ep+1
      else
          jp=ep
      end if
c      jp=ep+1
      do 150 i=1,n
          do 10 j=jp,256
              if(buf(j:j).ne.' ') go to 20
 10       continue
 20       continue
          jp=j
c         jp: beginning of i-th value
          ipd1=index(buf(jp+1:256),'''')
          if(ipd1.gt.0) then
              jp=ipd1+jp+1
          else
              jp=256
          end if
c         jp: beginning of the next prefix or value
 150  continue
      if(jp.eq.256) then
          write(iout,'(3a)') 'value of ',prfx,' not fund'
          call quit(' ')
      end if
      read(buf(ep+1:jp-1),*) (var(i)(1:lval),i=1,n)
      ip=jp
      return
 200  continue
           write(iout,'(2a)') prfx,' not found'
           call quit(' ')
      return
      end

      integer function istrln(c)
      character(*) c
      ln=len(c)
      do i=ln,1,-1
         if(c(i:i).ne.' ') then
            istrln=i
            return
         end if
      end do
      istrln=0
      return
      end

      subroutine setinp(inpu)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      cinpu=inpu
      return
      end

      subroutine setout(iout)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      coutu=iout
      return
      end

      subroutine getinp(inpu)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      inpu=cinpu
      return
      end

      subroutine getout(iout)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      iout=coutu
      return
      end

      subroutine setskp(iskp)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      cskip=iskp
      return
      end

      subroutine getskp(iskp)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      iskp=cskip
      return
      end

      subroutine quit(str)
      character(*) str
      write(6,*) str
      call getinp(inpu)
      call getout(iout)
      close(inpu)
      close(iout)
      stop
      return
      end
