      subroutine cxtoxy0(cr,dxy,ixm,iym,l,hscl,ax,bx)
      implicit integer (h)
      real cr(0:*)
      real dxy(0:ixm,0:iym)
      integer hmax(6)
      real hscl
      common /cabtxy/ xmin,xmax,ymin,ymax,ri1,ri2,xdiv,ydiv
      real x(6),xd(6),rx(6)
c      integer hd(6)
      common /ctr/ itr(6,6)
      common /cjbc/ jbc,xs(6),iax(6)
      integer rr
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      data eps /0.0001/
      call gethmax(hmax)
      call getnsymo(nsymo)
      call geticent(icent)
      fact1=(xmax-xmin)/(ixm*ax)
      fact2=(ymax-ymin)/(iym*bx)
c      write(6,*) (cr(i),i=1,10)
      if(icent.eq.0) then
         icd=1
      else
         icd=2
      end if
      do h=0,ixm-1
         do k=0,iym-1
            do i=1,6
               x(i)=0
               rx(i)=0
            end do
            x(iax(1))=xmin/ax+h*fact1
            x(iax(2))=ymin/bx+k*fact2
            do i=1,6
               x(i)=x(i)+xs(i)  ! origin shift
            end do
            fact=hscl
c     fact=hscl/(nsymo*icd)
c     get average density over all equivalent points
            dxy(h,k)=0
c     do 230 ns=1,nsymo
c     do 230 ic=0,icent
            ns=1
            ic=0
            call getrx0(x,xd,itr,tt,1,0) ! xd : original coordinates
            call getrx0(xd,rx,rr,tt,ns,ic) ! rx : equivalent coordinates
            call grad(cr,rx,dnsty)
            dxy(h,k)=dxy(h,k)+dnsty*fact
c     230     continue
         end do
      end do
      do k=0,iym-1
         dxy(ixm,k)=dxy(0,k)
      end do
      do h=0,ixm
         dxy(h,iym)=dxy(h,0)
      end do
c     do h=0,ixm
c     write(6,'(10f8.2)') (dxy(h,k),k=0,9)
c     end do
      write(6,*) ' '
      return
      end

      subroutine grad(dr,rx,dnsty)
      real dr(*)    ! dxya(0:*) ?
      real rx(*)
      integer hmax(6)
      real rd(6)
      integer h0(6),h1(6),h2(6)
      integer h(6),k(6),l(6),m(6)
      integer id(6)
      real grd0(6),grd1(6),grd2(6),dx(6)
      real dgrd(6,6)
      data eps/0.0001/
      call gethmax(hmax)
      do i=1,6
         rd(i)=mod(rx(i),1.)
         if(rd(i).lt.0) rd(i)=rd(i)+1.   ! coordinates in the unit cell
      end do
c     h0(i) (i=1,6)  nearest grid point for q(i)
      do i=1,6
         rd(i)=rd(i)*hmax(i)
         h0(i)=rd(i)+0.5
         dx(i)=rd(i)-h0(i)
         h0(i)=mod(h0(i),hmax(i))
      end do
c     h1(i),h2(i) (i=1,6) second nearest points along 6 axes
      do i=1,6
         if(abs(dx(i)).lt.eps) then
            id(i)=0
         else
            id(i)=1
         end if
         h1(i)=h0(i)+id(i)
         h2(i)=h0(i)-id(i)
         h1(i)=mod(h1(i),hmax(i))
         h2(i)=mod(h2(i),hmax(i))
         if(h1(i).lt.0) h1(i)=h1(i)+hmax(i)
         if(h2(i).lt.0) h2(i)=h2(i)+hmax(i)
      end do
c     write(6,'(a,6i4,6i4,6f8.5)') 'h0,h1,dx',h0,h1,dx
      i0=getxyztoj(h0)
      dnst0 =dr(i0)
      do i=1,6
         do j=1,6
            if(j.eq.i) then
               h(j)=h1(j)
               k(j)=h2(j)
            else
               h(j)=h0(j)
               k(j)=h0(j)
            end if
         end do
         i1=getxyztoj(h)
         i2=getxyztoj(k)         
         grd1(i)= (dr(i1)-dnst0)
         grd2(i)=-(dr(i2)-dnst0)
      end do

      do i=1,6
         grd0(i)=(grd1(i)+grd2(i))/2
         dgrd(i,i)=grd1(i)-grd2(i)
      end do
      do i=1,6
         call vcpyi(h0,h,6)
         call vcpyi(h0,k,6)
         call vcpyi(h0,l,6)
         call vcpyi(h0,m,6)
         do j=1,6
            if(j.ne.i) then
               h(i)=h1(i)
               l(i)=h1(i)
               k(i)=h2(i)
               m(i)=h2(i)
               
               l(j)=h1(j)
               m(j)=h1(j)
               i1=getxyztoj(h)
               i2=getxyztoj(l)
               i3=getxyztoj(k)
               i4=getxyztoj(m)
               dnst00 =dr(i1)
               dnst01 =dr(i2)
               dnst02 =dr(i3)
               dnst03 =dr(i4)
c     dnst00 =dr(h1(1),h0(2),h0(3),h0(4),h0(5),h0(6))
c     dnst01 =dr(h1(1),h1(2),h0(3),h0(4),h0(5),h0(6))
c     dnst02 =dr(h2(1),h0(2),h0(3),h0(4),h0(5),h0(6))
c     dnst03 =dr(h2(1),h1(2),h0(3),h0(4),h0(5),h0(6))
               grd3   =dnst01-dnst00
               grd4   =dnst03-dnst02
c     dnsxy1 =dnst00+grd3/2
c     dnsxy2 =dnst02+grd4/2
c     tmp0=dnst0+grd1(1)/2
c     tmp1=dnst00+dnsxy1/2
c     tmp2=dnst02+dnsxy2/2
               tmp1=dnst00+grd3/2 ! density at i+1, j+0.5
               tmp2=dnst02+grd4/2 ! density at i-1, j+0.5
               grdxy1 =(tmp1-tmp2)/2 ! avrage gradient along i-th axis at i,j+0.5
               l(j)=h2(j)
               m(j)=h2(j)
               i1=getxyztoj(h)
               i2=getxyztoj(l)
               i3=getxyztoj(k)
               i4=getxyztoj(m)
               dnst00 =dr(i1)
               dnst01 =dr(i2)
               dnst02 =dr(i3)
               dnst03 =dr(i4)
c     dnst00 =dr(h1(1),h0(2),h0(3),h0(4),h0(5),h0(6))
c     dnst01 =dr(h1(1),h2(2),h0(3),h0(4),h0(5),h0(6))
c     dnst02 =dr(h2(1),h0(2),h0(3),h0(4),h0(5),h0(6))
c     dnst03 =dr(h2(1),h2(2),h0(3),h0(4),h0(5),h0(6))
               grd5   =-(dnst01-dnst00)
               grd6   =-(dnst03-dnst02)
c     dnsxy1 =dnst00-grd5/2
c     dnsxy2 =dnst02-grd6/2
c     tmp0=dnst0-grd2(1)/2
c     tmp1=dnst00-dnsxy1/2
c     tmp2=dnst02-dnsxy2/2
               tmp3=dnst00-grd5/2 ! density at i+1, j-0.5
               tmp4=dnst02-grd6/2 ! density at i-1, j-0.5
               grdxy2 =(tmp3-tmp4)/2 ! average gradient along i-th axis at i,j-0.5
               dgrd(i,j)=grdxy1-grdxy2 ! change in dgdx along j-th axis
            end if
         end do
      end do
c     call getqir(grd,grdq)
c     call getqe0(dx,dxq)
      delt=0
      do i=1,6
c        delt=delt+grdq(i)*dxq(i)
         delt=delt+grd0(i)*dx(i)
      end do
      do i=1,6
         do j=1,6
            delt=delt+dgrd(i,j)*dx(i)*dx(j)
         end do
      end do
      dnsty=dnst0+delt
c      if(dnsty.lt.0) then
c         write(6,'(a,18i4)') 'h0,h1=',h0,h1,id
c         write(6,'(a,6f10.4)') 'grd=',grd
c         write(6,'(a,6f10.4)') 'dx=',dx
c         write(6,'(a,3f10.4)') 'dnst0,delt,dnsty=',dnst0,delt,dnsty
c      end if
      return
      end

      subroutine mapxyz(ar,ai,cr,ci,dmin,dmax)
      implicit integer (h)
      real ar(0:*),ai(0:*)
      real cr(0:*),ci(0:*)
      integer hmax(6)
      integer getnt
      data eps /0.01/
      vol=getvol()
      call gethmax(hmax)
      nt=getnt()
      call getidm(idm)
      write(6,*) 'vol,hmax,nt,idm=',vol,hmax,nt,idm
      call vcpyr(ar,cr,nt)
      call vcpyr(ai,ci,nt)
      call cft1(cr,ci,hmax,idm,1,icon)
      sum=0
      dmin=cr(0)/vol
      dmax=cr(0)/vol
      do i=0,nt-1
         tmp=cr(i)/vol
         cr(i)=tmp
         dmin=min(tmp,dmin)
         dmax=max(tmp,dmax)
      end do
      return
      end

      subroutine difxyz(ar,ai,br,bi,sg,f000,dr)
      real ar(0:*),ai(0:*)
      real br(0:*),bi(0:*)
      real sg(0:*)
      real dr(0:*)
      integer hmax(6)
      integer getnt
      data eps/1.e-6/
      nt=getnt()
      vol=getvol()
      call getidm(idm)
      call gethmax(hmax)
      br(1)=(ar(1)-br(1))/(vol*sg(1)/f000)
      bi(1)=0.
      do i=2,nt
******************
c        if(abs(ar(i)).lt.eps.and.abs(ai(i)).lt.eps) then
******************
         if(sg(i).eq.0.) then
c           skip non observed reflections
            br(i)=0.
            bi(i)=0.
         else
            br(i)=(ar(i)-br(i))/(vol*sg(i)/f000)
            bi(i)=(ai(i)-bi(i))/(vol*sg(i)/f000)
         end if
      end do
      call cft1(br,bi,hmax,idm,1,icon)
      call vcpyr(br,dr,nt)
      return
      end

      subroutine difxyz0(ar,ai,br,bi,sg,f000,dr)
      implicit integer (h)
      real ar(0:*),ai(0:*)
      real br(0:*),bi(0:*)
      real dr(0:*),sg(0:*)
      integer hmax(6)
      integer getnt
      nt=getnt()
      vol=getvol()
      call getidm(idm)
      call gethmax(hmax)
      write(6,*) 'nt,vol,hmax,idm=',nt,vol,hmax,idm
      br(1)=(ar(1)-br(1))/sg(1)**2
      do 10 i=2,nt
      if(sg(i).eq.0.0) then
         br(i)=0
         bi(i)=0
      else
         br(i)=(ar(i)-br(i))/sg(i)**2
         bi(i)=(ai(i)-bi(i))/sg(i)**2
      end if
 10   continue
      call cft1(br,bi,hmax,idm,1,icon)
      do 20 i=1,nt
         dr(i)=br(i)/vol
 20   continue
      return
      end

      subroutine maphkl(cr,br,bi)
      real cr(0:*)
      real br(0:*),bi(0:*)
      integer hmax(6)
      integer getnt
      nt=getnt()
      vol=getvol()
      call geticent(icent)
      call getidm(idm)
c     write(6,*) 'nt,idm,vol=',nt,idm,vol
      call gethmax(hmax)
      call vcpyr(cr,br,nt)
      call zerovr(bi,nt)
      call cft1(br,bi,hmax,idm,-1,icon)
      vnt=vol/nt
      do 10 i=1,nt
         if(icent.eq.0) then
            br(i)=br(i)*vnt
            bi(i)=bi(i)*vnt
         else
            br(i)=br(i)*vnt
            bi(i)=0.
         end if
 10   continue
      return
      end

      subroutine axs0(amin,amax,bmin,bmax,diva,divb,xx,yy)
      dimension xx(3),yy(3),ax(4),ay(4)
c     common /cabxy/ ax,bx,coscx,sincx,irl,amagx,amagy
      call plot(xx(1),yy(1),3)
      call plot(xx(2),yy(2),2)
      call plot(xx(1),yy(1),3)
      call plot(xx(3),yy(3),2)
      ax(3)=0.0
      ay(3)=0.0
      ax(4)=1.0
      ay(4)=1.0
      im=(amax-amin)/diva+0.001
      jm=(bmax-bmin)/divb+0.001
      do 60 i=1,im
      ax(1)=amin +diva*float(i)
      ay(1)=bmin
      call abtoxy(ax,ay,1)
      ax(2)=ax(1)
      ay(2)=ay(1)-0.1
c      if(irl.ne.1) ay(2)=ay(1)-0.1
c      if(irl.eq.1) ay(2)=ay(1)+0.1
 60   call line(ax,ay,2,1,0,0)
      do 61 j=1,jm
      ax(1)=amin
      ay(1)=bmin +divb*float(j)
      call abtoxy(ax,ay,1)
      ax(2)=ax(1)-0.1
      ay(2)=ay(1)
 61   call line(ax,ay,2,1,0,0)
      return
      end

      subroutine axs(amin,amax,bmin,bmax,diva,divb)
      dimension ax(4),ay(4)
      ax(3)=0.0
      ay(3)=0.0
      ax(4)=1.0
      ay(4)=1.0
      offsx=mod(amin,diva)
      offsy=mod(bmin,diva)
      im=(amax-amin+offsx)/diva+0.001
      jm=(bmax-bmin+offsy)/divb+0.001
      do 60 i=0,im
      ax(1)=amin-offsx +diva*float(i)
      ay(1)=bmin
      call abtoxy(ax,ay,1)
      ax(2)=ax(1)
      ay(2)=ay(1)-0.05
 60   call line(ax,ay,2,1,0,0)
      do 61 j=0,jm
      ax(1)=amin
      ay(1)=bmin-offsy +divb*float(j)
      call abtoxy(ax,ay,1)
      ax(2)=ax(1)-0.05
      ay(2)=ay(1)
 61   call line(ax,ay,2,1,0,0)
      do 70 i=0,im
      ax(1)=amin-offsx +diva*float(i)
      ay(1)=bmax
      call abtoxy(ax,ay,1)
      ax(2)=ax(1)
      ay(2)=ay(1)+0.05
 70   call line(ax,ay,2,1,0,0)
      do 71 j=0,jm
      ax(1)=amax
      ay(1)=bmin-offsy +divb*float(j)
      call abtoxy(ax,ay,1)
      ax(2)=ax(1)+0.05
      ay(2)=ay(1)
 71   call line(ax,ay,2,1,0,0)
      return
      end

      subroutine clin(a,b,n,ltyp,pitch)
      parameter (nhkl=2000)
      dimension a(*),b(*),ad(nhkl),bd(nhkl),d1(4)
      if(ltyp.eq.1) then
          a(n+1)=0.0
          b(n+1)=0.0
          a(n+2)=1.0
          b(n+2)=1.0
          call line(a,b,n,1,0,0)
          return
      end if
      if(ltyp.eq.2) then
           d1(1)=pitch/2
           d1(2)=d1(1)
           d1(3)=d1(1)
           d1(4)=d1(1)*5
      else if(ltyp.eq.3) then
           d1(1)=pitch
           d1(2)=d1(1)
           d1(3)=d1(1)
           d1(4)=d1(1)
      end if
      k=0
      is=2
      j=1
      ad(1)=a(1)
      bd(1)=b(1)
      dab=0.0
      dx=0.0
      i=1
      i1=1
 12   continue
      k=k+1
      k=mod(k-1,4)+1
      ad(1)=ad(j)
      bd(1)=bd(j)
      j=1
      dd=-dx
      do 10 i=is,n
          j=j+1
          if(j.gt.500) then
              call quit(' ad(j),bd(j), j>500 in clin ')
          end if
          da=a(i)-a(i-1)
          db=b(i)-b(i-1)
          dab=sqrt(da**2+db**2)
          d=dd+dab
          ad(j)=a(i)
          bd(j)=b(i)
          if(i.eq.n.and.d.lt.d1(k)) go to 11
          if(d.lt.d1(k)) go to 10
          dx=d1(k)-dd
          ad(j)=a(i-1)+da*dx/dab
          bd(j)=b(i-1)+db*dx/dab
          is=i
          if((k.eq.1.or.k.eq.3).and.i.ne.n) go to 12
 11       if((k.eq.1.or.k.eq.3).and.i.eq.n) go to 10
          ad(j+1)=0.0
          bd(j+1)=0.0
          ad(j+2)=1.0
          bd(j+2)=1.0
          call line(ad,bd,j,1,0,0)
          if(i.ne.n) go to 12
 10   dd=d
      return
      end


c s.contpl : sub to contour plot *********************************
c  contpl(hh,h,is,ie,js,je,xmin,ymin,fx,fy)                      *
c    *subroutine to plot contour line of height h                *
c     within (is-ie),(js-je) of 2d array hh(i,j)                 *
c     fx: increment of x in cm per data                          *
c     fy: increment of y in cm per data                          *
c     the above fx and fy values are evaluated by setting        *
c     the cell edges of the x and y axes to be edge cm.          *
c    *contour points: got by linear interpolation of adjacent    *
c     lattice points (thus, at most 1 contour point between      *
c     adjacent lattice points, and 0, 1 or at most 2 contour     *
c     lines in a unit cell of the lattice)                       *
c    *if 2 contour points on a unit cell boundary, these are     *
c     connected uncoditionally                                   *
c    *if 4 contour points on a unit cell boundary (thus, 2       *
c     contour lines in a cell), point connection be determined   *
c     on condition that line be less curved                      *
c    *to do above (check curvature), need 1 former point,        *
c     thus, 1st point to start a contour line be chosen among    *
c     2-contour-point cells                                      *
c    *contour lines are classified into 2 types                  *
c     1) line(s) running from boundary to boundary               *
c     2) loop(s) self-closed                                     *
c---- arrays ----------------------------------------------------*
c   (a,ia): coordinate data of contour points                    *
c           (x,iy): for y-axes data (m points)                   *
c           (y,ix): for x-axes data (n-m points)                 *
c   (x,y) : coordinate data for 'line' routine                   *
c---- control indices -------------------------------------------*
c    m  : number of y-axes data           (a,ia array)           *
c    n  : number of total data (y + x)    (a,ia array)           *
c    im : start of 'live' y-axes data     (a,ia array)           *
c    in : end of 'live' x-axes data       (a,ia array)           *
c    imm: temporary 'im'                  (a,ia array)           *
c    inn: tnmporary 'in'                  (a,ia array)           *
c    ist: start point of line             (a,ia array)           *
c    ib : boundary index                                         *
c    np : number of 'next' points                                *
c    j  : index of line to be plotted     (x,y array)            *
c---- co-subroutines --------------------------------------------*
c   contpn(h,is,ie,js,je)                                       *
c       find contour points of height h within (is-ie),(js-je)   *
c       set (a,ia) array and m,n                                 *
c   ib=bndry(i,is,ie,js,je)  (function)                          *
c       if i-th point is not on boundary, ib=0                   *
c       if i is on upper- or left- boundary, ib= 1               *
c       if i is on lower- or right-boundary, ib=-1               *
c   exchng(i,im,in,j,fx,fy)                                      *
c       if(j.eq.-1), only exchange                               *
c       if(j.le.-2), not exchange, j=-j                          *
c       if(j.ne.-1), j=j+1, set x(j)=fx*(x-coordinate of i) &    *
c                               y(j)=fy*(y-coordinate of i)      *
c       if(i.le.m), exchange im and i, set i=im, im=im+1         *
c       if(i.gt.m), exchange i and in, set i=in, in=in-1         *
c   search(ib,i0,i1,im,in,np)                                    *
c       search (i0)->(i1)->'next'? among im-in                   *
c       if(i0=0), get search direction from ib                   *
c       if(i0.ne.0), ib: not used                                *
c       np=number of found 'next' points                         *
c       if(i0.ge.1), i0=optimal 'next' among np points           *
c       if(np.ge.1), set i0=i1, i1='next'                        *
c    line(x,y,j,inc,ltp,iem) : plotter routine 'line'            *
c*****************************************************************
c
      subroutine contpl(h,al,is,ie,js,je,xmin,ymin,fx,fy,icon)
      parameter (ndata=20000)
c     real hh(ie,je),p(2,ndata)
      real h(ie,je),p(2,ndata)
c     common /cont/ ch(ndata),x(ndata*10),y(ndata*10),a(ndata*10),
      common /cont/ x(ndata*10),y(ndata*10),a(ndata*10),
     *              ia(ndata*10),m,n
*     a function to rotate the figure in a 180-degree arc
      parameter (edge=18.0)
c     yy(t)=edge*sinphi-t

c *** find points to form contour line of height h
      icon=0
      call contpn(h,al,is,ie,js,je)
      if(n.le.0) then
         icon=1
         return
      end if
      if(n.gt.ndata) call quit('n > ndata') 
      im=1 
      in=n 
      ib=1 
c  select first point to start contour line 
   10 continue 
 100  continue
      j=-1
      jb=0
   15 imm=im 
      inn=in
   20 continue
      do 30 i1=imm,inn 
      ib=bndry(i1,is,ie,js,je)
      if(ib.ne.0) goto 40 
   30 continue
      if(jb.eq.1) then
      jb=2
      goto 15
      endif
      i1=imm
   40 continue
      call exchng(i1,imm,inn,j,fx,fy)
      i0=0 
c  search next (second) point 
      call search(ib,i0,i1,im,in,np)
      if(np.gt.1.and.jb.le.1) then
      jb=1 
      goto 20
      endif
      j=0 
c  evaluate first point coordinate 
      call exchng(i0,im,in,j,fx,fy) 
c  store first point location 
      ist=i0 
   50 continue 
c  evaluate next point coordinate 
      call exchng(i1,im,in,j,fx,fy) 
c  check if terminal point 
      ib=bndry(i1,is,ie,js,je) 
      if(im.gt.in) goto 60 
      if(ib.ne. 0) goto 70 
c  search next point 
      call search(ib,i0,i1,im,in,np) 
      if(np.ne. 0) goto 50 
   60 continue 
c  check if terminal point is connected to first point 
      call search(ib,i0,i1,ist,ist,np) 
      if(np.eq.1) then
      j=-j 
      call exchng(i1,im,in,j,fx,fy)
      endif
   70 continue 

c *** plot found contour line
      do 80 i=1,j
          p(1,i)=x(i)+xmin
          p(2,i)=y(i)+ymin
   80 continue

      call smooth(p,j,x,y,npoint)
      call getcas(icase)
      if(abs(icase).le.8) then
          call abtoxy(x(1),y(1),npoint)
      end if
      if(al.gt.0.0) then
          call clin(x,y,npoint,1,0.1)
      else if(al.eq.0.0) then
          call clin(x,y,npoint,2,0.1)
      else if(al.lt.0.0) then
          call clin(x,y,npoint,3,0.1)
      end if
      if(im.lt.in) goto 10
      end

c s.contpl : sub to contour plot *********************************
c  contpl(hh,h,is,ie,js,je,xmin,ymin,fx,fy)                      *
c    *subroutine to plot contour line of height h                *
c     within (is-ie),(js-je) of 2d array hh(i,j)                 *
c     fx: increment of x in cm per data                          *
c     fy: increment of y in cm per data                          *
c     the above fx and fy values are evaluated by setting        *
c     the cell edges of the x and y axes to be edge cm.          *
c    *contour points: got by linear interpolation of adjacent    *
c     lattice points (thus, at most 1 contour point between      *
c     adjacent lattice points, and 0, 1 or at most 2 contour     *
c     lines in a unit cell of the lattice)                       *
c    *if 2 contour points on a unit cell boundary, these are     *
c     connected uncoditionally                                   *
c    *if 4 contour points on a unit cell boundary (thus, 2       *
c     contour lines in a cell), point connection be determined   *
c     on condition that line be less curved                      *
c    *to do above (check curvature), need 1 former point,        *
c     thus, 1st point to start a contour line be chosen among    *
c     2-contour-point cells                                      *
c    *contour lines are classified into 2 types                  *
c     1) line(s) running from boundary to boundary               *
c     2) loop(s) self-closed                                     *
c---- arrays ----------------------------------------------------*
c   (a,ia): coordinate data of contour points                    *
c           (x,iy): for y-axes data (m points)                   *
c           (y,ix): for x-axes data (n-m points)                 *
c   (x,y) : coordinate data for 'line' routine                   *
c---- control indices -------------------------------------------*
c    m  : number of y-axes data           (a,ia array)           *
c    n  : number of total data (y + x)    (a,ia array)           *
c    im : start of 'live' y-axes data     (a,ia array)           *
c    in : end of 'live' x-axes data       (a,ia array)           *
c    imm: temporary 'im'                  (a,ia array)           *
c    inn: tnmporary 'in'                  (a,ia array)           *
c    ist: start point of line             (a,ia array)           *
c    ib : boundary index                                         *
c    np : number of 'next' points                                *
c    j  : index of line to be plotted     (x,y array)            *
c---- co-subroutines --------------------------------------------*
c   contpn(h,is,ie,js,je)                                       *
c       find contour points of height h within (is-ie),(js-je)   *
c       set (a,ia) array and m,n                                 *
c   ib=bndry(i,is,ie,js,je)  (function)                          *
c       if i-th point is not on boundary, ib=0                   *
c       if i is on upper- or left- boundary, ib= 1               *
c       if i is on lower- or right-boundary, ib=-1               *
c   exchng(i,im,in,j,fx,fy)                                      *
c       if(j.eq.-1), only exchange                               *
c       if(j.le.-2), not exchange, j=-j                          *
c       if(j.ne.-1), j=j+1, set x(j)=fx*(x-coordinate of i) &    *
c                               y(j)=fy*(y-coordinate of i)      *
c       if(i.le.m), exchange im and i, set i=im, im=im+1         *
c       if(i.gt.m), exchange i and in, set i=in, in=in-1         *
c   search(ib,i0,i1,im,in,np)                                    *
c       search (i0)->(i1)->'next'? among im-in                   *
c       if(i0=0), get search direction from ib                   *
c       if(i0.ne.0), ib: not used                                *
c       np=number of found 'next' points                         *
c       if(i0.ge.1), i0=optimal 'next' among np points           *
c       if(np.ge.1), set i0=i1, i1='next'                        *
c    line(x,y,j,inc,ltp,iem) : plotter routine 'line'            *
c*****************************************************************
c
      subroutine contpl0(h,al,is,ie,js,je,xmin,ymin,fx,fy,icon)
      parameter (ndata=20000)
c     real hh(ie,je),p(2,ndata)
      real h(ie,je),p(2,ndata)
c     common /cont/ ch(ndata),x(ndata*10),y(ndata*10),a(ndata*10),
      common /cont/ x(ndata*10),y(ndata*10),a(ndata*10),
     *              ia(ndata*10),m,n
*     a function to rotate the figure in a 180-degree arc
      parameter (edge=18.0)
c     yy(t)=edge*sinphi-t

c *** find points to form contour line of height h
      icon=0
      call contpn(h,al,is,ie,js,je)
      if(n.le.0) then
         icon=1
         return
      end if
      if(n.gt.ndata) call quit('n > ndata') 
      im=1 
      in=n 
      ib=1 
c  select first point to start contour line 
   10 continue 
      j=-1
      jb=0
   15 imm=im 
      inn=in
   20 continue
      do 30 i1=imm,inn 
      ib=bndry(i1,is,ie,js,je)
      if(ib.ne.0) goto 40 
   30 continue
      if(jb.eq.1) then
      jb=2
      goto 15
      endif
      i1=imm
   40 continue
      call exchng(i1,imm,inn,j,fx,fy)
      i0=0 
c  search next (second) point 
      call search(ib,i0,i1,im,in,np)
      if(np.gt.1.and.jb.le.1) then
      jb=1 
      goto 20
      endif
      j=0 
c  evaluate first point coordinate 
      call exchng(i0,im,in,j,fx,fy) 
c  store first point location 
      ist=i0 
   50 continue 
c  evaluate next point coordinate 
      call exchng(i1,im,in,j,fx,fy) 
c  check if terminal point 
      ib=bndry(i1,is,ie,js,je) 
      if(im.gt.in) goto 60 
      if(ib.ne. 0) goto 70 
c  search next point 
      call search(ib,i0,i1,im,in,np) 
      if(np.ne. 0) goto 50 
   60 continue 
c  check if terminal point is connected to first point 
      call search(ib,i0,i1,ist,ist,np) 
      if(np.eq.1) then
      j=-j 
      call exchng(i1,im,in,j,fx,fy)
      endif
   70 continue 

c *** plot found contour line
      do 80 i=1,j
          p(1,i)=x(i)+xmin
          p(2,i)=y(i)+ymin
   80 continue
      call smooth(p,j,x,y,npoint)

      call getcas(icase)
      if(abs(icase).le.8) then
          call abtoxy(x(1),y(1),npoint)
      end if

      if(al.gt.0.0) then
          call clin(x,y,npoint,1,0.1)
      else if(al.eq.0.0) then
          call clin(x,y,npoint,2,0.1)
      else if(al.lt.0.0) then
          call clin(x,y,npoint,3,0.1)
      end if
      if(im.lt.in) goto 10
      end

************************************************************************

      subroutine smooth(p,n,x,y,npoint)
      parameter (ndata=20000,is=2,ntotal=(ndata-1)*10+1)
      real p(is,ndata),rslt(is,ntotal),x(*),y(*)

      iz=3
      call spline(p,n,iz,rslt,npoint)
      do 10 i=1,npoint
         x(i)=rslt(1,i)
         y(i)=rslt(2,i)
   10 continue
      end

************************************************************************

      subroutine spline(p,n,iz,rslt,npoint)
**    input data
*             p: coordinates of points
*             n: number of data
*            iz: number of interpolated points
**    output data
*          rslt: coordinates of total points
*        npoint: number of total points

      parameter (ndata=20000,is=2,ntotal=(ndata-1)*10+1)
      real p(is,ndata),rslt(is,ntotal),pi(is),pe(is)
c      common /spl1/ a(ndata,3),b(is,ndata),u(is,ndata),xl(ndata)

*     corrected (iz in the original program = number of interpolated
*     points + 1)
      iz2=iz+1
      ic1=1
      ic2=1
*     pi and pe is not used in the present program because ic1=ic2=1
*     input pi here if ic1=2
*     input pe here if ic2=2
      call endpnt(p,n,ic1,ic2,pi,pe)
      call gauss(p,n)
      call curgen(p,n,iz2,rslt)
      npoint=(n-1)*iz2+1
      end

************************************************************************

      subroutine endpnt(p,n,ic1,ic2,pi,pe)
      parameter (ndata=20000,is=2,ntotal=(ndata-1)*10+1)
      real p(is,ndata),pi(is),pe(is)
      common /spl1/ a(ndata,3),b(is,ndata),u(is,ndata),xl(ndata)

      if (ic1 .eq. 1) then
         a(1,2)=1.0
         a(1,3)=0.5
      else
         a(1,2)=1.0
         a(1,3)=0.0
         do 10 k=1,is
            b(k,1)=pi(k)
            u(k,1)=pi(k)
   10    continue
      end if

      do 30 k=1,n-1
         xd=0.0
         do 20 j=1,is
            xd=xd+(p(j,k+1)-p(j,k))*(p(j,k+1)-p(j,k))
   20    continue
         xl(k)=sqrt(xd)
   30 continue
      if (ic1 .ne. 2) then
         do 40 k=1,is
            b(k,1)=(3.0/(2.0*xl(1)))*(p(k,2)-p(k,1))
   40    continue
      end if
      if (ic2 .eq. 1) then
         a(n,1)=1.0
         a(n,2)=2.0
         do 50 k=1,is
            b(k,n)=(3.0/xl(n-1))*(p(k,n)-p(k,n-1))
   50    continue
      else
         a(n,1)=0.0
         a(n,2)=1.0
         do 60 k=1,is
            b(k,n)=pe(k)
            u(k,n)=pe(k)
   60    continue
      end if
      end

************************************************************************


************************************************************************

      subroutine curgen(p,n,iz,rslt)
      parameter (ndata=20000,is=2,ntotal=(ndata-1)*10+1)
      real p(is,ndata),rslt(is,ntotal),f(4,is)
      common /spl1/ a(ndata,3),b(is,ndata),u(is,ndata),xl(ndata)

      i=1
      do 40 j=1,n-1
         do 10 k=1,is
            f(1,k)=p(k,j)
            f(2,k)=u(k,j)
            f(3,k)=(3.0/(xl(j)*xl(j)))*(p(k,j+1)-p(k,j))
     &      -(1.0/xl(j))*(u(k,j+1)+2.0*u(k,j))
            f(4,k)=(-2.0/(xl(j)*xl(j)*xl(j)))*(p(k,j+1)-p(k,j))
     &      +(1.0/(xl(j)*xl(j)))*(u(k,j+1)+u(k,j))
   10    continue
         t=0.0
         do 30 l=1,iz
            do 20 k=1,is
               rslt(k,i)=((f(4,k)*t+f(3,k))*t+f(2,k))*t+f(1,k)
   20       continue
            i=i+1
            t=t+xl(j)/iz
   30    continue
   40 continue
      do 50 k=1,is
         rslt(k,i)=p(k,n)
   50 continue
      end

************************************************************************

c s.contpn: find contour points (max:225x73)
c
c     (a,ia): coordinate data of contour points
c             (x,iy): for y-axes data (m points)
c             (y,ix): for x-axes data (n-m points)
c
      subroutine contpn(hh,h,i1,i2,j1,j2)
      real hh(i2,j2)
      parameter (ndata=20000)
c     common /cont/ ch(ndata),x(ndata*10),y(ndata*10),a(ndata*10),
      common /cont/ x(ndata*10),y(ndata*10),a(ndata*10),
     *              ia(ndata*10),m,n
*     common /origin/i0,j0
*     set the origin (1988.7.1)
      data i0,j0/0,0/

      m=0
      do 10 j=j1-j0,j2-j0
      do 10 i=i1-i0,i2-i0-1
      if((hh(i,j)-h)*(hh(i+1,j)-h).gt.0.) goto 10
      if(hh(i,j).ge.h.and.hh(i+1,j).ge.h) goto 10
      m=m+1
      d=(hh(i,j)-h)/(hh(i,j)-hh(i+1,j))
      if(d.lt.0.01) d=0.01
      if(d.gt.0.99) d=0.99
*     a(m)=i+i0+d
      a(m)=float(i)+float(i0)+d
      ia(m)=j+j0
c  20 continue
   10 continue
      n=m
      do 40 i=i1-i0,i2-i0
      do 40 j=j1-j0,j2-j0-1
      if((hh(i,j)-h)*(hh(i,j+1)-h).gt.0.) goto 40
      if(hh(i,j).ge.h.and.hh(i,j+1).ge.h) goto 40
      n=n+1
      if(n.gt.ndata*10) goto 90
      d=(hh(i,j)-h)/(hh(i,j)-hh(i,j+1))
      if(d.lt.0.01) d=0.01
      if(d.gt.0.99) d=0.99
      a(n)=float(j)+float(j0)+d
      ia(n)=i+i0
c  50 continue
   40 continue
*     display(10,1010,line=14) h,i1,i2,j1,j2,m,n
      write(6,1010) h,i1,i2,j1,j2,m,n
 1010 format(' h=',f7.1,' (',2i4,') (',2i4,') m=',i4,' n=',i4)
      return
 90   continue
*     display(10,1020,line=14) h,i1,i2,j1,j2
      write(6,1020) h,i1,i2,j1,j2
 1020 format(' h=',f7.1,' (',2i4,')  (',2i4,') overflow')
      return
      end

************************************************************************

c s.bndry : support contplt routine
c     check if boundary point
      function bndry(i,is,ie,js,je)
      parameter (ndata=20000)
c     common /cont/ ch(ndata),x(ndata*10),y(ndata*10),a(ndata*10),
      common /cont/ x(ndata*10),y(ndata*10),a(ndata*10),
     *              ia(ndata*10),m,n
      bndry=0
      if(i.le.m) then
      if(ia(i).eq.js) bndry=1
      if(ia(i).eq.je) bndry=-1
      else
      if(ia(i).eq.is) bndry=1
      if(ia(i).eq.ie) bndry=-1
      endif
      return
      end

************************************************************************

c s.exchng : support contplt routine
c     replace data in (a,ia) array for contour plot
c
      subroutine exchng(i,im,in,j,fx,fy)
      parameter (ndata=20000)
c     common /cont/ ch(ndata),x(ndata*10),y(ndata*10),a(ndata*10),
      common /cont/ x(ndata*10),y(ndata*10),a(ndata*10),
     *              ia(ndata*10),m,n
      if(j.eq.-1) goto 10
      ib=1
      if(j.le.-2) then
      ib=-1
      j=-j
      endif
      j=j+1
      if(i.le.m) then
      x(j)=(a(i)-1.)*fx
      y(j)=(ia(i)-1)*fy
*     write(6,'(4f6.2,2f8.5)') x(j),y(j),a(i),float(ia(i)),fx,fy
      else
      x(j)=(ia(i)-1)*fx
      y(j)=(a(i)-1.)*fy
*     write(6,'(4f6.2,2f8.5)') x(j),y(j),float(ia(i)),a(i),fx,fy
      endif
      if(ib.eq.-1) return
   10 continue
      if(i.le.m) ib=im
      if(i.gt.m) ib=in
      buf=a(ib)
      a(ib)=a(i)
      a(i)=buf
      ibuf=ia(ib)
      ia(ib)=ia(i)
      ia(i)=ibuf
      i=ib
      if(i.le.m) im=im+1
      if(i.gt.m) in=in-1
      return
      end

************************************************************************

c s.search : support contplt routine
c     search 'next' point
c
      subroutine search(ib,i0,i1,im,in,np)
      parameter (ndata=20000)
c     common /cont/ ch(ndata),x(ndata*10),y(ndata*10),a(ndata*10),
      common /cont/ x(ndata*10),y(ndata*10),a(ndata*10),
     *              ia(ndata*10),m,n
      dimension ik(3)
      ixy1=a(i1)
      iyx1=ia(i1)
      if(i0.le.0) goto 10
      if(i0.le.m) then
       x0=a(i0)
       ix0=x0
       iy0=ia(i0)
       y0=iy0
      else
       ix0=ia(i0)
       x0=ix0
       y0=a(i0)
       iy0=y0
      endif
      if(i1.le.m) then
       ib=iyx1-iy0
       x1=a(i1)
       y1=iyx1
      else
       ib=iyx1-ix0
       x1=iyx1
       y1=a(i1)
      endif
   10 continue
      if(ib.le.0) ib=-1
      if(ib.gt.0) ib=0
      k=0
      do 20 i=im,in
      if(i.eq.i1) goto 20
      if(i1.le.m.and.i.le.m) goto 20
      if(i1.gt.m.and.i.gt.m) goto 20
      if(ifix(a(i)).ne.iyx1+ib) goto 20
      if(.not.(ia(i).eq.ixy1.or.ia(i).eq.ixy1+1)) goto 20
      k=k+1
      ik(k)=i
   20 continue
      if(ib.eq.0) ib=1
      do 30 i=im,in
      if(i1.le.m.and.i.gt.m) goto 30
      if(i1.gt.m.and.i.le.m) goto 30
      if(ia(i).ne.iyx1+ib) goto 30
      if(ifix(a(i)).ne.ixy1) goto 30
      k=k+1
      ik(k)=i
   30 continue
      np=k
      if(np.eq.0) return
      if(np.eq.1) then
       i0=i1
       i1=ik(1)
       return
      endif
      d1=(x1-x0)**2+(y1-y0)**2
      tmin=10.
      do 40 k=1,np
      i=ik(k)
      if(i.le.m) then
       if(i1.le.m) goto 40
       x2=a(i)
       y2=ia(i)
      else
       if(i1.gt.m) goto 40
       x2=ia(i)
       y2=a(i)
      endif
      d=(x2-x1)**2+(y2-y1)**2
      d2=(x2-x0)**2+(y2-y0)**2
      t=(d1+d-d2)/sqrt(d*d1)
      if(t.ge.tmin) goto 40
       imin=i
       tmin=t
   40 continue
   50 continue
      i0=i1
      i1=imin
      return
      end

      subroutine map0(hmin,div,lf,ndiv,a,b,ii,iw,xy,ixm,iym,xz)
      dimension hmin(*),div(*),lf(*),a(0:*),b(0:*)
      dimension xy(0:ixm,0:iym),xz(0:ixm,0:iym)
      common /cjbc/ jbc,xs(6),iax(6)
c      integer wtitl
c      common /name/ wtitl,wts,angl
      character*80 wtitle
      common /name/ iwtitl,ws,angl,wtitle
      character*80 title, coord, cmap
c      character*80 title, coord, cmap, tmap, hight
      common /ctitle/ title
      real shftxb,shftyb,shftxa,shftya
      common /cplt/ icase,iplot,shftxb,shftyb,shftxa,shftya,cosq,sinq
c      common /cabtxy/ xmin,xmax,ymin,ymax,ri1,ri2
      common /cabtxy/ xmin,xmax,ymin,ymax,ri1,ri2,xdiv,ydiv
      dimension rc(3),ar(502),br(502)
      common /cdim/ idm,nde
c
c
c     hmin(i): minimum hight in i-th range
c     div(i) : increase of hight in i-th range
c     lf(i)  : number of contour lines in i-th range
c     ndiv(i): number of ranges
c     a,b : work array to store the x,y coordinates on a contour line
c     xy(i,j): hight of the function at the lattice point (i,j)
c     ixm,iym : size of to dimensional array xy
c
c
c     usage:  call setxyt(ax,bx,coscx,irl) before calling this routine
c             to set ax and bx (the length of x and y axes devided by
c             im and jm, respectively) making an angle theta
c             coscx=cosine(theta) and irl=0,1 mean right-hand  and left-hand
c             coordinate system. these are used for getting (orthogonal)
c             coordinates of lattice points specified by oblique coordinates
c
      call getamg(amagx,amagy)
      amgn=amagx
      np=50
c     
      do 80 i=0,79
         j=80-i
         if(title(j:j).ne.' ') go to 81
 80   continue
 81   ntitle=j
c      if(abs(jbc).eq.1) then
c         cmap='Fo Fourier  '
c      else if(abs(jbc).eq.2) then
c         cmap='Fc Fourier  '
c      else if(abs(jbc).eq.3) then
c         cmap='D-Fourier   '
c      else if(abs(jbc).eq.4) then
c         cmap='Fo Patterson'
c      else if(abs(jbc).eq.5) then
c         cmap='Fc Patterson'
c      end if
c      write(coord,'(a,4f7.3)') 'z=',(xs(j),j=3,idm)

      dlm=2.001
c     plot boundary
      shftx1=shftx1+shftxb
      shfty1=shfty1+shftyb
      if(abs(icase).le.8.or.icase.ge.17) then
c          if(icase.gt.0) then
          divx=1
          divy=1
          call drwbox(xmin,xmax,ymin,ymax,divx,divy,shftx1,shfty1)
c          end if
      else if(abs(icase).eq.9) then
          call plot(shftx1,shfty1,-3)
          rc(1)=0
          rc(2)=0
          call setxyt(1.,1.,0.,0) 
          call abtoxy(rd1,rd2,1)
          call abtoxy(rc(1),rc(2),1)
          call sphere(rd1,rd2,rc)
          return
      else
          divx=1
          divy=1
          call drwbox(xmin,xmax,ymin,ymax,divx,divy,shftx1,shfty1)
c         return
      end if
      call getsmt(ismth)
      if(ismth.eq.1) then
         call smthxy1(xy(0,0),ixm,iym,xz)
      else if(ismth.eq.2) then
         call smthxy2(xy(0,0),ixm,iym,xz)
      else
c         call quit('invalid ismth')
      end if
      fx=(xmax-xmin)/ixm
      fy=(ymax-ymin)/iym
c     coordinates on a contour line
      idv=(ixm-1)/np+1
      jdv=(iym-1)/np+1
      idve=mod(ixm-1,np)+1
      jdve=mod(iym-1,np)+1
c     a large square is divided into idv x jdv small squares
      do 10 id=1,idv
         is=(id-1)*np+1
         if(id.lt.idv) then
            ie=is+np
         else
            ie=is+idve
         end if
c        xm=xmin+fx*(id-1)*np/2
         xm=xmin
      do 10 jd=1,jdv
         js=(jd-1)*np+1
         if(jd.lt.jdv) then
            je=js+np
         else
            je=js+jdve
         end if
c         ym=ymin+fy*(jd-1)*np/2
         ym=ymin
c         coordinates on a contour line
          ibtm=0
          do 10 nd=1,ndiv
          le=lf(nd)
          do 20 l=1,le
c           al: hight
            al=hmin(nd)+div(nd)*float(l-1)
c         call contpl(xy(0,0),ixm+1,iym+1,al,is,ie,js,je,xm,ym,fx,fy,
          call contpl(xy(0,0),al,is,ie,js,je,xm,ym,fx,fy,
     *           icon)
          if(icon.eq.1) then
             if(ibtm.eq.1) go to 30
          end if
          if(icon.eq.0) then
             if(ibtm.eq.0) ibtm=1
          end if
 20       continue
 30       continue
 10    continue
      return
 200  format(1h ,6hhight=,f12.6,5x,16hnumber of points,i6)
 201  format((1h ,10(2f6.1,1x)))
 202  format(1h ,a)
      end

      subroutine smthxy0(cxy,ixm,iym,dxy)
      real cxy(0:ixm,0:iym)
      real dxy(0:ixm,0:iym)
      do i=1,ixm-1
         do j=1,iym-1
            dxy(i,j)=(cxy(i-1,j)+2*cxy(i,j)+cxy(i+1,j))/8+
     *               (cxy(i,j-1)+2*cxy(i,j)+cxy(i,j+1))/8
         end do
      end do
      do i=0,0
         do j=1,iym-1
            dxy(i,j)=(cxy(i,j)+2*cxy(i,j)+cxy(i+1,j))/8+
     *               (cxy(i,j-1)+2*cxy(i,j)+cxy(i,j+1))/8
         end do
      end do
      do i=ixm,ixm
         do j=1,iym-1
            dxy(i,j)=(cxy(i-1,j)+2*cxy(i,j)+cxy(i,j))/8+
     *               (cxy(i,j-1)+2*cxy(i,j)+cxy(i,j+1))/8
         end do
      end do
      do i=1,ixm-1
         do j=0,0
            dxy(i,j)=(cxy(i-1,j)+2*cxy(i,j)+cxy(i+1,j))/8+
     *               (cxy(i,j)+2*cxy(i,j)+cxy(i,j+1))/8
         end do
      end do
      do i=1,ixm-1
         do j=iym,iym
            dxy(i,j)=(cxy(i-1,j)+2*cxy(i,j)+cxy(i+1,j))/8+
     *               (cxy(i,j-1)+2*cxy(i,j)+cxy(i,j))/8
         end do
      end do
      dxy(0,0)=cxy(0,0)
      dxy(ixm,0)=cxy(ixm,0)
      dxy(0,iym)=cxy(0,iym)
      dxy(ixm,iym)=cxy(ixm,iym)
      do i=0,ixm
         do j=0,iym
            cxy(i,j)=dxy(i,j)
         end do
      end do
      return
      end

      subroutine smthxy1(cxy,ixm,iym,dxy)
      real cxy(0:ixm,0:iym)
      real dxy(0:ixm,0:iym)
      do i=0,ixm
         i1=max(i-1,0)
         i2=i
         i3=min(i+1,ixm)
         do j=0,iym
            j1=max(j-1,0)
            j2=j
            j3=min(j+1,iym)
            dxy(i,j)=(cxy(i1,j2)+cxy(i2,j2)+cxy(i3,j2)+
     *                cxy(i2,j1)+cxy(i2,j2)+cxy(i2,j3))/6
         end do
      end do
      do i=0,ixm
         do j=0,iym
            cxy(i,j)=dxy(i,j)
         end do
      end do
      return
      end

      subroutine smthxy2(cxy,ixm,iym,dxy)
      real cxy(0:ixm,0:iym)
      real dxy(0:ixm,0:iym)
      do i=0,ixm
         i1=max(i-2,0)
         i2=max(i-1,0)
         i3=i
         i4=min(i+1,ixm)
         i5=min(i+2,ixm)
         do j=0,iym
            j1=max(j-2,0)
            j2=max(j-1,0)
            j3=j
            j4=min(j+1,iym)
            j5=min(j+2,iym)
            dxy(i,j)=(cxy(i1,j3)+cxy(i2,j3)+cxy(i3,j3)+
     *                cxy(i4,j3)+cxy(i5,j3)+
     *                cxy(i3,j1)+cxy(i3,j2)+cxy(i3,j3)+
     *                cxy(i3,j4)+cxy(i3,j5))/10
         end do
      end do
      do i=0,ixm
         do j=0,iym
            cxy(i,j)=dxy(i,j)
         end do
      end do
      return
      end

c           call map01(hmin,div,lf,ndiv,ax,bx,nbuf,iw,dxy,ixm,iym,ldev)
      subroutine map01(hmin,div,lf,ndiv,a,b,ii,iw,xy,ixm,iym,ldev)
      dimension hmin(*),div(*),lf(*),a(*),b(*)
      real xy(0:ixm,0:iym)
      real shftxb,shftyb,shftxa,shftya
      common /cplt/ icase,iplot,shftxb,shftyb,shftxa,shftya,cosq,sinq
      common /cabxy/ ax,bx,coscx,sincx,irl,amagx,amagy
      common /cjbc/ jbc,xs(6),iax(6)
c      integer wtitl
c      common /name/ wtitl,ws,angl
      character*80 wtitle
      common /name/ iwtitl,ws,angl,wtitle
c     character*80 title, coord, cmap, tmap, hight
      character*80 title,cmap
      common /ctitle/ title
      dimension xb(7),yb(7)
      common /cdim/ idm,nde
      common /cabtxy/ xmin,xmax,ymin,ymax,ri1,ri2,xdiv,ydiv
c     hmin(i): minimum hight in i-th range
c     div(i) : increase of hight in i-th range
c     lf(i)  : number of contour lines in i-th range
c     ndiv: number of ranges
c     a,b : work array to store the x,y coordinates on a contour line
c     xy(i,j): hight of the function at the lattice point (i,j)
c     ixm,iym : size of to dimensional array xy (number of points)
c
c
c     usage:  call setxyt(ax,bx,coscx,irl) before calling this routine
c             to set ax and bx (the length of x and y axes devided by
c             ixm and iym, respectively) making an angle theta
c             coscx=cosine(theta) and irl=0,1 mean right-hand  and left-hand
c             coordinate system. these are used for getting (orthogonal)
c             coordinates of lattice points specified by oblique coordinates
c          call plots(0.0,0.0,ldev)
c         shift before plot
          call plot(shftxb,shftyb,-3)
          call newpen(2)
      np=32
      do 80 i=0,79
          j=80-i
          if(title(j:j).ne.' ') go to 81
 80   continue
 81   ntitle=j
      cmap='MEM map'

c     plot boundary
      xb(1)=xmin
      yb(1)=ymin
      xb(2)=xmax
      yb(2)=ymin
      xb(3)=xmax
      yb(3)=ymax
      xb(4)=ymin
      yb(4)=ymax
      xb(5)=xmin
      yb(5)=ymin
      xb(6)=0.0
      yb(6)=0.0
      xb(7)=1.0
      yb(7)=1.0
      call abtoxy(xb,yb,5)
      call line(xb,yb,5,1,0,0)
      if(icase.gt.0) then
c         coordinates on a contour line
          ibtm=0
          do 10 nd=1,ndiv
          le=lf(nd)
          do 10 l=1,le
c            al: hight
             al=hmin(nd)+div(nd)*float(l-1)
             fx=(xmax-xmin)/ixm
             fy=(ymax-ymin)/iym
c            call contpl(xy(0,0),al,1,ixm+1,1,iym+1,xmin,ymin,fx,fy,
             call contpl(xy(0,0),al,1,ixm+1,1,iym+1,xmin,ymin,fx,fy,
     *            icon)
             if(icon.eq.1) then
                if(ibtm.eq.1) go to 30
             end if
             if(icon.eq.0) then
                if(ibtm.eq.0) ibtm=1
             end if
 10       continue
 30       continue
      end if
      return
      end

      subroutine map00(hmin,div,lf,ndiv,a,b,ii,iw,xy,ixm,iym,ldev)
      dimension hmin(*),div(*),lf(*),a(*),b(*)
      real xy(0:ixm,0:iym)
      real shftxb,shftyb,shftxa,shftya
      common /cplt/ icase,iplot,shftxb,shftyb,shftxa,shftya,cosq,sinq
      common /cabxy/ ax,bx,coscx,sincx,irl,amagx,amagy
      common /cjbc/ jbc,xs(6),iax(6)
c      integer wtitl
c      common /name/ wtitl,wts,angl
      character*80 wtitle
      common /name/ iwtitl,ws,angl,wtitle
      character*80 title, coord, cmap, tmap, hight
      common /ctitle/ title
      dimension ar(500),br(500),xb(7),yb(7)
      common /cdim/ idm,nde
c     hmin(i): minimum hight in i-th range
c     div(i) : increase of hight in i-th range
c     lf(i)  : number of contour lines in i-th range
c     ndiv: number of ranges
c     a,b : work array to store the x,y coordinates on a contour line
c     xy(i,j): hight of the function at the lattice point (i,j)
c     ixm,iym : size of to dimensional array xy (number of points)
c
c
c     usage:  call setxyt(ax,bx,coscx,irl) before calling this routine
c             to set ax and bx (the length of x and y axes devided by
c             ixm and iym, respectively) making an angle theta
c             coscx=cosine(theta) and irl=0,1 mean right-hand  and left-hand
c             coordinate system. these are used for getting (orthogonal)
c             coordinates of lattice points specified by oblique coordinates
c          call plots(0.0,0.0,ldev)
c         shift before plot
          call plot(shftxb,shftyb,-3)
          call newpen(2)
      np=32
      do 80 i=0,79
          j=80-i
          if(title(j:j).ne.' ') go to 81
 80   continue
 81   ntitle=j
      cmap='MEM map'
c      write(coord,'(a,4f7.3)') 'z=',(xs(j),j=3,idm)
c      do 300 ncoo=80,1,-1
c        if(coord(ncoo:ncoo).ne.' ') go to 301
c 300  continue
c 301  continue
      dlm=2.001
      bim=float(ixm)
      ajm=float(iym)
c      wtsd=wts*amagx
      wtsd=ws*amagx
c
c     plot boundary
      xb(1)=0.0
      yb(1)=0.0
c      xb(2)=bim*amagx
      xb(2)=bim
      yb(2)=0.0
c      xb(3)=bim*amagx
      xb(3)=bim
c      yb(3)=ajm*amagy
      yb(3)=ajm
      xb(4)=0.0
c      yb(4)=ajm*amagy
      yb(4)=ajm
      xb(5)=0.0
      yb(5)=0.0
      xb(6)=0.0
      yb(6)=0.0
      xb(7)=1.0
      yb(7)=1.0
      call abtoxy(xb,yb,5)
      call line(xb,yb,5,1,0,0)

c     coordinates on a contour line
      idv=(ixm-1)/np+1
      jdv=(iym-1)/np+1
      idve=mod(ixm-1,np)+1
      jdve=mod(iym-1,np)+1
      do 10 id=1,idv
      is0=(id-1)*np
      if(id.lt.idv) then
          ie0=is0+np
      else
          ie0=is0+idve
      end if
      alinit=-1.0e10
      almax=alinit
      almin=-alinit
      do 10 jd=1,jdv
      js0=(jd-1)*np
      if(jd.lt.jdv) then
          je0=js0+np
      else
          je0=js0+jdve
      end if
      do 10 nd=1,ndiv
      le=lf(nd)
      do 10 l=1,le
      al=hmin(nd)+div(nd)*float(l-1)
      is=is0
      ie=ie0
      js=js0
      je=je0
 15   if(ie.ne.ie0) is=ie
      ie=ie0
      m=0
      mf=0
      md=0
 39   continue
          do 36 i=is,ie
          do 34 j=js,je

          ix1=i
          ix2=i+1
          iy1=j
          iy2=j+1
c            hights at cube corner
c         h1:(i,j), h2:(i,j+1), h3:(i+1,j), h4:(i+1,j+1)
                                  h1=xy(ix1,iy1)-al
          if(j.ne.je)             h2=xy(ix1,iy2)-al
          if(i.ne.ie)             h3=xy(ix2,iy1)-al
          if(i.ne.ie.and.j.ne.je) h4=xy(ix2,iy2)-al
          if(h1+al.lt.almin) almin=h1+al
          if(h1+al.gt.almax) almax=h1+al
c           point in the range h1-h2
          if(j.ne.je) then
            if(sign(1.0,h1).ne.sign(1.0,h2)) then
               m=m+1
               if(m.gt.ii) go to 36
               a(m)=float(j)+h1/(h1-h2)
               b(m)=float(i)
            end if
          end if
c         point in the range h1-h3
          if(i.ne.ie) then
            if(sign(1.0,h1).ne.sign(1.0,h3)) then
                m=m+1
                if(m.gt.ii) go to 36
                a(m)=float(j)
                b(m)=float(i)+h1/(h1-h3)
            end if
          end if
c         point in the range h1-h4
          if(i.ne.ie.and.j.ne.je) then
              if(sign(1.0,h1).ne.sign(1.0,h4)) then
                   m=m+1
                   if(m.gt.ii) go to 36
                   a(m)=float(j)+h1/(h1-h4)
                   b(m)=float(i)+h1/(h1-h4)
              end if
          end if
c         point in the range h2-h3
          if(i.ne.ie.and.j.ne.je) then
              if(sign(1.0,h2).ne.sign(1.0,h3)) then
                 m=m+1
                 if(m.gt.ii) go to 36
                 a(m)=float(j)-h2/(h2-h3)
                 b(m)=float(i)+h2/(h2-h3)
               end if
          end if
 34       continue
          md0=md
          mf0=mf
          mf=m
          md=mf-mf0
          iend=i
 36       continue
      if(m.gt.ii) then
c         number of points on a contour line exceeds
c                array size of a and b
          if(iend.eq.ixm) then
              is=max0(iend-2,1)
              ie=max0(iend-1,1)
              m=mf0-md0
              go to 39
          else
              is=max0(iend-1,1)
              ie=iend
              m=mf0
              go to 39
          end if
      end if
      if(m.gt.1) then
           if(al.gt.almax) then
c              maximum hight
               almax=al
           end if
      else if(m.le.1) then
           if(al.gt.almin.and.almax.eq.alinit) then
c              minimum hight
               almin=al
           end if
      end if
      if(mf.le.1) go to 10

c       write coordinates on a contour line if necessary
      if(iw.eq.1) then
           write(6,202) title
           write(6,200) al,mf
           write(6,201) (b(m),a(m),m=1,mf)
      end if
c
c         find contour line
c     a,b: coordinates on a contour line
c     mf : number of points on the contour line
c
      ais=is
      aie=ie
      ajs=js
      aje=je
      i=0
      it=1
 42   n=0
 46   i=i+1
      i1=i+1
c    find nearest point on the contour line
      call fdmin(i1,mf,it,m1,dmin,a,b,ii)
      if(n.eq.0) then
c         starting point is the current point
          is=it
      end if
      if(a(is).eq.ajs.or.b(is).eq.ais.or.a(is).eq.aje.or.
     *     b(is).eq.aie.or.is.ne.i-n) then
c          starting point is on the boundary
           go to 12
      end if
      if(a(m1).ne.ajs.and.b(m1).ne.ais.and.a(m1).ne.aje.and.
     *         b(m1).ne.aie) then
c          found point is on the boundary
           go to 12
      end if
c          else fined a point on the boutndary
      call intch(a(is),b(is),a(m1),b(m1))
      i=is-1
      it=is
      go to 42
 12   continue
c     i1 is replaced by found point         
        call intch(a(i1),b(i1),a(m1),b(m1))
        n=n+1
        it=i1
        if(dmin.lt.dlm.and.i1.ne.mf) go to 46

 41   if(dmin.lt.dlm.and.i1.eq.mf) n=n+1
      if(dmin.lt.dlm.and.i1.eq.mf) i=i+1
      if(n.eq.1) go to 45
c       starting point of a contoue line
c      br(1)=b(is)*amagx
c      ar(1)=a(is)*amagy
      br(1)=b(is)
      ar(1)=a(is)
      do 44 k=2,n
      ki=i-n+k
      br(k)=b(ki)
 44   ar(k)=a(ki)
c      br(k)=b(ki)*amagx
c 44   ar(k)=a(ki)*amagy
c  
      if(a(i).eq.ajs.or.b(i).eq.ais.or.
     *       a(i).eq.aje.or.b(i).eq.aie)  go to 11
      call fdmin(is,is,i,m1,dmin,a,b,ii)
      if(dmin.le.dlm) go to 14
      i2=max0(i-n-1,i-4)
      if(i2.lt.1) go to 11
      call fdmin(1,i2,i ,m1,dmin,a,b,ii)
      if(dmin.gt.dlm) go to 11
 14   continue
      n=n+1
      if(n.gt.500) then
          call quit(' ar(n), br(n), n > 500 stop in map ')
      end if
      br(n)=b(m1)
      ar(n)=a(m1)
c      br(n)=b(m1)*amagx
c      ar(n)=a(m1)*amagy
      it=m1
      if(i.ne.mf) i=i-1
 11   continue
c     plot contour line
      call abtoxy(br,ar,n)
      if(al.gt.0.0) call clin(br,ar,n,1,0.1)
      if(al.eq.0.0) call clin(br,ar,n,2,0.1)
      if(al.lt.0.0) call clin(br,ar,n,3,0.1)
 45   if(i1.ne.mf) go to 42
      if(ie.ne.ie0) go to 15
 10   continue
c     plot title
      write(hight,'(2(a,f7.2))') 'hmin=',almin,' hmax=',almax
      ncoo=istrln(coord)
      nhgh=istrln(hight)
      nmap=14+ncoo
      tmap(1:nmap)=cmap(1:12)//'  '//coord(1:ncoo)
      fct=3.141592/180
      if(iwtitl.eq.1) then
          x1=-2*wtsd*sin(fct*angl)
          y1=-2*wtsd*cos(fct*angl)
          x2=-4*wtsd*sin(fct*angl)
          y2=-4*wtsd*cos(fct*angl)
          x3=-6*wtsd*sin(fct*angl)
          y3=-6*wtsd*cos(fct*angl)
           call symbol(x1,y1,wtsd,title,angl,ntitle)
           call symbol(x2,y2,wtsd,tmap,angl,nmap)
           call symbol(x3,y3,wtsd,hight,angl,nhgh)
      end if
      write(6,*)  'minimum density=',almin,' maximum density=',almax
c         shift after plot
          call plot(shftxa,shftya,-3)
c          call plote('end of plot')
c          if(ldev.eq.1.or.ldev.eq.2) call getzap()
      return
 200  format(1h ,6hhight=,f12.6,5x,16hnumber of points,i6)
 201  format((1h ,10(2f6.1,1x)))
 202  format(1h ,a)
      end

      subroutine map1(hmin,div,lf,ndiv,ax,bx,coscx,nbuf,iw,dxy,
     *     ixm,iym,ldev)
      dimension hmin(*),div(*),lf(*)
      real dxy(0:ixm,0:iym)
      common /cjbc/ jbc,xs(6),iax(6)
c      integer wtitl
c      common /name/ wtitl,ws,angl
      character*80 wtitle
      common /name/ iwtitl,ws,angl,wtitle
      character*80 title, coord, cmap, tmap, hight
      common /ctitle/ title
c     dimension ar(5000),br(5000)
      common /cdim/ idm,nde
      real shftxb,shftyb,shftxa,shftya
      common /cplt/ icase,iplot,shftxb,shftyb,shftxa,shftya,cosq,sinq
      common /cabtxy/ xmin,xmax,ymin,ymax,ri1,ri2,xdiv,ydiv
      real xb(502),yb(502)
c      integer h,k
c
c
c     hmin(i): minimum hight in i-th range
c     div(i) : increase of hight in i-th range
c     lf(i)  : number of contour lines in i-th range
c     ndiv: number of ranges
c     ixm  : number of lattice points along x-axis
c     iym  : number of lattice points along y-axis
c     a,b : work array to store the x,y coordinates on a contour line
c     dxy(i,j): hight of the function at the lattice point (i,j)
c     ih,jh : size of to dimensional array dxy
c
c
cc     usage:  call setxyt(ax,bx,coscx,irl) before calling this routine
cc             to set ax and bx (the length of x and y axes devided by
cc             ixm and iym, respectively) making an angle theta
cc             coscx=cosine(theta) and irl=0,1 mean right-hand  and left-hand
cc             coordinate system. these are used for getting (orthogonal)
cc             coordinates of lattice points specified by oblique coordinates
cc
c
      cmap='MEM map  '
c      write(coord,'(a,4f7.3)') 'z=',(xs(j),j=3,idm)
c      do 300 ncoo=80,1,-1
c        if(coord(ncoo:ncoo).ne.' ') go to 301
c 300  continue
c 301  continue
c      write(6,*) 'ndiv=',ndiv
c      write(6,*) 'lf=',lf(1)
d      do 500 h=0,ixm
d         write(6,'(10f8.2)') (dxy(h,k),k=0,9)
d 500  continue

      dlm=2.1
c
c      call plots(0.0,0.0,ldev)
      call plot(shftxb,shftyb,-3)
      call newpen(2)
c     plot title
      fct=3.141592/180
      call getamg(amagx,amagy)
c      wtsd=wts*amagx
      wtsd=ws*amagx
      write(6,*) 'iwtitl,wtsd,amagx',iwtitl,wtsd,amagx
      if(iwtitl.eq.1) then
          x1=-2*wtsd*sin(fct*angl)
          y1=-2*wtsd*cos(fct*angl)
          x2=-4*wtsd*sin(fct*angl)
          y2=-4*wtsd*cos(fct*angl)
          x3=-6*wtsd*sin(fct*angl)
          y3=-6*wtsd*cos(fct*angl)
           call symbol(x1,y1,wtsd,title,angl,ntitle)
           call symbol(x2,y2,wtsd,tmap,angl,nmap)
           call symbol(x3,y3,wtsd,hight,angl,nhgh)
      end if
c     plot boundary
      if(abs(icase).le.8) then
          if(icase.gt.0) then
          divx=1
          divy=1
          call drwbox(xmin,xmax,ymin,ymax,divx,divy,shftxb,shftyb)
          end if
      else
          divx=1
          divy=1
          call drwbox(xmin,xmax,ymin,ymax,divx,divy,shftxb,shftyb)
          if(ixm.ge.500) call quit('ixm > 500')
          do 20 i=0,ixm
          xb(i+1)=xmin+i*(xmax-xmin)/ixm
          yb(i+1)=(ymin+dxy(i,0))/100
 20       continue
          np=ixm+1
          if(np.ge.500) call quit('np > 500')
          xb(np+1)=0.0
          yb(np+1)=0.0
          xb(np+2)=1.0
          yb(np+2)=1.0
          call setxyt(1.,1.,coscx,0)
          call abtoxy(xb,yb,np)
          call line(xb,yb,np,1,0,0)
          call plot(shftxa,shftya,-3)
          return
      end if
      if(icase.gt.0) then
c         coordinates on a contour line
          ibtm=0
          do 10 nd=1,ndiv
          le=lf(nd)
          do 10 l=1,le
c           al: hight
            al=hmin(nd)+div(nd)*float(l-1)
             fx=(xmax-xmin)/ixm
             fy=(ymax-ymin)/iym
          call contpl(dxy(0,0),al,1,ixm+1,1,iym+1,xmin,ymin,fx,fy,icon)
          if(icon.eq.1) then
             if(ibtm.eq.1) go to 30
          end if
          if(icon.eq.0) then
             if(ibtm.eq.0) ibtm=1
          end if
 10       continue
 30       continue
      end if
      return
      end

      subroutine drwln(xw,yw,n)
      real xw(*),yw(*)
      if(n.gt.1) then
         xw(n+1)=0
         yw(n+1)=0
         xw(n+2)=1
         yw(n+2)=1
         call line(xw,yw,n,1,0,0)
      end if
      return
      end

      subroutine prj(rx,ry,rz,ru,rv)
      common /cmtrx/ux,uy,uz,vx,vy,vz,wx,wy,wz
      ru=rx*ux+ry*uy+rz*uz
      rv=rx*vx+ry*vy+rz*vz
      return
      end

      subroutine drwbox(xmin,xmax,ymin,ymax,divx,divy,shftxb,shftyb)
      real xb(7),yb(7)
      call getamg(amagx,amagy)
      xxa=xmin*amagx
      xxb=xmax*amagx
      yya=ymin*amagy
      yyb=ymax*amagy
      dvx=divx*amagx
      dvy=divy*amagy
      xb(1)=xxa
      yb(1)=yya
      xb(2)=xxb
      yb(2)=yya
      xb(3)=xxb
      yb(3)=yyb
      xb(4)=xxa
      yb(4)=yyb
      xb(5)=xxa
      yb(5)=yya

      xb(6)=0.0
      yb(6)=0.0
      xb(7)=1.0
      yb(7)=1.0
      x1=xb(1)-0.1
      y1=yb(1)-0.1
      x2=xb(3)+0.1
      y2=yb(3)+0.1
      x3=(-0.1+shftxb)/29.7
      y3=(-0.1+shftyb)/29.7
      x4=(xb(3)-xb(1)+0.1+shftxb)/29.7
      y4=(yb(3)-yb(1)+0.1+shftyb)/29.7
c     call setxyt(1.,1.,0.,0)
      call setxy0(1.,1.,0.,0)
      call abtoxy(x3,y3,1)
      call abtoxy(x4,y4,1)
      call window(x1,y1,x2,y2)
      call viewpt(x3,y3,x4,y4)
      call setxy0(1.,1.,0.,0)
      call abtoxy(xb,yb,5)
      call line(xb,yb,5,1,0,0)
c     call axs(xmin,xmax,ymin,ymax,divx,divy)
      call axs(xxa,xxb,yya,yyb,dvx,dvy)
      x1=xb(1)
      y1=yb(1)
      x2=xb(3)
      y2=yb(3)
      x3=(shftxb)/29.7
      y3=(shftyb)/29.7
      x4=(xb(3)-xb(1)+shftxb)/29.7
      y4=(yb(3)-yb(1)+shftyb)/29.7
c     call setxyt(1.,1.,0.,0)
      call setxy0(1.,1.,0.,0)
      call abtoxy(x3,y3,1)
      call abtoxy(x4,y4,1)
      call window(x1,y1,x2,y2)
      call viewpt(x3,y3,x4,y4)
c     call setxy0(1.,1.,0.,0)
c     call setxyt(1.,1.,0.,0)
      return
      end

      subroutine sphere(ri1,ri2,xy)
      real ri1,ri2,xy(*)
      call ellipse(0.,360.,0.,ri1,ri2,xy,0)
      return
      end

      subroutine setxyt(a,b,cosc,i)
      common /cabxy/ ax,bx,coscx,sincx,irl,amagx,amagy
      ax=a*amagx
      bx=b*amagy
      coscx=cosc
      sincx=sqrt(1-coscx**2)
      irl=i
      write(6,*) 'ax,bx,coscx=',ax,bx,coscx
      write(6,*) 'a,b,cosc,amagx,amagy=',a,b,cosc,amagx,amagy
      return
      end

      subroutine setxy0(a,b,cosc,i)
      common /cabxy/ ax,bx,coscx,sincx,irl,amagx,amagy
      ax=a
      bx=b
      coscx=cosc
      sincx=sqrt(1-coscx**2)
      irl=i
      return
      end

      subroutine ckhide(xn2,yn2,ix,ivis1,ixdaz,ixdmx,ihide)
c     HDDRAW
c     common /const/icymin,icymax,cy0,dh
      parameter (ndmax=1000)
      common /cynmx/ynmax(ndmax),ynmin(ndmax)
      ihide=1
c      y2=y
      ixd=ixdaz+ix
      if(ixd.lt.0.or.ixd.gt.ixdmx) return
      if(ixd.ne.ixd1) then
         ynmx=ynmax(ixd)
         ynmn=ynmin(ixd)
      end if
      if(ynmx.lt.ynmn) then
         ynmax(ixd)=yn2
         ynmin(ixd)=yn2
         ivis=1
      else if(yn2.ge.ynmx) then
         ynmax(ixd)=yn2
         ivis=1
      else if(yn2.le.ynmn) then
         ynmin(ixd)=yn2
         ivis=1
      else
         ivis=0
      end if
      if(ivis1.gt.0.and.ivis.gt.0) then
         if(ivis1.gt.0) then
             xna=xn1
             yna=yn1
         else
             xna=xn1
             yna=yn1
         end if
         if(ivis.gt.0) then
             xnb=xn2
             ynb=yn2
         else
             xnb=xn2
             ynb=yn2
         end if
c         call draw(xna,yna,xnb,ynb)
         ihide=0
      end if
      xn1=xn2
      yn1=yn2
      ynmx1=ynmx
      ynmn1=ynmn
c      y1=y2
      ivis1=ivis
      ixd1=ixd
      return
      end

      subroutine pksearch3d(cr,hmax,idm,pkmin)
      real cr(0:*)
      integer hmax(*)   ! number of divisions along x y z axes
      integer hkl(6),hd(6),h,k,l
      parameter (npkmax=2000)
      real x(npkmax),y(npkmax),z(npkmax),p(npkmax)
      integer st(npkmax,0:1),ip(npkmax)
      integer gethkltoj,getnt
      num=0  ! number of peak
      nt=getnt()
      do i=1,nt
         f=cr(i)
c     write(6,*) 'f',f
         call getitohkl(i,hkl)
c     if(f.gt.0) then   ! positive peak
c     get positive or negative peak         
         do h=hkl(1)-1,hkl(1)+1
            do k=hkl(2)-1,hkl(2)+1
               do l=hkl(3)-1,hkl(3)+1
                  hd(1)=h
                  hd(2)=k
                  hd(3)=l
                  if(h.ne.hkl(1).or.k.ne.hkl(2).or.l.ne.hkl(3))
     *                 then
                     j=gethkltoj(hd)
c     if(cr(j).gt.f) goto 10
                     if(f.gt.0.and.cr(j).gt.f) goto 10
                     if(f.lt.0.and.cr(j).lt.f) goto 10
                  end if
               end do
            end do
         end do
c     f is a local peak in 3D space
         if(abs(f).gt.pkmin) then
            num=num+1
            if(num.gt.npkmax) call quit('too many peaks')
            x(num)=float(hkl(1)-1)/hmax(1)
            y(num)=float(hkl(2)-1)/hmax(2)
            z(num)=float(hkl(3)-1)/hmax(3)
            p(num)=cr(i)
c     write(6,*) 'peak and x,y,z ',p(num),x(num),y(num),z(num)
         end if
c     end if
 10      continue
      end do
      write(6,*) 'number of peaks ',num
      call qsort(p,st,ip,num)
      do id=num,1,-1
         i=ip(id)
         write(6,'(a,f10.1,3f10.6)') 'peak and x,y,z ',
     *        p(id),x(i),y(i),z(i)
      end do
      return
      end

      subroutine pksearchnd(cr,pkmin)
      real cr(0:*)
      integer hmax(6)   ! number of divisions along x y z axes
      integer hkl(6),hd(6),h,k,l,m,n,o,dh(6)
      parameter (npkmax=2000)
      real x(6,npkmax),p(npkmax)
      real xw(6,npkmax),pw(npkmax)
      integer st(npkmax,0:1),ip(npkmax)
      integer gethkltoj,getnt
      call gethmax(hmax)
      call getidm(idm)
      num=0  ! number of peak
      nt=getnt()
      do i=1,nt
         f=cr(i)
c        write(6,*) 'f',f
         call getitohkl(i,hkl)
c         if(f.gt.0) then   ! positive peak
c     get positive or negative peak
         do j=1,idm
            dh(j)=1
         end do
         do j=idm+1,6
            dh(j)=0
         end do
         do h=hkl(1)-dh(1),hkl(1)+dh(1)
            do k=hkl(2)-dh(2),hkl(2)+dh(2)
               do l=hkl(3)-dh(3),hkl(3)+dh(3)
                  do m=hkl(4)-dh(4),hkl(4)+dh(4)
                     do n=hkl(5)-dh(5),hkl(5)+dh(5)
                        do o=hkl(6)-dh(6),hkl(6)+dh(6)
                           hd(1)=h
                           hd(2)=k
                           hd(3)=l
                           hd(4)=m
                           hd(5)=n
                           hd(6)=o
                           j=gethkltoj(hd)
c                           if(cr(j).gt.f) goto 10
                           if(f.gt.0.and.cr(j).gt.f) goto 10
                           if(f.lt.0.and.cr(j).lt.f) goto 10
                        end do
                     end do
                  end do
               end do
            end do
         end do
c     f is a local peak in 3D space
         if(abs(f).gt.pkmin) then
            num=num+1
            if(num.gt.npkmax) call quit('too many peaks')
            do j=1,idm
               x(j,num)=float(hkl(j)-1)/hmax(j)
            end do
            p(num)=cr(i)
c     write(6,*) 'peak and x,y,z ',p(num),(x(j,num),j=1,idm)
         end if
c      end if
 10      continue
      end do
      
      write(6,*) 'number of peaks ',num
      call qsort(p,st,ip,num)   ! sort in order of p
c     write(6,*) (p(j),j=num-50,num)

      j=0
      do id=num,1,-1
         i=ip(id)
         j=j+1
c         write(6,*) 'i,j=',i,j
         call vcpyr(x(1,i),xw(1,j),6)
         pw(j)=p(i)
c         write(6,'(a,f10.1,6f10.6)') 'peak and cooyb62.frmrdinates',
c     *        p(id),(x(j,i),j=1,idm)
      end do
      call indatm(num,xw,pw)
      return
      end
