      logical function isFixed(i) ! reflections with fixed phase
      include 'origin.inc'
      integer getirefn
      call getidm(idm)
      call geticent(icent)
      isFixed=.false.
      if(icent.eq.1) then
         return                 ! no reflections needed for fixing origin
      end if
      do j=1,idm
         if(i.eq.getirefn(j)) then ! i is fixed phase reflection number
            isFixed=.true.
            return
         end if
      end do
      return
      end

      integer function getirefn(i)
                                ! reflection index for i-th fixed phase
                                ! for fixinig origin 
      include 'origin.inc'
      getirefn=irefn(i)         ! ii: original index
      return
      end

      integer function getiphfix(i)
                                ! phase for i-th fixed phase
                                ! for fixinig origin 
      include 'origin.inc'
      getiphfix=iphfix(i)       ! fixed phase in degree
      return
      end

c     call getorgn(hkli,irefn,iphas,xo)
      subroutine getorgn(iref,iphas)
      integer iref(6,*),iphas(*)
      include 'origin.inc'
      real mtrx(6,6),piv(6)
      integer ipv(6),ind(12)
      call getidm(idm)
      call geticent(icent)

c      if(icent.eq.1) then
c         call zerovr(xo,6)    ! xo=0
c         write(6,*) 'origin',(xo(j),j=1,idm)
c         return
c      end if

      write(6,*) 'reflections chosen for fixing the origin'
      do i=1,idm
         ii=irefn(i)            ! ii: original index
         write(6,'(6i5)') (iref(j,ii),j=1,idm)
      end do

c     solv equiation h.x=iphas/360 for idm vector h
c     solv equiation h.x=pi*iphas/180 for idm vector h

      do i=1,idm
         ii=irefn(i)            ! ii: original index
c     xo(i)=iphas(i)/360.0
         xo(i)=torad(float(iphas(ii)))
         iphfix(i)=iphas(ii)
      end do
c     write(6,*) 'xo',(xo(j),j=1,idm)
      do i=1,idm
         do j=1,idm
c           write(6,*) 'irefn(i)',irefn(i)
            mtrx(i,j)=iref(j,irefn(i))
         end do
      end do
      call matinv(mtrx,6,idm,xo,1,det,ipv,ind,piv)
      call wtvctrrf('origin',xo,idm,'(6f10.5)')
      return
      end
