      function asf(yb,jk)
      include 'qcdiff.inc'
      parameter (nemx=nemax*3)
      common /asft/ ne,ascf(35,nemx),df1(nemx),df2(nemx),iand,
     *              iel(3,nemx)
      i=yb/0.05+1.0
      if(i.ge.29) i=(yb-1.4)/0.1+29.0
      if(i.ge.35) go to 20
      j=i+1
      if(i.ge.29) go to 21
      ai=float(i-1)*0.05
      asf=ascf(i,jk)+(ascf(j,jk)-ascf(i,jk))*(yb-ai)/0.05+df1(jk)
      return
 21   ai=float(i-29)*0.1+1.4
      asf=ascf(i,jk)+(ascf(j,jk)-ascf(i,jk))*(yb-ai)/0.1+df1(jk)
      return
 20   continue
      asf=0.0
      return
      end

      function f1p(jk)
      include 'qcdiff.inc'
      parameter (nemx=nemax*3)
      common /asft/ ne,ascf(35,nemx),df1(nemx),df2(nemx),iand,
     *              iel(3,nemx)
      f1p=df1(jk)
      return
      end

      function f2p(jk)
      include 'qcdiff.inc'
      parameter (nemx=nemax*3)
      common /asft/ ne,ascf(35,nemx),df1(nemx),df2(nemx),iand,
     *              iel(3,nemx)
      f2p=df2(jk)
      return
      end

      subroutine getiand(iandd)
      include 'qcdiff.inc'
      parameter (nemx=nemax*3)
      common /asft/ ne,ascf(35,nemx),df1(nemx),df2(nemx),iand,
     *              iel(3,nemx)
      iandd=iand
      return
      end

      subroutine getnel(nelem)
      include 'qcdiff.inc'
      parameter (nemx=nemax*3)
      common /asft/ ne,ascf(35,nemx),df1(nemx),df2(nemx),iand,
     *              iel(3,nemx)
      nelem=ne
      return
      end

      subroutine rdsymo(na,brv)
      common /cwflag/ iwflag(6)
      character brv
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      common /extcr/ nextnc,icef(7,60)
      common /cdim/ idm,nde
      common /cskip/ iskip,ltype
      integer imps(60),rg(6,6,5)
      real tg(6,5)
      character*30 coord
      character cltd(6)
      data cltd/'p','i','f','s','c','g'/      
c     initialization
      call getinp(inpu)
      call getout(iout)
c     iwflag(3)=1
      ige=1
c     
c     read(5,100) nsymo,icent,brv
      call freadi('nsymo=',1,nsymo,1)
      call freadi('icent=',1,icent,0)
      call freadc('brv=',1,brv,0)
      call setbrv(brv)

      nde=3       ! temporary
      idm=nde+3   ! temporary
      icom=0
c     
      write(iout,210) nsymo,icent,brv
      do i=1,6
         if(brv.eq.cltd(i)) then
            ltype=i
         end if
      end do

      if(ltype.eq.0) then
c          call quit('ltype incorrect')
         write(6,*) '******ltype=0*****'
      end if

c      read(inpu,*) 'symmetry operator'
      call freadr('symmetry operator',0,dummy,1)
      do k=1,nsymo
         read(inpu,'(a)') coord
         call decode(coord,rr,tt,k)
      end do

      if(iwflag(3).eq.1) then
c     if(icent.eq.1) then
         if(icent.eq.1.or.icent.eq.-1) then
            write(iout,2022)
         else
            write(iout,2021)
         end if
         if(ige.eq.1) then
            write(iout,201) 'generating elements'
         end if
         write(iout,'(1h )')
      end if
      
      nn=nde+1
      if(iwflag(3).eq.1) then
         call wtsymo(rr,tt,nsymo,idm)
      end if
      
      if(ige.eq.1) then
         call ordr(rr,imps,nsymo,idm)
         do i=1,nsymo
            do j=1,idm
               tg(j,i)=tt(j,i)
               do k=1,idm
                  rg(j,k,i)=rr(j,k,i)
 123              continue
               end do
            end do
         end do
         impt=1
         do i=1,6
            tt(i,1)=0.0
            do j=1,6
               rr(i,j,1)=0.0
               rr(i,i,1)=1.0
            end do
         end do
         do ns=1,nsymo
            imp=imps(ns)
c     modified to include the pure translation
            if(imp.eq.1) then
               if(tg(1,ns).ne.0.or.tg(2,ns).ne.0.or.tg(3,ns).ne.0
     *              .or.tg(4,ns).ne.0.or.tg(5,ns).ne.0.or.tg(6,ns).ne.0)
     *              imp=2
            end if
            do i=2,imp
               do j=1,impt
                  mp1=j+(i-2)*impt
                  mp2=j+(i-1)*impt
                  call mpso(rg,tg,ns,rr,tt,mp1,mp2,idm)
               end do
            end do
 50         impt=impt*imp
         end do
         nsymo=impt
         if(iwflag(3).eq.1) then
            write(iout,207)
            write(iout,'(1h )')
            call wtsymo(rr,tt,nsymo,idm)
         end if
      end if
 81   continue
      call getsys(isys)
      if(isys.le.2) then
         nde=3
      else
         nde=2
      end if
      idm=nde+3
      write(6,*) 'idm=',idm
      call setidm(idm)
      call setndm(nde)
      if(nextnc.eq.0) return
      if(iwflag(3).eq.1) then
           write(iout,231)
      end if

      return
 100  format(7i3)
 101  format(9i3,3f9.6,i3)
 102  format(3f8.5,2i3)
 103  format(24i3)
 200  format(1h ,2x,i2,4x,9f6.2,5x,3f10.6,5x,i3)
 201  format(1h ,a)
 2021 format(1h ,'symmetry operation',10x,'noncentrosymmetric')
 2022 format(1h ,'symmetry operation',10x,'centrosymmetric')
 204  format(1h ,'wavevector k',i1,10x,3f9.6,3x,'icorc=',i3,2x
     *       ,'ilm=',i3,2x,a2,'commensurate')
 205  format(1h ,'basic wavevectors')
 206  format(1h ,'generating elements')
 207  format(1h ,'symmetry operators generated by generating elements')
 208  format(1h ,i3,10x,24i3)
 209  format(1h ,'atom',9x,'symmetry operator to be skipped =1')
 210  format(1h ,'nsymo=',i3,2x,'icent=',i2,2x,'brv=',a)
 211  format(1h ,'periods along a,b,c axes' ,3i5)
 230  format(1h ,7i5)
 231  format(1h ,'extinction rules for general reflections'/1h ,
     *          'm1,m2,..,m6,m of m1*h1+m2*h2+...+m6*h6=m*n')
      end

      integer function getidm()
      common /cdim/ idm,nde
      getidm=idm
      return
      end

      integer function getndm()
      common /cdim/ idm,nde
      getndm=nde
      return
      end

      integer function getnde()
      common /cdim/ idm,nde
      getnde=nde
      return
      end

      subroutine setidm(idmd)
      common /cdim/ idm,nde
      idm=idmd
      return
      end

      subroutine setndm(ndmd)
      common /cdim/ idm,nde
      nde=ndmd
      return
      end

      subroutine ordr(re,imps,nsymo,idm)
      integer re(6,6,*),imps(*)
      integer r(6,6),a(6,6),b(6,6)
      data eps/0.001/
      call getinp(inpu)
      call getout(iout)
      do i=1,nsymo
         do j=1,idm
            do k=1,idm
               r(j,k)=re(j,k,i)
               b(j,k)=r(j,k)
            end do
         end do
         do j=1,13
c     check whether r is identity operator or not
            do k=1,idm
               if(r(k,k).ne.1) go to 15
               do l=1,idm
                  if(k.ne.l.and.r(k,l).ne.0) go to 15
               end do
            end do
            imps(i)=j
            go to 10
c     a=r
 15         continue
            do k=1,idm
               do l=1,idm
                  a(k,l)=r(k,l)
               end do
            end do
c       r=a*b   ==> r=r*re
            do k=1,idm
               do l=1,idm
                  r(k,l)=0
                  do m=1,idm
                     r(k,l)=r(k,l)+a(k,m)*b(m,l)
                  end do
               end do
            end do
         end do
 10      continue
      end do
      do i=1,nsymo
      if(imps(i).ge.13) then
           ierror=1
           go to 21
      else
           ierror=0
      end if
      end do
 21   continue
      if(ierror.eq.1) then
           write(iout,'(1h ,''error in symmetry operator ?'',a,24i3)')
     *      '  order: ',(imps(i),i=1,nsymo)
      end if
      return
      end

      subroutine wtsymo(rr,tt,nsymo,idm)
      integer rr(6,6,*)
      real tt(6,*)
      common /cwflag/ iwflag(6)
      character*3 wtt(6,60)
      integer wd(3),w
      data wd/6,5,4/,eps/0.001/
      call getinp(inpu)
      call getout(iout)
      w=wd(idm-3)
      ll=(nsymo-1)/w+1
      le=nsymo-(ll-1)*w
      call wtsmop(rr,tt,nsymo,idm-3,3)
      write(iout,'(1h )')
      call getwtt(tt,wtt,nsymo,idm)
c      do 31 ii=1,ll
c      lbgn=(ii-1)*w+1
c      if(ii.ne.ll) lend=lbgn+w-1
c      if(ii.eq.ll) lend=lbgn+le-1
c      do 31 i=1,idm
c      if(idm.eq.4) write(iout,204) ((rr(i,j,k),j=1,idm),wtt(i,k),
c     *                 k=lbgn,lend)
c      if(idm.eq.5) write(iout,205) ((rr(i,j,k),j=1,idm),wtt(i,k),
c     *                 k=lbgn,lend)
c      if(idm.eq.6) write(iout,206) ((rr(i,j,k),j=1,idm),wtt(i,k),
c     *                 k=lbgn,lend)
c      if(i.eq.idm) write(iout,'(1h )')
c 31   continue
      return
 204  format(1h ,8(4i2,1x,a,2x))
 205  format(1h ,7(5i2,1x,a,2x))
 206  format(1h ,6(6i2,1x,a,2x))
      end

      subroutine getwtt(tt,wtt,nsymo,idm)
      real tt(6,*)
      character*3 wtt(6,*)
      real rt(8)
      character*3 wt(8)
      data rt/0.,0.5,0.333333,0.666666,0.25,0.75,0.166666,0.833333/
      data wt/'0','1/2','1/3','2/3','1/4','3/4','1/6','5/6'/
      data eps/0.00001/
      call getinp(inpu)
      call getout(iout)
      do i=1,nsymo
         do j=1,idm
            td=tt(j,i)
            td=mod(td,1.)
            if(td.lt.-eps) then
               td=td+1
            else if(td.gt.1-eps) then
               td=td-1
            end if
            do k=1,8
               if(abs(td-rt(k)).lt.eps) then
                  wtt(j,i)=wt(k)
                  go to 110
               end if
            end do
 110        continue
         end do
      end do
      return
      end

      subroutine mpso(r1,t1,m1,r2,t2,m2,m3,idm)
      integer r1(6,6,*),r2(6,6,*)
      real t1(6,*),t2(6,*)
      do i=1,idm
         t2(i,m3)=0.0
         do j=1,idm
            t2(i,m3)=t2(i,m3)+r1(i,j,m1)*t2(j,m2)
         end do
         t2(i,m3)=t2(i,m3)+t1(i,m1)
         do j=1,idm
            r2(i,j,m3)=0.0
            do k=1,idm
               r2(i,j,m3)=r2(i,j,m3)+r1(i,k,m1)*r2(k,j,m2)
            end do
         end do
      end do
      return
      end

      subroutine sitesy(na,mpl,x,isk,irs) 
      real mpl(*),x(6,*)
      integer isk(0:120,*),irs(0:120,*)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      common /cdim/ idm,nde
      real rx(6)
      real rxs(6,120)
      integer rcomp
      call getsys(isys)
      if(isys.le.2) then
         icentd=icent
         istep=1
      else
         if(icent.eq.0) then
            icentd=icent
            istep=1
         else
            icentd=icent        ! include antisymmetric inversion -1
            istep=icent         ! include antisymmetric inversion -1
         end if
      end if
      do i=1,na
         nsym=0
         nrx=1
         isk(nrx,i)=1
         call savex(x(1,i),rxs(1,nrx))
c     do  ic=0,icent
         do  ic=0,icentd,istep
            do ns=1,nsymo
               call getrx(x(1,i),rx,rr,tt,ns,ic)
               do irx=1,nrx
                  if(rcomp(rx,rxs(1,irx)).eq.1) go to 120
               end do
c     site symmetry operator
               nrx=nrx+1
               call savex(rx,rxs(1,nrx))
               if(ic.eq.0) then
                  isk(nrx,i)=ns
               else
                  isk(nrx,i)=ns+nsymo
               end if
 120           continue
c     symmetry operator generating equivalent positions
               if(rcomp(rx,x(1,i)).eq.1) then
                  nsym=nsym+1
                  if(ic.eq.0) then
                     irs(nsym,i)=ns
                  else
                     irs(nsym,i)=ns+nsymo
                  end if
               end if
            end do
         end do
         isk(0,i)=nrx
         irs(0,i)=nsym
         mpl(i)=1
c     if(icent.eq.1) then
         if(icent.eq.1.or.(icent.eq.-1.and.x(6,i).eq.0.)) then
c     compress symmetry element > nsymo
            n=0
            do j=1,isk(0,i)
               if(isk(j,i).gt.nsymo) go to 201
               n=n+1
            end do
 201        continue
c     n: number of equivalent positions generated by given operators
c     isk(0,i): number of equivalent positions generated by given
c     symmetry operators and inversion
            mpl(i)=float(isk(0,i))/(float(n)*2)
            isk(0,i)=n
         end if
      end do
      write(6,*) 'site symmetry group'
      do i=1,na
         write(6,'(a,i3,20i4/(8x,20i4))')
     *        'atom=',i,(irs(j,i),j=1,irs(0,i))
c     write(6,'(a,i3/(20i4))') 'atom=',i,(irs(j,i),j=1,irs(0,i))
      end do
      write(6,*) 'equivalent position'
      do i=1,na
         write(6,'(a,i3,20i4/(8x,20i4))')
     *        'atom=',i,(isk(j,i),j=1,isk(0,i))
c     write(6,'(a,i3/(20i4))') 'atom=',i,(isk(j,i),j=1,isk(0,i))
      end do
      write(6,*) 'multiplicity'
      do i=1,na
         write(6,*) 'atom',i,'  ',mpl(i)
      end do
      return
      end

      subroutine sitesy1(na,mpl,x,isk,irs) 
      real mpl(*),x(6,*)
      integer isk(0:120,*),irs(0:120,*)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      common /cdim/ idm,nde
      real rx(6)
      real rxs(6,120)
      integer rcomp
      call getsys(isys)
      if(isys.le.2) then
         icentd=icent
         istep=1
      else
         if(icent.eq.0) then
            icentd=icent
            istep=1
         else
            icentd=icent
            istep=icent
         end if
      end if
      do i=1,na
         nsym=0
         nrx=1
         isk(nrx,i)=1
         call savex(x(1,i),rxs(1,nrx))
c     do 130 ic=0,icent
         do ic=0,icentd,istep
            do ns=1,nsymo
               call getrx(x(1,i),rx,rr,tt,ns,ic)
               do irx=1,nrx
                  if(rcomp(rx,rxs(1,irx)).eq.1) go to 120
               end do
c     site symmetry operator
               nrx=nrx+1
               call savex(rx,rxs(1,nrx))
               if(ic.eq.0) then
                  isk(nrx,i)=ns
               else
                  isk(nrx,i)=ns+nsymo
               end if
 120           continue
c     symmetry operator generating equivalent positions
               if(rcomp(rx,x(1,i)).eq.1) then
                  nsym=nsym+1
                  if(ic.eq.0) then
                     irs(nsym,i)=ns
                  else
                     irs(nsym,i)=ns+nsymo
                  end if
               end if
            end do
         end do
         isk(0,i)=nrx
         irs(0,i)=nsym
         mpl(i)=1
      end do
      write(6,*) 'site symmetry group'
      do i=1,na
         write(6,'(a,i3,20i4/(8x,20i4))')
     *        'atom=',i,(irs(j,i),j=1,irs(0,i))
c     write(6,'(a,i3/(20i4))') 'atom=',i,(irs(j,i),j=1,irs(0,i))
      end do
      write(6,*) 'equivalent position'
      do i=1,na
         write(6,'(a,i3,20i4/(8x,20i4))')
     *        'atom=',i,(isk(j,i),j=1,isk(0,i))
c     write(6,'(a,i3/(20i4))') 'atom=',i,(isk(j,i),j=1,isk(0,i))
      end do
      return
      end

      subroutine savex(rx,rxs)
      real rx(*),rxs(*)
      common /cdim/ idm,nde
      do i=1,idm
         rxs(i)=rx(i)
      end do
      return
      end

      subroutine getrx(x,rx,r,t,ns,ic)
      real x(*),rx(*),t(6,*)
      integer r(6,6,*)
      call getsys(isys)
      if(isys.le.2) then
         do i=1,6
            rx(i)=0.
            do j=1,6
               rx(i)=rx(i)+r(i,j,ns)*x(j)
            end do
            rx(i)=rx(i)+t(i,ns)
            if(ic.eq.1) then
               rx(i)=-rx(i)
            end if
         end do
      else
*************************************
         do i=1,6
            rx(i)=0.
            do j=1,6
               rx(i)=rx(i)+r(i,j,ns)*x(j)
            end do
            if(i.le.5) then
               rx(i)=rx(i)+t(i,ns)
               if(ic.eq.1.or.ic.eq.-1) then
                  rx(i)=-rx(i)
               end if
            else if(i.eq.6) then
               if(ic.eq.-1) then
                  rx(i)=-rx(i)
               end if
            end if
         end do
*************************************
      end if
      return
      end

c      subroutine getrx(x,rx,r,t,ns,ic)
c      real x(*),rx(*),t(6,*)
c      integer r(6,6,*)
c      do i=1,6
c           rx(i)=0.
c           do j=1,6
c                rx(i)=rx(i)+r(i,j,ns)*x(j)
c           end do
c      rx(i)=rx(i)+t(i,ns)
c      if(ic.eq.1) then
c         rx(i)=-rx(i)
c      end if
c      end do
c      return
c      end

      subroutine getnsyic(nsy,ic)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      nsy=nsymo
      ic=icent
      return
      end

      subroutine gettr(tr)
      real tr(6,*)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      do i=1,nsymo
         call vcpyr(tt(1,i),tr(1,i),6)
      end do
      return
      end

      subroutine gethr0(h,hr,ns,icnt)
      integer rr
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      integer h(*),hr(*)
      do i=1,6
         hr(i)=0.
         do j=1,6
            hr(i)=hr(i)+h(j)*rr(j,i,ns)
         end do
         if(icnt.eq.1) then
            hr(i)=-hr(i)
*************************************
         else if(icnt.eq.-1) then
            hr(i)=-hr(i)
*************************************
         end if
      end do
      return
      end

      subroutine gethr(h,hr,r,ns,icnt)
      integer h(*),hr(*),r(6,6,*)
      do i=1,6
         hr(i)=0.
         do j=1,6
            hr(i)=hr(i)+h(j)*r(j,i,ns)
         end do
         if(icnt.eq.1) then
            hr(i)=-hr(i)
*************************************
         else if(icnt.eq.-1) then
            hr(i)=-hr(i)
*************************************
         end if
      end do
      return
      end

c      integer function rcomp(x,rx)
c      real x(*),rx(*)
c      common /cdim/ idm,nde
c      common /cskip/ iskip,ltype
c      integer ntrc(3)
c      real trc(6,32,3)
c      data ntrc/1,2,32/
c      data (trc(i,1,1),i=1,6) /6*0.0/
c      data ((trc(i,j,2),i=1,6),j=1,2) /6*0.0,6*0.5/
c      data ((trc(i,j,3),i=1,6),j=1,32) /
c     *   0.0,0.0,0.0,0.0,0.0,0.0,  0.5,0.5,0.0,0.0,0.0,0.0,
c     *   0.5,0.0,0.5,0.0,0.0,0.0,  0.5,0.0,0.0,0.5,0.0,0.0,
c     *   0.5,0.0,0.0,0.0,0.5,0.0,  0.5,0.0,0.0,0.0,0.0,0.5,
c     *   0.0,0.5,0.5,0.0,0.0,0.0,  0.0,0.5,0.0,0.5,0.0,0.0,
c     *   0.0,0.5,0.0,0.0,0.5,0.0,  0.0,0.5,0.0,0.0,0.0,0.5,
c     *   0.0,0.0,0.5,0.5,0.0,0.0,  0.0,0.0,0.5,0.0,0.5,0.0,
c     *   0.0,0.0,0.5,0.0,0.0,0.5,  0.0,0.0,0.0,0.5,0.5,0.0,
c     *   0.0,0.0,0.0,0.5,0.0,0.5,  0.0,0.0,0.0,0.0,0.5,0.5,
c     *   0.0,0.0,0.5,0.5,0.5,0.5,  0.0,0.5,0.0,0.5,0.5,0.5,
c     *   0.0,0.5,0.5,0.0,0.5,0.5,  0.0,0.5,0.5,0.5,0.0,0.5,
c     *   0.0,0.5,0.5,0.5,0.5,0.0,  0.5,0.0,0.0,0.5,0.5,0.5,
c     *   0.5,0.0,0.5,0.0,0.5,0.5,  0.5,0.0,0.5,0.5,0.0,0.5,
c     *   0.5,0.0,0.5,0.5,0.5,0.0,  0.5,0.5,0.0,0.0,0.5,0.5,
c     *   0.5,0.5,0.0,0.5,0.0,0.5,  0.5,0.5,0.0,0.5,0.5,0.0,
c     *   0.5,0.5,0.5,0.0,0.0,0.5,  0.5,0.5,0.5,0.0,0.5,0.0,
c     *   0.5,0.5,0.5,0.5,0.0,0.0,  0.5,0.5,0.5,0.5,0.5,0.5/
c      data eps/0.00001/
cc       ltype=1,2,3 mean p,i,f in icosahedral lattice
c      rcomp=0
c      do 110 j=1,ntrc(ltype)
c           do i=1,6
c           xx=abs(x(i)-rx(i)-trc(i,j,ltype))+eps/2
c           xx=mod(xx,1.)
c           if(xx.gt.1-eps) then
c                xx=abs(xx-1)
c           else if(xx.lt.-1+eps) then
c                xx=abs(xx+1)
c           end if
c           if(xx.gt.eps) go to 110
c           end do
c      rcomp=1
c      return
c 110  continue
c      return
c      end

      integer function rcomp(x,rx)
      real x(*),rx(*)
      common /cskip/ iskip,ltype
      real trc(6,32)
      integer getidm
      data eps/0.00001/
c     ltype=1,2,3,4,5 mean p,i,f,s,c in icosahedral lattice
      call gettrc(ltype,trc,ntrc)
      call getsys(isys)
      idm=getidm()
c      if(isys.le.2) then
c         idm=6
c      else
c         idm=5
c      end if
      rcomp=0
      do j=1,ntrc
         do i=1,idm
            xx=abs(x(i)-rx(i)-trc(i,j))+eps/2
            xx=mod(xx,1.)
            if(xx.gt.1.-eps) then
               xx=abs(xx-1.)
            else if(xx.lt.-1.+eps) then
               xx=abs(xx+1.)
            end if
            if(xx.gt.eps) go to 110
         end do
         rcomp=1
         return
 110     continue
      end do
      return
      end

      subroutine gettrc(ltype,trc0,ntrc0)
      real trc0(6,*)
      integer ntrc(5)
      real trc1(6,1),trc2(6,2),trc3(6,32),trc4(6,1),trc5(6,2)
      data ntrc/1,2,32,1,2/
      data (trc1(i,1),i=1,6) /6*0.0/
      data ((trc2(i,j),i=1,6),j=1,2) /6*0.0,6*0.5/
      data ((trc3(i,j),i=1,6),j=1,32) /
     *   0.0,0.0,0.0,0.0,0.0,0.0,  0.5,0.5,0.0,0.0,0.0,0.0,
     *   0.5,0.0,0.5,0.0,0.0,0.0,  0.5,0.0,0.0,0.5,0.0,0.0,
     *   0.5,0.0,0.0,0.0,0.5,0.0,  0.5,0.0,0.0,0.0,0.0,0.5,
     *   0.0,0.5,0.5,0.0,0.0,0.0,  0.0,0.5,0.0,0.5,0.0,0.0,
     *   0.0,0.5,0.0,0.0,0.5,0.0,  0.0,0.5,0.0,0.0,0.0,0.5,
     *   0.0,0.0,0.5,0.5,0.0,0.0,  0.0,0.0,0.5,0.0,0.5,0.0,
     *   0.0,0.0,0.5,0.0,0.0,0.5,  0.0,0.0,0.0,0.5,0.5,0.0,
     *   0.0,0.0,0.0,0.5,0.0,0.5,  0.0,0.0,0.0,0.0,0.5,0.5,
     *   0.0,0.0,0.5,0.5,0.5,0.5,  0.0,0.5,0.0,0.5,0.5,0.5,
     *   0.0,0.5,0.5,0.0,0.5,0.5,  0.0,0.5,0.5,0.5,0.0,0.5,
     *   0.0,0.5,0.5,0.5,0.5,0.0,  0.5,0.0,0.0,0.5,0.5,0.5,
     *   0.5,0.0,0.5,0.0,0.5,0.5,  0.5,0.0,0.5,0.5,0.0,0.5,
     *   0.5,0.0,0.5,0.5,0.5,0.0,  0.5,0.5,0.0,0.0,0.5,0.5,
     *   0.5,0.5,0.0,0.5,0.0,0.5,  0.5,0.5,0.0,0.5,0.5,0.0,
     *   0.5,0.5,0.5,0.0,0.0,0.5,  0.5,0.5,0.5,0.0,0.5,0.0,
     *   0.5,0.5,0.5,0.5,0.0,0.0,  0.5,0.5,0.5,0.5,0.5,0.5/
      data (trc4(i,1),i=1,6) /6*0.0/
      data ((trc5(i,j),i=1,6),j=1,2) /6*0.0,0.,0.,0.,0.,0.5,0./
      data eps/0.00001/
      call getsys(isys)
c     ltype=1,2,3,4,5 mean p,i,f,s,c in icosahedral lattice
      if(ltype.eq.0.or.ltype.eq.1) then
         ntrc0=1
         ltyped=1
         do j=1,ntrc0
            do i=1,6
               trc0(i,j)=trc1(i,j)
            end do
         end do
      else if(ltype.eq.2) then
         ntrc0=ntrc(ltype)
         ltyped=ltype
         do j=1,ntrc0
            do i=1,6
               trc0(i,j)=trc2(i,j)
            end do
         end do
      else if(ltype.eq.3) then
         ntrc0=ntrc(ltype)
         ltyped=ltype
         do j=1,ntrc0
            do i=1,6
               trc0(i,j)=trc3(i,j)
            end do
         end do
      else if(ltype.eq.4) then
         if(isys.le.2) then
            ntrc0=32
            ltyped=3
            do j=1,ntrc0
               do i=1,6
                  trc0(i,j)=trc3(i,j)
               end do
            end do
         else if(isys.eq.3) then
            ntrc0=1
            ltyped=1
            do j=1,ntrc0
               do i=1,6
                  trc0(i,j)=trc1(i,j)
               end do
            end do
         else if(isys.eq.4) then
            ntrc0=1
            ltyped=1
            do j=1,ntrc0
               do i=1,6
                  trc0(i,j)=trc1(i,j)
               end do
            end do
         else if(isys.eq.5) then
            ntrc0=1
            ltyped=1
            do j=1,ntrc0
               do i=1,6
                  trc0(i,j)=trc1(i,j)
               end do
            end do
         end if
      else if(ltype.eq.5) then
         ntrc0=2
         ltyped=ltype
         do j=1,ntrc0
            do i=1,6
               trc0(i,j)=trc5(i,j)
            end do
         end do
      end if
      return
      end

      subroutine gettrc1(ltype,trc0,ntrc0)
c      this is equivalent to gettrc but does not work in f2c
      real trc0(6,*)
      integer ntrc(5)
      real trc(6,32,5)
      data ntrc/1,2,32,1,2/
      data (trc(i,1,1),i=1,6) /6*0.0/
      data ((trc(i,j,2),i=1,6),j=1,2) /6*0.0,6*0.5/
      data ((trc(i,j,3),i=1,6),j=1,32) /
     *   0.0,0.0,0.0,0.0,0.0,0.0,  0.5,0.5,0.0,0.0,0.0,0.0,
     *   0.5,0.0,0.5,0.0,0.0,0.0,  0.5,0.0,0.0,0.5,0.0,0.0,
     *   0.5,0.0,0.0,0.0,0.5,0.0,  0.5,0.0,0.0,0.0,0.0,0.5,
     *   0.0,0.5,0.5,0.0,0.0,0.0,  0.0,0.5,0.0,0.5,0.0,0.0,
     *   0.0,0.5,0.0,0.0,0.5,0.0,  0.0,0.5,0.0,0.0,0.0,0.5,
     *   0.0,0.0,0.5,0.5,0.0,0.0,  0.0,0.0,0.5,0.0,0.5,0.0,
     *   0.0,0.0,0.5,0.0,0.0,0.5,  0.0,0.0,0.0,0.5,0.5,0.0,
     *   0.0,0.0,0.0,0.5,0.0,0.5,  0.0,0.0,0.0,0.0,0.5,0.5,
     *   0.0,0.0,0.5,0.5,0.5,0.5,  0.0,0.5,0.0,0.5,0.5,0.5,
     *   0.0,0.5,0.5,0.0,0.5,0.5,  0.0,0.5,0.5,0.5,0.0,0.5,
     *   0.0,0.5,0.5,0.5,0.5,0.0,  0.5,0.0,0.0,0.5,0.5,0.5,
     *   0.5,0.0,0.5,0.0,0.5,0.5,  0.5,0.0,0.5,0.5,0.0,0.5,
     *   0.5,0.0,0.5,0.5,0.5,0.0,  0.5,0.5,0.0,0.0,0.5,0.5,
     *   0.5,0.5,0.0,0.5,0.0,0.5,  0.5,0.5,0.0,0.5,0.5,0.0,
     *   0.5,0.5,0.5,0.0,0.0,0.5,  0.5,0.5,0.5,0.0,0.5,0.0,
     *   0.5,0.5,0.5,0.5,0.0,0.0,  0.5,0.5,0.5,0.5,0.5,0.5/
      data (trc(i,1,4),i=1,6) /6*0.0/
      data ((trc(i,j,5),i=1,6),j=1,2) /6*0.0,0.,0.,0.,0.,0.5,0./
      data eps/0.00001/
      call getsys(isys)
c     ltype=1,2,3,4,5 mean p,i,f,s,c in icosahedral lattice
      if(ltype.eq.0) then
         ntrc0=1
         ltyped=1
      else if(ltype.le.3) then
         ntrc0=ntrc(ltype)
         ltyped=ltype
      else if(ltype.eq.4) then
         if(isys.le.2) then
            ntrc0=32
            ltyped=3
         else if(isys.eq.3) then
            ntrc0=1
            ltyped=1
         else if(isys.eq.4) then
            ntrc0=1
            ltyped=1
         else if(isys.eq.5) then
            ntrc0=1
            ltyped=1
         end if
      else if(ltype.eq.5) then
c         ntrc0=ntrc(ltype)
         ntrc0=2
         ltyped=ltype
      end if
      do j=1,ntrc0
         do i=1,6
            trc0(i,j)=trc(i,j,ltyped)
         end do
      end do
      return
      end

      subroutine wtsmop(r1,t1,nsymo,d1,d2)
c*******************************************************************
c         representation of symmetry operators in the i.t. format
c*******************************************************************
      implicit integer (a-z)
      dimension r1(6,6,*)
      dimension r(6,6),lenc(60),ip(16)
      real t1(6,*),t(6),eps,cnt2(27,6),rtr(7)
      character xyz(6)
c        for (d2+d1) dimensional case
      character*31 z1(60),bl
      character*3 ntr(7)
      data xyz/'x','y','z','t','u','v'/
      data ntr/'1/2','1/3','2/3','1/4','3/4','1/6','5/6'/
      data rtr/0.5,0.333333,0.666666,0.25,0.75,0.166666,0.833333/
      data bl/'                            '/
      call getinp(inpu)
      call getout(iout)
      eps=0.00001
      d3=d1+d2
c******** write centering translations *********
c      if(ncnt.gt.1) then
c      do i=1,ncnt
c      z1(i)=bl
c      cp=0
c      if(i.eq.1) then
c           z1(1)(1:1)='('
c           cp=1
c      end if
c      do j=1,d3
c          do k=1,7
c          if(abs(rtr(k)-cnt2(i,j)).lt.eps) then
c               z1(i)(cp+1:cp+3)=ntr(k)
c               cp=cp+3
c               go to 51
c          end if
c          end do
c          if(abs(cnt2(i,j)).lt.eps) then
c               z1(i)(cp+1:cp+1)='0'
c               cp=cp+1
c          end if
c 51   continue
c      end do
c      if(i.lt.ncnt) then
c           z1(i)(cp+1:cp+1)=';'
c           cp=cp+1
c      else
c           z1(i)(cp+1:cp+1)=')'
c           cp=cp+1
c      end if
c      ip(i)=cp
c      end do
c      write(iout,'(1h ,6a)') (z1(i)(1:ip(i)),i=1,ncnt)
c      end if
c******** write symmetry operators *******
      do ii=1,nsymo
         cp=1
         do i=1,d3
            t(i)=t1(i,ii)
            do j=1,d3
               r(i,j)=r1(i,j,ii)
            end do
         end do
         do i=1,d3
            t(i)=mod(t(i),1.)
            if(t(i).lt.eps) then
               t(i)=t(i)+1
            else if(t(i).gt.1.0-eps) then
               t(i)=t(i)-1
            end if
         end do
         do i=1,22
            z1(ii)=bl
         end do
         do i=1,d3
            do j=1,7
               if(abs(t(i)-rtr(j)).le.eps) then
                  z1(ii)(cp:cp+2)=ntr(j)
                  cp=cp+3
                  go to 132
               end if
            end do
 132        continue
            do j=1,d3
               if(j.le.d2) then
                  k=j
               else if(j.gt.d2) then
                  k=j+(3-d2)
               end if
               if(r(i,j).eq.1) then
                  if(cp.eq.1) then
                     z1(ii)(cp:cp)=xyz(k)
                     cp=cp+1
                  else if(z1(ii)(cp-1:cp-1).eq.',') then
                     z1(ii)(cp:cp)=xyz(k)
                     cp=cp+1
                  else
                     z1(ii)(cp:cp+1)='+'//xyz(k)
                     cp=cp+2
                  end if
               else if(r(i,j).eq.-1) then
                  z1(ii)(cp:cp+1)='-'//xyz(k)
                  cp=cp+2
               end if
               if(j.eq.d3.and.i.ne.d3) then
                  z1(ii)(cp:cp)=','
                  cp=cp+1
               else if(j.eq.d3.and.i.eq.d3) then
                  z1(ii)(cp:cp)=';'
                  cp=cp+1
               end if
            end do
         end do
         lenc(ii)=istrln(z1(ii))
      end do
      write(iout,'(1h ,6(i3,1x,a,1x))') (ii,z1(ii)(1:lenc(ii)),
     *     ii=1,nsymo)
      return
      end

      subroutine decode(coord,r,t,n)
c     symmetry operation in I.T into matrix representation
      character coord*30
      integer r(6,6,*)
      real t(6,*)
      common /cdim/ idm,nde
      character sym(6)*20,xyz(6)
      data xyz/'x','y','z','t','u','v'/
      call getinp(inpu)
      call getout(iout)
c     position of ',' 
      i=1
      do k=1,idm-1
         m=index(coord(i:30),',')
         if(m.eq.0) call quit(' incorrect symmetry operation')
         sym(k)=coord(i:i+m-2)
         i=i+m
      end do
      sym(idm)=coord(i:30)
c     
      do j=1,6
         t(j,n)=0
         do k=1,6
            r(j,k,n)=0
         end do
c     
c     rotation matrix
         do k=1,idm
            i=index(sym(j),xyz(k))
            if(i.gt.0) then
               if(i.eq.1) then
                  r(j,k,n)=1
               else
                  if(sym(j)(i-1:i-1).eq.'+') then
                     r(j,k,n)=1
                  else
                     r(j,k,n)=-1
                  endif
               endif
            endif
         end do
c     
c     translation vector
         i=index(sym(j),'/')
         if(i.gt.0) then
            read(sym(j)(i-1:i-1),'(i1)') n1
            read(sym(j)(i+1:i+1),'(i1)') n2
            t(j,n)=float(n1)/float(n2)
            if(i.ne.2.and.sym(j)(i-2:i-2).eq.'-') t(j,n)=-t(j,n)
         endif
      end do
      end

      subroutine mtmpl(a,b,c)
      real a(6,6),b(6,6),c(6,6)
      do i=1,6
         do j=1,6
            c(i,j)=0.
            do k=1,6
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine trnsp(sm)
      real smd(6,6),sm(6,6)
      do i=1,6
         do j=1,6
            smd(i,j)=sm(j,i)
         end do
      end do
      do i=1,6
         do j=1,6
            sm(i,j)=smd(i,j)
         end do
      end do
      return
      end

      subroutine rdhkl(hk,mpl,q,fcal,nh)
      integer hk(6,*),mpl(*)
      real q(*),fcal(*)
      nh=0
 100  continue
      nh=nh+1
      read(1,'(1h ,6i2,i5,f12.6)',end=200)
     *                 (hk(i,nh),i=1,6),mpl(nh),q(nh)
           go to 100
 200  continue
      nh=nh-1
      return
      end

      subroutine setinp(inpu)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      cinpu=inpu
      return
      end

      subroutine setout(iout)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      coutu=iout
      return
      end

      subroutine getinp(inpu)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      inpu=cinpu
      return
      end

      subroutine getout(iout)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      iout=coutu
      return
      end

      subroutine setskp(iskp)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      cskip=iskp
      return
      end

      subroutine getskp(iskp)
      integer cinpu, coutu,cskip
      common /ciount/ cinpu,coutu,cskip
      iskp=cskip
      return
      end

      subroutine getsys(isysd)
      common /cisys/ isys
      isysd=isys
      return
      end            

      subroutine setsys(isysd)
      common /cisys/ isys
      isys=isysd
      return
      end            

      subroutine geta(a1,a2)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      a1=al
      a2=am
      return
      end

      subroutine getc(c)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      c=cl
      return
      end

      subroutine seta(ae,ai)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      al=ae
      am=ai
      return
      end

      subroutine setc(c)
      common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
      cl=c
      return
      end


      subroutine caluid(ui,uid)
      real ui(6,3),uid(6,3),dq(6,6)
      call getsys(isys)
      call getdq(dq)  ! get transformation matrix M
      do i=1,6
         do j=1,3
            uid(i,j)=0
            do k=1,6
               uid(i,j)=uid(i,j)+dq(i,k)*ui(k,j)
            end do
         end do
      end do
      return
      end

      subroutine  caluiv(ub,pt,ui,v,as,bs,cs,cosas,cosbs,coscs)
c     ub : ub matrix
c     pt : transformation matrix of d* necessary for decagonal 
c          superstructure and icosahedral f-centered lattice
c     ui  : phonon-phason matrix
c     v  : orientation matrix
c     as : lattice constant in reciprocal space
c     cs : lattice constant in reciprocal space
c     get approximate values for  phonon-phason matrix u
c     orientation matrix v and lattice constants as, cs from ub matrix
      real ub(6,3),ui(6,3),v(3,3),pt(6,6)
      real u1(3,3),uv(6,3),vd(3,3),ubd(6,3)
      real dq(6,6),dr(6,6)
      real b(3),piv(3)
      real ub1(3),ub2(3),ub3(3)
      integer ip(3),indx(6)
      real x(3),z(3),xc(3)
      data pi /3.141592/

      f=180.0/pi
      call getsys(isys)
      call getnvec(nvec)
c      write(6,*) 'isys=',isys,' ndm=',ndm
      call getdr(dr)  ! get transformation matrix M^-1

c      write(6,*) 'dr='
c      do i=1,6
c         write(6,'(6f10.5)') (dr(i,j),j=1,6)
c      end do

c      write(6,*) 'ub='
c      do i=1,6
c         write(6,'(6f10.5)') (ub(i,j),j=1,3)
c      end do

      if(isys.le.2.and.nvec.lt.6) then
c        estimate other vectors by rotation around d1*
         z(1)=ub(1,1)
         z(2)=ub(1,2)
         z(3)=ub(1,3)
         do i=1,6-nvec
            x(1)=ub(nvec,1) ! last vector
            x(2)=ub(nvec,2)
            x(3)=ub(nvec,3)
            deg=72.0*i
            call rotate(x,z,deg) ! rotation of x around z by deg
            do j=1,3
               ub(nvec+i,j)=x(j)
            end do
         end do
         nvec=6
         do i=2,5
            do j=1,3
               ub1(j)=ub(1,j)
               ub2(j)=ub(i,j)
               ub3(j)=ub(i+1,j)
            end do
         end do
         det=determ3(ub1,ub2,ub3)
         if(det.lt.0) then
            write(6,*) 'determinant for ',1,i,i+1,' negative'
            stop
         end if
      else if(isys.ge.3.and.nvec.lt.5) then
c        estimate other vectors by rotation around dnvec*
         ub(5,1)=ub(nvec,1)
         ub(5,2)=ub(nvec,2)
         ub(5,3)=ub(nvec,3)
         z(1)=ub(5,1)
         z(2)=ub(5,2)
         z(3)=ub(5,3)
         if(isys.eq.3) then
            deg0=72.0
         else if(isys.eq.4) then
            deg0=45.0
         else if(isys.eq.5) then
            deg0=30.0
         end if
         do i=1,5-nvec
            x(1)=ub(nvec-1,1)
            x(2)=ub(nvec-1,2)
            x(3)=ub(nvec-1,3)
            deg=deg0*i
            call rotate(x,z,deg) ! rotation of x around z by deg
            do j=1,3
               ub(nvec+i-1,j)=x(j)
            end do
         end do
         nvec=5
         do i=1,3
            do j=1,3
               ub1(j)=ub(i,j)
               ub2(j)=ub(i+1,j)
               ub3(j)=ub(5,j)
            end do
         end do
         det=determ3(ub1,ub2,ub3)
         if(det.lt.0) then
            write(6,*) 'determinant for ',i,i+1,5,' negative'
            stop
         end if
      end if

      call mcpymn(ub,ubd,6,3)
      call mtmltijk(pt,ubd,ub,6,6,3)

      do i=1,nvec
         do j=1,3
            uv(i,j)=0
            do k=1,nvec
               uv(i,j)=uv(i,j)+dr(i,k)*ub(k,j)
            end do
         end do
      end do

      do i=nvec+1,6
         do j=1,3
            uv(i,j)=0
         end do
      end do
      
c      write(6,*) 'uv='
c      do i=1,6
c         write(6,*) (uv(i,j),j=1,3)
c      end do

c
c     uv in ideal quasicrystal and ideal orientation
c        as 0  0         as 0  0 
c        0  as 0         0  as 0
c        0  0  as        0  0  cs
c        0  0  0         0  0  0
c        0  0  0         0  0  0
c        0  0  0         0  0  0
c      orientation matrix symmetrize the first 3x3 part of ui
c      Euler angles are obtained from orientation matrix
c      
c      since cosas, cosbs, coscs is nearly zero  ui will be given as follows


      as=sqrt(uv(1,1)**2+uv(1,2)**2+uv(1,3)**2)
      bs=sqrt(uv(2,1)**2+uv(2,2)**2+uv(2,3)**2)
      cs=sqrt(uv(3,1)**2+uv(3,2)**2+uv(3,3)**2)
      coscs=(uv(1,1)*uv(2,1)+uv(1,2)*uv(2,2)+uv(1,3)*uv(2,3))/as/bs
      cosas=(uv(2,1)*uv(3,1)+uv(2,2)*uv(3,2)+uv(2,3)*uv(3,3))/bs/cs
      cosbs=(uv(3,1)*uv(1,1)+uv(3,2)*uv(1,2)+uv(3,3)*uv(1,3))/cs/as
      sinas=sqrt(1-cosas**2)
      sinbs=sqrt(1-cosbs**2)
      sincs=sqrt(1-coscs**2)


c      write(6,*) 'a*=',as
c      write(6,*) 'b*=',bs
c      write(6,*) 'c*=',cs
c      write(6,*) 'alpha*=',acos(cosas)*f,' cosa*=',cosas
c      write(6,*) 'beta* =',acos(cosbs)*f,' cosb*=',cosbs
c      write(6,*) 'gamma*=',acos(coscs)*f,' cosc*=',coscs

      call calu1(1,as,bs,cs,cosas,cosbs,coscs,u1)

c      write(6,*) 'u1='
c      do i=1,3
c         write(6,*) (u1(i,j),j=1,3)
c      end do

c     get orientation matrix v
      call calv(u1,uv,v)        ! v=u1^(-1)uv  orientation matrix

c      write(6,*) 'uv='
c      do i=1,6
c         write(6,*) (uv(i,j),j=1,3)
c      end do

c      write(6,*) 'v='
c      do i=1,3
c         write(6,*) (v(i,j),j=1,3)
c      end do

c     get ui matrix
      call mcpyr3(v,vd)
      call matinv(vd,3,3,b,0,det,ip,indx,piv)

c      write(6,*) 'vd='
c      do i=1,3
c        write(6,*) (vd(i,j),j=1,3)
c      end do

      do i=1,6
         do j=1,3
            ui(i,j)=0
            do k=1,3
               ui(i,j)=ui(i,j)+uv(i,k)*vd(k,j)
            end do
         end do
      end do

      call setnvec(nvec)
c      write(6,*) 'ui='
c      do i=1,6
c         write(6,*) (ui(i,j),j=1,3)
c      end do
      return
      end


      function determ3(u1,u2,u3)
      real u1(3),u2(3),u3(3)
      determ3=u1(1)*(u2(2)*u3(3)-u2(3)*u3(2))+
     *        u1(2)*(u2(3)*u3(1)-u2(1)*u3(3))+
     *        u1(3)*(u2(1)*u3(2)-u2(2)*u3(1))
      return
      end

      subroutine rotate(x,z,deg)
      real x(3),z(3),deg
      real n(3,3),y(3),yd(3)
      ang=deg*3.1415926/180
c      write(6,*) 'x0=',x
c      write(6,*) 'deg=',deg
c     normal vector along the rotation axis (z-axis)
      cc=sqrt(z(1)**2+z(2)**2+z(3)**2)
      n(3,1)=z(1)/cc
      n(3,2)=z(2)/cc
      n(3,3)=z(3)/cc
      zz=n(3,1)*x(1)+n(3,2)*x(2)+n(3,3)*x(3)
c     remove z component of vector x
      n(1,1)=x(1)-zz*n(3,1)
      n(1,2)=x(2)-zz*n(3,2)
      n(1,3)=x(3)-zz*n(3,3)
      aa=sqrt(n(1,1)**2+n(1,2)**2+n(1,3)**2)
c     normalization  (x-axis)
      n(1,1)=n(1,1)/aa
      n(1,2)=n(1,2)/aa
      n(1,3)=n(1,3)/aa
c     vector product of z and x (y-axis)
      n(2,1)=n(3,2)*n(1,3)-n(3,3)*n(1,2)
      n(2,2)=n(3,3)*n(1,1)-n(3,1)*n(1,3)
      n(2,3)=n(3,1)*n(1,2)-n(3,2)*n(1,1)
c     n(i,j) transformation matrix (orthogonal matrix)
c      write(6,*) 'n(i,j)'
c      do i=1,3
c         write(6,'(3f10.5)') (n(i,j),j=1,3)
c      end do
      do i=1,3
         y(i)=0
         do j=1,3
            y(i)=y(i)+n(i,j)*x(j)
         end do
      end do
c      write(6,*) 'y=',y
c     rotation around the z-axis
      cosang=cos(ang)
      sinang=sin(ang)
      yd(1)=cosang*y(1)-sinang*y(2)
      yd(2)=sinang*y(1)+cosang*y(2)
      yd(3)=y(3)
c      write(6,*) 'yd=',yd
c     transform into the original coordinates
      do i=1,3
         x(i)=0
         do j=1,3
            x(i)=x(i)+n(j,i)*yd(j)   ! note that n(i,j) is orthogonal
         end do
      end do
c      write(6,*) 'x=',x
      return
      end

      subroutine calv(u1,ub,v)
      real u1(3,3),ub(6,3),v(3,3)
      real vd(3,3),b(3),piv(3)
      integer ip(3),indx(6)
      call matinv(u1,3,3,b,0,det,ip,indx,piv)
      if(det.lt.0) then
         write(6,*) 'determinant of 3x3 part of ub matrix is negative'
         write(6,*) 'change the direction of one axis'
         stop
      end if
      do i=1,3
         do j=1,3
            vd(i,j)=ub(i,j)
         end do
      end do
      call mtmlt(u1,vd,v,3)
      return
      end

      subroutine getltcs(ad,bd,cd,cosad,cosbd,coscd)
      common /cltprm/ as,bs,cs,cosas,cosbs,coscs
      ad=as
      bd=bs
      cd=cs
      cosad=cosas
      cosbd=cosbs
      coscd=coscs
      return
      end

      subroutine setltcs(ad,bd,cd,cosad,cosbd,coscd)
      common /cltprm/ as,bs,cs,cosas,cosbs,coscs
      as=ad
      bs=bd
      cs=cd
      cosas=cosad
      cosbs=cosbd
      coscs=coscd
      return
      end

      subroutine setnvec(nvec)
      common /cnvec/ nvecs
      nvecs=nvec
      return
      end

      subroutine getnvec(nvec)
      common /cnvec/ nvecs
      nvec=nvecs
      return
      end


      subroutine seteuang1(euang)
      real euang(3)
      common /comtrx/ omtrx1(3,3),omtrx2(3,3),omtrx3(3,3),
     *     euang1(3),euang2(3),euang3(3)
      call vcpyr(euang,euang1,3)
      return
      end

      subroutine geteuang1(euang)
      real euang(3)
      common /comtrx/ omtrx1(3,3),omtrx2(3,3),omtrx3(3,3),
     *     euang1(3),euang2(3),euang3(3)
      call vcpyr(euang1,euang,3)
      return
      end

      subroutine setui(uid)
      real uid(6,3)
      common /cui/ ui(6,3)
      do i=1,6
         do j=1,3
            ui(i,j)=uid(i,j)
         end do
      end do
      return
      end

      subroutine getui(uid)
      real uid(6,3)
      common /cui/ ui(6,3)
      call mcpymn(ui,uid,6,3)
      return
      end

      subroutine mtmlt(x,y,z,n)
      real x(n,n), y(n,n), z(n,n)
      do i=1,n
         do j=1,n
            z(i,j)=0
            do k=1,n
               z(i,j)=z(i,j)+x(i,k)*y(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmltir(x,y,z,n)
      integer x(n,n)
      real y(n,n), z(n,n)
      do i=1,n
         do j=1,n
            z(i,j)=0
            do k=1,n
               z(i,j)=z(i,j)+x(i,k)*y(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmltri(x,y,z,n)
      real x(n,n)
      integer y(n,n)
      real z(n,n)
      do i=1,n
         do j=1,n
            z(i,j)=0
            do k=1,n
               z(i,j)=z(i,j)+x(i,k)*y(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmltijk(x,y,z,i,j,k)
      real x(i,j), y(j,k), z(i,k)
      do id=1,i
         do kd=1,k
            z(id,kd)=0
            do jd=1,j
               z(id,kd)=z(id,kd)+x(id,jd)*y(jd,kd)
            end do
         end do
      end do
      return
      end

      subroutine calu1(icase,as,bs,cs,cosas,cosbs,coscs,u1)
      real u1(3,3)  ! first 3x3 part of u matrix
      sinas=sqrt(1.-cosas**2)
      sinbs=sqrt(1.-cosbs**2)
      sincs=sqrt(1.-coscs**2)
      d=sqrt(1.0-cosas**2-cosbs**2-coscs**2+2.0*cosas*cosbs*coscs)
      if(icase.eq.1) then
         u1(1,1)=as
         u1(1,2)=0.0
         u1(1,3)=0.0
         u1(2,1)=bs*coscs
         u1(2,2)=bs*sincs
         u1(2,3)=0.0
         u1(3,1)=cs*cosbs
         u1(3,2)=cs*(cosas-cosbs*coscs)/sincs
         u1(3,3)=cs*d/sincs
      else if(icase.eq.2) then
         u1(2,2)=bs
         u1(2,3)=0.0
         u1(2,1)=0.0
         u1(3,2)=cs*cosas
         u1(3,3)=cs*sinas
         u1(3,1)=0.0
         u1(1,2)=as*coscs
         u1(1,3)=as*(cosbs-coscs*cosas)/sinas
         u1(1,1)=as*d/sinas
      else if(icase.eq.3) then
         u1(3,3)=cs
         u1(3,1)=0.0
         u1(3,2)=0.0
         u1(1,3)=as*cosbs
         u1(1,1)=as*sinbs
         u1(1,2)=0.0
         u1(2,3)=bs*cosas
         u1(2,1)=bs*(coscs-cosas*cosbs)/sinbs
         u1(2,2)=bs*d/sinbs
      else
         write(6,*) 'icase=',icase
         call quit('icase should be 1,2 or 3')
      end if
      return
      end

      subroutine caleuang(v,euang)
      real v(3,3),euang(3)
      real vd(3,3)
      real pm(2)
      data pm /1.,-1./
      data pi /3.14159265/

      theta=acos(v(3,3))        ! v(3,3)= cos(theta)
      phi=atan3(v(3,1),-v(3,2)) ! v(3,1)= sin(theta)sin(phi)
                                ! v(3,2)=-sin(theta)cos(phi)
      psi=atan3(v(1,3),v(2,3))  ! v(1,3)= sin(psi)sin(theta)
                                ! v(2,3)= cos(psi)sin(theta)
      f=180/pi
      do i=1,2
         do j=1,2
            do k=1,2
               call setomtr(phi*pm(i),theta*pm(j),psi*pm(k),vd)
               if(iomtrx(v,vd).eq.1) then
                  euang(1)=phi
                  euang(2)=theta
                  euang(3)=psi
                  return
               end if
            end do
         end do
      end do
      write(6,*) 'left hand oordinate system ?'
      call quit('can not determin orientation matrix')
      return
      end

      function iomtrx(o1,o2)
      real o1(3,3),o2(3,3)
c     data eps /0.0001/
      data eps /0.001/
      iomtrx=0
      do i=1,3
         do j=1,3
            if(abs(o1(i,j)-o2(i,j)).gt.eps) return
         end do
      end do
      iomtrx=1
      return
      end

      subroutine getdr(drd)
      real drd(6,6)
      common /cgethk/ d0(6,6),d1(6,6),d2(6,6),d3(6,6),d4(6,6)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      common /cgetd/ det
      call mcpyr6(dr,drd)
      return
      end

      function wghtf(fobs,sigmf,iwght,fmin,wg,wg0)
c     weighting scheme
      if(iwght.eq.0) then
         wghtf=wg
      else if(iwght.eq.1) then
         if(fobs.gt.fmin) then
            wghtf=1.0
         else
            wghtf=wg0
         end if
      else if(iwght.eq.2) then
         wghtf=1./(sigmf**2)
      else if(iwght.eq.3) then
         if(fobs.gt.fmin) then
            wghtf=fobs/10.
         else
            wghtf=fmin/10.
         end if
      else
         call quit('iwght should be 0,1,2 or 3')
      end if
c     write(6,*) 'iwght,fmin,fobs,wghtf=',iwght,fmin,fobs,wghtf
      return
      end

      subroutine setbrv(brv)
      character brv0,brv
      common /cbrv/ brv0
      brv0=brv
      return
      end

      subroutine getbrv(brv)
      character brv0,brv
      common /cbrv/ brv0
      brv=brv0
      return
      end
