      subroutine mcpyr(from,to,n)
      real from(n,n),to(n,n)
      do i=1,n
         do j=1,n
            to(i,j)=from(i,j)
         end do
      end do
      return
      end

      subroutine mcpyi(from,to,n)
      integer from(n,n),to(n,n)
      do i=1,n
         do j=1,n
            to(i,j)=from(i,j)
         end do
      end do
      return
      end

      subroutine mcpyr3(from,to)
      real from(3,3),to(3,3)
      do i=1,3
         do j=1,3
            to(i,j)=from(i,j)
         end do
      end do
      return
      end

      subroutine mcpyi3(from,to)
      integer from(3,3),to(3,3)
      do i=1,3
         do j=1,3
            to(i,j)=from(i,j)
         end do
      end do
      return
      end

      subroutine mcpyr6(from,to)
      real from(6,6),to(6,6)
      do i=1,6
         do j=1,6
            to(i,j)=from(i,j)
         end do
      end do
      return
      end

      subroutine mcpyi6(from,to)
      integer from(6,6),to(6,6)
      do i=1,6
         do j=1,6
            to(i,j)=from(i,j)
         end do
      end do
      return
      end

      subroutine mtcube6(a,a3) ! get a3=a*a*a
      real a(6,6),a3(6,6)
      real a2(6,6)
      call mtmplr(a,a,a2,6)
      call mtmplr(a2,a,a3,6)
      return
      end

      subroutine mtmpl(a,b,c)
      real a(6,6),b(6,6),c(6,6)
      do i=1,6
         do j=1,6
            c(i,j)=0.
            do k=1,6
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine trnsp(sm)
      real sm(6,6)
      call trnsp6(sm)
      return
      end

      subroutine trnsp3(sm)
      real smd(3,3),sm(3,3)
      do i=1,3
         do j=1,3
            smd(i,j)=sm(j,i)
         end do
      end do
      do i=1,3
         do j=1,3
            sm(i,j)=smd(i,j)
         end do
      end do
      return
      end

      subroutine trnsp6(sm)
      real smd(6,6),sm(6,6)
      do i=1,6
         do j=1,6
            smd(i,j)=sm(j,i)
         end do
      end do
      do i=1,6
         do j=1,6
            sm(i,j)=smd(i,j)
         end do
      end do
      return
      end

      subroutine vsub(e1,e2,e12,n)
      real e1(*),e2(*),e12(*)
      do i=1,n
         e12(i)=e1(i)-e2(i)
      end do
      return
      end

      subroutine vadd(e1,e2,e12,n)
      real e1(*),e2(*),e12(*)
      do i=1,n
         e12(i)=e1(i)+e2(i)
      end do
      return
      end

      subroutine qsort(x,st,ip,nx)
c     quick sort (ascending order of x)
c     nx: the number of data x
c     ip: the initial order
c     st: a work array
      real x(nx)
      real xt,temp
      integer st(nx,0:1),ip(nx)
      integer i,j,l,r,s
      integer true

      do i=1,nx
         ip(i)=i
      end do
      s=1
      st(1,0)=1
      st(1,1)=nx
      true=1
 1    continue                  !do { in java
      l=st(s,0)
      r=st(s,1)
      s=s-1
 2    continue                  !do { in java
      i=l
      j=r
      xt=x((l+r)/2)
      
 5    continue                  !do {
      do 3 while(x(i).lt.xt)    ! while(...) { in java
         if(i.lt.nx) then
            i=i+1
         endif
 3    continue                  ! } in java
      do 4 while(xt.lt.x(j))    ! while(...) { in java
         if(j.gt.1) then
            j=j-1
         endif
 4    continue                  ! } in java
      jump=0
      if(i.le.j) then
         temp=x(j)
         x(j)=x(i)
         x(i)=temp
         itemp=ip(j)
         ip(j)=ip(i)
         ip(i)=itemp
         if(i.le.nx.and.j.ge.1) then
            i=i+1
            j=j-1
            jump=1
         end if
      endif
      if(jump.eq.1.and.i.le.nx.and.j.ge.1) go to 5
                          ! } while(jump.eq.1.and.i.le.nx.and.j.ge.1) in java
      if(j-l.gt.r-i) then
         if(i.lt.r) then
            s=s+1
            st(s,0)=i
            st(s,1)=r
         endif
         r=j
      else
         if(l.lt.j) then
            s=s+1
            st(s,0)=l
            st(s,1)=j
         endif
         l=i
      end if
      if(l.lt.r) go to 2        ! } while(l.lt.r); in java
      if(s.ne.0) go to 1        ! } while(s.ne.0); in java
      return
      end

      subroutine vrcpy(s1,s2,n)
      real s1(*),s2(*)
      do j=1,n
         s2(j)=s1(j)
      end do
      return
      end

      subroutine vicpy(s1,s2,n)
      integer s1(*),s2(*)
      do j=1,n
         s2(j)=s1(j)
      end do
      return
      end

      subroutine mtcpyr(a,b,n)
      real a(n,n),b(n,n)
      do i=1,n
         do j=1,n
            b(i,j)=a(i,j)
         end do
      end do
      return
      end

      subroutine mtcpyir(a,b,n)
      integer a(n,n)
      real b(n,n)
      do i=1,n
         do j=1,n
            b(i,j)=a(i,j)
         end do
      end do
      return
      end

      subroutine mtcpy(a,b,n)
      call mtcpyr(a,b,n)
      return
      end

      subroutine mtcpyi(a,b,n)
      integer a(n,n),b(n,n)
      do i=1,n
         do j=1,n
            b(i,j)=a(i,j)
         end do
      end do
      return
      end

      subroutine mtmpli6(a,b,c)
      integer a(6,6),b(6,6),c(6,6)
      do i=1,6
         do j=1,6
            c(i,j)=0.
            do k=1,6
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmpl3(a,b,c)
      real a(3,3),b(3,3),c(3,3)
      do i=1,3
         do j=1,3
            c(i,j)=0.
            do k=1,3
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end


      subroutine vprd(x,y,z)
c*****vector product of 3-dimensional vector x,y
      real x(*),y(*),z(*)
      z(1)=x(2)*y(3)-x(3)*y(2)
      z(2)=x(3)*y(1)-x(1)*y(3)
      z(3)=x(1)*y(2)-x(2)*y(1)
      return
      end

      subroutine sclvctr(vctr,scl,n) ! scale real vector
      real vctr(*)
      do i=1,n
         vctr(i)=vctr(i)*scl
      end do
      return
      end

      subroutine getrowmtrxr(mtrx,vctr,n,i)  ! copy i-th row in nxn matrix
      real mtrx(n,n),vctr(n)
      do j=1,n
         vctr(j)=mtrx(i,j)
      end do
      return
      end

      subroutine getrowmtrxi(mtrx,vctr,n,i)  ! copy i-th row in nxn matrix
      integer mtrx(n,n),vctr(n)
      do j=1,n
         vctr(j)=mtrx(i,j)
      end do
      return
      end

      subroutine setrowmtrxr(vctr,mtrx,n,i)  ! copy vctr into i-th row of mtrx
      real mtrx(n,n),vctr(n)
      do j=1,n
         mtrx(i,j)=vctr(j)
      end do
      return
      end

      subroutine setrowmtrxi(vctr,mtrx,n,i)  ! copy vctr into i-th row of mtrx
      integer mtrx(n,n),vctr(n)
      do j=1,n
         mtrx(i,j)=vctr(j)
      end do
      return
      end


      subroutine sclmtrx(mtrx,scl,n) ! scale real matrix
      real mtrx(n,n)
      do i=1,n
         do j=1,n
            mtrx(i,j)=mtrx(i,j)*scl
         end do
      end do
      return
      end

      subroutine mnegater(x,n) ! negate real matrix
      real x(n,n)
      do i=1,n
         do j=1,n
            x(i,j)=-x(i,j)
         end do
      end do
      return
      end 

      subroutine mnegatei(x,n) ! negate integer matrix
      integer x(n,n)
      do i=1,n
         do j=1,n
            x(i,j)=-x(i,j)
         end do
      end do
      return
      end 

      subroutine vnegater(x,n) ! negate real vector
      real x(*)
      do i=1,n
         x(i)=-x(i)
      end do
      return
      end 

      subroutine vnegatei(x,n) ! negate integer vector
      integer x(*)
      do i=1,n
         x(i)=-x(i)
      end do
      return
      end 

      subroutine vcpyr(x,y,n)
c*****vector copy of of n-dimensional vector
      real x(*),y(*)
      do i=1,n
         y(i)=x(i)
      end do
      return
      end

      subroutine vcpyi(x,y,n)
      integer x(*),y(*)
      do i=1,n
         y(i)=x(i)
      end do
      return
      end

      real function vabs(x,n)
c*****absolute value of n-dimensional vector x
      real x(*)
      vabs=0
      do i=1,n
         vabs=vabs+x(i)**2
      end do
      vabs=sqrt(vabs)
      return
      end

      real function vinp(x,y,n)
c*****inner product of n-dimensional vactors, x,y
      real x(*),y(*)
      vinp=0
      do i=1,n
         vinp=vinp+x(i)*y(i)
      end do
      return
      end

      integer function ifzerov(x,n) ! if zero vector return 1 else 0
      real x(*)
      ifzerov=1
      do i=1,n
         if(x(i).ne.0) then
            ifzerov=0
            return
         end if
      end do
      return
      end

      subroutine norml(x,n)
      real x(*)
      real vabs,absh
c     normalization of x
      if(ifzerov(x,n).eq.1) then
         return
      end if
      absh=vabs(x,n)
      do i=1,n
         x(i)=x(i)/absh
      end do
      return
      end

      subroutine matinv6(a,b,m,det)
      real a(6,6),b(6)
      integer index(6,2),ipivot(6)
      real pivot(6)
      call matinv(a,6,6,b,m,det,ipivot,index,pivot)
      return
      end

      subroutine matinv(a,nm,n,b,m,determ,ipivot,index,pivot)
c     *********    new version   *******
c     
c     n*n matrix a is replaced by its inverse matrix a**-1
c     if m is nonzero vector b is replaced by a**-1*b
c     
      real a(nm,nm),b(nm),pivot(nm),determ
      integer ipivot(nm),index(nm,2)
      real amax,t,swap
      equivalence (irow,jrow),(icolum,jcolum),(amax,t,swap)
      determ=1.0
      do j=1,n
         ipivot(j)=0
      end do
      do 555 i=1,n
         amax=0.0
         do 105 j=1,n
c           if(ipivot(j).eq.1) go to 105
            if(ipivot(j).ne.1) then
               do 100 k=1,n
c                 if(ipivot(k)-1) 80,100,740
                  if(ipivot(k).gt.1) then
                     return
                  else if(ipivot(k).lt.1) then
c     80             if(abs(amax).ge.abs(a(j,k))) go to 100
                     if(abs(amax).lt.abs(a(j,k))) then
                        irow=j
                        icolum=k
                        amax=a(j,k)
                     end if
                  end if
 100           continue
            end if
 105     continue
         ipivot(icolum)=ipivot(icolum)+1
c        if(irow.eq.icolum) go to 260
         if(irow.ne.icolum) then
            determ=-determ
            do l=1,n
               swap=a(irow,l)
               a(irow,l)=a(icolum,l)
               a(icolum,l)=swap
            end do
c           if(m.eq.0) go to 260
            if(m.ne.0)  then
               swap=b(irow)
               b(irow)=b(icolum)
               b(icolum)=swap
            end if
         end if
 260     continue
         index(i,1)=irow
         index(i,2)=icolum
         pivot(i)=a(icolum,icolum)
         determ=determ*pivot(i)
         a(icolum,icolum)=1.0
         do l=1,n
            a(icolum,l)=a(icolum,l)/pivot(i)
         end do
c        if(m.eq.0) go to 380
         if(m.ne.0) then
            b(icolum)=b(icolum)/pivot(i)
         end if
 380     continue
         do 550 l1=1,n
c           if(l1.eq.icolum) go to 550
            if(l1.ne.icolum) then
               t=a(l1,icolum)
               a(l1,icolum)=0.0
               do l=1,n
                  a(l1,l)=a(l1,l)-a(icolum,l)*t
               end do
c              if(m.eq.0) go to 550
               if(m.ne.0) then
                  b(l1)=b(l1)-b(icolum)*t
               end if
            end if
 550     continue
 555  continue
      do 710 i=1,n
         l=n+1-i
c        if(index(l,1).eq.index(l,2)) go to 710
         if(index(l,1).ne.index(l,2)) then
            jrow=index(l,1)
            jcolum=index(l,2)
            do 700  k=1,n
               swap=a(k,jrow)
               a(k,jrow)=a(k,jcolum)
               a(k,jcolum)=swap
 700        continue
         end if
 710  continue
      
 740  continue
      return
      end


      subroutine wtvctrr(str,v,n)
      character*(*) str
      real v(*)
      write(6,'(a,$)') str
      write(6,*) (v(j),j=1,n)
      return
      end

      subroutine wtvctri(str,v,n)
      character*(*) str
      integer v(*)
      write(6,'(a,$)') str
      write(6,*) (v(j),j=1,n)
      return
      end

      subroutine wtvctrrf(str,v,n,frmt)
      character(*) str,frmt
      real v(*)
      write(6,'(a,$)') str
      write(6,frmt) (v(j),j=1,n)
      return
      end

      subroutine wtvctrif(str,v,n,frmt)
      character*(*) str,frmt
      integer v(*)
      write(6,'(a,$)') str
      write(6,frmt) (v(j),j=1,n)
      return
      end

      subroutine wtmtrxi(str,mtrx,n)
      character*(*) str
      integer mtrx(n,n)
      write(6,'(a)') str
      do i=1,n
         write(6,*) (mtrx(i,j),j=1,n)
      end do
      return
      end

      subroutine wtmtrxr(str,mtrx,n)
      character*(*) str
      real mtrx(n,n)
      write(6,'(a,$)') str
      do i=1,n
         write(6,*) (mtrx(i,j),j=1,n)
      end do
      return
      end

      subroutine wtmtrxif(str,mtrx,n,frmt)
      character*(*) str,frmt
      integer mtrx(n,n)
      write(6,'(a)') str
      do i=1,n
         write(6,frmt) (mtrx(i,j),j=1,n)
      end do
      return
      end

      subroutine wtmtrxrf(str,mtrx,n,frmt)
      character*(*) str,frmt
      real mtrx(n,n)
      write(6,'(a)') str
      do i=1,n
         write(6,frmt) (mtrx(i,j),j=1,n)
      end do
      return
      end

      subroutine wtrmtrx6(str,rmtrx)
      character*(*) str
      real rmtrx(6,6)
      write(6,*) str
      do i=1,6
         write(6,'(6f10.5)') (rmtrx(i,j),j=1,6)
      end do
      return
      end

      subroutine mtmplr6(a,b,c)   ! multiply real 6x6 matrices
      real a(6,6),b(6,6),c(6,6)
      do i=1,6
         do j=1,6
            c(i,j)=0.
            do k=1,6
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmplr(a,b,c,n)   ! multiply real 6x6 matrices
      real a(n,n),b(n,n),c(n,n)
      do i=1,n
         do j=1,n
            c(i,j)=0.
            do k=1,n
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmpli(a,b,c,n)   ! multiply integer 6x6 matrices
      integer a(n,n),b(n,n),c(n,n)
      do i=1,n
         do j=1,n
            c(i,j)=0.
            do k=1,n
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmplmnor(a,b,c,m,n,o) ! multiply real mxn and nxo matrices
      integer m,n,o
      real a(m,n),b(n,o),c(m,o)
      do i=1,m
         do j=1,o
            c(i,j)=0.
            do k=1,n
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmplmnoi(a,b,c,m,n,o)
      ! multiply integer mxn and nxo matrices
      integer m,n,o
      integer a(m,n),b(n,o),c(m,o)
      do i=1,m
         do j=1,o
            c(i,j)=0.
            do k=1,n
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmplmnoir(a,b,c,m,n,o) ! integer mxn and real mxo matrices
      integer m,n,o
      integer a(m,n)
      real b(n,o),c(m,o)
      do i=1,m
         do j=1,o
            c(i,j)=0.
            do k=1,n
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmplmnori(a,b,c,m,n,o) ! real mxn and integer mxo matrices
      integer m,n,o
      integer b(m,n)
      real a(n,o),c(m,o)
      do i=1,m
         do j=1,o
            c(i,j)=0.
            do k=1,n
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine zerov(v1,n)  ! real zero vectors
      real v1(*)
      do j=1,n
         v1(j)=0
      end do
      return
      end

      subroutine zerovi(v1,n)  ! integer zero vectors
      integer v1(*)
      do j=1,n
         v1(j)=0
      end do
      return
      end

      subroutine dagmtrxr(da,a,n)
      real da(n),a(n,n)
!     get real diagonal matrix a with diagonal part da
      call zeromtrxr(a,n)
      do i=1,n
            a(i,i)=da(i)
      end do
      return
      end

      subroutine dagmtrxi(da,a,n)
      integer da(n),a(n,n)
!     get integer diagonal matrix a with diagonal part da
      call zeromtrxi(a,n)
      do i=1,n
            a(i,i)=da(i)
      end do
      return
      end

      subroutine unitmtrxi(a,n)
      integer a(n,n)
      call zeromtrxi(a,n)
      do i=1,n
         a(i,i)=1
      end do
      return
      end

      subroutine unitmtrxr(a,n)
      real a(n,n)
      call zeromtrxr(a,n)
      do i=1,n
         a(i,i)=1.
      end do
      return
      end

      subroutine zeromtrxr(m,n)  ! zero matrix
      real m(n,n)
      do i=1,n
         do j=1,n
            m(i,j)=0
         end do
      end do
      return
      end

      subroutine zeromtrxi(m,n)  ! zero matrix
      integer m(n,n)
      do i=1,n
         do j=1,n
            m(i,j)=0
         end do
      end do
      return
      end

      function identm(rr)
      integer rr(6,6)
c     if rr is identity matrix identm=1 else 0
      identm=0
      do i=1,6
         do j=1,6
            if(i.eq.j) then
               if(rr(i,i).ne.1) return
            else
               if(rr(i,j).ne.0) return
            end if
         end do
      end do
      identm=1
      return
      end

      function isamem(r1,r2)
      integer r1(6,6),r2(6,6)
c     if r1 and r2 is the same isamem=1 else 0
      isamem=0
c      call wtmtrxif('r1',r1,6,'(6i3)')
c      call wtmtrxif('r2',r2,6,'(6i3)')
      do i=1,6
         do j=1,6
            if(r1(i,j).ne.r2(i,j)) return
         end do
      end do
      isamem=1
      return
      end

      subroutine mround(m1,m2,eps,n)
      real m1(n,n),eps
      integer m2(n,n)
      do i=1,n
         do j=1,n
            m2(i,j)=m1(i,j)+sign(eps,m1(i,j))
         end do
      end do
      return
      end

      subroutine mscaler(m1,fac,m2,n)
      real m1(n,n),m2(n,n),fac
      do i=1,n
         do j=1,n
            m2(i,j)=m1(i,j)*fac
         end do
      end do
      return
      end

      subroutine mscalei(m1,fac,m2,n)
      integer m1(n,n),m2(n,n),fac
      do i=1,n
         do j=1,n
            m2(i,j)=m1(i,j)*fac
         end do
      end do
      return
      end

      subroutine vscaler(v1,fac,v2,n)
      real v1(*),v2(*),fac
      do j=1,n
         v2(j)=v1(j)*fac
      end do
      return
      end

      subroutine vscalei(v1,fac,v2,n)
      integer v1(*),v2(*),fac
      do j=1,n
         v2(j)=v1(j)*fac
      end do
      return
      end

      subroutine mtmplri6(a,b,c)   ! multiply real and integer 6x6 matrices
      real a(6,6),c(6,6)
      integer b(6,6)
      do i=1,6
         do j=1,6
            c(i,j)=0.
            do k=1,6
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmplir6(a,b,c)   ! multiply integer and real 6x6 matrices
      integer a(6,6)
      real b(6,6),c(6,6)
      do i=1,6
         do j=1,6
            c(i,j)=0.
            do k=1,6
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmplrmno(a,b,c,m,n,o) ! multiply real mxn and mxo matrices
      integer m,n,o
      real a(m,n),b(n,o),c(m,o)
      do i=1,m
         do j=1,o
            c(i,j)=0.
            do k=1,n
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmplimno(a,b,c,m,n,o) ! multiply integer mxn and mxo matrices
      integer m,n,o
      integer a(m,n),b(n,o),c(m,o)
      do i=1,m
         do j=1,o
            c(i,j)=0.
            do k=1,n
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmplirmno(a,b,c,m,n,o) ! multiply integer mxn and real nxo matrices
      integer m,n,o
      integer a(m,n)
      real b(n,o),c(m,o)
      do i=1,m
         do j=1,o
            c(i,j)=0.
            do k=1,n
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine mtmplrimno(a,b,c,m,n,o) ! multiply real mxn and integer nxo matrices
      integer m,n,o
      real a(m,n),c(m,o)
      integer b(n,o)
      do i=1,m
         do j=1,o
            c(i,j)=0.
            do k=1,n
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end
