c
c     generate polyhedron
c
c     generate triangular plane and save it by calling 
c     call savetri(rx,ry,rz,nrm,dstd,kcl,npln) 
c     then you can use drwphd package for drawing
c
      integer function genpolyh0(n,ni,irs,icol,jaslct) ! get small OD
      real ni(0:6,4,*)
      integer irs(0:120)
      integer genpolyh0_0,genpolyh0_1
      genpolyh0=genpolyh0_1(n,ni,irs,icol,jaslct) ! get small OD
      return
      end

      integer function getkcl(icol)
      call getshd(ishd)
      if(ishd.eq.1) then  ! shading
         kcl=icol
      else                ! no shading
         kcl=-1
      end if
      getkcl=kcl
      return
      end

      integer function genpolyh0_0(n,ni,irs,icol,jaslct) ! get small OD
      include 'impr8.inc'
      include 'qcstrc.inc'
      real ni(0:6,4,*)
      integer irs(0:120)
      real ej
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      real prj
      common /euler/ prj(3,3)   ! projection operator
      common /cnpln/ npln
      common /cisym/ ieqs,ists,mode
      real amag,aa,rmag
      common /camag/ amag,aa,rmag

      real nid(6),centg(6)
      real nrm(3)

      real rx0(3),rx1(3,3)
      real xy0(3),xy(3,3)
      real dx0(3),dx1(3,3)

      real rx(3),ry(3),rz(3)
      real nik(3,4)

      real tmp0(6),tmp1(6),tmp2(6),tmp3(6)
      real eid1(6)
      real ej0(6,3)
      real tmpn(3)
      real teq(6)
      real q0(6)
      real dstnc
      save centg,adst,scal
      integer getisyd,getkcl
      integer ip1(3),ip2(3)
      data centg /0.,0.,0.,1.,1.,1./, adst /0./
      data scal/1./
      data dx0 /3*0.d0/
      data ip1 /1,2,3/
      data ip2 /2,3,1/
      rb=getramax0(n)
c     e(1,i)-e(6,i) : i-th edge vector defining a primitive of a polyhedron
c       polyhedron is given by the primitive and site symmetry operations
c     e(1,i)-e(3,i) external components
c     e(4,i),e(6,i) internal components
c     ni(0,i,j) : distance to the i-th face of the tetrahedron
c     ni(4,i,j) : x component of the normal of the i-th face
c     ni(5,i,j) : y component of the normal of the i-th face
c     ni(6,i,j) : z component of the normal of the i-th face
c     first three faces pass through the origin
c     fourth face is the face of the polyhedron
c     irs(0): number of (pseudo-) site symmetry operators
c     
      isyd=getisyd(n)
      call getneq(ns,icn)   ! sym. op. give equiv pos.
      call setreq(ns)
      call getteq(teq)             ! translation vector for getting equiv. OD
      call getimd(imode)

c      if(jaslct.eq.1.or.jaslct.eq.2) then
      if(jaslct.eq.1) then
         ks=4
c      else if(jaslct.eq.3) then
      else if(jaslct.eq.2.or.jaslct.eq.3) then
         ks=1
      end if
      
      do nsd=1,irs(0) ! number of pseud-site symmetry operators
         nsj=irs(nsd) ! pseud-site symmetry operator
         call rednsic(nsj,nsy,icnt)
c         if(nsd.eq.1.and.nsy.ne.1) then
c            write(6,*) 'n,nsd,nsy=',n,nsd,nsy
c            call quit('stop in genpolyh0_0')
c         end if
         do i=1,nth(n)         ! nth independent tetrahedron
            call rednsic(isyd,isd,icd)
            j1=mej(1,i,n)
            j2=mej(2,i,n)
            j3=mej(3,i,n)
            call vcpyr(ej(1,j1,n),ej0(1,1),6)
            call vcpyr(ej(1,j2,n),ej0(1,2),6)
            call vcpyr(ej(1,j3,n),ej0(1,3),6)
c     get outward normal of tetrahedron
            do iii=1,3
               call getxe(ej0(1,iii),tmp0)        ! 6D vector
               call getrx0(tmp0,tmp1,nsy,icnt) ! site sym.
c              call rescl(tmp1,rb(n),6)           ! scaling
               call rescl(tmp1,rb,6)           ! scaling
               call getrx0(tmp1,tmp2,isd,icd)  ! orientation
               call getrx0(tmp2,tmp1,ns,icn)
               call rescl(tmp1,rmag,6)

               if(ists.eq.0) then
                  call vadd(tmp1,teq,tmp3,6)  ! add x0i
               else if(ists.eq.1) then
                  call vcpyr(tmp1,tmp3,6)
               end if
               call getqed(tmp3,eid1) ! external and internal comp. under phason 

               call trcs(eid1(4),xy(1,iii)) ! cartesian coordinates
               call viewtrns(xy(1,iii),rx1(1,iii)) ! viewing transformation
            end do
c     origin of the small occupation domain   teq
            if(ists.eq.0) then
               call getqe(teq,q0)       ! domain center teq
            else if(ists.eq.1) then
               call zerov(q0,6)       ! negrect teq
            end if

            call trcs(q0(4),xy0) ! cartesian coordinates
            call viewtrns(xy0,rx0) ! projection

            call rescl(rx0,amag,3)
            do iii=1,3
               call rescl(rx1(1,iii),amag,3)
               call vsub(rx1(1,iii),rx0,dx1(1,iii),3)
            end do

c     nik:  plane normal of a tetrahedron after the viewing transformation
c           call vsub(rx0,rx0,dx0,3)

            call ni3(dx1(1,1),dx1(1,2),dx1(1,3),dx0,
     *           nik(1,1),nik(1,2),nik(1,3),nik(1,4))

            kcl=getkcl(icol)            
            do k=ks,4            
               if(imode.eq.1 .or.                ! wireframe
     *              nik(3,k).gt.0.00001) then    ! plane is visible
                  npln=npln+1
                  if(k.le.3) then
                     call vcpyr(nik(1,k),nrm,3)
                     dstd=dstnc(nrm,rx1(1,ip1(k)))
                     call getrxyz(rx1(1,ip1(k)),rx1(1,ip2(k)),
     *                    rx0,rx,ry,rz)
                     call savetri(rx,ry,rz,nrm,dstd,kcl,npln)
                  else if(k.eq.4) then
                     call vcpyr(nik(1,k),nrm,3)
                     dstd=dstnc(nrm,rx1(1,1))
                     call getrxyz(rx1(1,1),rx1(1,2),rx1(1,3),rx,ry,rz)
                     call savetri(rx,ry,rz,nrm,dstd,kcl,npln)
                  end if
               end if
            end do
         end do
      end do

c      write(6,*) 'npln=',npln
      call getend(iend)
      if(iend.eq.0) then
          genpolyh0_0=1
          return
      end if
      genpolyh0_0=1
      return
      end

      integer function genpolyh0_1(n,ni,irs,icol,jaslct) ! get small OD
      include 'impr8.inc'
      include 'qcstrc.inc'
      real ni(0:6,4,*)
      integer irs(0:120)
      real ej
      common /cisym/ ieqs,ists,mode
      real prj
      common /euler/ prj(3,3)   ! projection operator
      common /cnpln/ npln
      real amag,aa,rmag
      common /camag/ amag,aa,rmag

      real nid(6),centg(6)
      real nrm(3)

      real rx0(3),rx1(3,3)
      real xy0(3),xy(3,3)
      real dx0(3),dx1(3,3)

      real rx(3),ry(3),rz(3)
      real nik(3,4)

      real tmp1(6),tmp2(6),tmp3(6)
      real fj0(6,3)
      real fj(6,3)
      real eid1(6)
      real ej0(6,3)
      real tmpn(3)
      real teq(6),q(6)
      real q0(6)
      real dstnc
      integer ip1(3),ip2(3)
      save centg,adst,scal
      integer getisyd,getapprx,getnth,expnsic,getkcl
      data centg /0.,0.,0.,1.,1.,1./, adst /0./
      data scal/1./
      data dx0 /3*0.d0/
      data ip1 /1,2,3/
      data ip2 /2,3,1/
      rb=getramax0(n)
      isyd=getisyd(n)
c     fj(1,i)-fj(6,i) : i-th edge vector defining a primitive of a polyhedron
c       polyhedron is given by the primitive and site symmetry operations
c       for phason strain calculations they should be 6D vectors
c     ni(0,i,j) : distance to the i-th face of the tetrahedron
c     ni(4,i,j) : x component of the normal of the i-th face
c     ni(5,i,j) : y component of the normal of the i-th face
c     ni(6,i,j) : z component of the normal of the i-th face
c     first three faces pass through the origin
c     fourth face is the face of the polyhedron
c     irs(0): number of (pseudo-) site symmetry operators
c     
      call getshd(ishd)
      call getneq(ns,icn)   ! sym. op. give equiv pos. (getirs ?)
      ns1=expnsic(ns,icn)
      call setreq(ns)      ! for getteq
      call getteq(teq)     ! translation vector for getting equiv. OD ( q space)
      call getimd(imode)

c      if(jaslct.eq.1.or.jaslct.eq.2) then
      if(jaslct.eq.1) then
         ks=4
c      else if(jaslct.eq.3) then
      else if(jaslct.eq.2.or.jaslct.eq.3) then
         ks=1
      end if
      
      do nsd=1,irs(0) ! number of pseud-site symmetry operators
         nsy=irs(nsd)     ! pseud-site symmetry operator
         ns2=mpltblv(isyd,nsy)
         ns3=mpltblv(ns1,ns2)
         call rednsic(isyd,nsy,icnt)  ! get nsy,icnt from isyd
         nth=getnth(n)
         do i=1,nth          ! nth independent tetrahedron
            call getfj123(n,i,fj0(1,1),fj0(1,2),fj0(1,3))   ! 6D vector
            do ii=1,3
               call getfjd0(fj0(1,ii),fj(1,ii),ns3) ! fj1 : rotated vector
               call vcpyr(fj(1,ii),tmp1,6)        ! copy 6D vector
               call rescl(tmp1,rmag*rb,6)
               call getqedrs(tmp1,eid1) ! reshaped edge vector
               if(ists.eq.0) then
                  call vadd(eid1,teq,q,6) ! add x0i : center of small OD
               end if
               call trcs(q(4),xy(1,ii)) ! cartesian coordinates of int. comp.
               call viewtrns(xy(1,ii),rx1(1,ii)) ! viewing transformation
            end do
c           origin of the small occupation domain   teq
            if(ists.eq.0) then
c               call getqe(teq,q0)       ! domain center teq
               call vcpyr(teq,q0,6)       ! domain center teq
            else if(ists.eq.1) then
               call zerov(q0,6)       ! negrect teq
            end if
            call trcs(q0(4),xy0) ! cartesian coordinates
            call viewtrns(xy0,rx0) ! projection
            call rescl(rx0,amag,3)
            do ii=1,3
               call rescl(rx1(1,ii),amag,3)
               call vsub(rx1(1,ii),rx0,dx1(1,ii),3)
            end do
c     nik:  plane normal of a tetrahedron after the viewing transformation
c           call vsub(rx0,rx0,dx0,3)
            call ni3(dx1(1,1),dx1(1,2),dx1(1,3),dx0,
     *           nik(1,1),nik(1,2),nik(1,3),nik(1,4))
            kcl=getkcl(icol)
            do k=ks,4            
               if(imode.eq.1 .or.                ! wireframe
     *              nik(3,k).gt.0.00001) then    ! plane is visible
                  npln=npln+1
                  if(k.le.3) then
                     call vcpyr(nik(1,k),nrm,3)
                     dstd=dstnc(nrm,rx1(1,ip1(k)))
                     call getrxyz(rx1(1,ip1(k)),rx1(1,ip2(k)),
     *                    rx0,rx,ry,rz)
                     call savetri(rx,ry,rz,nrm,dstd,kcl,npln)
                  else if(k.eq.4) then
                     call vcpyr(nik(1,k),nrm,3)
                     dstd=dstnc(nrm,rx1(1,1))
                     call getrxyz(rx1(1,1),rx1(1,2),rx1(1,3),rx,ry,rz)
                     call savetri(rx,ry,rz,nrm,dstd,kcl,npln)
                  end if
               end if
            end do
         end do
      end do

c     write(6,*) 'npln=',npln
      call getend(iend)
      if(iend.eq.0) then
          genpolyh0_1=1
          return
      end if
      genpolyh0_1=1
      return
      end

      subroutine getfjd0(x,rx,ns)
      real x(*),rx(*)
      call rednsic(ns,nsd,icd)
      call getrx(x,rx,nsd,icd) ! 6D vector rotation
      return
      end 

      subroutine setreq(nsy)
      integer req
      common /creq/ req(6,6)
      integer r
      real t
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      call mtcpyi(r(1,1,nsy),req,6)
      return
      end

      subroutine getreq(reqd)
      integer reqd(6,6)
      integer req
      common /creq/ req(6,6)
      call mtcpyi(req,reqd,6)
      return
      end

      subroutine setteq(teqd)
      real teqd(6)
      common /cteq/ teq(6)
      call vcpyr(teqd,teq,6)
      return
      end

      subroutine getteq(teqd)
      real teqd(6)
      common /cteq/ teq(6)
      call vcpyr(teq,teqd,6)
      return
      end
     
