      subroutine hdiag(b,m,c,e,im,jm)
c     eigen value of Helmite matrix b and their eigen value c
c       m <= 36
      dimension b(m,m),c(m,m),is(36),rowmax(36),a(36)
      integer r,s
      complex b,c,q,b1,b2,c1,c2,sscq,ssq
      double precision t,v
      jn=im+jm-2
      in=im+jm-1
      do 200 i=im,in
 200  a(i)=real(b(i,i))
      do 202 i=im,in
      do 203 j=im,in
 203  c(i,j)=(0.0,0.0)
 202  c(i,i)=(1.0,0.0)
      if(jm.eq.1) go to 113
      do 121 i=im,jn
      rowmax(i)=0.0
      ii=i+1
      do 121 j=ii,in
      bb=real(b(i,j))**2+aimag(b(i,j))**2
      if(bb.lt.rowmax(i)) go to 121
      rowmax(i)=bb
      is(i)=j
 121  continue
      nn=0
 108  continue
      amax=0.0
      do 122 i=im,jn
      if(rowmax(i).lt.amax) go to 122
      amax=rowmax(i)
      r=i
      s=is(r)
 122  continue
      amax=sqrt(amax)
      nn=nn+1
      if(nn.gt.2000) go to 105
      if(amax.le.e) go to 102
      t=a(s)-a(r)
      v=dsqrt(t*t+4.0d0*amax**2)
      tv=t/v
      if(abs(tv).ge.1.0) go to 103
      cs=sqrt((1.0-tv)/2.0)
      ss=sqrt((1.0+tv)/2.0)
      q=b(r,s)/amax
      sscq=ss*conjg(q)
      ssq=ss*q
      aa=(a(r)+a(s))/2.0
      a(r)=aa+v/2.0
      a(s)=aa-v/2.0
      b(r,r)=cmplx(a(r),0.0)
      b(s,s)=cmplx(a(s),0.0)
      b(r,s)=(0.0,0.0)
      b(s,r)=(0.0,0.0)
      do 107 i=im,in
      if(i.eq.r.or.i.eq.s) go to 104
      b1=b(i,r)
      b2=b(i,s)
      b(i,r)=b1*cs+b2*sscq
      b(i,s)=b2*cs-b1*ssq
      b(r,i)=conjg(b(i,r))
      b(s,i)=conjg(b(i,s))
 104  continue
      c1=c(i,r)
      c2=c(i,s)
      c(i,r)=c1*cs+c2*sscq
      c(i,s)=c2*cs-c1*ssq
 107  continue
      do 126 i=im,jn
      if(i.eq.r.or.i.eq.s.or.is(i).eq.r.or.is(i).eq.s) go to 127
      bb=real(b(i,r))**2+aimag(b(i,r))**2
      if(i.ge.r.or.bb.lt.rowmax(i)) go to 125
      rowmax(i)=bb
      is(i)=r
 125  continue
      bb=real(b(i,s))**2+aimag(b(i,s))**2
      if(i.ge.s.or.bb.lt.rowmax(i)) go to 126
      rowmax(i)=bb
      is(i)=s
 126  continue
      go to 108
 102  continue
      do 112 j=im,in
      gg=0.0
      do 110 i=im,in
 110  gg=gg+real(c(i,j))**2+aimag(c(i,j))**2
      sqrtgg=sqrt(gg)
      do 109 k=im,in
 109  c(k,j)=c(k,j)/sqrtgg
 112  continue
 113  continue
      return
 103  write(6,301) amax
 301  format(1h ,40hhdiag can not converge    any more amax=,f12.6)
      go to 102
 105  write(6,300) amax
 300  format(1h ,26hhdiag no convergence amax=,f12.6)
      go to 102
 127  continue
      rowmax(i)=0.0
      ii=i+1
      do 128 j=ii,in
      bb=real(b(i,j))**2+aimag(b(i,j))**2
      if(bb.lt.rowmax(i)) go to 128
      rowmax(i)=bb
      is(i)=j
 128  continue
      go to 126
      end
