      integer function getisxt(id)
      include 'qcdiff.inc'
      real mu
      common /cisextd/ isextd(idsmax)
      getisxt=isextd(id)
c      write(6,*) 'id,getisxt in getisxt=',id,getisxt
      return
      end

      integer function getcisxt()
      include 'qcdiff.inc'
      real mu
      common /cisextd/ isextd(idsmax)
      integer getid
      getcisxt=isextd(getid())
      return
      end

      subroutine  setisxt(id,isxt)
      include 'qcdiff.inc'
      real mu
      common /cisextd/ isextd(idsmax)
      isextd(id)=isxt
c      write(6,*) 'id,isextd(id) in setisxt=',id,isextd(id)
      return
      end

      integer function getcmthd()  ! return current method
      include 'qcdiff.inc'
      real mu
      common /cmthd/ mthd(idsmax)  ! 0 for powder 1 for single crystal
      integer getid
      getcmthd=mthd(getid())
      return
      end

      integer function getmthd(id) ! get methd for id-th data set
      include 'qcdiff.inc'
      real mu
      common /cmthd/ mthd(idsmax)  ! 0 for powder 1 for single crystal
c      write(6,*) 'id,mthd(id) in getmthd=',id,mthd(id)
      getmthd=mthd(id)
      return
      end

      subroutine setmthd(id,mth) ! get methd for id-th data set
      include 'qcdiff.inc'
      real mu
      common /cmthd/ mthd(idsmax)  ! 0 for powder 1 for single crystal
c      write(6,*) 'id,mthd(id) in getmthd=',id,mthd(id)
      mthd(id)=mth
      return
      end

      integer function getcimthd() ! get current imethd
                                ! 0 for 4-circle 1 for weissen
      include 'qcdiff.inc'
      real mu
      common /csext/ imthd(idsmax),mu(idsmax)
      integer getid
c      write(6,*) 'id,imthd(id) in getcimthd=',id,imthd(id)
      getcimthd=imthd(getid())
      return
      end

      integer function getimthd(id) ! get methd for id-th data set
                                ! 0 for 4-circle 1 for weissen
      include 'qcdiff.inc'
      real mu
      common /csext/ imthd(idsmax),mu(idsmax)
c      write(6,*) 'id,imthd(id) in getimthd=',id,imthd(id)
      getimthd=imthd(id)
      return
      end

      subroutine setimthd(id,imth) ! get methd for id-th data set
                                ! 0 for 4-circle 1 for weissen
      include 'qcdiff.inc'
      real mu
      common /csext/ imthd(idsmax),mu(idsmax)
      imthd(id)=imth
c      write(6,*) 'id,imthd(id) in setimthd=',id,imthd(id)
      return
      end

      real function getcmu()   ! get current mu
      include 'qcdiff.inc'
      real mu
      common /csext/ imthd(idsmax),mu(idsmax)
      integer getid
      getcmu=mu(getid())
      return
      end

      real function getmu(id)   ! get mu for id-th data set
      include 'qcdiff.inc'
      real mu
      common /csext/ imthd(idsmax),mu(idsmax)
      getmu=mu(id)
      return
      end

      subroutine setmu(id,mud)   ! get mu for id-th data set
      real mud
      include 'qcdiff.inc'
      real mu
      common /csext/ imthd(idsmax),mu(idsmax)
      mu(id)=mud
      return
      end

      subroutine saveextc(id)   ! save extinction parameters for id-th dataset
      include 'qcdiff.inc'
      real mu
c     current parameters
      include 'extncf.inc'
c     parameters for all data sets
      include 'extncfid.inc'
c     call setisxt(id,isext)  ! this does not work strange *****
      if(isext.eq.0) then
         return
      end if

      call mcpyr(cm,cmd(1,1,id),3)
      call mcpyr(om,omd(1,1,id),3)
      call vcpyr(aa,aad(1,id),nbfm)
      call vcpyr(bb,bbd(1,id),nbfm)
      call vcpyr(cc,ccd(1,id),nbfm)
      call vcpyr(ff,ffd(1,id),nbfm)
      nbfd(id)=nbf
      cefd(id)=cef
      cbt2d(id)=cbt2
      vold(id)=vol
      call vcpyr(ex,exd(1,id),nbfm)
      call vcpyr(ey,eyd(1,id),nbfm)
      call vcpyr(ez,ezd(1,id),nbfm)
      call vcpyr(wxyz,wxyzd(1,id),nbfm)
      bthd(id)=bth
      amagd(id)=amag
      icmd(id)=icm
      return
      end

      subroutine setextc(id)  ! set orientation matrix etc for extinction corr.
      include 'qcdiff.inc'
      real mu
c     current parameters
      include 'extncf.inc'
c     parameters for all data sets
      include 'extncfid.inc'
      isextd(id)=isext
      if(isext.eq.0) then
         return
      end if
      call mcpyr(cmd(1,1,id),cm,3)
      call mcpyr(omd(1,1,id),om,3)
      call vcpyr(aad(1,id),aa,nbfm)
      call vcpyr(bbd(1,id),bb,nbfm)
      call vcpyr(ccd(1,id),cc,nbfm)
      call vcpyr(ffd(1,id),ff,nbfm)
      nbf=nbfd(id)
      cef=cefd(id)
      cbt2=cbt2d(id)
      vol=vold(id)
      call vcpyr(exd(1,id),ex,nbfm)
      call vcpyr(eyd(1,id),ey,nbfm)
      call vcpyr(ezd(1,id),ez,nbfm)
      call vcpyr(wxyzd(1,id),wxyz,nbfm)
      bth=bthd(id)
      amag=amagd(id)
      icm=icmd(id)
      return
      end

      subroutine rdextc(isxt)   ! read current extinction parameters
      common /cwflag/ iwflag(7)
      include 'qcdiff.inc'
      include 'extncf.inc'
      real euang1(3)
      real ui(6,3),omtrx(3,3),ub(6,3)
      data pi /3.1415926/
      if(isxt.eq.0) then
         isext=0
         return
      else
         isext=isxt
      end if
c     read data for extinction correction
c      read(5,110) nbf,mp,mq,mr,icm
      iwflag(3)=1
      call freadis('nbf=',1,nbf,1)
      call freadis('mp=',1,mp,0)
      call freadis('mq=',1,mq,0)
      call freadis('mr=',1,mr,0)
      call freadis('icm=',1,icm,0)
      if(nbf .gt.nbfm) then
          call quit('nbf.gt.nbfm')
      else if(nbf .eq. 0.or.(nbf .gt.1.and.nbf .lt.4).or.nbf .lt.-1)
     *         then
          call quit('nbf should be -1 1, .ge.4')
      end if
      if(mp*mq*mr .gt.1000) then
          call quit('mp*mq*mr.gt.1000')
      end if
c     read(5,112) (aa(i),bb(i),cc(i),ff(i),i=1,abs(nbf))
      do i=1,abs(nbf)
         call freadrs('aa=',1,aa(i),1)
         call freadrs('bb=',1,bb(i),0)
         call freadrs('cc=',1,cc(i),0)
         call freadrs('ff=',1,ff(i),0)
      end do
c     if(iwflag(3) .eq. 1) then
           write(6,210) nbf,mp,mq,mr,icm
           write(6,211) (aa(i),bb(i),cc(i),ff(i),i=1,abs(nbf))
c     end if

      if(nbf .eq. 1) then
         aa(1)=1/aa(1)
         bb(1)=1/bb(1)
         cc(1)=1/cc(1)
      else if(nbf .eq. -1) then
         aa(1)=1/aa(1)
         bb(1)=1/bb(1)
      end if

      if(nbf .eq. 1) then
         aa(1)=aa(1)**2
         bb(1)=bb(1)**2
         cc(1)=cc(1)**2
         ff(1)=ff(1)**2
      else if(nbf .eq. -1) then
         aa(1)=aa(1)**2
         bb(1)=bb(1)**2
         ff(1)=ff(1)**2
      end if

      call freadrs('wv=',1,wv,1)
      call freadrs('abc0=',1,abc0,0)
      call freadrs('bth=',1,bth,0)
      call freadrs('amag=',1,amag,0)
      write(6,212) wv,abc0,bth,amag

      if(icm.eq.0) then         ! ub matrix
         call freadra('cm=',9,cm,1)
         call mtrnspr3(cm)  ! transpose matrix
         do i=1,6
            do j=1,3
               if(i.le.3) then
                  ub(i,j)=cm(i,j)
               else
                  ub(i,j)=0
               end if
            end do
         end do
         call caluiv(ub,ui,v,as,bs,cs,cosas,cosbs,coscs)
         call caleuang(v,euang1)
         call seteuang1(euang1)
      else if(icm.eq.1) then    ! orientation matrix
         call freadra('cm=',9,cm,1)
         call mtrnspr3(cm)   ! transpose matrix
         call caleuang(cm,euang1)
         call seteuang1(euang1)
         call setomtr(euang1(1),euang1(2),euang1(3),omtrx)
         call getui(ui)
         call mtmltijk(ui,omtrx,ub,6,3,3)
         do i=1,3
            do j=1,3
               cm(i,j)=ub(i,j)
            end do
         end do
      else if(icm.eq.2) then    ! euler angle
         call freadra('euang1=',3,euang1,1)
         write(6,*) 'euang1=',(euang1(j),j=1,3)
         euang1(1)=euang1(1)*pi/180
         euang1(2)=euang1(2)*pi/180
         euang1(3)=euang1(3)*pi/180
         call seteuang1(euang1)
         call setomtr(euang1(1),euang1(2),euang1(3),omtrx)
         call getui(ui)
         write(6,217) ((ui(i,j),j=1,3),i=1,6)
         call mtmltijk(ui,omtrx,ub,6,3,3)
         do i=1,3
            do j=1,3
               cm(i,j)=ub(i,j)
            end do
         end do
      end if

      do i=1,3
         do j=1,3
            cm(i,j)=cm(i,j)*wv
         end do
      end do
      write(6,215) ((cm(i,j),j=1,3),i=1,3)
      call freadra('om=',9,om,1)
      call mtrnspr3(om) ! transpose matrix
      write(6,216) ((om(i,j),j=1,3),i=1,3)
      return
 110  format(26i3)
 111  format(10f8.5)
 112  format(4f8.5)
 210  format(1h ,'nbf',i3,3x,'mp',i3,3x,'mq',i3,3x,'mr',i3,3x,'icm',i3)
 211  format(1h ,'boundary functions'/1h ,5x,'aa',10x,'bb',10x,'cc',
     *        10x,'ff'/(1h ,4f12.5))
 212  format(1h ,'wave length',f12.5,6x,'linear absorption coef.',
     *        f12.5,6x,'bragg angle of monochrometer',f12.5/1h ,
     *       ' amag',f12.5)
 213  format(1h ,'cell orientation matrix'/(1h ,3f12.5))
 214  format(1h ,'orientation matrix'/(1h ,3f12.5))
 215  format(1h ,'cm matrix'/(1h ,3f12.5))
 216  format(1h ,'orentation matrix'/(1h ,3f12.5))
 217  format(1h ,'ui matrix'/(1h ,3f12.5))
      end

      subroutine initextc(id,isxtd)
      common /cwflag/ iwflag(7)
      include 'qcdiff.inc'
c     common /extcr0/ a0,c0
      include 'extncf.inc'
      if(isxtd.eq.0) then
         call saveextc(id)
         return
      end if

      call getsys(isys)
      call getdet(det)
      call geta(al)
      call getam(am)
      if(isys .le.2) then
         v=al**3/abs(det)/amag   !  v=al**3/det  May 12 '99
      else
         call getc(cl)
         v=al**2*cl/abs(det)/amag  !  v=al**2*cl/det May 12 '99
      end if
      write(6,*) 'volume of the unit cell in 5D or 6D=',v
c
c     (e^2/mc^2)=(2.818*10^(-5)) angstrome
c     wv/v                       angstrome^(-2)
c     cef = (2.18)^2*10^(-10)    angstrome^(-2)
c         = (2.18)^2/1000 mm^(-1) angstrome^(-1)
c

c           ads in angstrome
      if(isext .gt.0) then         ! X-ray
c       cef=(wv*28.18/v)**2     ! in cm for x,y,z  ads in micron
        cef=(wv*0.218/v)**2/10  ! in mm for x,y,z  ads in angstrome
      else if(isext .lt.0) then    ! neutron
c       cef=(wv*10.0/v)**2      ! in cm for x,y,z  ads in micron
        cef=(wv*0.10/v)**2/10   ! in mm for x,y,z  ads in angstrome
      end if
      cbt=cos(2.0*bth*6.28318/360.0)
      cbt2=cbt**2
      call table(mp,mq,mr,wxyz,ex,ey,ez,nbf,aa,bb,cc,ff)
      do i=1,3
         do j=1,3
            cm(i,j)=cm(i,j)*wv
         end do
      end do
      call saveextc(id)
      return
      end

      subroutine table(mp,mq,mr,wxyz,x,y,z,nbf,aa,bb,cc,ff)
      dimension x(mp,mq,mr),y(mp,mq,mr),z(mp,mq,mr),wxyz(mp,mq,mr)
     *        ,aa(*),bb(*),cc(*),ff(*)
      dimension a(3,3),b(3),ipivot(3),index(3,2),pivot(3)
      common /bgn1/ilm(3),icorc(3),pxj(100,3),hj(100,3)
      wt(x1,x2,x3,h,p,q,f)=h*x1+p*x2+q*x3-f
      fuvw(c,f)=-sqrt(f/c)

c     write(6,*) 'beginning of table'
      eps=1.e-06
      ilm(1)=mp
      ilm(2)=mq
      ilm(3)=mr
      do i=1,3
         icorc(i)=1
      end do
      call gauss1
      if(nbf .eq. 1) then
c        ellipsoidal crystals         
         do np=1,mp
            do nq=1,mq
               do nr=1,mr
                  f0=ff(1)
                  ua=fuvw(aa(1),f0)
                  ub=-ua
                  du=ub-ua
                  rx    =hj(np,1)*du
                  x(np,nq,nr)=ua+(pxj(np,1)+0.5)*du
                  f1=f0-aa(1)*x(np,nq,nr)**2
                  va=fuvw(bb(1),f1)
                  vb=-va
                  dv=vb-va
                  ry    =hj(nq,2)*dv
                  y(np,nq,nr)=va+(pxj(nq,2)+0.5)*dv
                  f2=f1-bb(1)*y(np,nq,nr)**2
                  wa=fuvw(cc(1),f2)
                  wb=-wa
                  dw=wb-wa
                  rz    =hj(nr,3)*dw
                  z(np,nq,nr)=wa+(pxj(nr,3)+0.5)*dw
                  wxyz(np,nq,nr)=rx*ry*rz
               end do
            end do
         end do
         return
      else if(nbf .eq. -1) then
c        cylindorical crystals
         do np=1,mp
            do nq=1,mq
               do nr=1,mr
                  f0=ff(1)
                  ua=fuvw(aa(1),f0)
                  ub=-ua
                  du=ub-ua
                  rx    =hj(np,1)*du
                  x(np,nq,nr)=ua+(pxj(np,1)+0.5)*du
                  f1=f0-aa(1)*x(np,nq,nr)**2
                  va=fuvw(bb(1),f1)
                  vb=-va
                  dv=vb-va
                  ry    =hj(nq,2)*dv
                  y(np,nq,nr)=va+(pxj(nq,2)+0.5)*dv
                  wa=cc(1)
                  wb=-wa
                  dw=wb-wa
                  rz    =hj(nr,3)*dw
                  z(np,nq,nr)=wa+(pxj(nr,3)+0.5)*dw
                  wxyz(np,nq,nr)=rx*ry*rz
               end do
            end do
         end do
         return
      else    ! nbf .ge. 4
 150     do i=1,nbf
            absa=sqrt(aa(i)**2+bb(i)**2+cc(i)**2)
            aa(i)=aa(i)/absa
            bb(i)=bb(i)/absa
            cc(i)=cc(i)/absa
            ff(i)=ff(i)/absa
         end do
         nbf2=nbf-2
         nbf1=nbf-1
         ua=1000.
         ub=-1000.
         do i=1,nbf2
            ip=i+1
            do j=ip,nbf1
               jp=j+1
               if(1.0-abs(aa(i)*aa(j)+bb(i)*bb(j)+cc(i)*cc(j)) .lt.eps)
     *              go to 11
               do k=jp,nbf
                  if(1.0-abs(aa(i)*aa(k)+bb(i)*bb(k)+cc(i)*cc(k)) .lt.
     *                 eps) go to 12
                  if(1.0-abs(aa(j)*aa(k)+bb(j)*bb(k)+cc(j)*cc(k)) .lt.
     *                 eps) go to 12
                  a(1,1)=aa(i)
                  a(1,2)=bb(i)
                  a(1,3)=cc(i)
                  a(2,1)=aa(j)
                  a(2,2)=bb(j)
                  a(2,3)=cc(j)
                  a(3,1)=aa(k)
                  a(3,2)=bb(k)
                  a(3,3)=cc(k)
                  b(1)=ff(i)
                  b(2)=ff(j)
                  b(3)=ff(k)
                  call matinv(a,3,3,b,1,det,ipivot,index,pivot)
                  do l=1,nbf
                     if(wt(b(1),b(2),b(3),aa(l),bb(l),cc(l),ff(l)) .gt.
     *                    eps) go to 12
                  end do
                  if(b(1) .lt.ua) ua=b(1)
                  if(b(1) .gt.ub) ub=b(1)
 12               continue
               end do
 11            continue
            end do
         end do
         du=ub-ua
         do np=1,mp
            rx=hj(np,1)*du
            do nq=1,mq
               do nr=1,mr
                  x(np,nq,nr)=ua+(pxj(np,1)+0.5)*du
               end do
            end do
            va=1000.
            vb=-1000.
            do i=1,nbf1
               jp=i+1
               if(1.0-abs(aa(i)) .lt.eps) go to 20
               do j=jp,nbf
                  if(1.0-abs(aa(j)) .lt.eps) go to 21
                  if(1.0-abs(aa(i)*aa(j)+bb(i)*bb(j)+cc(i)*cc(j)) .lt.
     *                 eps) go to 21
                  a(1,1)=bb(i)
                  a(1,2)=cc(i)
                  a(2,1)=bb(j)
                  a(2,2)=cc(j)
                  b(1)=ff(i)-aa(i)*x(np,1,1)
                  b(2)=ff(j)-aa(j)*x(np,1,1)
                  call matinv(a,3,2,b,1,det,ipivot,index,pivot)
                  do l=1,nbf
                     if(wt(x(np,1,1),b(1),b(2),aa(l),bb(l),cc(l),ff(l))
     *                    .gt.eps) go to 21
                  end do
                  if(b(1) .lt.va) va=b(1)
                  if(b(1) .gt.vb) vb=b(1)
 21               continue
               end do
 20            continue
            end do
            dv=vb-va
            do nq=1,mq
               ry=hj(nq,2)*dv
               do nr=1,mr
                  y(np,nq,nr)=va+(pxj(nq,2)+0.5)*dv
               end do
               wa=1000.
               wb=-1000.
               do i=1,nbf
                  if(abs(cc(i)) .lt.eps) go to 30
                  b(1)=(ff(i)-aa(i)*x(np,1,1)-bb(i)*y(np,nq,1))/cc(i)
                  do l=1,nbf
                     if(wt(x(np,1,1),y(np,nq,1),b(1),aa(l),bb(l),
     *                    cc(l),ff(l)) .gt.eps) go to 30
                  end do
                  if(b(1) .lt.wa) wa=b(1)
                  if(b(1) .gt.wb) wb=b(1)
 30               continue
               end do
               dw=wb-wa
               do nr=1,mr
                  rz=hj(nr,3)*dw
                  z(np,nq,nr)=wa+(pxj(nr,3)+0.5)*dw
                  wxyz(np,nq,nr)=rx*ry*rz
               end do
            end do
         end do
      end if
      write(6,*) 'end of table'
      return
      end

      subroutine gauss1
      implicit real*8 (a-h,o-z)
      real pxj,hj
      common /bgn1/ ilm(3),icorc(3),pxj(100,3),hj(100,3)
      dimension p(3)
c     write(6,*) 'beginning of gauss1'
c     calculation of interval and weight of gauss integral
      do l=1,3
         n=ilm(l)
         if(icorc(l) .eq. 1) then
c     incommensurate case
            eps=1.0d-10
            do k=1,ilm(l)
               xm=float(n+1-2*k)/float(2*n+1)
               x=dsin(xm*3.1415926536)
 30            p(1)=1.0
               p(2)=x
               do i=2,n
                  p(3)=x*p(2)+float(i-1)/float(i)*(x*p(2)-p(1))
                  p(1)=p(2)
                  p(2)=p(3)
               end do
               d=(1.0d0-x**2)*p(2)/(float(n)*(p(1)-x*p(2)))
               if(dabs(d) .lt.eps) go to 40
               x=x-d
               go to 30
 40            w=2.0d0*(1.0d0-x**2)/(float(n)*p(1))**2
               pxj(k,l)=-x/2.0d0
               hj(k,l)=w/2.0d0
            end do
            go to 12
         else
c     commensurate case
            do k=1,ilm(l)
               pxj(k,l)=float(k-1)/float(n)
               hj(k,l)=1.0/float(n)
            end do
         end if
 12   continue
      end do
c     write(6,*) 'end of gauss1'
      return
      end

      integer function getnpqr(i,j,k)
      common /extcr2/ ex(1000),ey(1000),ez(1000),wxyz(1000),mp,mq,mr
      getnpqr=i+(j-1)*mp+(k-1)*mp*mq
      return
      end

      subroutine extcor(ads0,ama0,yd,fcal,ext,extd)
      real ads0(2)              ! extinction parameter
      real ams0                 ! extinction parameter
      real yd(3)                ! diffraction vector in crystal system
      real extd(*)
      real xc(3)                ! diffraction vector in camera system
      real nd(3)                ! normalized yd
      include 'qcdiff.inc'
      include 'extncf.inc'
      real s(3),so(3),sop(3),sp(3),n0(2),n1(2)
      integer getnpqr,getimthd,getid
      data pi /3.14159265/
      us(s1,s2,s3,a,b,c)=a*s1**2+b*s2**2+c*s3**2           ! 
      vs(s1,s2,s3,x1,x2,x3,a,b,c)=2.0*(a*x1*s1+b*x2*s2+c*x3*s3)
      ws(x1,x2,x3,a,b,c,f)=a*x1**2+b*x2**2+c*x3**2-f

      ur(s1,s2,a,b)=a*s1**2+b*s2**2
      vr(s1,s2,x1,x2,a,b)=2.0*(a*x1*s1+b*x2*s2)
      wr(x1,x2,a,b,f)=a*x1**2+b*x2**2-f

      vt(s1,s2,s3,a,b,c)=a*s1+b*s2+c*s3     ! projection of s to plane normal
      wt(x1,x2,x3,a,b,c,f)=a*x1+b*x2+c*x3-f ! dist. from x,y,z to the boundary

      st1(u,v,w)=(-v+sqrt(v**2-4.0*u*w))/(2.0*u)
      st2(u,v,w)=-w/v

      ai0(u)=1+u**2/4.0+u**4/64.0+u**6/2304.0
      ai0d(u)=u/2.0+u**3/16.0+u**5/384.0

      if(isext.eq.0) then
         ext=1
         return
      end if

      call vcpyr(yd,nd,3)
      call norml(nd,3)    ! normalized yd

      xc(1)=(yd(1)*cm(1,1)+yd(2)*cm(2,1)+yd(3)*cm(3,1))
      xc(2)=(yd(1)*cm(1,2)+yd(2)*cm(2,2)+yd(3)*cm(3,2))
      xc(3)=(yd(1)*cm(1,3)+yd(2)*cm(2,3)+yd(3)*cm(3,3))
c     xc : diffraction vector in camera system
      
      id=getid()
      imthd=getimthd(id)
c     imthd=0  ! for 4-circle diffractmeter
c     imthd=1  ! for weissenberg camera

      if(imthd.eq.0) then
         call dif4(xc,sop,sp,stt,ctt)     ! 4-circle bisecting position
      else 
         iy=1
         call difw(xc,sop,sp,stt,ctt,iy)  ! Weissenberg
c        write(6,*) 'xc=',xc,' yc=',yc,' zc=',zc,'so=',sop,' sp=',sp
      end if

      call xmpy(om,sop,so,3,3,1)
      call xmpy(om,sp,s,3,3,1)

      mc2an=10000   ! micormeter -> angstrome
      de2rd=pi/180  ! degree     -> radian

c     two extinction parameter ads0, ama0
c     alph=2*pi*stt/wv       ! inverse angstrome
      alph=stt/wv            ! inverse angstrome

      ads1=ads0(1)*mc2an         ! ads in micro meter -> ads in angstrom
c     fct2=nd(1)**2+nd(2)**2-nd(3)**2  ! anisotropic factor
      fct2=nd(3)**2-nd(1)**2-nd(2)**2    ! anisotropic factor
c     write(6,*) 'fct2=',fct2,' nd=',nd,' yd=',yd
      if(abs(isext).eq.2) then
         ads2=ads0(2)*mc2an*fct2
      else
         ads2=0   ! isotropic
      end if
      ama=ama0*de2rd            ! ama0 in degree      -> ama in radian
      xx=alph*(ads1+ads2)*ama   ! dimensionless

      if(abs(isext).eq.1) then
         deno=1.+xx
         deno2=deno**2
      else if(abs(isext).eq.2) then
c         deno=sqrt(2+4*xx**2)
c         deno3=deno**3
         deno=1.+xx
         deno2=deno**2
      else
         call quit('invalid isext')
      end if

      tau=(ads1+ads2)/deno      ! tau in angstrom

c     dtau/ads dtau/ama
      dtad1=1.0/deno-xx/deno2
      dtam=-(ads1+ads2)**2*alph/deno2
      if(abs(isext).eq.2) then
         dtad2=fct2*dtad1
c     dtad=(1./deno-4*xx**2/deno3)
c     dtam=(-4*ads*(alph*ads)**2*ama/deno3)
      end if

      fcal2=fcal**2
      ctt2=ctt**2

      if(iabs(isext).gt.0) then
          pf=cbt2+ctt2
      else
          cbt2=1
          ctt2=0
          pf=cbt2
      end if

c     for elipsoidal case, a(x1+ts1)^2+b(x2+ts2)^2+c(x3+ts3)^2=f
c     (as1^2+bs2^2+cs3^2)t^2+2(ax1s1+bx2s2+cx3s3)t+ax1^2+bx2^2+cx3^2-f=0
c     ust^2 + vst + ws=0
c     t=st1(us,vs,ws)

c     for columnar case,   a(x1+ts1)^2+b(x2+ts2)^2=f 
c     (as1^2+bs2^2)t^2+2(ax1s1+bx2s2)t+ax1^2+bx2^2-f=0
c     urt^2 + vrt + wr=0
c     t=st1(ur,vr,wr)

      sg1=tau*cef*fcal2    ! in inverse cm
      sg2=sg1*ctt2
      vol=0.0
      ext1=0.0
      ext2=0.0
      ext3=0.
      ext4=0.
      do np=1,mp
         do nq=1,mq
            do nr=1,mr
               to=1000.
               t=1000.
               npqr=getnpqr(np,nq,nr)
               x1=ex(npqr)
               x2=ey(npqr)
               x3=ez(npqr)
               do i=1,abs(nbf)
                  top=1000.
                  tp=1000.
                  if(nbf.eq.1) then
c                    elipsoical sample
                     ws0=ws(x1,x2,x3,aa(i),bb(i),cc(i),ff(i))
                     us0=us(so(1),so(2),so(3),aa(i),bb(i),cc(i))
                     us1=us(s(1),s(2),s(3),aa(i),bb(i),cc(i))
                     vs0=vs(so(1),so(2),so(3),x1,x2,x3,aa(i),bb(i),
     *                    cc(i))
                     vs1=vs(s(1),s(2),s(3),x1,x2,x3,aa(i),bb(i),
     *                    cc(i))
                     top=st1(us0,-vs0,ws0)
                     tp=st1(us1,vs1,ws0)
                  else if(nbf.eq.-1) then
c                    cylindorical sample
                     abss0=sqrt(so(1)**2+so(2)**2)
                     n0(1)=so(1)/abss0
                     n0(2)=so(2)/abss0
                     abss1=sqrt(s(1)**2+s(2)**2)
                     n1(1)=s(1)/abss1
                     n1(2)=s(2)/abss1
                     ws0=wr(x1,x2,aa(i),bb(i),ff(i))
                     us0=ur(n0(1),n0(2),aa(i),bb(i))
                     vs0=vr(n0(1),n0(2),x1,x2,aa(i),bb(i))
                     ws1=ws0
                     us1=ur(n1(1),n1(2),aa(i),bb(i))
                     vs1=vr(n1(1),n1(2),x1,x2,aa(i),bb(i))
                     t0=st1(us0,-vs0,ws0)
                     t1=st1(us1,vs1,ws1)
c                     if(so(3) > 0) then
                     if(so(3) .gt. 0) then
c                        if(t0*so(3) < cc(i)-x3) then
                        if(t0*so(3) .lt. cc(i)-x3) then
                           top=t0*sqrt(1+so(3)**2)
                        else
                           top=t0*sqrt(1+so(3)**2)*(cc(1)-x3)/
     *                          (t0*so(3))
                        end if
                     else
c                        if(-t0*so(3) < cc(i)+x3) then
                        if(-t0*so(3) .lt. cc(i)+x3) then
                           top=t0*sqrt(1+so(3)**2)
                        else
                           top=-t0*sqrt(1+so(3)**2)*(cc(i)+x3)/
     *                          (t0*so(3))
                        end if
                     end if
c                     if(s(3) > 0) then
                     if(s(3) .gt. 0) then
c                        if(t1*so(3) < cc(i)-x3) then
                        if(t1*so(3) .lt. cc(i)-x3) then
                           tp=t1*sqrt(1+s(3)**2)
                        else
                           tp=t1*sqrt(1+s(3)**2)*(cc(i)-x3)/
     *                          (t1*s(3))
                        end if
                     else
c                        if(-t1*s(3) < cc(i)+x3) then
                        if(-t1*s(3) .lt. cc(i)+x3) then
                           tp=t1*sqrt(1+s(3)**2)
                        else
                           tp=-t1*sqrt(1+s(3)**2)*(cc(i)+x3)/
     *                          (t1*s(3))
                        end if
                     end if
 427              else if(nbf.gt.3) then
c                    polyhedral sample
                     ws0=wt(x1,x2,x3,aa(i),bb(i),cc(i),ff(i))
                     us0=us(so(1),so(2),so(3),aa(i),bb(i),cc(i))
                     us1=us(s(1),s(2),s(3),aa(i),bb(i),cc(i))
                     vs0=vt(so(1),so(2),so(3),aa(i),bb(i),cc(i))
                     vs1=vt(s(1),s(2),s(3),aa(i),bb(i),cc(i))
                     if(abs(vs0).gt.1.e-20) top=st2(us0,-vs0,ws0)
                     if(abs(vs1).gt.1.e-20) tp=st2(us1,vs1,ws0)
                  end if
                  if(top.gt.0.0.and.top.lt.to) to=top ! path length ?
                  if(tp.gt.0.0.and.tp.lt.t) t=tp ! path length ?
               end do
c              compute extinction factor
               q=wxyz(npqr)
               ta=to+t
               sta=2.0*sqrt(to*t)
               exp1=exp(-(abc0+sg1)*ta)*q
               exp2=exp(-(abc0+sg2)*ta)*q
               ai01=ai0(sg1*sta)
               ai02=ai0(sg2*sta)

               ext1=ext1+exp1*ai01
               ext3=ext3-exp1*(ai01*ta-ai0d(sg1*sta)*sta)

               if(abs(isext).gt.0) then
                  ext2=ext2+exp2*ai02
                  ext4=ext4-exp2*(ai02*ta-ai0d(sg2*sta)*sta)
               else
                  ext2=0
                  ext4=0
               end if

               vol=vol+q
            end do
         end do
      end do

      ext=(cbt2  *ext1+ctt2  *ext2)/(vol*pf)
      ext=sqrt(ext)
      exd=(cbt2*ext3+ctt2*ext4*ctt2)*cef*fcal2/(2.0*ext*vol*pf)
      if(abs(isext).eq.1) then
         extd(1)=exd*dtad1*mc2an ! dext/dads*dads/dads0(1)
         extd(2)=exd*dtam*de2rd ! dext/dadn*dadm/dadm0
      else if(abs(isext).eq.2) then
         extd(1)=exd*dtad1*mc2an ! dext/dads*dads/dads0(1)
         extd(2)=exd*dtad2*mc2an ! dext/dads*dads/dads0(2)
         extd(3)=exd*dtam*de2rd  ! dext/dadn*dadm/dadm0
      end if
      return
      end

      subroutine dif4(xc,so,s,stt,ctt)
      dimension xc(3),so(3),s(3)
      data pi4/0.785398/
c      xy=sqrt(xc**2+yc**2)
c      xyz=sqrt(xy**2+zc**2)
      xy=vabs(xc,2)
      xyz=vabs(xc,3)
      sth=xyz/2.0
      cth=sqrt(1.0-sth**2)
      stt=2.0*sth*cth
      ctt=cth**2-sth**2
      phi=pi4
      chi=pi4
      if(xc(1).ne.0) phi=atan2(xc(2),xc(1))
      cph=cos(phi)
      sph=sin(phi)
      if(xy.ne.0) chi=atan2(xc(3),xy)
      cch=cos(chi)
      sch=sin(chi)

      s11=sth*cch*cph
      s12=cth*sph
      s21=sth*cch*sph
      s22=cth*cph
      s31=sth*sch
      so(1)=-s11-s12
      so(2)=-s21+s22
      so(3)=-s31
      s(1)=s11-s12
      s(2)=s21+s22
      s(3)=s31
      return
      end

      subroutine difw(xc,so,s,stt,ctt,iy)
      dimension xc(3),so(3),s(3)
      real sx(2),sy(2),sz(2),rota(2)
      real mu
      data pi4/0.785398/

      mu=getcmu()
c     xc       : coordinates in crystal system at initial position
c     so       : unit vector of incident beam in crystal system
c     s        : unit vector of diffracted beam in crystal system
c      xy=sqrt(xc(1)**2+xc(1)**2)
c      xyz=sqrt(xc(1)**2+xc(2)**2+xc(3)**2)
      xy=vabs(xc,2)
      xyz=vabs(xc,3)
      sth=xyz/2.0            ! sin(theta)
      cth=sqrt(1.0-sth**2)   ! cos(theta)
      stt=2.0*sth*cth        ! sin(2*theta)=2sin(theta)cos(teta)
      ctt=cth**2-sth**2      ! cos(2*theta)=cos(theta)^2-sin(theta)^2

      cmu=cos(mu)
      smu=sin(mu)
      call cylnd(xc(1),xc(2),xc(3),rx,ry,iskip)
      call weis2(rx,ry,xc(3),sx,sy,sz,rota,icond)
c     rota rotation angle for a given reflection (xc,yc,zc)
c     incident and diffracted beam directions in the crystal system
c     are obtained from those of the equipment system by rotating
c     -rota
c           test two methods

      mthd=2
      if(iy.eq.1) then
         if(mthd.eq.1) then
            so(1)=cmu
            so(2)=0
            so(3)=-smu
            call rotz(so,-rota(1))
            s(1)=so(1)+xc(1)
            s(2)=so(2)+xc(2)
            s(3)=so(3)+xc(3)
         else
            so(1)=cmu
            so(2)=0
            so(3)=-smu
            s(1)=sx(1)
            s(2)=sy(1)
            s(3)=sz(1)         
            call rotz(so,-rota(1))
            call rotz(s,-rota(1))
         end if
      else
         if(mthd.eq.1) then
            so(1)=cmu
            so(2)=0
            so(3)=-smu
            call rotz(so,-rota(2))
            s(1)=so(1)+xc(1)
            s(2)=so(2)+xc(2)
            s(3)=so(3)+xc(3)
         else
            so(1)=cmu
            so(2)=0
            so(3)=-smu
            s(1)=sx(2)
            s(2)=sy(2)
            s(3)=sz(2)         
            call rotz(so,-rota(2))
            call rotz(s,-rota(2))
         end if
      end if
      return
      end

      subroutine rotz(s,rot)
      real s(*),sd(3)
      sd(1)=cos(rot)*s(1)-sin(rot)*s(2)
      sd(2)=sin(rot)*s(1)+cos(rot)*s(2)
      sd(3)=s(3)
      s(1)=sd(1)
      s(2)=sd(2)
      s(3)=sd(3)
      return
      end
