      subroutine gcoset1(iaslct,j) ! coset number for all R
c     j-th atom   ***** different from gcoset0
c     iaslct(k,j) 1 for k-th symmetry operator is included in the site symmetry
c     
      integer iaslct(120,*)

      include 'qcdiff.inc'
      integer coset,cosrep
      common /ccoset/ coset(120,namax),ncst(namax),cosrep(120,namax)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      integer rd,rsub
      common /cgetson/ rd(6,6,120),rsub(6,6,120),icost(120)
      real mpl
      common /toqcd2/ na,mpl(namax),isk(0:120,namax),irs(0:120,namax),
     *     isymo(0:120)
      real t0(6)
      data t0 /0.,0.,0.,0.,0.,0./

c     calculate coset for real-sitesymmetry
c     generate all the symmetry operation including inversion (rd)
      call zerovi(icost,120)
      n=0
      do icnt=0,icent
         do ns=1,nsymo
            n=n+1
            call micpy(r(1,1,ns),rd(1,1,n))
            if(icnt.eq.1) then
               call invr(rd(1,1,n))
            end if
         end do
      end do

c     select site symmetry operations of occupation domain (rsub)
      ne=nsymo*(1+icent)
      n=0
      do ns=1,ne
         if(iaslct(ns,j).eq.1) then
            n=n+1
            call micpy(rd(1,1,ns),rsub(1,1,n))
         end if
      end do

      nsub=n                    ! order of subgroup
      ncst(j)=ne/nsub           ! number of cosets
c     write(6,*) 'rsub created, nsub, ncst', nsub, ncst
c     generate cosets
      nc=0
      do ns=1,ne
         if(icost(ns).eq.0) then
            nc=nc+1
            cosrep(nc,j)=ns   ! coset representativ of the nc-th coset
            call getcos(nc,ns,nsub,coset(1,j))
         end if
      end do
      write(6,*) 'p.o.d. ',j,' number of cosets=',nc
      write(6,'(a,20i4/(7x,20i4))') 'cosrep=',(cosrep(k,j),k=1,ncst(j))
      write(6,'(a,20i4/(7x,20i4))') 'coset =',(coset(k,j),k=1,ne)
      return
      end 
