      subroutine setprjop0()    ! initialize projection operators under no phason
      common /cprjop0/ prjoext0(6,6),prjoint0(6,6)
      real prjext20(6,6),prjint20(6,6),zeromtr0(6,6)
      call prjopext0(prjoext0)
      call prjopint0(prjoint0)
      call wtrmtrx6('prjoext0',prjoext0)
      call wtrmtrx6('prjoint0',prjoint0)
c      call mtmplr6(prjoext0,prjoext0,prjext20)
c      call mtmplr6(prjoint0,prjoint0,prjint20)
c      call mtmplr6(prjoext0,prjoint0,zeromtr0)
c      call wtrmtrx6('prjext20',prjext20)
c      call wtrmtrx6('prjint20',prjint20)
c      call wtrmtrx6('zeromtr0',zeromtr0)
      return
      end

      subroutine setprjop()     ! initialize projection operators under phason
      common /cprjop/ prjoext(6,6),prjoint(6,6)
      real prjext2(6,6),prjint2(6,6),zeromtr(6,6)
      call prjopext(prjoext)
      call prjopint(prjoint)
      call wtrmtrx6('prjoext',prjoext)
      call wtrmtrx6('prjoint',prjoint)
c      call mtmplr6(prjoext,prjoext,prjext2)
c      call mtmplr6(prjoint,prjoint,prjint2)
c      call mtmplr6(prjoext,prjoint,zeromtr)
c      call wtrmtrx6('prjext2',prjext2)
c      call wtrmtrx6('prjint2',prjint2)
c      call wtrmtrx6('zeromtr',zeromtr)
      return
      end

      subroutine prjext(x,xe)
      real x(*),xe(*)
      common /cprjop/ prjoext(6,6),prjoint(6,6)
      call mtmplrmno(prjoext,x,xe,6,6,1)
      return
      end

      subroutine prjint(x,xi)
      real x(*),xi(*)
      common /cprjop/ prjoext(6,6),prjoint(6,6)
      call mtmplrmno(prjoint,x,xi,6,6,1)
      return
      end

      subroutine prjext0(x,xe)
      real x(*),xe(*)
      common /cprjop0/ prjoext0(6,6),prjoint0(6,6)
      call mtmplrmno(prjoext0,x,xe,6,6,1)
      return
      end

      subroutine prjext1(x,xe)  ! projection onto ext space and normalize
      real x(*),xe(*)
      real q(6)
      common /cprjop0/ prjoext0(6,6),prjoint0(6,6)
      call mtmplrmno(prjoext0,x,xe,6,6,1)
      call getqe(xe,q)
      call norml(q,6)    ! normalize
      call getxe(q,xe)
      return
      end

      subroutine prjint0(x,xi)
      real x(*),xi(*)
      common /cprjop0/ prjoext0(6,6),prjoint0(6,6)
      call mtmplrmno(prjoint0,x,xi,6,6,1)
      return
      end

      subroutine prjopext0(pext)  ! projection operator
      real pext(6,6)
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      do i=1,6
         do j=1,6
            pext(i,j)=0
            do k=1,3
               pext(i,j)=pext(i,j)+dq(i,k)*dr(k,j)
            end do
         end do
      end do
      return
      end

      subroutine prjopint0(pint)  ! projection operator
      real pint(6,6)
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      do i=1,6
         do j=1,6
            pint(i,j)=0
            do k=4,6
               pint(i,j)=pint(i,j)+dq(i,k)*dr(k,j)
            end do
         end do
      end do
      return
      end

      subroutine prjopext(pext)  ! projection operator
      real pext(6,6)
      real drd(6,6),dqd(6,6)
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      call mtmplr6(de,dr,drd)
      call mtmplr6(dq,di,dqd)
      do i=1,6
         do j=1,6
            pext(i,j)=0
            do k=1,3
               pext(i,j)=pext(i,j)+dqd(i,k)*drd(k,j)
            end do
         end do
      end do
      return
      end

      subroutine prjopint(pint)  ! projection operator
      real pint(6,6)
      real drd(6,6),dqd(6,6)
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      call mtmplr6(de,dr,drd)
      call mtmplr6(dq,di,dqd)
      do i=1,6
         do j=1,6
            pint(i,j)=0
            do k=4,6
               pint(i,j)=pint(i,j)+dqd(i,k)*drd(k,j)
            end do
         end do
      end do
      return
      end
