      subroutine setwght(iwght)
      common /cwght/ iwghts
      iwghts=iwght
      return
      end

      subroutine getwght(iwght)
      common /cwght/ iwghts
      iwght=iwghts
      return
      end

      function wghtf(fobs,sigmf,iwght,fmin,wg,wg0,expa)
      wghtf=wghtf0(fobs,sigmf,iwght,fmin,wg,wg0)  ! old version
c     wghtf=wghtf1(fobs,sigmf,iwght,fmin,wg,wg0,expa)
      return
      end

      function wghtf1(fobs,sigmf,iwght,fmin,wg,wg0,expa)
c     weighting scheme
      if(iwght.eq.0) then       ! given weight
         wghtf1=wg*expa
      else if(iwght.eq.1) then  ! unit weight
         if(fobs.gt.fmin) then
            wghtf1=1.0*expa
         else
            wghtf1=wg0*expa
         end if
      else if(iwght.eq.2) then  ! 1/(sigmf**2)
         if(sigmf.eq.0) then    ! just for removing from the refinement
            wghtf1=0
         else
            wghtf1=expa/(sigmf**2)
         end if
      else if(iwght.eq.3) then
         if(sigmf.eq.0) then    ! just for removing from the refinement
            wghtf1=0
         else
            call geta1a2(a1,a2)
            wghtf1=expa/sqrt(sigmf**2+a1*fobs+(a2*fobs)**2)
         end if
      else
         call quit('iwght should be 0,1,2 or 3')
      end if
c     write(6,*) 'iwght,fmin,fobs,wghtf1=',iwght,fmin,fobs,wghtf1
      return
      end

      function wghtf0(fobs,sigmf,iwght,fmin,wg,wg0)
c     weighting scheme
      if(iwght.eq.0) then       ! given weight
         wghtf0=wg
      else if(iwght.eq.1) then  ! unit weight
         if(fobs.gt.fmin) then
            wghtf0=1.0
         else
            wghtf0=wg0
         end if
      else if(iwght.eq.2) then  ! 1/(sigmf**2)
         if(sigmf.eq.0) then    ! just for removing from the refinement
            wghtf0=0
         else
            wghtf0=1.0/(sigmf**2)
         end if
      else if(iwght.eq.3) then
         if(sigmf.eq.0) then    ! just for removing from the refinement
            wghtf0=0
         else
            call geta1a2(a1,a2)
            wghtf0=1.0/sqrt(sigmf**2+a1*fobs+(a2*fobs)**2)
         end if
      else
         call quit('iwght should be 0,1,2 or 3')
      end if
c     write(6,*) 'iwght,fmin,fobs,wghtf0=',iwght,fmin,fobs,wghtf0
      return
      end

