c
c     approximation for occupation domain shape
c
      integer function getreshp()
      common /creshp/ ireshp
      getreshp=ireshp
      return
      end

      subroutine setreshp(ireshpd)
      common /creshp/ ireshp
      ireshp=ireshpd
      return
      end

      integer function getapprx()
      common /capprx/ iapprx
      getapprx=iapprx
      return
      end

      subroutine setapprx(iapprxd)
      common /capprx/ iapprx
      iapprx=iapprxd
      return
      end

      subroutine prjint1(xid,xi)
      real xid(*),xi(*)
      integer getapprx
      if(getapprx().eq.1) then
         call prjint0(xid,xi)   ! projection onto internal space
      else
         call prjint(xid,xi)    ! projection onto internal space
      end if
      return
      end

      subroutine getqed1(x,q)
      real x(*),q(*)
      integer getapprx
c     write(6,*) 'getapprx()',getapprx()
      if(getapprx().eq.1) then
         call getqe(x,q)        ! rotated q vector
      else
         call getqed(x,q)       ! rotated q vector
      end if
      return
      end

      subroutine getxed1(x,q)
      real x(*),q(*)
      integer getapprx
c     write(6,*) 'getapprx()',getapprx()
      if(getapprx().eq.1) then
         call getxe(x,q)        ! rotated q vector
      else
         call getxed(x,q)       ! rotated q vector
      end if
      return
      end

      integer function polyhd(qd,n,isg) ! if qd is in n-th OD return 0 else 1
      real qd(*)
      integer getapprx,polyhd0,polyhd1
      if(getapprx().eq.1) then      ! deformation of OD neglected
         polyhd=polyhd0(qd,n,isg)   ! undeformed OD
      else
         polyhd=polyhd1(qd,n,isg)   ! reshaped OD
      end if
      return
      end

      integer function polyg(q,n,isg)
      real q(*)
      integer getapprx,polyg0,polyg1
      if(getapprx().eq.1) then    ! deformation of OD neglected
         polyg=polyg0(q,n,isg)
      else                    ! deformation of OD included
         polyg=polyg1(q,n,isg)
      end if
      return
      end
