#include <cstdio>
#include <cstring>
#include <cmath>
#include <string>

using namespace std;

extern "C" {
  void opencfile_();
  void closecfile_();
  void natomout_(int &natoms);
  void atomxyzout_(float xyz[],int &atom);
}

FILE *fptr;

void natomout_(int &natoms) { 
  fprintf(fptr,"\"No title\"\n");
  fprintf(fptr,"%d\n",natoms);
}

void atomxyzout_(float xyz[],int &atom) { 
  fprintf(fptr,"%f,%f,%f,%d\n",xyz[0],xyz[1],xyz[2],atom);
}

void opencfile_() { 
  fptr = fopen("atomxyz.mld","w");
}

void closecfile_() {
 fclose(fptr);
}

/*
main(int argc, char *argv[]) {
   if (argc != 1) {
      fprintf (stderr, "%s", "Usage: encodexyz\n\n"); 
      return 0;
   }

   float dmin = 30000;
   float dmax = 600000;
   setdminmax_(dmin,dmax);  // callable from Fortran

   int n[] ={30000, 0x8000, 50000, 0x10000, 100000, 200000,400000,600000};
   for(int i=0; i < 8; i++) {
     fprintf(stderr," %d",n[i]);
     unsigned short m = encode(n[i]);
     fprintf(stderr," %d",m);
     int l = decode(m);
     fprintf(stderr," %d\n",l);
   }

   fprintf(stderr,"\n");
   //float m[] ={30000, 64511, 63973, 63487, 62410, 59285, 53035, 46785};
   float m[] ={30000, 0x8000, 50000, 0x10000, 100000, 200000,400000,600000};

   for(int i=0; i < 8; i++) {
     fprintf(stderr," %10.1f",m[i]);  // original
     unsigned short l = encodedxyz_(m[i]);  // callable from Fortran
     fprintf(stderr," %d",l);   // encoded unsigned short
     float n = decodedxyz_(l);              // callable from Fortran
     fprintf(stderr," %10.1f\n",n);     // dcoded value
   }
}
*/
