      subroutine setdminmax(dmind,dmaxd)
      common /climit2/ dmin,dmax
      dmin=dmind
      dmax=dmaxd
      return
      end

      subroutine getdminmax(dmind,dmaxd)
      common /climit2/ dmin,dmax
      dmind=dmin
      dmaxd=dmax
      return
      end

      function ifatmi(qd,n)
      real qd(*)
      integer getish,getjob
      job=getjob()
      if(job.ne.2) then  ! atom coordinates
         if(getish(n).eq.-2) then
            ifatmi=ifatm2i(qd,n) ! for spherical OD
         else if(getish(n).eq.-1) then
            ifatmi=0             ! for elipsoidal OD
            call quit('not inplemented yet')
         else
            ifatmi=ifatm0i(qd,n) ! for polyhedral OD
         end if
      else       ! for inter atomic distances
         if(getish(n).eq.-2) then
            ifatmi=ifdst2i(qd,n) ! for spherical OD
         else if(getish(n).eq.-1) then
            ifatmi=0
            call quit('not inplemented yet')
         else
            ifatmi=ifdst0i(qd,n) ! for polyhedral OD
         end if
      end if
      return
      end

      function ifatmd(qd,n)
      real qd(*)
      integer getish,getjob
      job=getjob()
      if(job.ne.2) then
         if(getish(n).eq.-2) then
            ifatmd=ifatm2d(qd,n) ! for circuler OD
         else if(getish(n).eq.-1) then
            ifatmd=0            ! for elipsoidal OD
            call quit('not inplemented yet')
         else
            ifatmd=ifatm0d(qd,n) ! for polygonal OD
         end if
      else                      ! for inter atomic distances
         if(getish(n).eq.-2) then
            ifatmd=ifdst2d(qd,n)
         else if(getish(n).eq.-1) then
            ifatmd=0
            call quit('not inplemented yet')
         else
            ifatmd=ifdst0d(qd,n)
         end if
      end if
      return
      end

      function ifatm2i(qd,n) ! if qd in a sphare return 0 else 1
      real qd(*)
      call geta(al,am)
      r1=getramin(n)*al
      r2=getramax(n)*al
      absqd=vabs(qd(4),3)
      if(absqd.le.r1.and.absqd.ge.r2) then
         ifatm2i=0
      else
         ifatm2i=1
      end if
      return
      end

      function ifatm0i(qd,n)  ! if qd in OD of n-th atom return 0 else 1
      real qd(*)
      real q(6)
      integer polyhd,getisyd,getish
      integer getitypn
      isyd=getisyd(n)
      ra=getramax(n)
      ityp=getitypn(getish(n))
c     write(6,*) 'getish(n),ityp=',getish(n),ityp
      rimin=getrimin(n)
      rimax=getrimax(n)
      absqd=vabs(qd(4),3)
      if(absqd.gt.rimax) then
         ifatm0i=1   ! -q is out of OD
         return
      else if(ityp.eq.1.and.absqd.lt.rimin) then
         ifatm0i=0   ! -q is in OD
         return
      end if
      ifatm0i=0
      ifatm0i=polyhd(qd,n,1)
      return
      end

      function ifatm1i(q,ra,rb,ishpe)
      real q(*),ra,rb
      integer ishpe
      real cent(6),dcent(6)
      integer triach
c      common /cfatm/ nasym(2),nnsym(60,2),qg(6,60,2)
      data rat/1.3763/
c     ************vertex position
      data dcent /0., 0., 0., 0., 0., 0./
c      if atom appears in ve then ifatm1i=0
      call geta(al,am)
      rad=ra*al
      rbd=rb*al
      ifatm1i=1
      if(ishpe.eq.1) then
         call vcpyr(dcent,cent,6)
         if(triach(q,rad*rat,cent,ishpe).eq.0 .or.
     *        triach(q,rbd*rat,cent,ishpe).eq.1) return
      else
           call quit('undefined shape used')
      end if
      ifatm1i=0
      return
      end

      function ifatm2d(qd,n) ! if qd in a circle return 0 else 1
      real qd(*)
      integer getisys
      call geta(al,am)
      r1=getramin(n)*al
      r2=getramax(n)*al
      isys=getisys()
      absqd=vabs(qd(4),2)
      if(absqd.le.r1.and.absqd.ge.r2) then
         ifatm2d=0
      else
         ifatm2d=1
      end if
      return
      end

      function ifatm0d(q,n)
      real q(*)
      integer polyg,polyg0,getish,getitypn
      ityp=getitypn(getish(n))
      rimin=getrimin(n)
      rimax=getrimax(n)
      absqd=vabs(q(4),2)
c     write(6,*) 'rimax=',rimax,' absqd=',absqd
      if(absqd.gt.rimax) then
         ifatm0d=1
         return
      endif
c     if atom appears in ve then ifatm0=0
c     if approximate calculation
      ifatm0d=0
      ifatm0d=polyg(q,n,1)
      return
      end

      function ifatm1d(q,ra,rb,ishpe,nsy,icnt)
      real q(*),ra,rb
      integer ishpe,pent1,pent2
c      if atom appears in ve then ifatm1d=0
c      data ras/0.8700/
      data ras/1./
      ifatm1d=1
      call geta(al,am)
      call getout(iout)
      rad=ra*al
      rbd=rb*al
      if(ishpe.eq.0) then
           di=vabs(q(4),2)
           if(di.gt.rbd*ras.or.di.lt.rad*ras) return
      else if(ishpe.eq.1) then
           if(pent1(q,rad,nsy,icnt).eq.0 .or.
     *        pent1(q,rbd,nsy,icnt).eq.1) return
      else if(ishpe.eq.2) then
           if(pent2(q,rad,nsy,icnt).eq.0 .or.
     *        pent2(q,rbd,nsy,icnt).eq.1) return
      else
           write(iout,'(a)') 'undefined shape used'
           stop
      end if
      ifatm1d=0
      return
      end

c      function ifatm2d(q,ra,rb,ish,nsy,icnt)
c      real q(*),ra,rb
c      integer ish,nsy,decag
cc      if atom appears in ve then ifatm2=0
c      ifatm2d=1
c      call geta(al,am)
c      rad=ra*al
c      rbd=rb*al
c      if(ish.ge.1.and.ish.le.5) then
c           if(decag(q,rad,nsy,icnt,ish).eq.0 .or.
c     *        decag(q,rbd,nsy,icnt,ish).eq.1) return
c      else
c           write(6,'(a)') 'undefined shape used'
c           stop
c      end if
c      ifatm2d=0
c      return
c      end


      function ifdst2i(qd,n)  ! if n0 and n-th OD overlapp return 0 else 1
      real qd(*)
      common /climit2/ dmin,dmax
      integer getn0
      de=vabs(qd,3)          ! distance in external space
      di=vabs(qd(4),3)       ! distance in internal space
      n0=getn0()
      call geta(al,am)
      r1=getramax(n0)*al
      r2=getramax(n)*al
      rim0=r1+r2
      if(di.gt.rim0) then
         ifdst2i=1
         return
      else if(de.ge.dmin.and.de.le.dmax) then
c         write(6,*) 'r1,r2,di=',r1,r2,di
         ifdst2i=0
         vol=getvol2i(qd,n0,n,r1,r2)
         if(vol.eq.0) then
            write(6,*) 'vol=',vol
         end if
         call setvol(vol)
      else
c     inter-atomid distance too large
         ifdst2i=1
      end if
      return
      end

c     spherical domain approximation
      function ifdst0i(qd,n)  ! if n0 and n-th OD overlapp return 0 else 1
      real qd(*)
      common /climit2/ dmin,dmax
      integer getn0
      de=vabs(qd,3)          ! distance in external space
      di=vabs(qd(4),3)       ! distance in internal space
      n0=getn0()
      r1=getrimax(n0)*getramax(n0)
      r2=getrimax(n)*getramax(n)
      rim0=r1+r2
      if(di.gt.rim0) then
         ifdst0i=1
         return
      else if(de.ge.dmin.and.de.le.dmax) then
c         write(6,*) 'r1,r2,di=',r1,r2,di
         ifdst0i=0
         vol=getvol2i(qd,n0,n,r1,r2)
         if(vol.eq.0) then
            write(6,*) 'vol=',vol
         end if
         call setvol(vol)
      else
c     inter-atomid distance too large
         ifdst0i=1
      end if
      return
      end

      function ifdst0i_org(qd,n)  ! if n0 and n-th OD overlapp return 0 else 1
      real qd(*)
      common /climit2/ dmin,dmax
      integer getn0
      n0=getn0()
      rimax0=getrimax(n0)
      rimaxn=getrimax(n)
      rim0=rimax0+rimaxn
      de=vabs(qd,3)          ! distance in external space
      di=vabs(qd(4),3)       ! distance in internal space
      if(di.gt.rim0) then
c        not overlapped
         ifdst0i_org=1
      else if(de.ge.dmin.and.de.le.dmax) then
c         write(6,*) 'rimax0,rimaxn,di=',rimax0,rimaxn,di
         vol=getvol0i(qd,n0,n)
         call setvol(vol)
         if(vol.ne.0) then
c           overlapped
            ifdst0i_org=0
c            write(6,*) 'n0=',n0,' n=',n
         else
           ifdst0i_org=1
         end if
      else
c        inter-atomid distance too large
         ifdst0i_org=1
      end if
      return
      end

      function ifdst2d(qd,n)  ! if n0 and n-th OD overlapp return 0 else 1
      real qd(*)
      common /climit2/ dmin,dmax
      integer getn0
      de=vabs(qd,3)          ! distance in external space
      di=vabs(qd(4),2)       ! distance in internal space
      n0=getn0()
      call geta(al,am)
      r1=getramax(n0)*al
      r2=getramax(n)*al
      rim0=r1+r2
      if(di.gt.rim0) then
         ifdst2d=1
         return
      else if(de.ge.dmin.and.de.le.dmax) then
         ifdst2d=0
         vol=getvol2d(qd,n0,n)
         call setvol(vol)
      else
c        inter-atomid distance too large
         ifdst2d=1
      end if
      return
      end

      function ifdst0d(qd,n)  ! if n0 and n-th OD overlapp return 0 else 1
      real qd(*)
      common /climit2/ dmin,dmax
      integer getn0
      data pi /3.141592/
      n0=getn0()
      rimax0=getrimax(n0)
      rimaxn=getrimax(n)
      rim0=rimax0+rimaxn
      de=vabs(qd,3)          ! distance in external space
      di=vabs(qd(4),2)       ! distance in internal space
      if(di.gt.rim0) then
c        not overlapped
         ifdst0d=1
      else if(de.ge.dmin.and.de.le.dmax) then
         vol=getvol0d(qd,n0,n)
         call setvol(vol)
         if(vol.ne.0) then
c           overlapped
            ifdst0d=0
c            write(6,*) 'n0=',n0,' n=',n
         else
           ifdst0d=1
         end if
      else
c        inter-atomid distance too large
         ifdst0d=1
      end if
      return
      end

      function getvol2i(qd,n0,n,r1,r2)  ! common volume of n and n0 atoms in Vi
      real qd(*)
      data pi /3.141592/
      call geta(al,am)
      rim0=r1+r2
      de=vabs(qd,3)          ! distance in external space
      di=vabs(qd(4),3)       ! distance in internal space
      getvol2i=0
      if(di.le.abs(r1-r2)) then  ! r1 or r2 include r2 or r1
         r0=min(r1,r2)
         vol=4*pi*r0**3/3
         getvol2i=vol
      else if(di.le.rim0) then
c      
c     h1+h2=di
c     h1^2+r3^2=r1^2
c     h2^2+r3^2=r2^2
c     (h1-h2)*(h1+h2)=(h1-h2)*di=(r1-r2)*(r1+r2)
c     (h1-h2)=(r1-r2)*(r1+r2)/di
c     h1-(di-h1)=2*h1-di=(r1-r2)*(r1+r2)/di
c     h1=((r1-r2)*(r1+r2)/di+di)/2
c     h2=di-h1
c     r3=sqrt(r1^2-h1^2)
c     vol=pi*r3^2*(h1+h2)/3=pi*r3^3*di/3   ! vol of two cones
         h1=((r1-r2)*(r1+r2)/di+di)/2
c     write(6,*) 'h1=',h1,' r1,r2,di=',r1,r2,di
         r3=sqrt(r1**2-h1**2)
         vol1=pi*r3**2*di/3     ! sum of two cones
         sinth1=r3/r1
         sinth2=r3/r2
         costh1=sqrt(1-sinth1**2)
         costh2=sqrt(1-sinth2**2)
c     r10=sinth1
c     r20=sinth2
         r10=1-costh1
         r20=1-costh2
c     vol2=4*pi*(r1**3*r10+r2**3*r20)/3 ! sum of two solid angle volumes
         vol2=2*pi*(r1**3*r10+r2**3*r20)/3 ! sum of two solid angle volumes
         getvol2i=vol2-vol1
      end if
c     write(6,*) 'vol1,vol2,getvol2i',vol1,vol2,getvol2i
      return
      end

      function getvol0i(qd,n0,n)  ! common volume of n and n0 atoms in Vi
      real qd(*)
      real q0(6),q1(6),qn(6)
      iran=2                     ! initial random number seed
      rm=getrimax(n0)            ! radius of n0-th OD
c      write(6,*) 'rm=',rm
      call zerov(q1,6)           ! initialize q1
c     ranp(iran) homogeneous random number generator
                                 !  0 < randp < 1
      call getnsic(nsn,icn)      ! get current sym. op. for n-th OD
c     write(6,*) 'nsn,icn',nsn,icn
      getvol0i=0
      imax=25
c     imax=10
      do i=1,imax
         do j=1,imax
            do k=1,imax
               q1(4)=(ranp(iran)*2-1)*rm ! -rm < q1(4) < rm
               q1(5)=(ranp(iran)*2-1)*rm
               q1(6)=(ranp(iran)*2-1)*rm
               call vcpyr(q1,q0,6)      ! copy q1 into q0
               call negater(q0,6)       ! replace q0 with -q0
               call setnsic(1,0)        ! reset current symo. for ind. OD
               ifatm0=ifatm0i(q0,n0)
               if(ifatm0.eq.0) then
                  call vsubr(q1,qd,qn,6) ! qn=q1-qd
                  call negater(qn,6)    ! replace qn with -qn
                  call setnsic(nsn,icn) ! restore current symo.
                  ifatm1=ifatm0i(qn,n)
                  if(ifatm1.eq.0) then
                     getvol0i=getvol0i+1
                  end if
               end if
            end do
         end do
      end do
      call setnsic(nsn,icn)       ! restore current symo.      
      getvol0i=getvol0i*8*rm**3/(imax**3)
      return
      end

      function getvol2d(qd,n0,n)  ! common volume of n and n0 atoms in Vi
      real qd(*)
      data pi /3.141592/
      call geta(al,am)
      r1=getramax(n0)*al
      r2=getramax(n)*al
      rim0=r1+r2
      de=vabs(qd,3)          ! distance in external space
      di=vabs(qd(4),2)       ! distance in internal space
c      
c     h1+h2=di
c     h1^2+r3^2=r1^2
c     h2^2+r3^2=r2^2
c     (h1-h2)*(h1+h2)=(h1-h2)*di=(r1-r2)*(r1+r2)
c     (h1-h2)=(r1-r2)*(r1+r2)/di
c      h1-(di-h1)=2*h1-di=(r1-r2)*(r1+r2)/di
c      h1=((r1-r2)*(r1+r2)/di+di)/2
c      h2=di-h1
c      r3=sqrt(r1^2-h1^2)
c     vol=pi*r3^3*(h1+h2)/3=pi*r3^3*di/3
      h1=((r1-r2)*(r1+r2)/di+di)/2
      r3=sqrt(r1**2-h1**2)
      vol1=r3*di     ! sum of two triangle areas
      sinth1=r3/r1
      sinth2=r3/r2
      vol2=pi*(r1**2*asin(sinth1)+r2**2*asin(sinth2))/pi ! sum of two arc areas
      getvol2d=vol2-vol1
      return
      end

      function getvol0d(qd,n0,n) ! common volume of n and n0 atoms in Vi
      real qd(*)                 ! vector between n0 and n ODs
      real q0(6),q1(6),qn(6)
      iran=2                     ! initial random number seed
      rm=getrimax(n0)
c     write(6,*) 'rm=',rm
      call zerov(q1,6)
c     ranp(iran) homogeneous random number generator
                                !  0 < randp < 1
      call getnsic(nsn,icn)     ! get current sym. op. for n-th OD
c      write(6,*) 'nsn,icn=',nsn,icn
c     write(6,*) 'ns,ic',ns,ic
      getvol0d=0
      imax=25
c     imax=10
      do i=1,imax
         q1(4)=(ranp(iran)*2-1)*rm     ! -rm < q1(4) < rm
         do j=1,imax
            q1(5)=(ranp(iran)*2-1)*rm
            q1(6)=0
            call vcpyr(q1,q0,6)
            call negater(q0,6)
            call setnsic(1,0)   ! reset current symo. for ind. OD
            ifatm0=ifatm0d(q0,n0)
            if(ifatm0.eq.0) then
               call vsubr(q1,qd,qn,6)
               call negater(qn,6)
               call setnsic(nsn,icn) ! restore current symo.
               ifatm1=ifatm0d(qn,n)
               if(ifatm1.eq.0) then
c                  write(6,*) 'ns0,ic0',ns0,ic0
c                  write(6,*) 'nsn,icn',nsn,icn
                  getvol0d=getvol0d+1
               end if
            end if
         end do
      end do
      call setnsic(nsn,icn)       ! restore current symo.      
      getvol0d=getvol0d*4*rm**2/(imax**2)
      return
      end

c     random number generator
      function ranp(iran)
      iran=12869*iran+6925
      iran=mod(iran,2**15)
      ranp=float(iran)/2.0**15   ! 0 < ranp < 1
      return
      end
