      subroutine setndm(ndmd)
      common /cndm/ ndm
      ndm=ndmd
      return
      end

      integer function getndm()
      common /cndm/ ndm
      getndm=ndm
      return
      end

      subroutine getshfto(shift)
      real shift(6)
      include 'qcstrc.inc'
      common /cshift/ shifto(6)
      call vcpyr(shifto,shift,6)
      return
      end

      subroutine setshfto(shift)
      real shift(6)
      include 'qcstrc.inc'
      common /cshift/ shifto(6)
      call vcpyr(shift,shifto,6)
      return
      end

      function ifskip(q)
      real q(*)
      common /cskp/ q1(6),q2(6),q3(6)
      integer getisys
c     data eps/0.001/
      data eps/0.0001/
      isys=getisys()
      ifskip=1
      if(isys.le.2) then
          if(-0.58778525*q(1)+0.80901699*q(2).lt.-eps) return
          if(0.6882*q(1)+0.5*q(2)+0.5257*q(3).lt.-eps) return
          if(q(2).gt.eps) return
          if(q(3).lt.-eps) return
c          if(vinpr(q1,q,3).gt.eps) return
c          if(vinpr(q2,q,3).gt.eps) return
c          if(vinpr(q3,q,3).gt.eps) return
          ifskip=0
          return
      else if(isys.eq.3) then
c           decagonal
          if(q(3).lt.-eps) return
          if(q(2).gt.eps) return
          if(-.30901699*q(1)+0.95105652*q(2).lt.-eps) return
          ifskip=0
          return
      else if(isys.eq.-3) then
c           pentagonal
          if(q(3).lt.-eps) return
          if(q(2).gt.eps) return
          if(-.58778525*q(1)+0.80901699*q(2).lt.-eps) return
          ifskip=0
          return
      else if(isys.eq.4) then
c           octagonal
          if(q(3).lt.-eps) return
          if(q(2).gt.eps) return
          if(-.38268343*q(1)+0.92387953*q(2).lt.-eps) return
          ifskip=0
          return
      else if(isys.eq.5) then
c           dodecagonal
          if(q(3).lt.-eps) return
          if(q(2).gt.eps) return
          if(-.25881905*q(1)+0.96592583*q(2).lt.-eps) return
          ifskip=0
          return
      else
          call quit('isys invalid')
      end if 
      return
      end

      integer function decag(q,ra,nsy,icnt,ish)
      real q(*),ra,ni(6),qc(6),td(6)
      real nr
      common /cintsc/ nr(6,10,10),fx(10,10),nps(10)
      data rat/0.8090/
c     nr: normal to pentagon edge
      decag=1
      do i=1,nps(ish)
         call getrx0(nr(1,i,ish),qc,nsy,icnt)
         call getqed(qc,ni)
         absq=vabs(ni(4),2)
c**   ni : direction cosine of the normal to the boundary
         ni(4)=ni(4)/absq
         ni(5)=ni(5)/absq
c**** minus sign is necessary for qn
c     for noncentrosymmetric atoms
         qn=-(q(4)*ni(4)+q(5)*ni(5))
         if(qn.gt.ra*fx(i,ish)) return
      end do
      decag=0
      return
      end

      integer function pent1(q,ra,nsy,icnt)
      real q(*),ra,ni(6),qc(6),td(6)
      real nr(6,5),nd(6,5)
      save icount,nr
      data nd/ 1,0,0,0,0,0,
     *         0,1,0,0,0,0,
     *         0,0,1,0,0,0,
     *         0,0,0,1,0,0,
     *         0,0,0,0,1,0/
      data rat/0.8090/,icount/0/
      icount=icount+1
      if(icount.eq.1) then
         do i=1,5
            call tr6to5e(nd(1,i),nr(1,i))
         end do
      end if
c     nr: normal to pentagon edge
      pent1=1
      do i=1,5
         call getrx0(nr(1,i),qc,nsy,icnt)
         call getqed(qc,ni)
         call norml(ni(4),2)
         qn=vinpr(q(4),ni(4),2)
         if(qn.gt.ra*rat) return
      end do
      pent1=0
      return
      end

      integer function pent2(q,ra,nsy,icnt)
      real q(*),ra,ni(6),qc(6),td(6)
      real nr(6,5),nd(6,5)
      save icount,nr
      data nd/ -1,0,0,0,0,0,
     *         0,-1,0,0,0,0,
     *         0,0,-1,0,0,0,
     *         0,0,0,-1,0,0,
     *         0,0,0,0,-1,0/
      data rat/0.8090/,icount/0/
      icount=icount+1
      if(icount.eq.1) then
         do i=1,5
            call tr6to5e(nd(1,i),nr(1,i))
         end do
      end if
      pent2=1
      do i=1,5
         call getrx0(nr(1,i),qc,nsy,icnt)
         call getqed(qc,ni)
         absq=vabs(ni(4),2)
         ni(4)=ni(4)/absq
         ni(5)=ni(5)/absq
         qn=(q(4)*ni(4)+q(5)*ni(5))
         if(qn.gt.ra*rat) return
      end do
      pent2=0
      return
      end

      integer function iand(i,j)
      iand=mod(i,j*2)
      return
      end

      integer function ior(i,j)
      ior=i+j
      return
      end

      subroutine quit(str)
      character(*) str
      write(6,*) str
      close(unit=3)
      close(unit=4)
      close(unit=91)
      close(unit=92)
      stop
      end

      subroutine cntsymd(x1,ish,rc,xy,ncol)
      real xy(*)
      real x(8),y(8)
      real angl2(4),angl3(5),angl4(6),angl5(6)
      data angl2/ 0., 120., 240., 0./
      data angl3/ 0., 90., 180., 270.,0./
      data angl4/ 0., 72., 144., 216., 288., 0./
      data angl5/ 18., 162., 306., 90., 234., 18./
      data n2/4/, n3/5/, n4/6/, n5/6/, pi2/6.28318/
c********************************************************
c             circle, polyhedron or star symbol
c********************************************************
c     x1: angle in rad/6.28318   (0<=x1<=1)
c     ish: 0,1:circle, 2:triangle, 3:square, 4:pentagon, 5:star
c     rc: radius
c     xy: center of cirlce (x,y,z in plotter system)
      if(ish.eq.2) then
c     triangle
         do i=1,n2
            x(i)=1.3*rc*cos((angl2(i)/360+x1)*pi2)+xy(1)
            y(i)=1.3*rc*sin((angl2(i)/360+x1)*pi2)+xy(2)
         end do
         n=n2
      else if(ish.eq.3) then
c     square
         do i=1,n3
            x(i)=rc*cos((angl3(i)/360+x1)*pi2)+xy(1)
            y(i)=rc*sin((angl3(i)/360+x1)*pi2)+xy(2)
         end do
         n=n3
      else if(ish.eq.4) then
c     pentagon
         do i=1,n4
            x(i)=rc*cos((angl4(i)/360+x1)*pi2)+xy(1)
            y(i)=rc*sin((angl4(i)/360+x1)*pi2)+xy(2)
         end do
         n=n4
      else if(ish.eq.5) then
c     star
         do i=1,n5
            x(i)=1.5*rc*cos((angl5(i)/360+x1)*pi2)+xy(1)
            y(i)=1.5*rc*sin((angl5(i)/360+x1)*pi2)+xy(2)
         end do
         n=n5
      end if
      call fillarea(1)
      call fillcolor(ncol)
      if(ish.eq.0.or.ish.eq.1) then
         call circle(0.,360.,rc,xy,0)
      else if(ish.le.5) then
         x(n+1)=0.0
         y(n+1)=0.0
         x(n+2)=1.0
         y(n+2)=1.0
         call plylin(x,y,n,1,0,0)
      end if
      if(ncol.eq.10) then
c     write outline
         call fillarea(0)
         call linecolor(0)
         if(ish.eq.0.or.ish.eq.1) then
            call circle(0.,360.,rc,xy,0)
         else if(ish.le.5) then
            call plylin(x,y,n,1,0,0)
         end if
      end if
      return
      end

      subroutine getdet(det0)
      common /cgetd/ det
      det0=det
      return
      end

      subroutine wtbox(xmin,ymin,xmax,ymax,amag,shftx,shfty)
c      call setfont('/Helvetica-Bold-Scand')
      x1=xmin*amag
      y1=ymin*amag
      x2=xmax*amag
      y2=ymax*amag
      x0=shftx
      y0=shfty
      x3=x1/29.7+x0/29.7
      y3=y1/29.7+y0/29.7
      x4=x2/29.7+x0/29.7
      y4=y2/29.7+y0/29.7
      call window(x1,y1,x2,y2)
      call viewpt(x3,y3,x4,y4)
c     write box
      call draw(x1,y1,x1,y2)
      call draw(x1,y2,x2,y2)
      call draw(x2,y2,x2,y1)
      call draw(x2,y1,x1,y1)
      return
      end


