c
c     structural information class
c
      function getx6(n)
      include 'qcstrc.inc'
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax),b10(namax),ui0(6,namax)
      getx6=x0(6,n)
      return
      end

      subroutine setodn(jk)
      common /csetjk/ njk
      njk=jk
      return
      end
      
      integer function getodn()
      common /csetjk/ njk
      getodn=njk
      return
      end


      subroutine rdjaslct()
      include 'qcstrc.inc'
      common /cislct/ iaslct(120,namax),jaslct(namax)
      integer getna
      na=getna()
      read(5,'(80i1)') (jaslct(j),j=1,na)
      write(6,'(a,40i2/(7x,40i2))') 'jaslct=',(jaslct(j),j=1,na)
      return
      end
      
      subroutine resetjaslct()  ! reset jaslct if p0=0
      include 'qcstrc.inc'
      common /cislct/ iaslct(120,namax),jaslct(namax)
      common /cstfc2/ p0(namax),s0(2,namax),ramin0(namax),ramax0(namax)
      integer getna
      na=getna()
      do i=1,na
         if(p0(i).eq.0) then
            jaslct(i)=0
         end if
      end do
      return
      end

      subroutine rdap(na)
      include 'qcstrc.inc'
      common /cwflag/ iwflag(6)
      character(6) atom
      common /cltc/ atom(namax)
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax),b10(namax),ui0(6,namax)
      common /cstfc2/ p0(namax),s0(2,namax),ramin0(namax),ramax0(namax)
      common /crimax/ rimin(namax),rimax(namax)
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      common /copd1/ ramin00(namax),ramax00(namax)
      common /copd2/ ej0(7,nemax,namax),nej0(namax),nth0(namax),
     *     mej0(3,nemax,namax)
      common /cstfc5d/ fj(7,nemax,namax),xi0(6,namax),xe0t(6,namax)
      real xe1d(7),xe2d(7),xe3d(7),xid(7)
      real q(6),yd(6)
      real qe1(6),qe2(6),qe3(6),qi(6)
      real xjd(6)
      integer getisys,getjsimod
      data eps /0.00001/

      isys=getisys()
      call getinp(inpu)
      iwflag(3)=1
      if(iwflag(3).eq.1) then
         write(6,301) na
         write(6,'(2a)')
     *      'no symbol ien ish ne  be    bi   ramin   ramax    p',
     *      '       s1      s2'
      end if

      if(isys.ne.5) then
         nd=6
      else
         nd=7
      end if
      jsimod=getjsimod()

      do i=1,na
         read(inpu,*) ik,atom(i),ien(i),ish(i),nej(i),
     *        be0(i),bi0(i),ramin0(i),ramax0(i),p0(i),s0(1,i),s0(2,i)
         if(ish(i).ne.0.and.nej(i).gt.nemax) call quit('ne > nemax')
         call freadra('x=',6,x0(1,i),1)
         call freadra('xe1=',nd,xe1d,1)
         call freadr('u1=',1,u01(i),0)
         call freadra('xe2=',nd,xe2d,1)
         call freadr('u2=',1,u02(i),0)
         call freadra('xe3=',nd,xe3d,1)
         call freadr('u3=',1,u03(i),0)
         call freadra('xi=',nd,xid,1)
         call freadr('v=',1,v0(i),0)

         if(ish(i).eq.-1.or.ish(i).eq.0) then
            do j=1,nej(i)
               call freadra('ej=',nd,fj(1,j,i),1)
            end do
         else if(ish(i).gt.0) then  ! copy ej0 for POD
            nej(i)=nej0(ish(i))
            do j=1,nej(i)
               call vcpyr(ej0(1,j,ish(i)),fj(1,j,i),nd)
            end do
         end if

         if(ish(i).ge.0) then
            if(ish(i).eq.0) then
               call freadi('nth=',1,nth(i),1)
               isyd(i)=1
               if(nth(i).gt.nemax) call quit('nth > nemax')
               do j=1,nth(i)
                  if(isys.le.2) then
                     call freadia(' ',3,mej(1,j,i),0)
                  else
                     call freadia(' ',2,mej(1,j,i),0)
                  end if
               end do
            else
               call freadi('isyd=',1,isyd(i),1)
               nth(i)=nth0(ish(i))
               if(nth(i).eq.0) then
                  write(6,*) 'i,isyd(i)=',i,isyd(i)
                  call quit('nth(i)=0 in rdap')
               end if
               do j=1,nth(i)
                  if(isys.le.2) then
                     call vcpyi(mej0(1,j,ish(i)),mej(1,j,i),3)
                  else
                     call vcpyi(mej0(1,j,ish(i)),mej(1,j,i),2)
                  end if
               end do
            end if
         end if
         if(iwflag(3).eq.1) then
            write(6,302) ik,atom(i),ien(i),ish(i),nej(i),
     *           be0(i),bi0(i),ramin0(i),ramax0(i),p0(i),s0(1,i),
     *           s0(2,i)
            write(6,303) 'x =', (x0(j,i),j=1,6)
            if(isys.ne.5) then
               write(6,306) 'xe1=', (xe1d(j),j=1,nd),'u1=',u01(i)
               write(6,306) 'xe2=', (xe2d(j),j=1,nd),'u2=',u02(i)
               write(6,306) 'xe3=', (xe3d(j),j=1,nd),'u3=',u03(i)
               write(6,306) 'xi =', (xid(j),j=1,nd),'v= ',v0(i)
            else
               write(6,303) 'xe1=', (xe1d(j),j=1,nd),'u1=',u01(i)
               write(6,303) 'xe2=', (xe2d(j),j=1,nd),'u2=',u02(i)
               write(6,303) 'xe3=', (xe3d(j),j=1,nd),'u3=',u03(i)
               write(6,303) 'xi= ', (xid(j),j=1,nd),'v= ',v0(i)
            end if
            if(ish(i).ge.0) then
               do j=1,nej(i)
                  write(6,303) 'ej=', (fj(k,j,i),k=1,nd)
               end do
               if(isys.le.2) then
                  write(6,304) ('(',(mej(k,j,i),k=1,3),j=1,nth(i))
               else
                  write(6,305) ('(',(mej(k,j,i),k=1,2),j=1,nth(i))
               end if
               write(6,*) 'isyd=',isyd(i)
            else if(ish(i).eq.-1) then
               do j=1,nej(i)
                  write(6,303) 'ej=', (fj(k,j,i),k=1,nd)
               end do
            end if
         end if

c     ve and vi components
         call trhtole(xe1d)     ! tr6to5d etc if possible
         call trhtole(xe2d)
         call trhtole(xe3d)
         call trhtole(xid)          
         call vcpyr(xid,xi0(1,i),6)  ! store 6D coordinates
         call prjext1(xe1d,xe1(1,i)) ! projection onto external space
         call prjext1(xe2d,xe2(1,i)) ! and normalize
         call prjext1(xe3d,xe3(1,i))

*************
c         call smtrx(xid,xjd,jsimod)
c         call vcpyr(xjd,xid,6)
*************
         call prjint1(xid,xi(1,i))  ! iapprx dependent
         do j=1,6
            xe0t(j,i)=u01(i)*xe1(j,i)+u02(i)*xe2(j,i)+u03(i)*xe3(j,i)
         end do

c         call wtvctrr('xe1',xe1(1,i),6)
c         call wtvctrr('xe2',xe2(1,i),6)
c         call wtvctrr('xe3',xe3(1,i),6)
c         call wtvctrr('xi ',xi(1,i),6)
c         call getqe(xe1(1,i),qe1)
c         call getqe(xe2(1,i),qe2)
c         call getqe(xe3(1,i),qe3)
c         call getqe(xi(1,i),qi)
c         call wtvctrr('qe1',qe1,6)
c         call wtvctrr('qe2',qe2,6)
c         call wtvctrr('qe3',qe3,6)
c         call wtvctrr('qi',qi,6)

         do j=1,nej(i)
            call trhtole(fj(1,j,i)) ! high dim to low dim if possible
            call getqed1(fj(1,j,i),ej(1,j,i))  ! iapprx dependent
         end do
      end do
      if(iwflag(3).eq.1) then
         write(6,300)
      end if
 102  format(i2,a,2i2,7f8.5/(6f8.5))
 300  format(' ')
 301  format(' ','na=',i3)
 302  format(' ',i4,2x,a,2x,3i2,2x,7f8.5)
 303  format(' ',a,7f8.5,2x,a,f8.5)
 306  format(' ',a,6f8.5,2x,a,f8.5)
 304  format(' ','(e1,e2,e3)=',8(a,i2,',',i2,',',i2,')')/
     *     (' ',11x,8(a,i2,',',i2,',',i2,')')))
 305  format(' ','(e1,e2)=',10(a,i2,',',i2,')')/
     *              (' ',8x,10(a,i2,',',i2,')')))
      return
      end

      function getramin(i)
      include 'qcstrc.inc'
      common /cstrc7/ p(namax),s(2,namax),ramin(namax),ramax(namax)
      getramin=ramin(i)
      return
      end

      function getramax(i)
      include 'qcstrc.inc'
      common /cstrc7/ p(namax),s(2,namax),ramin(namax),ramax(namax)
      getramax=ramax(i)
      return
      end

      function getp(i)
      include 'qcstrc.inc'
      common /cstrc7/ p(namax),s(2,namax),ramin(namax),ramax(namax)
      getp=p(i)
      return
      end

      subroutine  gets1s2(i,s1,s2)
      include 'qcstrc.inc'
      common /cstrc7/ p(namax),s(2,namax),ramin(namax),ramax(namax)
      s1=s(1,i)
      s2=s(1,i)
      return
      end

      function getramin0(i)
      include 'qcstrc.inc'
      common /cstfc2/ p0(namax),s0(2,namax),ramin0(namax),ramax0(namax)
      getramin0=ramin0(i)
      return
      end

      function getramax0(i)
      include 'qcstrc.inc'
      common /cstfc2/ p0(namax),s0(2,namax),ramin0(namax),ramax0(namax)
      getramax0=ramax0(i)
      return
      end

      function getp0(i)
      include 'qcstrc.inc'
      common /cstfc2/ p0(namax),s0(2,namax),ramin0(namax),ramax0(namax)
      getp0=p0(i)
      return
      end

      subroutine gets1s20(i,s10,s20)
      include 'qcstrc.inc'
      common /cstfc2/ p0(namax),s0(2,namax),ramin0(namax),ramax0(namax)
      s10=s0(1,i)
      s20=s0(2,i)
      return
      end

      subroutine xtoxs(na)  ! called from main program
c     transformation of atom coordinates
      include 'qcstrc.inc'
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax),b10(namax),ui0(6,namax)
      common /cstfc2/ p0(namax),s0(2,namax),ramin0(namax),ramax0(namax)
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      common /cstfc5d/ fj(7,nemax,namax),xi0(6,namax),xe0t(6,namax)

      real xd(6),xf(6)
      common /cinnn/ innn
      integer getisys
      character brv
      call getbrv(brv)
      if(brv.ne.'s') then
         return
      end if

c     only for 's' lattice
      isys=getisys()
      do i=1,na
         if(isys.le.2) then
            call celltr(x0(1,i),1)
            ramin0(i)=ramin0(i)/2
            ramax0(i)=ramax0(i)/2
            v0(i)=v0(i)/2
         else if(isys.eq.3) then
            call celltr(x0(1,i),1)
            call celltr(xi(1,i),1)
            do j=1,nej(i)
               call celltr(fj(1,j,i),1)
               call getqe(fj(1,j,i),ej(1,j,i))
            end do
         else if(isys.eq.4) then
            call celltr(xi(1,i),innn)
            call celltr(x0(1,i),innn)
         end if
      end do
c     call setbrv('f')
      return
      end

      subroutine xstox(na)
c     transformation of atom coordinates
      include 'qcstrc.inc'
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax),b10(namax),ui0(6,namax)
      common /cstfc2/ p0(namax),s0(2,namax),ramin0(namax),ramax0(namax)
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      common /cstfc5d/ fj(7,nemax,namax),xi0(6,namax),xe0t(6,namax)

      real xd(6),xf(6)
      common /cinnn/ innn
      integer getisys
      character brv
      call getbrv(brv)
      if(brv.ne.'s') then
         return
      end if

      isys=getisys()
      if(isys.le.2) then
         do i=1,na
            call celltr(x0(1,i),-1)
            v0(i)=v0(i)*2
            ramin0(i)=ramin0(i)*2
            ramax0(i)=ramax0(i)*2
         end do
      else if(isys.eq.3) then
         do i=1,na
            call celltr(x0(1,i),-1)
            call celltr(xi(1,i),-1)
            do j=1,nej(i)
               call celltr(fj(1,j,i),-1)
               call getqe(fj(1,j,i),ej(1,j,i))
            end do
         end do
      else if(isys.eq.4) then
         do i=1,na
            call celltr(x0(1,i),-innn)
            call celltr(xi(1,i),-innn)
         end do
      end if
      return
      end

      subroutine getx0(i,x)
      real x(*)
      include 'qcstrc.inc'
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax),b10(namax),ui0(6,namax)
      call vcpyr(x0(1,i),x,6)
      return
      end

      subroutine getu0(i,u1,u2,u3)
      include 'qcstrc.inc'
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax),b10(namax),ui0(6,namax)
      u1=u01(i)
      u2=u02(i)
      u3=u03(i)
      return
      end

      function getv0(i)
      include 'qcstrc.inc'
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax),b10(namax),ui0(6,namax)
      getv0=v0(i)
      return
      end

      subroutine getx(n,xd)
      real xd(*)
      include 'qcstrc.inc'
      common /cstrc6/ x(6,namax),u1(namax),u2(namax),u3(namax),
     *     v(namax),be(namax),bi(namax),b1(namax),ui(6,namax)
      call vcpyr(x(1,n),xd,6)
      return
      end

      subroutine getu(i,u1d,u2d,u3d)
      include 'qcstrc.inc'
      common /cstrc6/ x(6,namax),u1(namax),u2(namax),u3(namax),
     *     v(namax),be(namax),bi(namax),b1(namax),ui(6,namax)
      u1d=u1(i)
      u2d=u2(i)
      u3d=u3(i)
      return
      end

      subroutine getui(i,uid)  ! get anisotropic temperature factor for i-th OD
      real uid(*)
      include 'qcstrc.inc'
      common /cstrc6/ x(6,namax),u1(namax),u2(namax),u3(namax),
     *     v(namax),be(namax),bi(namax),b1(namax),ui(6,namax)
      call vcpyr(ui(1,i),uid,6)
      return
      end

      integer function getish(i)
      include 'qcstrc.inc'
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      getish=ish(i)
      return
      end

      integer function getisyd(i)
      include 'qcstrc.inc'
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      getisyd=isyd(i)
      return
      end

      integer function getien(i)
      include 'qcstrc.inc'
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
c      if(i.lt.1.or.i.gt.namax) then
c         write(6,*) 'i in getien=',i
c         call quit(' ')
c      end if
      getien=ien(i)
      return
      end

      integer function getnth(n)
      include 'qcstrc.inc'
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      getnth=nth(n)
      return
      end

      subroutine getfj12(n,ith,fj1,fj2)
      real fj1(6),fj2(6)
      include 'qcstrc.inc'
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      common /cstfc5d/ fj(7,nemax,namax),xi0(6,namax),xe0t(6,namax)
      j1=mej(1,ith,n)
      j2=mej(2,ith,n)
      call vcpyr(fj(1,j1,n),fj1,6)
      call vcpyr(fj(1,j2,n),fj2,6)
      return
      end


      subroutine getej12(n,ith,ej1,ej2)
      real ej1(6),ej2(6)
      include 'qcstrc.inc'
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      j1=mej(1,ith,n)
      j2=mej(2,ith,n)
      call vcpyr(ej(1,j1,n),ej1,6)
      call vcpyr(ej(1,j2,n),ej2,6)
      return
      end

      subroutine getfj123(n,ith,fj1,fj2,fj3)
      real fj1(6),fj2(6),fj3(6)
      include 'qcstrc.inc'
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      common /cstfc5d/ fj(7,nemax,namax),xi0(6,namax),xe0t(6,namax)
      j1=mej(1,ith,n)
      j2=mej(2,ith,n)
      j3=mej(3,ith,n)
      call vcpyr(fj(1,j1,n),fj1,6)
      call vcpyr(fj(1,j2,n),fj2,6)
      call vcpyr(fj(1,j3,n),fj3,6)
      return
      end

      subroutine getej123(n,ith,ej1,ej2,ej3)
      real ej1(6),ej2(6),ej3(6)
      include 'qcstrc.inc'
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      j1=mej(1,ith,n)
      j2=mej(2,ith,n)
      j3=mej(3,ith,n)
      call vcpyr(ej(1,j1,n),ej1,6)
      call vcpyr(ej(1,j2,n),ej2,6)
      call vcpyr(ej(1,j3,n),ej3,6)
c      call wtrvct6('ej1',ej1)
c      call wtrvct6('ej2',ej2)
c      call wtrvct6('ej3',ej1)
      return
      end

      subroutine getxe123(i,xe1d,xe2d,xe3d)
      real xe1d(*),xe2d(*),xe3d(*)
      include 'qcstrc.inc'
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      call vcpyr(xe1(1,i),xe1d,6)
      call vcpyr(xe2(1,i),xe2d,6)
      call vcpyr(xe3(1,i),xe3d,6)
      return
      end

      subroutine getxi(n,xid)
      real xid(*)
      include 'qcstrc.inc'
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      call vcpyr(xi(1,n),xid,6)
      return
      end

      subroutine getxi0(n,xid)  ! 6D expres. of xi
      real xid(*)
      include 'qcstrc.inc'
      common /cstfc5d/ fj(7,nemax,namax),xi0(6,namax),xe0t(6,namax)
      call vcpyr(xi0(1,n),xid,6)
      return
      end

      subroutine getxe0t(n,xet)  ! 6D expres. of shift
      real xet(*)
      include 'qcstrc.inc'
      common /cstfc5d/ fj(7,nemax,namax),xi0(6,namax),xe0t(6,namax)
      call vcpyr(xe0t(1,n),xet,6)
      return
      end

      subroutine setrimin(n,rimind)
      include 'qcstrc.inc'
      common /crimax/ rimin(namax),rimax(namax)
      rimin(n)=rimind
      return
      end

      subroutine setrimax(n,rimaxd)
      include 'qcstrc.inc'
      common /crimax/ rimin(namax),rimax(namax)
      rimax(n)=rimaxd
      return
      end

      function getrimin(n)
      include 'qcstrc.inc'
      common /crimax/ rimin(namax),rimax(namax)
      getrimin=rimin(n)
      return
      end

      function getrimax(n)
      include 'qcstrc.inc'
      common /crimax/ rimin(namax),rimax(namax)
      getrimax=rimax(n)
      return
      end

      subroutine getx00(x00)
      real x00(6,*)
      real x0(6)
      real xe1(6),xe2(6),xe3(6),xi(6)
      integer getna
      na=getna()
      do n=1,na
         call getx0(n,x0)
         call getu0(n,u01,u02,u03)
         v0=getv0(n)
         call getxe123(n,xe1,xe2,xe3)
         call getxi(n,xi)
         do j=1,6
            x00(j,n)=x0(j)+u01*xe1(j)+u02*xe2(j)+u03*xe3(j)+v0*xi(j)
         end do
      end do
      return
      end

      subroutine getrq00d(n,ns,ic,rq00)  ! get q for rotated x under phason
      real rq00(6)
      call getrq00d_1(n,ns,ic,rq00)  ! get q for rotated x under phason
      return
      end

      subroutine getrq00d_0(n,ns,ic,rq00)  ! get q for rotated x under phason
      real rq00(6)
      real x(6),rx0(6)
      call getx(n,x)
      call getrx(x,rx0,ns,ic)   ! rotate x0     
      call getqed(rx0,rq00)     ! rotated q vector
      return
      end

      subroutine getrq00d_1(n,ns,ic,rq00)  ! get q for rotated x under phason
      real rq00(6)
      real x0(6),rx0(6)
      real xet(6),rxet(6)
      real xi(6),rxi(6),rxid(6)
      real qet(6),rqet(6),rq0(6),rqi(6)
      call getx0(n,x0)             ! get center of large OD in 6D
      call getrx(x0,rx0,ns,ic)     ! rotate x0
      call getqed(rx0,rq0)         ! rotated q vector

      call getxe0t(n,xet)          ! xet under no phason
      call getqe(xet,qet)          ! q vector under no phason
      call zerovr(qet(4),3)        ! zero internal component
      call getrx0i(qet,rqet,ns,ic) ! rotated q vector

c     rqet is regarded as external component under phason
      call getxi0(n,xi)            ! 6D xi
      call getrx(xi,rxi,ns,ic)     ! rotated xi
      call getqed1(rxi,rqi)        ! rotated q  (iapprx dependent)
      call zerovr(rqi,3)           ! zero external component
      v0=getv0(n)
      do j=1,6
         rq00(j)=rq0(j)+rqet(j)+v0*rqi(j)
      end do

      return
      end

      subroutine getrx00d(n,ns,ic,rx00)   ! for phason strain
      real rx00(6)
      real rq00(6)
      real x0(6),rx0(6)
      real xet(6),rxet(6)
      real xi(6),rxi(6),rxid(6)
      real qet(6),rqet(6),rq0(6),rqi(6)
      call getx0(n,x0)
      call getrx(x0,rx0,ns,ic)
      call getqed(rx0,rq0)         ! center of large OD

      call getxe0t(n,xet)          ! xet under no phason
      call getqe(xet,qet)          ! q vector under no phason
      call getrx0i(qet,rqet,ns,ic) ! rotate q vector
c     rqet is regarded as external component under phason
c      call getxed1(rqet,rxet)      ! rxet under phason
      call getxe(rqet,rxet)        ! rxet under phason

c     call wtvctrrf('rxet=',rxet,6,'(6f10.5)')
      call prjint1(rxi,rxid)    ! projection onto internal space under phason
c      call wtvctrrf('xet=',xet,6,'(6f10.5)')
c      call wtvctrrf('rx0=',rx0,6,'(6f10.5)')
c      call wtvctrrf('rxet=',rxet,6,'(6f10.5)')
c      call wtvctrrf('rxid=',rxid,6,'(6f10.5)')
      v0=getv0(n)
      do j=1,6
         rx00(j)=rx0(j)+rxet(j)+v0*rxid(j)
      end do
      return
      end

      subroutine setna(nad)
      common /cnapod/ na, npod
      na=nad
      return
      end

      integer function getna()
      common /cnapod/ na, npod
      getna=na
      return
      end

      subroutine prmtbl(df,ny)
      real df(*)
      call prmtbl1(df,ny)
      return
      end

      subroutine prmtbl0(df,ny)
      real df(*)
      include 'qcstrc.inc'
      common /cpwint/ ips(0:nxprm),ipt(0:40*idsmax),nlc
      common /cstfc5/ jz(nxprm),ja(2,nxprm*jzm),ea(nxprm*jzm)
      common /cstrc6/ x(6,namax),u1(namax),u2(namax),u3(namax),
     *     v(namax),be(namax),bi(namax),b1(namax),ui(6,namax)
      common /cstrc7/ p(namax),s(2,namax),ramin(namax),ramax(namax)
      character(6) wx(18)
      integer idf(18)
      integer getitempfi,getna
      na=getna()
      write(6,'(a,7x,10(a,10x),2(a,8x))')
     *     ' atom','u1','u2','u3','be','b1','bi','p ','s1','s2',
     *     'v','ramin','ramax'
      do i=1,na
         if(getitempfi(i).eq.1) then
            call getwx(wx,i,df,ny)
            call getwx(wx,i,df,ny)
            if(getitempfi(i).eq.1) then
               be(i)=getbeq(i,ui(1,i)) ! equivalent temp. fac.
            end if
            write(6,'((i3,2x,10(f6.2,a),2(f8.4,a)))')
     *           i,u1(i),wx(1),u2(i),wx(2),u3(i),wx(3),be(i),wx(4),
     *           b1(i),wx(5),bi(i),wx(6),p(i),wx(7),s(1,i),wx(8),s(2,i),
     *           wx(9),v(i),wx(10),ramin(i),wx(11),ramax(i),wx(12)
         end if
      end do
      return
      end

      subroutine prmtbl1(df,ny)
      real df(*)
      include 'qcstrc.inc'
      common /cpwint/ ips(0:nxprm),ipt(0:40*idsmax),nlc
      common /cstfc5/ jz(nxprm),ja(2,nxprm*jzm),ea(nxprm*jzm)
      common /cstrc6/ x(6,namax),u1(namax),u2(namax),u3(namax),
     *     v(namax),be(namax),bi(namax),b1(namax),ui(6,namax)
      common /cstrc7/ p(namax),s(2,namax),ramin(namax),ramax(namax)
      character(6) wx(18)
      integer getitempfi,getna
      na=getna()
      write(6,'(a,7x,10(a,10x),2(a,8x))')
     *     ' atom','u1','u2','u3','be','b1','bi','p ','s1','s2',
     *     'v','ramin','ramax'

      do i=1,na
         call getwx(wx,i,df,ny)
         if(getitempfi(i).eq.1) then
            be(i)=getbeq(i,ui(1,i)) ! equivalent temp. fac.
         end if
         write(6,'((i3,2x,10(f6.2,a),2(f8.4,a)))')
     *        i,u1(i),wx(1),u2(i),wx(2),u3(i),wx(3),be(i),wx(4),
     *        b1(i),wx(5),bi(i),wx(6),p(i),wx(7),s(1,i),wx(8),s(2,i),
     *        wx(9),v(i),wx(10),ramin(i),wx(11),ramax(i),wx(12)
      end do
      write(6,'(a,7x,8(a,11x))') ' atom','u11','u22','u33','u23','u31',
     *     'u12'
      do i=1,na
         if(getitempfi(i).eq.1) then
            call getwx(wx,i,df,ny)
            be(i)=getbeq(i,ui(1,i)) ! equivalent temp. fac.
            write(6,'(i3,2x,6(f8.4,a))')
     *           i,ui(1,i),wx(13),ui(2,i),wx(14),ui(3,i),wx(15),
     *           ui(4,i),wx(16),ui(5,i),wx(17),ui(6,i),wx(18)
         end if
      end do
      return
      end


      subroutine getwx(wx,i,df,ny)
      character(6) wx(*)
      real df(*)
      include 'qcstrc.inc'
      common /cips/ ips(0:nxprm)
      common /cipt/ ipt(0:40*idsmax),nlc
      common /cstfc5/ jz(nxprm),ja(2,nxprm*jzm),ea(nxprm*jzm)
      integer idf(18)
      nwx=18
      do j=1,nwx
         wx(j)='(----)'
         idf(j)=0
      end do
      n0=0
      do l=1,ny
         if(ips(l) .eq. 1) then
            do k=1,jz(l)
               n=n0+k
               ii=ja(1,n)
               j=ja(2,n)
               if(ii .eq. i) then
                  if(j.le.10) then
                     idf(j)=idf(j)+df(l)*ea(n)*100
                     write(wx(j),'(a,i4,a)') '(',idf(j),')'
                  else
                     idf(j)=idf(j)+df(l)*ea(n)*10000
                     write(wx(j),'(a,i4,a)') '(',idf(j),')'
                  end if
               end if
            end do
         end if
         n0=n0+jz(l)
      end do
      return
      end

      subroutine seticont(icontd)  ! set icont for setxbp
      common /cicont/ icont
      icont=icontd
      return
      end

      integer function geticont()  ! set icont for setxbp
      common /cicont/ icont
      geticont=icont
      return
      end

      subroutine setxbp(z,ny)
      real z(*)
c     call setxbp0(z,ny)
      call setxbp1(z,ny)
      return
      end

      subroutine setxbp0(z,ny)
      real z(*)
      include 'qcstrc.inc'
      common /cpwint/ ips(0:nxprm),ipt(0:40*idsmax),nlc
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax),b10(namax),ui0(6,namax)
      common /cstfc2/ p0(namax),s0(2,namax),ramin0(namax),ramax0(namax)
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      common /cstfc5/ jz(nxprm),ja(2,nxprm*jzm),ea(nxprm*jzm)
      common /cstrc6/ x(6,namax),u1(namax),u2(namax),u3(namax),
     *     v(namax),be(namax),bi(namax),b1(namax),ui(6,namax)
      common /cstrc7/ p(namax),s(2,namax),ramin(namax),ramax(namax)
      common /cstfc5d/ fj(7,nemax,namax),xi0(6,namax),xe0t(6,namax)
      integer getna
      na=getna()
      do i=1,na
         u1(i)=u01(i)
         u2(i)=u02(i)
         u3(i)=u03(i)
         v(i)=v0(i)
         be(i)=be0(i)
         bi(i)=bi0(i)
         b1(i)=b10(i)
         ramin(i)=ramin0(i)
         ramax(i)=ramax0(i)
         p(i)=p0(i)
         s(1,i)=s0(1,i)
         s(2,i)=s0(2,i)
      end do
      n=0
      do l=1,ny
         do k=1,jz(l)
            n=n+1
            i=ja(1,n)
            j=ja(2,n)
            if(j.eq.1) then
               u1(i)=u1(i)+z(l)*ea(n)
            else if(j.eq.2) then
               u2(i)=u2(i)+z(l)*ea(n)
            else if(j.eq.3) then
               u3(i)=u3(i)+z(l)*ea(n)
            else if(j.eq.4) then
               be(i)=be(i)+z(l)*ea(n)
            else if(j.eq.5) then
               b1(i)=b1(i)+z(l)*ea(n)
            else if(j.eq.6) then
               bi(i)=bi(i)+z(l)*ea(n)
            else if(j.eq.7) then
               p(i)=p(i)+z(l)*ea(n)
            else if(j.eq.8) then
               s(1,i)=s(1,i)+z(l)*ea(n)
            else if(j.eq.9) then
               s(2,i)=s(2,i)+z(l)*ea(n)
            else if(j.eq.10) then
               v(i)=v(i)+z(l)*ea(n)
            else if(j.eq.11) then
               ramin(i)=ramin(i)+z(l)*ea(n)
            else if(j.eq.12) then
               ramax(i)=ramax(i)+z(l)*ea(n)
            end if
         end do
      end do
      call setnewx(i)
      return
      end

      subroutine setxbp1(z,ny)
      real z(*)
      include 'qcstrc.inc'
      common /cips/ ips(0:nxprm)
      common /cipt/ ipt(0:40*idsmax),nlc
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax),b10(namax),ui0(6,namax)
      common /cstfc2/ p0(namax),s0(2,namax),ramin0(namax),ramax0(namax)
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      common /cstfc5/ jz(nxprm),ja(2,nxprm*jzm),ea(nxprm*jzm)
      common /cstrc6/ x(6,namax),u1(namax),u2(namax),u3(namax),
     *     v(namax),be(namax),bi(namax),b1(namax),ui(6,namax)
      common /cstrc7/ p(namax),s(2,namax),ramin(namax),ramax(namax)
      common /cstfc5d/ fj(7,nemax,namax),xi0(6,namax),xe0t(6,namax)
      integer getitempf,getitempfi,getna,geticont
      itempf=getitempf()
      icont=geticont()
      na=getna()
c      call wtvctrr('xe1=',xe1,6)
c      call wtvctrr('xe2=',xe2,6)
c      call wtvctrr('xe3=',xe3,6)
c      call wtvctrr('xi =',xi,6)
c      stop
c      call wtvctrr('z=',z,ny)
c      write(6,*) 'itempfi=',(getitempfi(i),i=1,na)
c      write(6,'(8e14.6)') (z(j),j=1,ny)
      do i=1,na
         u1(i)=u01(i)
         u2(i)=u02(i)
         u3(i)=u03(i)
         v(i)=v0(i)
         be(i)=be0(i)
         b1(i)=b10(i)
         bi(i)=bi0(i)
         ramin(i)=ramin0(i)
         ramax(i)=ramax0(i)
         p(i)=p0(i)
         s(1,i)=s0(1,i)
         s(2,i)=s0(2,i)
         itempfi=getitempfi(i)
         if(itempf.eq.1) then
            be(i)=be0(i)
            b1(i)=b10(i)
c         else
            call vcpyr(ui0(1,i),ui(1,i),6) ! ui calculated from bi0
         end if
      end do

c     if(icont.eq.1) then
      n=0
      do l=1,ny
         do k=1,jz(l)
            n=n+1
            i=ja(1,n)
            j=ja(2,n)
            if(j .eq. 1) then
               u1(i)=u1(i)+z(l)*ea(n)
            else if(j .eq. 2) then
               u2(i)=u2(i)+z(l)*ea(n)
            else if(j .eq. 3) then
               u3(i)=u3(i)+z(l)*ea(n)
            else if(j .eq. 4) then
               be(i)=be(i)+z(l)*ea(n)
            else if(j .eq. 5) then
               b1(i)=b1(i)+z(l)*ea(n)
            else if(j .eq. 6) then
               bi(i)=bi(i)+z(l)*ea(n)
            else if(j .eq. 7) then
               p(i)=p(i)+z(l)*ea(n)
            else if(j .eq. 8) then
               s(1,i)=s(1,i)+z(l)*ea(n)
            else if(j .eq. 9) then
               s(2,i)=s(2,i)+z(l)*ea(n)
            else if(j .eq. 10) then
               v(i)=v(i)+z(l)*ea(n)
            else if(j .eq. 11) then
               ramin(i)=ramin(i)+z(l)*ea(n)
            else if(j .eq. 12) then
               ramax(i)=ramax(i)+z(l)*ea(n)
            else if(j .ge. 13 .and. j .le. 18) then
               ui(j-12,i)=ui(j-12,i)+z(l)*ea(n)
            end if
         end do
      end do
c      end if

c     calculate equivalent aniso or isotropic temperature factors
c     for display
      do i=1,na
c        write(6,*) 'u1(i),u2(i),u3(i)',u1(i),u2(i),u3(i)
c        call wtvctrrf('xe1(1,i)',xe1(1,i),6,'(6f10.5)')
c        call wtvctrrf('xe2(1,i)',xe2(1,i),6,'(6f10.5)')
c        call wtvctrrf('xe3(1,i)',xe3(1,i),6,'(6f10.5)')
         itempfi=getitempfi(i)
         if(itempf.eq.1) then
            if(itempfi.eq.0) then
               call getbtoui(i,be(i),ui(1,i))  ! equivalent ui
            else
               be(i)=getbeq(i,ui(1,i))         ! equivalent beq
            end if
         end if
c        call wtvctrrf('ui=',ui(1,i),6,'(6f10.5)')
         call setnewx(i)
      end do
c     stop
      return
      end

      subroutine setnewx(i)
      include 'qcstrc.inc'
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax),b10(namax),ui0(6,namax)
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      common /cstrc6/ x(6,namax),u1(namax),u2(namax),u3(namax),
     *     v(namax),be(namax),bi(namax),b1(namax),ui(6,namax)
      common /cstfc5d/ fj(7,nemax,namax),xi0(6,namax),xe0t(6,namax)
      real q(6)
      do j=1,6
         xe0t(j,i)=u1(i)*xe1(j,i)+u2(i)*xe2(j,i)+u3(i)*xe3(j,i)
      end do
      do j=1,6
         x(j,i)=x0(j,i)+xe0t(j,i)+v(i)*xi(j,i)
      end do
      call getqe(xe0t(1,i),q)
c     write(6,'(i3,a,f10.5)') i,' vabs(q(xe0t))=',vabs(q,3)
      return
      end

      subroutine settmp2x(z,ny)  ! be and uij to z==x
      real z(*)
      include 'qcstrc.inc'
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax),b10(namax),ui0(6,namax)
      common /cstfc5/ jz(nxprm),ja(2,nxprm*jzm),ea(nxprm*jzm)
      common /cstrc6/ x(6,namax),u1(namax),u2(namax),u3(namax),
     *     v(namax),be(namax),bi(namax),b1(namax),ui(6,namax)
      common /cstrc7/ p(namax),s(2,namax),ramin(namax),ramax(namax)
      integer getitempf,getitempfi
      if(getitempf().eq.0) then
         return
      end if
      n=1
      do l=1,ny
         i=ja(1,n)
         j=ja(2,n)
         itempfi=getitempfi(i)
         if(itempfi.eq.1) then
            if(j.eq.4) then
               bei=getbeq(i,ui(1,i))     ! equivalent b
               z(l)=(bei-be0(i))/ea(n)   ! difference
            end if
         else if(itempfi.eq.0) then
            if(j .ge. 13 .and. j .le. 18) then
               jd=j-12
               z(l)=(ui(jd,i)-ui0(jd,i))/ea(n)
            end if
         end if
         n=n+jz(l)
      end do
      return
      end

      subroutine rdintl(z,nx)   ! set itempf
      real z(*)
      include 'qcstrc.inc'
      common /const/ pai2,jk(14)
      common /ctorms0/ job,ids,mthd(idsmax)
      common /cbackg/ pb(0:12,idsmax), dpb(12,idsmax), zps(2,idsmax)
      common /cstfc5/ jz(nxprm),ja(2,nxprm*jzm),ea(nxprm*jzm)
      integer itempfi(namax)
      integer getna
c          z(*)    : independent parameter
c          ja(2,*) : u,v,be,bi,ramin,ramax,p,s1,s2 for 1-9
c          jz(*) : number of corrlated parameters
c          ja(1,*) : atom number
c          ea(*)   : coefficient
      call freadi('itempf=',1,itempf,1)   ! for temperature factor
      call setitempf(itempf)
      call freadi('nx=',1,nx,1)
      write(6,*) ' independent structural parameters'
      if(nx.ne.0) then
          jk(1)=1
          jk(14)=nx
      else
          jk(1)=0
          jk(14)=0
      end if
      l=0
      do i=1,nx
         call freadr('z=',1,z(i),1)
         call freadi('jz=',1,jz(i),0)
         if(jz(i).gt.jzm) call quit('jz > jzm')
         do j=1,jz(i)
            call freadi(' ',1,ja(1,l+j),0)
            call freadi(' ',1,ja(2,l+j),0)
            call freadr(' ',1,ea(l+j),0)
         end do
         write(6,'(a,i3,1x,f8.4,5(2i3,f8.4)/(12x,5(2i3,f8.4)))')
     *        '#',i,z(i),((ja(j,l+k),j=1,2),ea(l+k),k=1,jz(i))
         l=l+jz(i)
         if(l.gt.namax*10) call quit('nzc > namax*10')
c     if(l.gt.nxprm) call quit('nzc > nxprm')
      end do
      return
      end

      subroutine ificont(z,ny,flnm3)
      real z(*)
      character(*) flnm3
c     set ui equivalent to B or Beq equivalent to ui
      call freadi('icont=',1,icont,1)
      call freadc('flnm3=',1,flnm3,1)
      write(6,*) 'icont=',icont
      call seticont(icont)      ! set icont for setxbp

      if(icont.eq.1) then       ! read independent parameters from a file
         call openfile(4,flnm3,'OLD')
         read(4,212) (z(j),j=1,ny)
c        write(6,212)  (z(j),j=1,ny)
 212     format(8e14.6)
      else
         call openfile(4,flnm3,'UNKNOWN')
      end if
      return
      end

      subroutine setequi0()   ! initial equivalent temp. factors
      include 'qcstrc.inc'
      common /const/ pai2,jk(14)
      common /ctorms0/ job,ids,mthd(idsmax)
      common /cbackg/ pb(0:12,idsmax), dpb(12,idsmax), zps(2,idsmax)
      common /cstfc5/ jz(nxprm),ja(2,nxprm*jzm),ea(nxprm*jzm)
      integer itempfi(namax)
      integer getna,getitempf
      itempf=getitempf()
      if(itempf.eq.1) then
         na=getna()
         if(itempf.eq.1) then
            read(5,'(80i1)') (itempfi(j),j=1,na)
         else
            call zerovi(itempfi,na)
         end if
         call setitempfi(itempfi)
         call setui0(na)      ! set equivalent ui
      else
         call setitempfi0()   ! use isotropic temp. fac. for all atoms
      end if
      return
      end

      subroutine setui0(na)   ! set ui0 equivalent to isotropic be
      include 'qcstrc.inc'
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax),b10(namax),ui0(6,namax)
      do n=1,na
         call getbtoui(n,be0(n),ui0(1,n))
      end do
      return
      end

      subroutine getni()
      include 'qcstrc.inc'
      real ni(0:6,4,nemax,namax),mpl(namax)
      integer isk(0:120,namax),irs(0:120,namax),hc(6)
      common /cislct/ iaslct(120,namax),jaslct(namax)
      common /toatm/ ni,mpl,isk,irs,hc,abszc,qimax(namax)

      integer getisys,getna
      isys=getisys()
      na=getna()
      write(6,*) 'isys=',isys,' na=',na
      if(isys.le.2) then
c        get plane normal of each tetrahedral domain and rimin
         call getnii(na,ni)
c        call getnii0(na,ni)
      else if(isys.ge.3) then
c        get plane normal of each triangular domain and rimin 
         call getnid(na,ni)
      else
         call quit('invalid isys in getni')
      end if
      return
      end

      subroutine getnii(na,ni)  ! setrimin  for icosahedral
c     get normal to the plane of a tetrahedron and rimin
      include 'qcstrc.inc'
      real ni(0:6,4,nemax,*)
      real ej1(6),ej2(6),ej3(6)
      integer getnth,getish
      real td(6),cent(6)
      data eps/0.00001/, td/6*0./
c     unit vector along ej and
c     normal to the boundary plane defined by ej(*,i), ej(*,i+1)
      do i=1,na
         nth=getnth(i)
         ish=getish(i)
         if(ish.gt.0) then
            if(nth.eq.0) then
               write(6,*) 'i,nth(i)=',i,nth
               call quit('nth=0 in getnii')
            end if
            
            do j=1,nth
               call getej123(i,j,ej1,ej2,ej3)
               call getnii1(ej1,ej2,ej3,ni(0,1,j,i),sig)
               ri=vinpr(ej1(4),ni(4,4,j,i),3)*getramax0(i)
               rj=max(vabs(ej1(4),3),vabs(ej2(4),3),vabs(ej3(4),3))*
     *              getramax0(i)
               if(j.eq.1) then
                  call setrimin(i,ri)
                  call setrimax(i,rj)
               else
                  rimind=min(getrimin(i),ri)
                  rimaxd=max(getrimax(i),rj)
                  call setrimin(i,rimind)
                  call setrimax(i,rimaxd)
               end if
            end do
c            write(6,'(a,i3,2(a,f10.5))') 'atom=',i,' rimin=',
c     *           getrimin(i),' rimax=',getrimax(i)
c            write(6,'(a,i3,2(a,f10.5))') 'atom=',i,' ramin=',
c     *           getramin0(i),' ramax=',getramax0(i)
         else
c            write(6,'(a,i3,2(a,f10.5))') 'atom=',i,' ramin=',
c     *           getramin0(i),' ramax=',getramax0(i)
         end if
      end do
      return
      end

      subroutine getnii0(na,ni)
c     get normal to the plane of a tetrahedron and rimin
      include 'qcstrc.inc'
      real ni(0:6,4,nemax,*)
      real ej1(6),ej2(6),ej3(6)
      real td(6),cent(6)
      real ejl(6)
      integer getnth
      data eps/0.00001/, td/6*0./
c     unit vector along ej and
c     normal to the boundary plane defined by ej(*,i), ej(*,i+1)
      do i=1,na
         nth=getnth(i)
         if(nth.eq.0) then
            write(6,*) 'i,nth=',i,nth
            call quit('nth=0 in getnii')
         end if
         do j=1,nth
            call getej123(i,j,ej1,ej2,ej3)
            if(j.gt.nemax) then
               call quit('nth > nemax')
            end if
c     normal to the plane trough 0, ej2,ej1 etc.
            call pnrml1(ej2,ej1,ni(0,1,j,i))
            call pnrml1(ej3,ej2,ni(0,2,j,i))
            call pnrml1(ej1,ej3,ni(0,3,j,i))
c     normal to the plane throug ej(j1) ej(j2) ej(j3)
            call pnrml2(ej1,ej2,ej3,ni(0,4,j,i))
            rimind=vinpr(ej1(4),ni(4,4,j,i),3)*getramax0(i)
c            write(6,*) 'rimind,ramax0(i)',rimind,getramax0(i)
            if(j.eq.1) then
               call setrimin(i,rimind)
            else
               rimind=min(getrimin(i),rimind)
               call setrimin(i,rimind)
            end if

            do l=1,3
               if(l.eq.1) then
                  call vcpyr(ej1,ejl,6)
               else if(l.eq.2) then
                  call vcpyr(ej2,ejl,6)
               else if(l.eq.3) then
                  call vcpyr(ej3,ejl,6)
               end if
               do k=4,6
                  cent(k)=ejl(k)-(ej1(k)+ej2(k)+ej3(k))/3
               end do
               if(vinpr(cent(4),ni(4,l,j,i),3).gt.0.) then
                  sig=1.
               else
                  sig=-1.
               end if
               do k=4,6     ! Dec. 25, 1977
                  ni(k,l,j,i)=ni(k,l,j,i)*sig
               end do
            end do
c     write(6,*) 'ni(1)=',(ni(jj,1,j,i),jj=4,6)
c     write(6,*) 'ni(2)=',(ni(jj,2,j,i),jj=4,6)
c     write(6,*) 'ni(3)=',(ni(jj,3,j,i),jj=4,6)
c     write(6,*) 'ni(4)=',(ni(jj,4,j,i),jj=4,6)
         end do
         write(6,'(a,i3,a,f10.5)') 'atom=',i,' rimin=',getrimin(i)
      end do
      return
      end

      subroutine setisk0(i,iskd)
      integer iskd(0:120)
      include 'qcstrc.inc'
      real ni(0:6,4,nemax,namax),mpl(namax)
      integer isk(0:120,namax),irs(0:120,namax),hc(6)
      common /toatm0/ ni,mpl,isk,irs,hc,abszc,qimax(namax)
      call vcpyi(iskd,isk(0,i),121)
      return
      end

      subroutine getisk0(i,iskd)
      integer iskd(0:120)
      include 'qcstrc.inc'
      real ni(0:6,4,nemax,namax),mpl(namax)
      integer isk(0:120,namax),irs(0:120,namax),hc(6)
      common /toatm0/ ni,mpl,isk,irs,hc,abszc,qimax(namax)
      call vcpyi(isk(0,i),iskd,121)
c     write(6,*) 'i,iskd(0)',i,iskd(0)
      return
      end

      subroutine setirs0(i,irsd)  ! set site symmetry operations for i-atom
      integer irsd(0:120)
      include 'qcstrc.inc'
      real ni(0:6,4,nemax,namax),mpl(namax)
      integer isk(0:120,namax),irs(0:120,namax),hc(6)
      common /toatm0/ ni,mpl,isk,irs,hc,abszc,qimax(namax)
      call vcpyi(irsd,irs(0,i),121)
      return
      end

      subroutine getirs0(i,irsd)  ! get site symmetry operations for i-atom
      integer irsd(0:120)
      include 'qcstrc.inc'
      real ni(0:6,4,nemax,namax),mpl(namax)
      integer isk(0:120,namax),irs(0:120,namax),hc(6)
      common /toatm0/ ni,mpl,isk,irs,hc,abszc,qimax(namax)
      call vcpyi(irs(0,i),irsd,121)
      return
      end

      subroutine setmpl0(i,mpld)  ! set multiplicity for i-atom
      real mpld
      include 'qcstrc.inc'
      real ni(0:6,4,nemax,namax),mpl(namax)
      integer isk(0:120,namax),irs(0:120,namax),hc(6)
      common /toatm0/ ni,mpl,isk,irs,hc,abszc,qimax(namax)
      mpl(i)=mpld
      return
      end

      function getmpl0(i)         ! get multiplicity for i-atom
      real mpld
      include 'qcstrc.inc'
      real ni(0:6,4,nemax,namax),mpl(namax)
      integer isk(0:120,namax),irs(0:120,namax),hc(6)
      common /toatm0/ ni,mpl,isk,irs,hc,abszc,qimax(namax)
      getmpl0=mpl(i)
      return
      end

      subroutine setisk(i,iskd)
      integer iskd(0:120)
      include 'qcstrc.inc'
      real ni(0:6,4,nemax,namax),mpl(namax)
      integer isk(0:120,namax),irs(0:120,namax),hc(6)
      common /toatm/ ni,mpl,isk,irs,hc,abszc,qimax(namax)
      call vcpyi(iskd,isk(0,i),121)
      return
      end

      subroutine getisk(i,iskd)
      integer iskd(0:120)
      include 'qcstrc.inc'
      real ni(0:6,4,nemax,namax),mpl(namax)
      integer isk(0:120,namax),irs(0:120,namax),hc(6)
      common /toatm/ ni,mpl,isk,irs,hc,abszc,qimax(namax)
      call vcpyi(isk(0,i),iskd,121)
c     write(6,*) 'i,iskd(0)',i,iskd(0)
      return
      end

      subroutine setirs(i,irsd)  ! set site symmetry operations for i-atom
      integer irsd(0:120)
      include 'qcstrc.inc'
      real ni(0:6,4,nemax,namax),mpl(namax)
      integer isk(0:120,namax),irs(0:120,namax),hc(6)
      common /toatm/ ni,mpl,isk,irs,hc,abszc,qimax(namax)
      call vcpyi(irsd,irs(0,i),121)
      return
      end

      subroutine getirs(i,irsd)  ! get site symmetry operations for i-atom
      integer irsd(0:120)
      include 'qcstrc.inc'
      real ni(0:6,4,nemax,namax),mpl(namax)
      integer isk(0:120,namax),irs(0:120,namax),hc(6)
      common /toatm/ ni,mpl,isk,irs,hc,abszc,qimax(namax)
      call vcpyi(irs(0,i),irsd,121)
      return
      end

      subroutine setmpl(i,mpld)  ! set multiplicity for i-atom
      real mpld
      include 'qcstrc.inc'
      real ni(0:6,4,nemax,namax),mpl(namax)
      integer isk(0:120,namax),irs(0:120,namax),hc(6)
      common /toatm/ ni,mpl,isk,irs,hc,abszc,qimax(namax)
      mpl(i)=mpld
      return
      end

      function getmpl(i)         ! get multiplicity for i-atom
      real mpld
      include 'qcstrc.inc'
      real ni(0:6,4,nemax,namax),mpl(namax)
      integer isk(0:120,namax),irs(0:120,namax),hc(6)
      common /toatm/ ni,mpl,isk,irs,hc,abszc,qimax(namax)
      getmpl=mpl(i)
      return
      end

      subroutine sethc(zc)
      real zc(*)
      include 'qcstrc.inc'
      real ni(0:6,4,nemax,namax),mpl(namax)
      integer isk(0:120,namax),irs(0:120,namax),hc(6)
      common /toatm/ ni,mpl,isk,irs,hc,abszc,qimax(namax)
      do i=1,6
         hc(i)=zc(i)+sign(0.5,zc(i))
      end do
c        write(6,*) 'hc=',hc
      return
      end

      subroutine gethc(hcd)
      integer hcd(*)
      include 'qcstrc.inc'
      real ni(0:6,4,nemax,namax),mpl(namax)
      integer isk(0:120,namax),irs(0:120,namax),hc(6)
      common /toatm/ ni,mpl,isk,irs,hc,abszc,qimax(namax)
      call vcpyi(hc,hcd,6)
      return
      end

      subroutine wtsitesy0(na)
      integer irs(0:120)
      write(6,*) 'site symmetry group for x0'
      do i=1,na
         call getirs0(i,irs)
         write(6,'(a,i3,20i4/(8x,20i4))')
     *        'atom=',i,(irs(j),j=1,irs(0))
c     write(6,'(a,i3/(20i4))') 'atom=',i,(irs(j),j=1,irs(0))
      end do
      return
      end

      subroutine  wtequipos0(na)
      real mpl
      integer isk(0:120)
      write(6,*) 'equivalent position for x0'
      do i=1,na
         call getisk0(i,isk)
         write(6,'(a,i3,20i4/(8x,20i4))')
     *        'atom=',i,(isk(j),j=1,isk(0))
      end do
      write(6,*) 'multiplicity'
      do i=1,na
         mpl=getmpl0(i)
         write(6,'(a,i4,f10.5)') 'atom',i,mpl
      end do
      return
      end

      subroutine wtsitesy(na)
      integer irs(0:120)
      write(6,*) 'site symmetry group'
      do i=1,na
         call getirs(i,irs)
         write(6,'(a,i3,20i4/(8x,20i4))')
     *        'atom=',i,(irs(j),j=1,irs(0))
c     write(6,'(a,i3/(20i4))') 'atom=',i,(irs(j),j=1,irs(0))
      end do
      return
      end

      subroutine  wtequipos(na)
      real mpl
      integer isk(0:120)
      write(6,*) 'equivalent position'
      do i=1,na
         call getisk(i,isk)
         write(6,'(a,i3,20i4/(8x,20i4))')
     *        'atom=',i,(isk(j),j=1,isk(0))
      end do
      write(6,*) 'multiplicity'
      do i=1,na
         mpl=getmpl(i)
         write(6,'(a,i4,f10.5)') 'atom',i,mpl
      end do
      return
      end


      subroutine sitesyx(na,x) 
      real x(6,*)
      real mpl
      integer isk(0:120),irs(0:120)
c     write(6,*) 'na in sitesy=',na
      do i=1,na
         call sitesy0(x(1,i),isk,irs,mpl)
         call setisk(i,isk)   ! save symmetry op. generating equiv. sites
         call setirs(i,irs)   ! save site symmetry op. for i-th atom
         call setmpl(i,mpl)   ! save multipricity for i-th atom
      end do
      call wtsitesy(na)
      call wtequipos(na)
      return
      end

      subroutine sitesyx0(na,x0) 
      real x0(6,*)
      real mpl
      integer isk(0:120),irs(0:120)
c     write(6,*) 'na in sitesy=',na
      do i=1,na
         call sitesy0(x0(1,i),isk,irs,mpl)
         call setisk0(i,isk)   ! save symmetry op. generating equiv. sites
         call setirs0(i,irs)   ! save site symmetry op. for i-th atom
         call setmpl0(i,mpl)   ! save multipricity for i-th atom
      end do
      call wtsitesy0(na)
      call wtequipos0(na)
      return
      end

      subroutine replx0(na,qemax,qimax)
c     get positional vector with the smallest internal vector component
c     and original x0 is replaced by it
      real qimax(*)
      include 'qcstrc.inc'
      parameter (tau=1.61803399)
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax),b10(namax),ui0(6,namax)
      real xs(6),h(6),x1(6),q(6)
      integer ji(6),hmax(6),mm(7)
      integer getisys
      call geta(al,am)
      isys=getisys()
      if(isys.le.2) then
         i5s=-1
         i5e=1
         i6s=-1
         i6e=1
         ad=al
      else if(isys.eq.3) then
         i5s=0
         i5e=0
         i6s=0
         i6e=0
         ad=al*tau
      else if(isys.eq.4) then
         i5s=0
         i5e=0
         i6s=0
         i6e=0
         ad=al
      else
         call quit('wrong isys')
      end if
c      find minimum qimax
      do n=1,na
         if(isys.le.2) then
            call reduc(x0(1,n))
         else if(isys.eq.3) then
            call getqe(x0(1,n),q)
            qet0=vabs(q(1),2)
            qit0=vabs(q(4),2)
            call vcpyr(x0(1,n),xs,6)
            if(qet0.lt.ad.and.qit0.lt.ad) go to 100
            do i=1,4
               hmax(i)=1
            end do
            hmax(5)=i5e
            hmax(6)=i6e
            call getmm(hmax,mm,nt)
            do nd=1,nt
               call gethkl(nd,hmax,ji,mm)               
               call vcpyir(ji,h,6)
               call vsumr(h,x0(1,n),x1,6)
               call getqe(x1,q)
               qe=vabs(q(1),3)
               if(isys.le.2) then
                  qi=vabs(q(4),3)
               else
                  qi=vabs(q(4),2)
               end if
               if(qe.lt.ad.and.qi.lt.ad) then
                  call vcpyr(x1,xs,6)
                  go to 100
               end if
            end do
 100        continue
            call vcpyr(xs,x0(1,n),6)
         else if(isys.eq.4.or.isys.eq.5) then
            call reduc(x0(1,n))
         end if
         call getqe(x0(1,n),q)
         if(isys.le.2) then
            qet=vabs(q(1),3)
            qit=vabs(q(4),3)
         else if(isys.eq.3) then
            qet=vabs(q(1),2)
            qit=vabs(q(4),2)
         else if(isys.eq.4) then
            qet=vabs(q(1),2)
            qit=vabs(q(4),2)
         end if
         qimax(n)=qit
         if(n.eq.1) then
            qemax=qet
         else
            if(qet.gt.qemax) then
               qemax=qet
            end if
         end if
         write(6,*) 'qet,qit,qimax(n)=',qet,qit,qimax(n)
      end do
      do i=1,na
         write(6,'(a,6f9.5)') 'x0=',(x0(j,i),j=1,6)
      end do
      write(6,*) 'qemax=',qemax
      return
      end

      subroutine replx(na,qemax,qimax)
c     get positional vector with the smallest internal vector component
c     and original x is replaced by it
      real qimax(*)
      include 'qcstrc.inc'
      parameter (tau=1.61803399)
      common /cstrc6/ x(6,namax),u1(namax),u2(namax),u3(namax),
     *     v(namax),be(namax),bi(namax),b1(namax),ui(6,namax)
      real xs(6),h(6),x1(6),q(6)
      integer ji(6),hmax(6),mm(7)
      integer getisys
      call geta(al,am)
      isys=getisys()
      if(isys.le.2) then
         i5s=-1
         i5e=1
         i6s=-1
         i6e=1
         ad=al
      else if(isys.eq.3) then
         i5s=0
         i5e=0
         i6s=0
         i6e=0
         ad=al*tau
      else if(isys.eq.4) then
         i5s=0
         i5e=0
         i6s=0
         i6e=0
         ad=al
      else
         call quit('wrong isys')
      end if
c     find minimum qimax
      do n=1,na
         if(isys.le.2) then
            call reduc(x(1,n))
         else if(isys.eq.3) then
            call getqe(x(1,n),q)
            qet0=vabs(q(1),2)
            qit0=vabs(q(4),2)
            call vcpyr(x(1,n),xs,6)
            if(qet0.lt.ad.and.qit0.lt.ad) go to 100
            do i=1,4
               hmax(i)=1
            end do
            hmax(5)=i5e
            hmax(6)=i6e
            call getmm(hmax,mm,nt)
            do nd=1,nt
               call gethkl(nd,hmax,ji,mm)               
               call vsumr(h,x(1,n),x1,6)
               call getqe(x1,q)
               qe=vabs(q(1),3)
               if(isys.le.2) then
                  qi=vabs(q(4),3)
               else
                  qi=vabs(q(4),2)
               end if
               if(qe.lt.ad.and.qi.lt.ad) then
                  call vcpyr(x1,xs,6)
                  go to 100
               end if
            end do
 100        continue
            call vcpyr(xs,x(1,n),6)
         else if(isys.eq.4.or.isys.eq.5) then
            call reduc(x(1,n))
         end if
         call getqe(x(1,n),q)
         if(isys.le.2) then
            qet=vabs(q(1),3)
            qit=vabs(q(4),3)
         else if(isys.eq.3) then
            qet=vabs(q(1),2)
            qit=vabs(q(4),2)
         else if(isys.eq.4) then
            qet=vabs(q(1),2)
            qit=vabs(q(4),2)
         end if
         qimax(n)=qit
         if(n.eq.1) then
            qemax=qet
         else
            if(qet.gt.qemax) then
               qemax=qet
            end if
         end if
         write(6,*) 'qet,qit,qimax(n)=',qet,qit,qimax(n)
      end do
      do i=1,na
         write(6,'(a,6f9.5)') 'x=',(x(j,i),j=1,6)
      end do
      write(6,*) 'qemax=',qemax
      return
      end

